



% sampleTime = 0.01;

SampleTimeKalman =sampleTime;
SampleTimeMeas = SampleTimeKalman*10;
h = SampleTimeKalman;

STM = SampleTimeMeas/SampleTimeKalman;

%% Kalman for method 1 in the NED frame, X = [x y - u v - T1' T2' -'];

T1_kal = 10;
T2_kal = 10;

Time_kal =diag([T1_kal T2_kal]);



disk_A_NED =    [1 0 h 0 0 0;
                 0 1 0 h 0 0;
                 0 0 1 0 h 0; 
                 0 0 0 1 0 h;
                 0 0 0 0 1-h*(1/T1_kal) 0
                 0 0 0 0 0 1-h*(1/T2_kal)];
H_NED = [diag([1 1]) zeros(2,4)];




P0 =0;
P02 = P0;
E = 1;
R_NED = diag([0.1^2 0.1^2]);  
Q_NED =diag([1 1 1 1 1 1])*0.01;


%% Kalman for method 2,1 in the body frame, X = [x, y, phi, u, v, r, T1', T2', T3']; 9

T11                          = 5;
T22                          = 5;
T33                          = 5;
T44                          = 1;
T55                          = 1;
T66                          = 1;





Disk_A_method2              = [1 0 0 h 0 0 0 0 0;
                               0 1 0 0 h 0 0 0 0;
                               0 0 1 0 0 h 0 0 0;
                               0 0 0 1-h*(1/T11) 0 0 h 0 0;
                               0 0 0 0 1-h*(1/T22) 0 0 h 0;
                               0 0 0 0 0 1-h*(1/T33) 0 0 h;
                               0 0 0 0 0 0 1-h*(1/T44) 0 0;
                               0 0 0 0 0 0 0 1-h*(1/T55) 0;
                               0 0 0 0 0 0 0 0 1-h*(1/T66)];
                           
                           

                           
                           
H2_BODY                     = [eye(3,3), zeros(3,6)] ;                         
P02                         = 0;

E2                          = 1;
R2_BODY                     = diag([0.1^2 0.1^2 0.1^2])*1;

Q2_BODY                     = diag([1 1 1 1 1 1 1 1 1])*1;




