/* Include files */

#include "blascompat32.h"
#include "objectTrackingFilter_sfun.h"
#include "c2_objectTrackingFilter.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "objectTrackingFilter_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c2_debug_family_names[20] = { "R", "Q", "H", "Gama", "hat_P",
  "nargin", "nargout", "y", "Q_NED", "H_NED", "E", "R_NED", "disk_A_NED",
  "SampleTimeKalman", "STM", "hat_x", "K", "pre_P", "pre_x", "index" };

/* Function Declarations */
static void initialize_c2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance);
static void initialize_params_c2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance);
static void enable_c2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance);
static void disable_c2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance);
static void c2_update_debugger_state_c2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance);
static void set_sim_state_c2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance, const mxArray *c2_st);
static void finalize_c2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance);
static void sf_c2_objectTrackingFilter(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance);
static void c2_chartstep_c2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance);
static void initSimStructsc2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c2_machineNumber, uint32_T
  c2_chartNumber);
static const mxArray *c2_sf_marshallOut(void *chartInstanceVoid, void *c2_inData);
static real_T c2_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_b_index, const char_T *c2_identifier);
static real_T c2_b_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId);
static void c2_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_b_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static void c2_c_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_b_pre_x, const char_T *c2_identifier, real_T
  c2_y[6]);
static void c2_d_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[6]);
static void c2_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_c_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static void c2_e_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_b_pre_P, const char_T *c2_identifier, real_T
  c2_y[36]);
static void c2_f_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[36]);
static void c2_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_d_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static void c2_g_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_K, const char_T *c2_identifier, real_T c2_y
  [12]);
static void c2_h_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[12]);
static void c2_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_e_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static void c2_i_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_hat_x, const char_T *c2_identifier, real_T
  c2_y[6]);
static void c2_j_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[6]);
static void c2_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_f_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static real_T c2_k_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId);
static void c2_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_g_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static void c2_l_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[36]);
static void c2_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_h_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static void c2_m_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[4]);
static void c2_h_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_i_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static void c2_n_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[12]);
static void c2_i_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_j_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static void c2_info_helper(c2_ResolvedFunctionInfo c2_info[48]);
static void c2_rdivide(SFc2_objectTrackingFilterInstanceStruct *chartInstance,
  real_T c2_x[4], real_T c2_y, real_T c2_z[4]);
static void c2_eml_scalar_eg(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance);
static void c2_b_eml_scalar_eg(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance);
static void c2_c_eml_scalar_eg(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance);
static void c2_inv(SFc2_objectTrackingFilterInstanceStruct *chartInstance,
                   real_T c2_x[4], real_T c2_y[4]);
static real_T c2_norm(SFc2_objectTrackingFilterInstanceStruct *chartInstance,
                      real_T c2_x[4]);
static void c2_eml_warning(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance);
static void c2_b_eml_warning(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, char_T c2_varargin_2[14]);
static void c2_d_eml_scalar_eg(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance);
static void c2_e_eml_scalar_eg(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance);
static void c2_f_eml_scalar_eg(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance);
static void c2_eye(SFc2_objectTrackingFilterInstanceStruct *chartInstance,
                   real_T c2_I[36]);
static void c2_check_forloop_overflow_error
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance);
static void c2_g_eml_scalar_eg(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance);
static void c2_h_eml_scalar_eg(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance);
static void c2_i_eml_scalar_eg(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance);
static void c2_o_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_sprintf, const char_T *c2_identifier, char_T
  c2_y[14]);
static void c2_p_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  char_T c2_y[14]);
static const mxArray *c2_k_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static int32_T c2_q_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId);
static void c2_j_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static uint8_T c2_r_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_b_is_active_c2_objectTrackingFilter, const
  char_T *c2_identifier);
static uint8_T c2_s_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId);
static void init_dsm_address_info(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance)
{
  chartInstance->c2_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c2_pre_P_not_empty = FALSE;
  chartInstance->c2_pre_x_not_empty = FALSE;
  chartInstance->c2_index_not_empty = FALSE;
  chartInstance->c2_is_active_c2_objectTrackingFilter = 0U;
}

static void initialize_params_c2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance)
{
  real_T c2_dv0[36];
  int32_T c2_i0;
  real_T c2_dv1[12];
  int32_T c2_i1;
  real_T c2_d0;
  real_T c2_dv2[4];
  int32_T c2_i2;
  real_T c2_dv3[36];
  int32_T c2_i3;
  real_T c2_d1;
  real_T c2_d2;
  sf_set_error_prefix_string(
    "Error evaluating data 'Q_NED' in the parent workspace.\n");
  sf_mex_import_named("Q_NED", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      c2_dv0, 0, 0, 0U, 1, 0U, 2, 6, 6);
  for (c2_i0 = 0; c2_i0 < 36; c2_i0++) {
    chartInstance->c2_Q_NED[c2_i0] = c2_dv0[c2_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'H_NED' in the parent workspace.\n");
  sf_mex_import_named("H_NED", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      c2_dv1, 0, 0, 0U, 1, 0U, 2, 2, 6);
  for (c2_i1 = 0; c2_i1 < 12; c2_i1++) {
    chartInstance->c2_H_NED[c2_i1] = c2_dv1[c2_i1];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'E' in the parent workspace.\n");
  sf_mex_import_named("E", sf_mex_get_sfun_param(chartInstance->S, 0, 0), &c2_d0,
                      0, 0, 0U, 0, 0U, 0);
  chartInstance->c2_E = c2_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'R_NED' in the parent workspace.\n");
  sf_mex_import_named("R_NED", sf_mex_get_sfun_param(chartInstance->S, 3, 0),
                      c2_dv2, 0, 0, 0U, 1, 0U, 2, 2, 2);
  for (c2_i2 = 0; c2_i2 < 4; c2_i2++) {
    chartInstance->c2_R_NED[c2_i2] = c2_dv2[c2_i2];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'disk_A_NED' in the parent workspace.\n");
  sf_mex_import_named("disk_A_NED", sf_mex_get_sfun_param(chartInstance->S, 6, 0),
                      c2_dv3, 0, 0, 0U, 1, 0U, 2, 6, 6);
  for (c2_i3 = 0; c2_i3 < 36; c2_i3++) {
    chartInstance->c2_disk_A_NED[c2_i3] = c2_dv3[c2_i3];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'SampleTimeKalman' in the parent workspace.\n");
  sf_mex_import_named("SampleTimeKalman", sf_mex_get_sfun_param(chartInstance->S,
    5, 0), &c2_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c2_SampleTimeKalman = c2_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'STM' in the parent workspace.\n");
  sf_mex_import_named("STM", sf_mex_get_sfun_param(chartInstance->S, 4, 0),
                      &c2_d2, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c2_STM = c2_d2;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c2_update_debugger_state_c2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance)
{
  const mxArray *c2_st;
  const mxArray *c2_y = NULL;
  int32_T c2_i4;
  real_T c2_u[12];
  const mxArray *c2_b_y = NULL;
  int32_T c2_i5;
  real_T c2_b_u[6];
  const mxArray *c2_c_y = NULL;
  real_T c2_hoistedGlobal;
  real_T c2_c_u;
  const mxArray *c2_d_y = NULL;
  int32_T c2_i6;
  real_T c2_d_u[36];
  const mxArray *c2_e_y = NULL;
  int32_T c2_i7;
  real_T c2_e_u[6];
  const mxArray *c2_f_y = NULL;
  uint8_T c2_b_hoistedGlobal;
  uint8_T c2_f_u;
  const mxArray *c2_g_y = NULL;
  real_T (*c2_hat_x)[6];
  real_T (*c2_K)[12];
  c2_K = (real_T (*)[12])ssGetOutputPortSignal(chartInstance->S, 2);
  c2_hat_x = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c2_st = NULL;
  c2_st = NULL;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_createcellarray(6), FALSE);
  for (c2_i4 = 0; c2_i4 < 12; c2_i4++) {
    c2_u[c2_i4] = (*c2_K)[c2_i4];
  }

  c2_b_y = NULL;
  sf_mex_assign(&c2_b_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 2, 6, 2), FALSE);
  sf_mex_setcell(c2_y, 0, c2_b_y);
  for (c2_i5 = 0; c2_i5 < 6; c2_i5++) {
    c2_b_u[c2_i5] = (*c2_hat_x)[c2_i5];
  }

  c2_c_y = NULL;
  sf_mex_assign(&c2_c_y, sf_mex_create("y", c2_b_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_setcell(c2_y, 1, c2_c_y);
  c2_hoistedGlobal = chartInstance->c2_index;
  c2_c_u = c2_hoistedGlobal;
  c2_d_y = NULL;
  if (!chartInstance->c2_index_not_empty) {
    sf_mex_assign(&c2_d_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c2_d_y, sf_mex_create("y", &c2_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c2_y, 2, c2_d_y);
  for (c2_i6 = 0; c2_i6 < 36; c2_i6++) {
    c2_d_u[c2_i6] = chartInstance->c2_pre_P[c2_i6];
  }

  c2_e_y = NULL;
  if (!chartInstance->c2_pre_P_not_empty) {
    sf_mex_assign(&c2_e_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c2_e_y, sf_mex_create("y", c2_d_u, 0, 0U, 1U, 0U, 2, 6, 6),
                  FALSE);
  }

  sf_mex_setcell(c2_y, 3, c2_e_y);
  for (c2_i7 = 0; c2_i7 < 6; c2_i7++) {
    c2_e_u[c2_i7] = chartInstance->c2_pre_x[c2_i7];
  }

  c2_f_y = NULL;
  if (!chartInstance->c2_pre_x_not_empty) {
    sf_mex_assign(&c2_f_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c2_f_y, sf_mex_create("y", c2_e_u, 0, 0U, 1U, 0U, 1, 6),
                  FALSE);
  }

  sf_mex_setcell(c2_y, 4, c2_f_y);
  c2_b_hoistedGlobal = chartInstance->c2_is_active_c2_objectTrackingFilter;
  c2_f_u = c2_b_hoistedGlobal;
  c2_g_y = NULL;
  sf_mex_assign(&c2_g_y, sf_mex_create("y", &c2_f_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 5, c2_g_y);
  sf_mex_assign(&c2_st, c2_y, FALSE);
  return c2_st;
}

static void set_sim_state_c2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance, const mxArray *c2_st)
{
  const mxArray *c2_u;
  real_T c2_dv4[12];
  int32_T c2_i8;
  real_T c2_dv5[6];
  int32_T c2_i9;
  real_T c2_dv6[36];
  int32_T c2_i10;
  real_T c2_dv7[6];
  int32_T c2_i11;
  real_T (*c2_K)[12];
  real_T (*c2_hat_x)[6];
  c2_K = (real_T (*)[12])ssGetOutputPortSignal(chartInstance->S, 2);
  c2_hat_x = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c2_doneDoubleBufferReInit = TRUE;
  c2_u = sf_mex_dup(c2_st);
  c2_g_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 0)), "K",
                        c2_dv4);
  for (c2_i8 = 0; c2_i8 < 12; c2_i8++) {
    (*c2_K)[c2_i8] = c2_dv4[c2_i8];
  }

  c2_i_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 1)),
                        "hat_x", c2_dv5);
  for (c2_i9 = 0; c2_i9 < 6; c2_i9++) {
    (*c2_hat_x)[c2_i9] = c2_dv5[c2_i9];
  }

  chartInstance->c2_index = c2_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c2_u, 2)), "index");
  c2_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 3)),
                        "pre_P", c2_dv6);
  for (c2_i10 = 0; c2_i10 < 36; c2_i10++) {
    chartInstance->c2_pre_P[c2_i10] = c2_dv6[c2_i10];
  }

  c2_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 4)),
                        "pre_x", c2_dv7);
  for (c2_i11 = 0; c2_i11 < 6; c2_i11++) {
    chartInstance->c2_pre_x[c2_i11] = c2_dv7[c2_i11];
  }

  chartInstance->c2_is_active_c2_objectTrackingFilter = c2_r_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 5)),
     "is_active_c2_objectTrackingFilter");
  sf_mex_destroy(&c2_u);
  c2_update_debugger_state_c2_objectTrackingFilter(chartInstance);
  sf_mex_destroy(&c2_st);
}

static void finalize_c2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance)
{
}

static void sf_c2_objectTrackingFilter(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance)
{
  int32_T c2_i12;
  int32_T c2_i13;
  int32_T c2_i14;
  int32_T c2_i15;
  int32_T c2_i16;
  int32_T c2_i17;
  int32_T c2_i18;
  real_T (*c2_K)[12];
  real_T (*c2_hat_x)[6];
  real_T (*c2_y)[2];
  c2_K = (real_T (*)[12])ssGetOutputPortSignal(chartInstance->S, 2);
  c2_hat_x = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c2_y = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 0U, chartInstance->c2_sfEvent);
  for (c2_i12 = 0; c2_i12 < 2; c2_i12++) {
    _SFD_DATA_RANGE_CHECK((*c2_y)[c2_i12], 0U);
  }

  for (c2_i13 = 0; c2_i13 < 6; c2_i13++) {
    _SFD_DATA_RANGE_CHECK((*c2_hat_x)[c2_i13], 1U);
  }

  for (c2_i14 = 0; c2_i14 < 12; c2_i14++) {
    _SFD_DATA_RANGE_CHECK((*c2_K)[c2_i14], 2U);
  }

  for (c2_i15 = 0; c2_i15 < 36; c2_i15++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c2_Q_NED[c2_i15], 3U);
  }

  for (c2_i16 = 0; c2_i16 < 12; c2_i16++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c2_H_NED[c2_i16], 4U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c2_E, 5U);
  for (c2_i17 = 0; c2_i17 < 4; c2_i17++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c2_R_NED[c2_i17], 6U);
  }

  for (c2_i18 = 0; c2_i18 < 36; c2_i18++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c2_disk_A_NED[c2_i18], 7U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c2_SampleTimeKalman, 8U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c2_STM, 9U);
  chartInstance->c2_sfEvent = CALL_EVENT;
  c2_chartstep_c2_objectTrackingFilter(chartInstance);
  sf_debug_check_for_state_inconsistency(_objectTrackingFilterMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c2_chartstep_c2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance)
{
  real_T c2_hoistedGlobal;
  real_T c2_b_hoistedGlobal;
  real_T c2_c_hoistedGlobal;
  int32_T c2_i19;
  real_T c2_y[2];
  int32_T c2_i20;
  real_T c2_b_Q_NED[36];
  int32_T c2_i21;
  real_T c2_b_H_NED[12];
  real_T c2_b_E;
  int32_T c2_i22;
  real_T c2_b_R_NED[4];
  int32_T c2_i23;
  real_T c2_b_disk_A_NED[36];
  real_T c2_b_SampleTimeKalman;
  real_T c2_b_STM;
  uint32_T c2_debug_family_var_map[20];
  real_T c2_R[4];
  real_T c2_Q[36];
  real_T c2_H[12];
  real_T c2_Gama;
  real_T c2_hat_P[36];
  real_T c2_nargin = 8.0;
  real_T c2_nargout = 2.0;
  real_T c2_hat_x[6];
  real_T c2_K[12];
  int32_T c2_i24;
  int32_T c2_i25;
  int32_T c2_i26;
  int32_T c2_i27;
  int32_T c2_i28;
  real_T c2_c_R_NED[4];
  real_T c2_dv8[4];
  int32_T c2_i29;
  int32_T c2_i30;
  real_T c2_a[36];
  real_T c2_b;
  int32_T c2_i31;
  int32_T c2_i32;
  int32_T c2_i33;
  real_T c2_d_hoistedGlobal[36];
  int32_T c2_i34;
  int32_T c2_i35;
  int32_T c2_i36;
  int32_T c2_i37;
  real_T c2_b_b[12];
  int32_T c2_i38;
  int32_T c2_i39;
  int32_T c2_i40;
  real_T c2_b_y[12];
  int32_T c2_i41;
  int32_T c2_i42;
  int32_T c2_i43;
  int32_T c2_i44;
  real_T c2_b_a[12];
  int32_T c2_i45;
  int32_T c2_i46;
  int32_T c2_i47;
  int32_T c2_i48;
  real_T c2_c_y[12];
  int32_T c2_i49;
  int32_T c2_i50;
  int32_T c2_i51;
  int32_T c2_i52;
  int32_T c2_i53;
  int32_T c2_i54;
  int32_T c2_i55;
  int32_T c2_i56;
  int32_T c2_i57;
  int32_T c2_i58;
  real_T c2_d_y[4];
  int32_T c2_i59;
  int32_T c2_i60;
  int32_T c2_i61;
  real_T c2_e_y[4];
  int32_T c2_i62;
  int32_T c2_i63;
  int32_T c2_i64;
  int32_T c2_i65;
  int32_T c2_i66;
  int32_T c2_i67;
  int32_T c2_i68;
  int32_T c2_i69;
  int32_T c2_i70;
  int32_T c2_i71;
  int32_T c2_i72;
  int32_T c2_i73;
  int32_T c2_i74;
  int32_T c2_i75;
  real_T c2_e_hoistedGlobal[6];
  int32_T c2_i76;
  real_T c2_f_hoistedGlobal[6];
  int32_T c2_i77;
  int32_T c2_i78;
  real_T c2_f_y[2];
  int32_T c2_i79;
  int32_T c2_i80;
  int32_T c2_i81;
  int32_T c2_i82;
  int32_T c2_i83;
  real_T c2_g_y[6];
  int32_T c2_i84;
  int32_T c2_i85;
  int32_T c2_i86;
  int32_T c2_i87;
  int32_T c2_i88;
  int32_T c2_i89;
  int32_T c2_i90;
  int32_T c2_i91;
  int32_T c2_i92;
  real_T c2_h_y[36];
  int32_T c2_i93;
  int32_T c2_i94;
  int32_T c2_i95;
  int32_T c2_i96;
  int32_T c2_i97;
  int32_T c2_i98;
  int32_T c2_i99;
  int32_T c2_i100;
  int32_T c2_i101;
  int32_T c2_i102;
  int32_T c2_i103;
  int32_T c2_i104;
  int32_T c2_i105;
  int32_T c2_i106;
  int32_T c2_i107;
  int32_T c2_i108;
  int32_T c2_i109;
  int32_T c2_i110;
  int32_T c2_i111;
  int32_T c2_i112;
  int32_T c2_i113;
  real_T c2_c_b[36];
  int32_T c2_i114;
  int32_T c2_i115;
  int32_T c2_i116;
  int32_T c2_i117;
  int32_T c2_i118;
  int32_T c2_i119;
  int32_T c2_i120;
  int32_T c2_i121;
  int32_T c2_i122;
  int32_T c2_i123;
  int32_T c2_i124;
  int32_T c2_i125;
  int32_T c2_i126;
  int32_T c2_i127;
  int32_T c2_i128;
  int32_T c2_i129;
  int32_T c2_i130;
  int32_T c2_i131;
  int32_T c2_i132;
  int32_T c2_i133;
  int32_T c2_i134;
  int32_T c2_i135;
  int32_T c2_i136;
  int32_T c2_i137;
  int32_T c2_i138;
  int32_T c2_i139;
  int32_T c2_i140;
  int32_T c2_i141;
  int32_T c2_i142;
  int32_T c2_i143;
  int32_T c2_i144;
  int32_T c2_i145;
  int32_T c2_i146;
  int32_T c2_i147;
  int32_T c2_i148;
  int32_T c2_i149;
  int32_T c2_i150;
  int32_T c2_i151;
  int32_T c2_i152;
  int32_T c2_i153;
  real_T c2_c_a;
  int32_T c2_i154;
  int32_T c2_i155;
  real_T c2_d_b;
  int32_T c2_i156;
  int32_T c2_i157;
  int32_T c2_i158;
  int32_T c2_i159;
  int32_T c2_i160;
  int32_T c2_i161;
  int32_T c2_i162;
  int32_T c2_i163;
  int32_T c2_i164;
  int32_T c2_i165;
  real_T (*c2_b_hat_x)[6];
  real_T (*c2_b_K)[12];
  real_T (*c2_i_y)[2];
  boolean_T guard1 = FALSE;
  c2_b_K = (real_T (*)[12])ssGetOutputPortSignal(chartInstance->S, 2);
  c2_b_hat_x = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c2_i_y = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 0U, chartInstance->c2_sfEvent);
  c2_hoistedGlobal = chartInstance->c2_E;
  c2_b_hoistedGlobal = chartInstance->c2_SampleTimeKalman;
  c2_c_hoistedGlobal = chartInstance->c2_STM;
  for (c2_i19 = 0; c2_i19 < 2; c2_i19++) {
    c2_y[c2_i19] = (*c2_i_y)[c2_i19];
  }

  for (c2_i20 = 0; c2_i20 < 36; c2_i20++) {
    c2_b_Q_NED[c2_i20] = chartInstance->c2_Q_NED[c2_i20];
  }

  for (c2_i21 = 0; c2_i21 < 12; c2_i21++) {
    c2_b_H_NED[c2_i21] = chartInstance->c2_H_NED[c2_i21];
  }

  c2_b_E = c2_hoistedGlobal;
  for (c2_i22 = 0; c2_i22 < 4; c2_i22++) {
    c2_b_R_NED[c2_i22] = chartInstance->c2_R_NED[c2_i22];
  }

  for (c2_i23 = 0; c2_i23 < 36; c2_i23++) {
    c2_b_disk_A_NED[c2_i23] = chartInstance->c2_disk_A_NED[c2_i23];
  }

  c2_b_SampleTimeKalman = c2_b_hoistedGlobal;
  c2_b_STM = c2_c_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 20U, 20U, c2_debug_family_names,
    c2_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(c2_R, 0U, c2_h_sf_marshallOut,
    c2_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c2_Q, 1U, c2_g_sf_marshallOut,
    c2_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c2_H, 2U, c2_i_sf_marshallOut,
    c2_i_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c2_Gama, 3U, c2_f_sf_marshallOut,
    c2_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c2_hat_P, 4U, c2_g_sf_marshallOut,
    c2_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c2_nargin, 5U, c2_f_sf_marshallOut,
    c2_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c2_nargout, 6U, c2_f_sf_marshallOut,
    c2_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c2_y, 7U, c2_j_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c2_b_Q_NED, 8U, c2_g_sf_marshallOut,
    c2_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c2_b_H_NED, 9U, c2_i_sf_marshallOut,
    c2_i_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c2_b_E, 10U, c2_f_sf_marshallOut,
    c2_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c2_b_R_NED, 11U, c2_h_sf_marshallOut,
    c2_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c2_b_disk_A_NED, 12U,
    c2_g_sf_marshallOut, c2_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c2_b_SampleTimeKalman, 13U,
    c2_f_sf_marshallOut, c2_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c2_b_STM, 14U, c2_f_sf_marshallOut,
    c2_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c2_hat_x, 15U, c2_e_sf_marshallOut,
    c2_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c2_K, 16U, c2_d_sf_marshallOut,
    c2_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(chartInstance->c2_pre_P, 17U,
    c2_c_sf_marshallOut, c2_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(chartInstance->c2_pre_x, 18U,
    c2_b_sf_marshallOut, c2_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c2_index, 19U,
    c2_sf_marshallOut, c2_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 3);
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 4);
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 5);
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 8);
  guard1 = FALSE;
  if (CV_EML_COND(0, 1, 0, !chartInstance->c2_pre_x_not_empty)) {
    guard1 = TRUE;
  } else if (CV_EML_COND(0, 1, 1, !chartInstance->c2_pre_P_not_empty)) {
    guard1 = TRUE;
  } else {
    CV_EML_MCDC(0, 1, 0, FALSE);
    CV_EML_IF(0, 1, 0, FALSE);
  }

  if (guard1 == TRUE) {
    CV_EML_MCDC(0, 1, 0, TRUE);
    CV_EML_IF(0, 1, 0, TRUE);
    _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 10);
    for (c2_i24 = 0; c2_i24 < 2; c2_i24++) {
      chartInstance->c2_pre_x[c2_i24] = c2_y[c2_i24];
    }

    for (c2_i25 = 0; c2_i25 < 2; c2_i25++) {
      chartInstance->c2_pre_x[c2_i25 + 2] = 0.0;
    }

    for (c2_i26 = 0; c2_i26 < 2; c2_i26++) {
      chartInstance->c2_pre_x[c2_i26 + 4] = 0.0;
    }

    chartInstance->c2_pre_x_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 11);
    for (c2_i27 = 0; c2_i27 < 36; c2_i27++) {
      chartInstance->c2_pre_P[c2_i27] = 0.0;
    }

    chartInstance->c2_pre_P_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 12);
    chartInstance->c2_index = c2_b_STM;
    chartInstance->c2_index_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 15);
  for (c2_i28 = 0; c2_i28 < 4; c2_i28++) {
    c2_c_R_NED[c2_i28] = c2_b_R_NED[c2_i28];
  }

  c2_rdivide(chartInstance, c2_c_R_NED, c2_b_SampleTimeKalman, c2_dv8);
  for (c2_i29 = 0; c2_i29 < 4; c2_i29++) {
    c2_R[c2_i29] = c2_dv8[c2_i29];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 16);
  for (c2_i30 = 0; c2_i30 < 36; c2_i30++) {
    c2_a[c2_i30] = c2_b_Q_NED[c2_i30];
  }

  c2_b = c2_b_SampleTimeKalman;
  for (c2_i31 = 0; c2_i31 < 36; c2_i31++) {
    c2_Q[c2_i31] = c2_a[c2_i31] * c2_b;
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 17);
  for (c2_i32 = 0; c2_i32 < 12; c2_i32++) {
    c2_H[c2_i32] = c2_b_H_NED[c2_i32];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 18);
  c2_Gama = c2_b_E;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 20);
  if (CV_EML_IF(0, 1, 1, chartInstance->c2_index == c2_b_STM)) {
    _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 22);
    for (c2_i33 = 0; c2_i33 < 36; c2_i33++) {
      c2_d_hoistedGlobal[c2_i33] = chartInstance->c2_pre_P[c2_i33];
    }

    c2_i34 = 0;
    for (c2_i35 = 0; c2_i35 < 2; c2_i35++) {
      c2_i36 = 0;
      for (c2_i37 = 0; c2_i37 < 6; c2_i37++) {
        c2_b_b[c2_i37 + c2_i34] = c2_H[c2_i36 + c2_i35];
        c2_i36 += 2;
      }

      c2_i34 += 6;
    }

    c2_eml_scalar_eg(chartInstance);
    c2_eml_scalar_eg(chartInstance);
    for (c2_i38 = 0; c2_i38 < 6; c2_i38++) {
      c2_i39 = 0;
      for (c2_i40 = 0; c2_i40 < 2; c2_i40++) {
        c2_b_y[c2_i39 + c2_i38] = 0.0;
        c2_i41 = 0;
        for (c2_i42 = 0; c2_i42 < 6; c2_i42++) {
          c2_b_y[c2_i39 + c2_i38] += c2_d_hoistedGlobal[c2_i41 + c2_i38] *
            c2_b_b[c2_i42 + c2_i39];
          c2_i41 += 6;
        }

        c2_i39 += 6;
      }
    }

    for (c2_i43 = 0; c2_i43 < 36; c2_i43++) {
      c2_d_hoistedGlobal[c2_i43] = chartInstance->c2_pre_P[c2_i43];
    }

    for (c2_i44 = 0; c2_i44 < 12; c2_i44++) {
      c2_b_a[c2_i44] = c2_H[c2_i44];
    }

    c2_b_eml_scalar_eg(chartInstance);
    c2_b_eml_scalar_eg(chartInstance);
    for (c2_i45 = 0; c2_i45 < 2; c2_i45++) {
      c2_i46 = 0;
      c2_i47 = 0;
      for (c2_i48 = 0; c2_i48 < 6; c2_i48++) {
        c2_c_y[c2_i46 + c2_i45] = 0.0;
        c2_i49 = 0;
        for (c2_i50 = 0; c2_i50 < 6; c2_i50++) {
          c2_c_y[c2_i46 + c2_i45] += c2_b_a[c2_i49 + c2_i45] *
            c2_d_hoistedGlobal[c2_i50 + c2_i47];
          c2_i49 += 2;
        }

        c2_i46 += 2;
        c2_i47 += 6;
      }
    }

    c2_i51 = 0;
    for (c2_i52 = 0; c2_i52 < 2; c2_i52++) {
      c2_i53 = 0;
      for (c2_i54 = 0; c2_i54 < 6; c2_i54++) {
        c2_b_b[c2_i54 + c2_i51] = c2_H[c2_i53 + c2_i52];
        c2_i53 += 2;
      }

      c2_i51 += 6;
    }

    c2_c_eml_scalar_eg(chartInstance);
    c2_c_eml_scalar_eg(chartInstance);
    for (c2_i55 = 0; c2_i55 < 2; c2_i55++) {
      c2_i56 = 0;
      c2_i57 = 0;
      for (c2_i58 = 0; c2_i58 < 2; c2_i58++) {
        c2_d_y[c2_i56 + c2_i55] = 0.0;
        c2_i59 = 0;
        for (c2_i60 = 0; c2_i60 < 6; c2_i60++) {
          c2_d_y[c2_i56 + c2_i55] += c2_c_y[c2_i59 + c2_i55] * c2_b_b[c2_i60 +
            c2_i57];
          c2_i59 += 2;
        }

        c2_i56 += 2;
        c2_i57 += 6;
      }
    }

    for (c2_i61 = 0; c2_i61 < 4; c2_i61++) {
      c2_e_y[c2_i61] = c2_d_y[c2_i61] + c2_R[c2_i61];
    }

    c2_inv(chartInstance, c2_e_y, c2_d_y);
    c2_d_eml_scalar_eg(chartInstance);
    c2_d_eml_scalar_eg(chartInstance);
    for (c2_i62 = 0; c2_i62 < 12; c2_i62++) {
      c2_K[c2_i62] = 0.0;
    }

    for (c2_i63 = 0; c2_i63 < 12; c2_i63++) {
      c2_K[c2_i63] = 0.0;
    }

    for (c2_i64 = 0; c2_i64 < 12; c2_i64++) {
      c2_b_b[c2_i64] = c2_K[c2_i64];
    }

    for (c2_i65 = 0; c2_i65 < 12; c2_i65++) {
      c2_K[c2_i65] = c2_b_b[c2_i65];
    }

    for (c2_i66 = 0; c2_i66 < 12; c2_i66++) {
      c2_b_b[c2_i66] = c2_K[c2_i66];
    }

    for (c2_i67 = 0; c2_i67 < 12; c2_i67++) {
      c2_K[c2_i67] = c2_b_b[c2_i67];
    }

    for (c2_i68 = 0; c2_i68 < 6; c2_i68++) {
      c2_i69 = 0;
      c2_i70 = 0;
      for (c2_i71 = 0; c2_i71 < 2; c2_i71++) {
        c2_K[c2_i69 + c2_i68] = 0.0;
        c2_i72 = 0;
        for (c2_i73 = 0; c2_i73 < 2; c2_i73++) {
          c2_K[c2_i69 + c2_i68] += c2_b_y[c2_i72 + c2_i68] * c2_d_y[c2_i73 +
            c2_i70];
          c2_i72 += 6;
        }

        c2_i69 += 6;
        c2_i70 += 2;
      }
    }

    _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 24);
    chartInstance->c2_index = 1.0;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 26);
    for (c2_i74 = 0; c2_i74 < 12; c2_i74++) {
      c2_K[c2_i74] = 0.0;
    }

    _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 27);
    chartInstance->c2_index++;
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 30);
  for (c2_i75 = 0; c2_i75 < 6; c2_i75++) {
    c2_e_hoistedGlobal[c2_i75] = chartInstance->c2_pre_x[c2_i75];
  }

  for (c2_i76 = 0; c2_i76 < 6; c2_i76++) {
    c2_f_hoistedGlobal[c2_i76] = chartInstance->c2_pre_x[c2_i76];
  }

  for (c2_i77 = 0; c2_i77 < 12; c2_i77++) {
    c2_b_a[c2_i77] = c2_H[c2_i77];
  }

  c2_e_eml_scalar_eg(chartInstance);
  c2_e_eml_scalar_eg(chartInstance);
  for (c2_i78 = 0; c2_i78 < 2; c2_i78++) {
    c2_f_y[c2_i78] = 0.0;
    c2_i79 = 0;
    for (c2_i80 = 0; c2_i80 < 6; c2_i80++) {
      c2_f_y[c2_i78] += c2_b_a[c2_i79 + c2_i78] * c2_f_hoistedGlobal[c2_i80];
      c2_i79 += 2;
    }
  }

  for (c2_i81 = 0; c2_i81 < 12; c2_i81++) {
    c2_b_b[c2_i81] = c2_K[c2_i81];
  }

  for (c2_i82 = 0; c2_i82 < 2; c2_i82++) {
    c2_f_y[c2_i82] = c2_y[c2_i82] - c2_f_y[c2_i82];
  }

  c2_f_eml_scalar_eg(chartInstance);
  c2_f_eml_scalar_eg(chartInstance);
  for (c2_i83 = 0; c2_i83 < 6; c2_i83++) {
    c2_g_y[c2_i83] = 0.0;
    c2_i84 = 0;
    for (c2_i85 = 0; c2_i85 < 2; c2_i85++) {
      c2_g_y[c2_i83] += c2_b_b[c2_i84 + c2_i83] * c2_f_y[c2_i85];
      c2_i84 += 6;
    }
  }

  for (c2_i86 = 0; c2_i86 < 6; c2_i86++) {
    c2_hat_x[c2_i86] = c2_e_hoistedGlobal[c2_i86] + c2_g_y[c2_i86];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 31);
  for (c2_i87 = 0; c2_i87 < 12; c2_i87++) {
    c2_b_b[c2_i87] = c2_K[c2_i87];
  }

  for (c2_i88 = 0; c2_i88 < 12; c2_i88++) {
    c2_b_a[c2_i88] = c2_H[c2_i88];
  }

  c2_g_eml_scalar_eg(chartInstance);
  c2_g_eml_scalar_eg(chartInstance);
  for (c2_i89 = 0; c2_i89 < 6; c2_i89++) {
    c2_i90 = 0;
    c2_i91 = 0;
    for (c2_i92 = 0; c2_i92 < 6; c2_i92++) {
      c2_h_y[c2_i90 + c2_i89] = 0.0;
      c2_i93 = 0;
      for (c2_i94 = 0; c2_i94 < 2; c2_i94++) {
        c2_h_y[c2_i90 + c2_i89] += c2_b_b[c2_i93 + c2_i89] * c2_b_a[c2_i94 +
          c2_i91];
        c2_i93 += 6;
      }

      c2_i90 += 6;
      c2_i91 += 2;
    }
  }

  for (c2_i95 = 0; c2_i95 < 36; c2_i95++) {
    c2_d_hoistedGlobal[c2_i95] = chartInstance->c2_pre_P[c2_i95];
  }

  c2_eye(chartInstance, c2_a);
  for (c2_i96 = 0; c2_i96 < 36; c2_i96++) {
    c2_a[c2_i96] -= c2_h_y[c2_i96];
  }

  c2_h_eml_scalar_eg(chartInstance);
  c2_h_eml_scalar_eg(chartInstance);
  for (c2_i97 = 0; c2_i97 < 6; c2_i97++) {
    c2_i98 = 0;
    for (c2_i99 = 0; c2_i99 < 6; c2_i99++) {
      c2_h_y[c2_i98 + c2_i97] = 0.0;
      c2_i100 = 0;
      for (c2_i101 = 0; c2_i101 < 6; c2_i101++) {
        c2_h_y[c2_i98 + c2_i97] += c2_a[c2_i100 + c2_i97] *
          c2_d_hoistedGlobal[c2_i101 + c2_i98];
        c2_i100 += 6;
      }

      c2_i98 += 6;
    }
  }

  for (c2_i102 = 0; c2_i102 < 12; c2_i102++) {
    c2_b_b[c2_i102] = c2_K[c2_i102];
  }

  for (c2_i103 = 0; c2_i103 < 12; c2_i103++) {
    c2_b_a[c2_i103] = c2_H[c2_i103];
  }

  c2_g_eml_scalar_eg(chartInstance);
  c2_g_eml_scalar_eg(chartInstance);
  for (c2_i104 = 0; c2_i104 < 6; c2_i104++) {
    c2_i105 = 0;
    c2_i106 = 0;
    for (c2_i107 = 0; c2_i107 < 6; c2_i107++) {
      c2_d_hoistedGlobal[c2_i105 + c2_i104] = 0.0;
      c2_i108 = 0;
      for (c2_i109 = 0; c2_i109 < 2; c2_i109++) {
        c2_d_hoistedGlobal[c2_i105 + c2_i104] += c2_b_b[c2_i108 + c2_i104] *
          c2_b_a[c2_i109 + c2_i106];
        c2_i108 += 6;
      }

      c2_i105 += 6;
      c2_i106 += 2;
    }
  }

  c2_eye(chartInstance, c2_a);
  c2_i110 = 0;
  for (c2_i111 = 0; c2_i111 < 6; c2_i111++) {
    c2_i112 = 0;
    for (c2_i113 = 0; c2_i113 < 6; c2_i113++) {
      c2_c_b[c2_i113 + c2_i110] = c2_a[c2_i112 + c2_i111] -
        c2_d_hoistedGlobal[c2_i112 + c2_i111];
      c2_i112 += 6;
    }

    c2_i110 += 6;
  }

  c2_h_eml_scalar_eg(chartInstance);
  c2_h_eml_scalar_eg(chartInstance);
  for (c2_i114 = 0; c2_i114 < 6; c2_i114++) {
    c2_i115 = 0;
    for (c2_i116 = 0; c2_i116 < 6; c2_i116++) {
      c2_d_hoistedGlobal[c2_i115 + c2_i114] = 0.0;
      c2_i117 = 0;
      for (c2_i118 = 0; c2_i118 < 6; c2_i118++) {
        c2_d_hoistedGlobal[c2_i115 + c2_i114] += c2_h_y[c2_i117 + c2_i114] *
          c2_c_b[c2_i118 + c2_i115];
        c2_i117 += 6;
      }

      c2_i115 += 6;
    }
  }

  for (c2_i119 = 0; c2_i119 < 12; c2_i119++) {
    c2_b_b[c2_i119] = c2_K[c2_i119];
  }

  for (c2_i120 = 0; c2_i120 < 4; c2_i120++) {
    c2_d_y[c2_i120] = c2_R[c2_i120];
  }

  c2_d_eml_scalar_eg(chartInstance);
  c2_d_eml_scalar_eg(chartInstance);
  for (c2_i121 = 0; c2_i121 < 6; c2_i121++) {
    c2_i122 = 0;
    c2_i123 = 0;
    for (c2_i124 = 0; c2_i124 < 2; c2_i124++) {
      c2_b_y[c2_i122 + c2_i121] = 0.0;
      c2_i125 = 0;
      for (c2_i126 = 0; c2_i126 < 2; c2_i126++) {
        c2_b_y[c2_i122 + c2_i121] += c2_b_b[c2_i125 + c2_i121] * c2_d_y[c2_i126
          + c2_i123];
        c2_i125 += 6;
      }

      c2_i122 += 6;
      c2_i123 += 2;
    }
  }

  c2_i127 = 0;
  for (c2_i128 = 0; c2_i128 < 6; c2_i128++) {
    c2_i129 = 0;
    for (c2_i130 = 0; c2_i130 < 2; c2_i130++) {
      c2_b_a[c2_i130 + c2_i127] = c2_K[c2_i129 + c2_i128];
      c2_i129 += 6;
    }

    c2_i127 += 2;
  }

  c2_g_eml_scalar_eg(chartInstance);
  c2_g_eml_scalar_eg(chartInstance);
  for (c2_i131 = 0; c2_i131 < 6; c2_i131++) {
    c2_i132 = 0;
    c2_i133 = 0;
    for (c2_i134 = 0; c2_i134 < 6; c2_i134++) {
      c2_h_y[c2_i132 + c2_i131] = 0.0;
      c2_i135 = 0;
      for (c2_i136 = 0; c2_i136 < 2; c2_i136++) {
        c2_h_y[c2_i132 + c2_i131] += c2_b_y[c2_i135 + c2_i131] * c2_b_a[c2_i136
          + c2_i133];
        c2_i135 += 6;
      }

      c2_i132 += 6;
      c2_i133 += 2;
    }
  }

  for (c2_i137 = 0; c2_i137 < 36; c2_i137++) {
    c2_hat_P[c2_i137] = c2_d_hoistedGlobal[c2_i137] + c2_h_y[c2_i137];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 34);
  for (c2_i138 = 0; c2_i138 < 36; c2_i138++) {
    c2_a[c2_i138] = c2_b_disk_A_NED[c2_i138];
  }

  for (c2_i139 = 0; c2_i139 < 36; c2_i139++) {
    c2_c_b[c2_i139] = c2_hat_P[c2_i139];
  }

  c2_h_eml_scalar_eg(chartInstance);
  c2_h_eml_scalar_eg(chartInstance);
  for (c2_i140 = 0; c2_i140 < 6; c2_i140++) {
    c2_i141 = 0;
    for (c2_i142 = 0; c2_i142 < 6; c2_i142++) {
      c2_h_y[c2_i141 + c2_i140] = 0.0;
      c2_i143 = 0;
      for (c2_i144 = 0; c2_i144 < 6; c2_i144++) {
        c2_h_y[c2_i141 + c2_i140] += c2_a[c2_i143 + c2_i140] * c2_c_b[c2_i144 +
          c2_i141];
        c2_i143 += 6;
      }

      c2_i141 += 6;
    }
  }

  c2_i145 = 0;
  for (c2_i146 = 0; c2_i146 < 6; c2_i146++) {
    c2_i147 = 0;
    for (c2_i148 = 0; c2_i148 < 6; c2_i148++) {
      c2_c_b[c2_i148 + c2_i145] = c2_b_disk_A_NED[c2_i147 + c2_i146];
      c2_i147 += 6;
    }

    c2_i145 += 6;
  }

  c2_h_eml_scalar_eg(chartInstance);
  c2_h_eml_scalar_eg(chartInstance);
  for (c2_i149 = 0; c2_i149 < 6; c2_i149++) {
    c2_i150 = 0;
    for (c2_i151 = 0; c2_i151 < 6; c2_i151++) {
      c2_d_hoistedGlobal[c2_i150 + c2_i149] = 0.0;
      c2_i152 = 0;
      for (c2_i153 = 0; c2_i153 < 6; c2_i153++) {
        c2_d_hoistedGlobal[c2_i150 + c2_i149] += c2_h_y[c2_i152 + c2_i149] *
          c2_c_b[c2_i153 + c2_i150];
        c2_i152 += 6;
      }

      c2_i150 += 6;
    }
  }

  c2_c_a = c2_Gama;
  for (c2_i154 = 0; c2_i154 < 36; c2_i154++) {
    c2_c_b[c2_i154] = c2_Q[c2_i154];
  }

  for (c2_i155 = 0; c2_i155 < 36; c2_i155++) {
    c2_c_b[c2_i155] *= c2_c_a;
  }

  c2_d_b = c2_Gama;
  for (c2_i156 = 0; c2_i156 < 36; c2_i156++) {
    c2_c_b[c2_i156] *= c2_d_b;
  }

  for (c2_i157 = 0; c2_i157 < 36; c2_i157++) {
    chartInstance->c2_pre_P[c2_i157] = c2_d_hoistedGlobal[c2_i157] +
      c2_c_b[c2_i157];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 35);
  for (c2_i158 = 0; c2_i158 < 36; c2_i158++) {
    c2_a[c2_i158] = c2_b_disk_A_NED[c2_i158];
  }

  for (c2_i159 = 0; c2_i159 < 6; c2_i159++) {
    c2_f_hoistedGlobal[c2_i159] = c2_hat_x[c2_i159];
  }

  c2_i_eml_scalar_eg(chartInstance);
  c2_i_eml_scalar_eg(chartInstance);
  for (c2_i160 = 0; c2_i160 < 6; c2_i160++) {
    c2_g_y[c2_i160] = 0.0;
    c2_i161 = 0;
    for (c2_i162 = 0; c2_i162 < 6; c2_i162++) {
      c2_g_y[c2_i160] += c2_a[c2_i161 + c2_i160] * c2_f_hoistedGlobal[c2_i162];
      c2_i161 += 6;
    }
  }

  for (c2_i163 = 0; c2_i163 < 6; c2_i163++) {
    chartInstance->c2_pre_x[c2_i163] = c2_g_y[c2_i163];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, -35);
  sf_debug_symbol_scope_pop();
  for (c2_i164 = 0; c2_i164 < 6; c2_i164++) {
    (*c2_b_hat_x)[c2_i164] = c2_hat_x[c2_i164];
  }

  for (c2_i165 = 0; c2_i165 < 12; c2_i165++) {
    (*c2_b_K)[c2_i165] = c2_K[c2_i165];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 0U, chartInstance->c2_sfEvent);
}

static void initSimStructsc2_objectTrackingFilter
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c2_machineNumber, uint32_T
  c2_chartNumber)
{
}

static const mxArray *c2_sf_marshallOut(void *chartInstanceVoid, void *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  real_T c2_u;
  const mxArray *c2_y = NULL;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_u = *(real_T *)c2_inData;
  c2_y = NULL;
  if (!chartInstance->c2_index_not_empty) {
    sf_mex_assign(&c2_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c2_y, sf_mex_create("y", &c2_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static real_T c2_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_b_index, const char_T *c2_identifier)
{
  real_T c2_y;
  emlrtMsgIdentifier c2_thisId;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_b_index), &c2_thisId);
  sf_mex_destroy(&c2_b_index);
  return c2_y;
}

static real_T c2_b_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  real_T c2_y;
  real_T c2_d3;
  if (mxIsEmpty(c2_u)) {
    chartInstance->c2_index_not_empty = FALSE;
  } else {
    chartInstance->c2_index_not_empty = TRUE;
    sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_d3, 1, 0, 0U, 0, 0U, 0);
    c2_y = c2_d3;
  }

  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void c2_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_b_index;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_b_index = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_b_index), &c2_thisId);
  sf_mex_destroy(&c2_b_index);
  *(real_T *)c2_outData = c2_y;
  sf_mex_destroy(&c2_mxArrayInData);
}

static const mxArray *c2_b_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i166;
  real_T c2_b_inData[6];
  int32_T c2_i167;
  real_T c2_u[6];
  const mxArray *c2_y = NULL;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  for (c2_i166 = 0; c2_i166 < 6; c2_i166++) {
    c2_b_inData[c2_i166] = (*(real_T (*)[6])c2_inData)[c2_i166];
  }

  for (c2_i167 = 0; c2_i167 < 6; c2_i167++) {
    c2_u[c2_i167] = c2_b_inData[c2_i167];
  }

  c2_y = NULL;
  if (!chartInstance->c2_pre_x_not_empty) {
    sf_mex_assign(&c2_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  }

  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static void c2_c_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_b_pre_x, const char_T *c2_identifier, real_T
  c2_y[6])
{
  emlrtMsgIdentifier c2_thisId;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_b_pre_x), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_b_pre_x);
}

static void c2_d_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[6])
{
  real_T c2_dv9[6];
  int32_T c2_i168;
  if (mxIsEmpty(c2_u)) {
    chartInstance->c2_pre_x_not_empty = FALSE;
  } else {
    chartInstance->c2_pre_x_not_empty = TRUE;
    sf_mex_import(c2_parentId, sf_mex_dup(c2_u), c2_dv9, 1, 0, 0U, 1, 0U, 1, 6);
    for (c2_i168 = 0; c2_i168 < 6; c2_i168++) {
      c2_y[c2_i168] = c2_dv9[c2_i168];
    }
  }

  sf_mex_destroy(&c2_u);
}

static void c2_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_b_pre_x;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y[6];
  int32_T c2_i169;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_b_pre_x = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_b_pre_x), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_b_pre_x);
  for (c2_i169 = 0; c2_i169 < 6; c2_i169++) {
    (*(real_T (*)[6])c2_outData)[c2_i169] = c2_y[c2_i169];
  }

  sf_mex_destroy(&c2_mxArrayInData);
}

static const mxArray *c2_c_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i170;
  int32_T c2_i171;
  int32_T c2_i172;
  real_T c2_b_inData[36];
  int32_T c2_i173;
  int32_T c2_i174;
  int32_T c2_i175;
  real_T c2_u[36];
  const mxArray *c2_y = NULL;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_i170 = 0;
  for (c2_i171 = 0; c2_i171 < 6; c2_i171++) {
    for (c2_i172 = 0; c2_i172 < 6; c2_i172++) {
      c2_b_inData[c2_i172 + c2_i170] = (*(real_T (*)[36])c2_inData)[c2_i172 +
        c2_i170];
    }

    c2_i170 += 6;
  }

  c2_i173 = 0;
  for (c2_i174 = 0; c2_i174 < 6; c2_i174++) {
    for (c2_i175 = 0; c2_i175 < 6; c2_i175++) {
      c2_u[c2_i175 + c2_i173] = c2_b_inData[c2_i175 + c2_i173];
    }

    c2_i173 += 6;
  }

  c2_y = NULL;
  if (!chartInstance->c2_pre_P_not_empty) {
    sf_mex_assign(&c2_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 2, 6, 6), FALSE);
  }

  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static void c2_e_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_b_pre_P, const char_T *c2_identifier, real_T
  c2_y[36])
{
  emlrtMsgIdentifier c2_thisId;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_b_pre_P), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_b_pre_P);
}

static void c2_f_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[36])
{
  real_T c2_dv10[36];
  int32_T c2_i176;
  if (mxIsEmpty(c2_u)) {
    chartInstance->c2_pre_P_not_empty = FALSE;
  } else {
    chartInstance->c2_pre_P_not_empty = TRUE;
    sf_mex_import(c2_parentId, sf_mex_dup(c2_u), c2_dv10, 1, 0, 0U, 1, 0U, 2, 6,
                  6);
    for (c2_i176 = 0; c2_i176 < 36; c2_i176++) {
      c2_y[c2_i176] = c2_dv10[c2_i176];
    }
  }

  sf_mex_destroy(&c2_u);
}

static void c2_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_b_pre_P;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y[36];
  int32_T c2_i177;
  int32_T c2_i178;
  int32_T c2_i179;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_b_pre_P = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_b_pre_P), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_b_pre_P);
  c2_i177 = 0;
  for (c2_i178 = 0; c2_i178 < 6; c2_i178++) {
    for (c2_i179 = 0; c2_i179 < 6; c2_i179++) {
      (*(real_T (*)[36])c2_outData)[c2_i179 + c2_i177] = c2_y[c2_i179 + c2_i177];
    }

    c2_i177 += 6;
  }

  sf_mex_destroy(&c2_mxArrayInData);
}

static const mxArray *c2_d_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i180;
  int32_T c2_i181;
  int32_T c2_i182;
  real_T c2_b_inData[12];
  int32_T c2_i183;
  int32_T c2_i184;
  int32_T c2_i185;
  real_T c2_u[12];
  const mxArray *c2_y = NULL;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_i180 = 0;
  for (c2_i181 = 0; c2_i181 < 2; c2_i181++) {
    for (c2_i182 = 0; c2_i182 < 6; c2_i182++) {
      c2_b_inData[c2_i182 + c2_i180] = (*(real_T (*)[12])c2_inData)[c2_i182 +
        c2_i180];
    }

    c2_i180 += 6;
  }

  c2_i183 = 0;
  for (c2_i184 = 0; c2_i184 < 2; c2_i184++) {
    for (c2_i185 = 0; c2_i185 < 6; c2_i185++) {
      c2_u[c2_i185 + c2_i183] = c2_b_inData[c2_i185 + c2_i183];
    }

    c2_i183 += 6;
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 2, 6, 2), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static void c2_g_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_K, const char_T *c2_identifier, real_T c2_y
  [12])
{
  emlrtMsgIdentifier c2_thisId;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_K), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_K);
}

static void c2_h_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[12])
{
  real_T c2_dv11[12];
  int32_T c2_i186;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), c2_dv11, 1, 0, 0U, 1, 0U, 2, 6, 2);
  for (c2_i186 = 0; c2_i186 < 12; c2_i186++) {
    c2_y[c2_i186] = c2_dv11[c2_i186];
  }

  sf_mex_destroy(&c2_u);
}

static void c2_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_K;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y[12];
  int32_T c2_i187;
  int32_T c2_i188;
  int32_T c2_i189;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_K = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_K), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_K);
  c2_i187 = 0;
  for (c2_i188 = 0; c2_i188 < 2; c2_i188++) {
    for (c2_i189 = 0; c2_i189 < 6; c2_i189++) {
      (*(real_T (*)[12])c2_outData)[c2_i189 + c2_i187] = c2_y[c2_i189 + c2_i187];
    }

    c2_i187 += 6;
  }

  sf_mex_destroy(&c2_mxArrayInData);
}

static const mxArray *c2_e_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i190;
  real_T c2_b_inData[6];
  int32_T c2_i191;
  real_T c2_u[6];
  const mxArray *c2_y = NULL;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  for (c2_i190 = 0; c2_i190 < 6; c2_i190++) {
    c2_b_inData[c2_i190] = (*(real_T (*)[6])c2_inData)[c2_i190];
  }

  for (c2_i191 = 0; c2_i191 < 6; c2_i191++) {
    c2_u[c2_i191] = c2_b_inData[c2_i191];
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static void c2_i_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_hat_x, const char_T *c2_identifier, real_T
  c2_y[6])
{
  emlrtMsgIdentifier c2_thisId;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_j_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_hat_x), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_hat_x);
}

static void c2_j_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[6])
{
  real_T c2_dv12[6];
  int32_T c2_i192;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), c2_dv12, 1, 0, 0U, 1, 0U, 1, 6);
  for (c2_i192 = 0; c2_i192 < 6; c2_i192++) {
    c2_y[c2_i192] = c2_dv12[c2_i192];
  }

  sf_mex_destroy(&c2_u);
}

static void c2_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_hat_x;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y[6];
  int32_T c2_i193;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_hat_x = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_j_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_hat_x), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_hat_x);
  for (c2_i193 = 0; c2_i193 < 6; c2_i193++) {
    (*(real_T (*)[6])c2_outData)[c2_i193] = c2_y[c2_i193];
  }

  sf_mex_destroy(&c2_mxArrayInData);
}

static const mxArray *c2_f_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  real_T c2_u;
  const mxArray *c2_y = NULL;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_u = *(real_T *)c2_inData;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", &c2_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static real_T c2_k_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  real_T c2_y;
  real_T c2_d4;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_d4, 1, 0, 0U, 0, 0U, 0);
  c2_y = c2_d4;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void c2_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_b_STM;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_b_STM = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_k_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_b_STM), &c2_thisId);
  sf_mex_destroy(&c2_b_STM);
  *(real_T *)c2_outData = c2_y;
  sf_mex_destroy(&c2_mxArrayInData);
}

static const mxArray *c2_g_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i194;
  int32_T c2_i195;
  int32_T c2_i196;
  real_T c2_b_inData[36];
  int32_T c2_i197;
  int32_T c2_i198;
  int32_T c2_i199;
  real_T c2_u[36];
  const mxArray *c2_y = NULL;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_i194 = 0;
  for (c2_i195 = 0; c2_i195 < 6; c2_i195++) {
    for (c2_i196 = 0; c2_i196 < 6; c2_i196++) {
      c2_b_inData[c2_i196 + c2_i194] = (*(real_T (*)[36])c2_inData)[c2_i196 +
        c2_i194];
    }

    c2_i194 += 6;
  }

  c2_i197 = 0;
  for (c2_i198 = 0; c2_i198 < 6; c2_i198++) {
    for (c2_i199 = 0; c2_i199 < 6; c2_i199++) {
      c2_u[c2_i199 + c2_i197] = c2_b_inData[c2_i199 + c2_i197];
    }

    c2_i197 += 6;
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 2, 6, 6), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static void c2_l_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[36])
{
  real_T c2_dv13[36];
  int32_T c2_i200;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), c2_dv13, 1, 0, 0U, 1, 0U, 2, 6, 6);
  for (c2_i200 = 0; c2_i200 < 36; c2_i200++) {
    c2_y[c2_i200] = c2_dv13[c2_i200];
  }

  sf_mex_destroy(&c2_u);
}

static void c2_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_b_disk_A_NED;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y[36];
  int32_T c2_i201;
  int32_T c2_i202;
  int32_T c2_i203;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_b_disk_A_NED = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_l_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_b_disk_A_NED), &c2_thisId,
                        c2_y);
  sf_mex_destroy(&c2_b_disk_A_NED);
  c2_i201 = 0;
  for (c2_i202 = 0; c2_i202 < 6; c2_i202++) {
    for (c2_i203 = 0; c2_i203 < 6; c2_i203++) {
      (*(real_T (*)[36])c2_outData)[c2_i203 + c2_i201] = c2_y[c2_i203 + c2_i201];
    }

    c2_i201 += 6;
  }

  sf_mex_destroy(&c2_mxArrayInData);
}

static const mxArray *c2_h_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i204;
  int32_T c2_i205;
  int32_T c2_i206;
  real_T c2_b_inData[4];
  int32_T c2_i207;
  int32_T c2_i208;
  int32_T c2_i209;
  real_T c2_u[4];
  const mxArray *c2_y = NULL;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_i204 = 0;
  for (c2_i205 = 0; c2_i205 < 2; c2_i205++) {
    for (c2_i206 = 0; c2_i206 < 2; c2_i206++) {
      c2_b_inData[c2_i206 + c2_i204] = (*(real_T (*)[4])c2_inData)[c2_i206 +
        c2_i204];
    }

    c2_i204 += 2;
  }

  c2_i207 = 0;
  for (c2_i208 = 0; c2_i208 < 2; c2_i208++) {
    for (c2_i209 = 0; c2_i209 < 2; c2_i209++) {
      c2_u[c2_i209 + c2_i207] = c2_b_inData[c2_i209 + c2_i207];
    }

    c2_i207 += 2;
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 2, 2, 2), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static void c2_m_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[4])
{
  real_T c2_dv14[4];
  int32_T c2_i210;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), c2_dv14, 1, 0, 0U, 1, 0U, 2, 2, 2);
  for (c2_i210 = 0; c2_i210 < 4; c2_i210++) {
    c2_y[c2_i210] = c2_dv14[c2_i210];
  }

  sf_mex_destroy(&c2_u);
}

static void c2_h_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_b_R_NED;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y[4];
  int32_T c2_i211;
  int32_T c2_i212;
  int32_T c2_i213;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_b_R_NED = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_m_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_b_R_NED), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_b_R_NED);
  c2_i211 = 0;
  for (c2_i212 = 0; c2_i212 < 2; c2_i212++) {
    for (c2_i213 = 0; c2_i213 < 2; c2_i213++) {
      (*(real_T (*)[4])c2_outData)[c2_i213 + c2_i211] = c2_y[c2_i213 + c2_i211];
    }

    c2_i211 += 2;
  }

  sf_mex_destroy(&c2_mxArrayInData);
}

static const mxArray *c2_i_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i214;
  int32_T c2_i215;
  int32_T c2_i216;
  real_T c2_b_inData[12];
  int32_T c2_i217;
  int32_T c2_i218;
  int32_T c2_i219;
  real_T c2_u[12];
  const mxArray *c2_y = NULL;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_i214 = 0;
  for (c2_i215 = 0; c2_i215 < 6; c2_i215++) {
    for (c2_i216 = 0; c2_i216 < 2; c2_i216++) {
      c2_b_inData[c2_i216 + c2_i214] = (*(real_T (*)[12])c2_inData)[c2_i216 +
        c2_i214];
    }

    c2_i214 += 2;
  }

  c2_i217 = 0;
  for (c2_i218 = 0; c2_i218 < 6; c2_i218++) {
    for (c2_i219 = 0; c2_i219 < 2; c2_i219++) {
      c2_u[c2_i219 + c2_i217] = c2_b_inData[c2_i219 + c2_i217];
    }

    c2_i217 += 2;
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 2, 2, 6), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static void c2_n_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[12])
{
  real_T c2_dv15[12];
  int32_T c2_i220;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), c2_dv15, 1, 0, 0U, 1, 0U, 2, 2, 6);
  for (c2_i220 = 0; c2_i220 < 12; c2_i220++) {
    c2_y[c2_i220] = c2_dv15[c2_i220];
  }

  sf_mex_destroy(&c2_u);
}

static void c2_i_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_b_H_NED;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y[12];
  int32_T c2_i221;
  int32_T c2_i222;
  int32_T c2_i223;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_b_H_NED = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_n_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_b_H_NED), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_b_H_NED);
  c2_i221 = 0;
  for (c2_i222 = 0; c2_i222 < 6; c2_i222++) {
    for (c2_i223 = 0; c2_i223 < 2; c2_i223++) {
      (*(real_T (*)[12])c2_outData)[c2_i223 + c2_i221] = c2_y[c2_i223 + c2_i221];
    }

    c2_i221 += 2;
  }

  sf_mex_destroy(&c2_mxArrayInData);
}

static const mxArray *c2_j_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i224;
  real_T c2_b_inData[2];
  int32_T c2_i225;
  real_T c2_u[2];
  const mxArray *c2_y = NULL;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  for (c2_i224 = 0; c2_i224 < 2; c2_i224++) {
    c2_b_inData[c2_i224] = (*(real_T (*)[2])c2_inData)[c2_i224];
  }

  for (c2_i225 = 0; c2_i225 < 2; c2_i225++) {
    c2_u[c2_i225] = c2_b_inData[c2_i225];
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 1, 2), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

const mxArray *sf_c2_objectTrackingFilter_get_eml_resolved_functions_info(void)
{
  const mxArray *c2_nameCaptureInfo;
  c2_ResolvedFunctionInfo c2_info[48];
  const mxArray *c2_m0 = NULL;
  int32_T c2_i226;
  c2_ResolvedFunctionInfo *c2_r0;
  c2_nameCaptureInfo = NULL;
  c2_nameCaptureInfo = NULL;
  c2_info_helper(c2_info);
  sf_mex_assign(&c2_m0, sf_mex_createstruct("nameCaptureInfo", 1, 48), FALSE);
  for (c2_i226 = 0; c2_i226 < 48; c2_i226++) {
    c2_r0 = &c2_info[c2_i226];
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c2_r0->context)), "context", "nameCaptureInfo",
                    c2_i226);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c2_r0->name)), "name", "nameCaptureInfo", c2_i226);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c2_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c2_i226);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c2_r0->resolved)), "resolved", "nameCaptureInfo",
                    c2_i226);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c2_i226);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c2_i226);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c2_i226);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c2_i226);
  }

  sf_mex_assign(&c2_nameCaptureInfo, c2_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c2_nameCaptureInfo);
  return c2_nameCaptureInfo;
}

static void c2_info_helper(c2_ResolvedFunctionInfo c2_info[48])
{
  c2_info[0].context = "";
  c2_info[0].name = "rdivide";
  c2_info[0].dominantType = "double";
  c2_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c2_info[0].fileTimeLo = 1286818844U;
  c2_info[0].fileTimeHi = 0U;
  c2_info[0].mFileTimeLo = 0U;
  c2_info[0].mFileTimeHi = 0U;
  c2_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c2_info[1].name = "eml_div";
  c2_info[1].dominantType = "double";
  c2_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c2_info[1].fileTimeLo = 1313347810U;
  c2_info[1].fileTimeHi = 0U;
  c2_info[1].mFileTimeLo = 0U;
  c2_info[1].mFileTimeHi = 0U;
  c2_info[2].context = "";
  c2_info[2].name = "mtimes";
  c2_info[2].dominantType = "double";
  c2_info[2].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[2].fileTimeLo = 1289519692U;
  c2_info[2].fileTimeHi = 0U;
  c2_info[2].mFileTimeLo = 0U;
  c2_info[2].mFileTimeHi = 0U;
  c2_info[3].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[3].name = "eml_index_class";
  c2_info[3].dominantType = "";
  c2_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c2_info[3].fileTimeLo = 1323170578U;
  c2_info[3].fileTimeHi = 0U;
  c2_info[3].mFileTimeLo = 0U;
  c2_info[3].mFileTimeHi = 0U;
  c2_info[4].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[4].name = "eml_scalar_eg";
  c2_info[4].dominantType = "double";
  c2_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c2_info[4].fileTimeLo = 1286818796U;
  c2_info[4].fileTimeHi = 0U;
  c2_info[4].mFileTimeLo = 0U;
  c2_info[4].mFileTimeHi = 0U;
  c2_info[5].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[5].name = "eml_xgemm";
  c2_info[5].dominantType = "char";
  c2_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c2_info[5].fileTimeLo = 1299076772U;
  c2_info[5].fileTimeHi = 0U;
  c2_info[5].mFileTimeLo = 0U;
  c2_info[5].mFileTimeHi = 0U;
  c2_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c2_info[6].name = "eml_blas_inline";
  c2_info[6].dominantType = "";
  c2_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c2_info[6].fileTimeLo = 1299076768U;
  c2_info[6].fileTimeHi = 0U;
  c2_info[6].mFileTimeLo = 0U;
  c2_info[6].mFileTimeHi = 0U;
  c2_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m!below_threshold";
  c2_info[7].name = "mtimes";
  c2_info[7].dominantType = "double";
  c2_info[7].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[7].fileTimeLo = 1289519692U;
  c2_info[7].fileTimeHi = 0U;
  c2_info[7].mFileTimeLo = 0U;
  c2_info[7].mFileTimeHi = 0U;
  c2_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c2_info[8].name = "eml_index_class";
  c2_info[8].dominantType = "";
  c2_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c2_info[8].fileTimeLo = 1323170578U;
  c2_info[8].fileTimeHi = 0U;
  c2_info[8].mFileTimeLo = 0U;
  c2_info[8].mFileTimeHi = 0U;
  c2_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c2_info[9].name = "eml_scalar_eg";
  c2_info[9].dominantType = "double";
  c2_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c2_info[9].fileTimeLo = 1286818796U;
  c2_info[9].fileTimeHi = 0U;
  c2_info[9].mFileTimeLo = 0U;
  c2_info[9].mFileTimeHi = 0U;
  c2_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c2_info[10].name = "eml_refblas_xgemm";
  c2_info[10].dominantType = "char";
  c2_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c2_info[10].fileTimeLo = 1299076774U;
  c2_info[10].fileTimeHi = 0U;
  c2_info[10].mFileTimeLo = 0U;
  c2_info[10].mFileTimeHi = 0U;
  c2_info[11].context = "";
  c2_info[11].name = "inv";
  c2_info[11].dominantType = "double";
  c2_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/inv.m";
  c2_info[11].fileTimeLo = 1305318000U;
  c2_info[11].fileTimeHi = 0U;
  c2_info[11].mFileTimeLo = 0U;
  c2_info[11].mFileTimeHi = 0U;
  c2_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/inv.m!inv2x2";
  c2_info[12].name = "eml_xcabs1";
  c2_info[12].dominantType = "double";
  c2_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xcabs1.m";
  c2_info[12].fileTimeLo = 1286818706U;
  c2_info[12].fileTimeHi = 0U;
  c2_info[12].mFileTimeLo = 0U;
  c2_info[12].mFileTimeHi = 0U;
  c2_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xcabs1.m";
  c2_info[13].name = "abs";
  c2_info[13].dominantType = "double";
  c2_info[13].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c2_info[13].fileTimeLo = 1286818694U;
  c2_info[13].fileTimeHi = 0U;
  c2_info[13].mFileTimeLo = 0U;
  c2_info[13].mFileTimeHi = 0U;
  c2_info[14].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c2_info[14].name = "eml_scalar_abs";
  c2_info[14].dominantType = "double";
  c2_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c2_info[14].fileTimeLo = 1286818712U;
  c2_info[14].fileTimeHi = 0U;
  c2_info[14].mFileTimeLo = 0U;
  c2_info[14].mFileTimeHi = 0U;
  c2_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/inv.m!inv2x2";
  c2_info[15].name = "mrdivide";
  c2_info[15].dominantType = "double";
  c2_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c2_info[15].fileTimeLo = 1342810944U;
  c2_info[15].fileTimeHi = 0U;
  c2_info[15].mFileTimeLo = 1319729966U;
  c2_info[15].mFileTimeHi = 0U;
  c2_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c2_info[16].name = "rdivide";
  c2_info[16].dominantType = "double";
  c2_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c2_info[16].fileTimeLo = 1286818844U;
  c2_info[16].fileTimeHi = 0U;
  c2_info[16].mFileTimeLo = 0U;
  c2_info[16].mFileTimeHi = 0U;
  c2_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/inv.m!inv2x2";
  c2_info[17].name = "mtimes";
  c2_info[17].dominantType = "double";
  c2_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[17].fileTimeLo = 1289519692U;
  c2_info[17].fileTimeHi = 0U;
  c2_info[17].mFileTimeLo = 0U;
  c2_info[17].mFileTimeHi = 0U;
  c2_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/inv.m!checkcond";
  c2_info[18].name = "norm";
  c2_info[18].dominantType = "double";
  c2_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m";
  c2_info[18].fileTimeLo = 1336522094U;
  c2_info[18].fileTimeHi = 0U;
  c2_info[18].mFileTimeLo = 0U;
  c2_info[18].mFileTimeHi = 0U;
  c2_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!mat1norm";
  c2_info[19].name = "abs";
  c2_info[19].dominantType = "double";
  c2_info[19].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c2_info[19].fileTimeLo = 1286818694U;
  c2_info[19].fileTimeHi = 0U;
  c2_info[19].mFileTimeLo = 0U;
  c2_info[19].mFileTimeHi = 0U;
  c2_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!mat1norm";
  c2_info[20].name = "isnan";
  c2_info[20].dominantType = "double";
  c2_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isnan.m";
  c2_info[20].fileTimeLo = 1286818760U;
  c2_info[20].fileTimeHi = 0U;
  c2_info[20].mFileTimeLo = 0U;
  c2_info[20].mFileTimeHi = 0U;
  c2_info[21].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!mat1norm";
  c2_info[21].name = "eml_guarded_nan";
  c2_info[21].dominantType = "char";
  c2_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_guarded_nan.m";
  c2_info[21].fileTimeLo = 1286818776U;
  c2_info[21].fileTimeHi = 0U;
  c2_info[21].mFileTimeLo = 0U;
  c2_info[21].mFileTimeHi = 0U;
  c2_info[22].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_guarded_nan.m";
  c2_info[22].name = "eml_is_float_class";
  c2_info[22].dominantType = "char";
  c2_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c2_info[22].fileTimeLo = 1286818782U;
  c2_info[22].fileTimeHi = 0U;
  c2_info[22].mFileTimeLo = 0U;
  c2_info[22].mFileTimeHi = 0U;
  c2_info[23].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/inv.m!checkcond";
  c2_info[23].name = "mtimes";
  c2_info[23].dominantType = "double";
  c2_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[23].fileTimeLo = 1289519692U;
  c2_info[23].fileTimeHi = 0U;
  c2_info[23].mFileTimeLo = 0U;
  c2_info[23].mFileTimeHi = 0U;
  c2_info[24].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/inv.m!checkcond";
  c2_info[24].name = "eml_warning";
  c2_info[24].dominantType = "char";
  c2_info[24].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_warning.m";
  c2_info[24].fileTimeLo = 1286818802U;
  c2_info[24].fileTimeHi = 0U;
  c2_info[24].mFileTimeLo = 0U;
  c2_info[24].mFileTimeHi = 0U;
  c2_info[25].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/inv.m!checkcond";
  c2_info[25].name = "isnan";
  c2_info[25].dominantType = "double";
  c2_info[25].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isnan.m";
  c2_info[25].fileTimeLo = 1286818760U;
  c2_info[25].fileTimeHi = 0U;
  c2_info[25].mFileTimeLo = 0U;
  c2_info[25].mFileTimeHi = 0U;
  c2_info[26].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/inv.m!checkcond";
  c2_info[26].name = "eps";
  c2_info[26].dominantType = "char";
  c2_info[26].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c2_info[26].fileTimeLo = 1326727996U;
  c2_info[26].fileTimeHi = 0U;
  c2_info[26].mFileTimeLo = 0U;
  c2_info[26].mFileTimeHi = 0U;
  c2_info[27].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c2_info[27].name = "eml_is_float_class";
  c2_info[27].dominantType = "char";
  c2_info[27].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c2_info[27].fileTimeLo = 1286818782U;
  c2_info[27].fileTimeHi = 0U;
  c2_info[27].mFileTimeLo = 0U;
  c2_info[27].mFileTimeHi = 0U;
  c2_info[28].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c2_info[28].name = "eml_eps";
  c2_info[28].dominantType = "char";
  c2_info[28].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_eps.m";
  c2_info[28].fileTimeLo = 1326727996U;
  c2_info[28].fileTimeHi = 0U;
  c2_info[28].mFileTimeLo = 0U;
  c2_info[28].mFileTimeHi = 0U;
  c2_info[29].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_eps.m";
  c2_info[29].name = "eml_float_model";
  c2_info[29].dominantType = "char";
  c2_info[29].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_float_model.m";
  c2_info[29].fileTimeLo = 1326727996U;
  c2_info[29].fileTimeHi = 0U;
  c2_info[29].mFileTimeLo = 0U;
  c2_info[29].mFileTimeHi = 0U;
  c2_info[30].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/inv.m!checkcond";
  c2_info[30].name = "eml_flt2str";
  c2_info[30].dominantType = "double";
  c2_info[30].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_flt2str.m";
  c2_info[30].fileTimeLo = 1309451196U;
  c2_info[30].fileTimeHi = 0U;
  c2_info[30].mFileTimeLo = 0U;
  c2_info[30].mFileTimeHi = 0U;
  c2_info[31].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_flt2str.m";
  c2_info[31].name = "char";
  c2_info[31].dominantType = "double";
  c2_info[31].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/strfun/char.m";
  c2_info[31].fileTimeLo = 1319729968U;
  c2_info[31].fileTimeHi = 0U;
  c2_info[31].mFileTimeLo = 0U;
  c2_info[31].mFileTimeHi = 0U;
  c2_info[32].context = "";
  c2_info[32].name = "eye";
  c2_info[32].dominantType = "double";
  c2_info[32].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m";
  c2_info[32].fileTimeLo = 1286818688U;
  c2_info[32].fileTimeHi = 0U;
  c2_info[32].mFileTimeLo = 0U;
  c2_info[32].mFileTimeHi = 0U;
  c2_info[33].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c2_info[33].name = "eml_assert_valid_size_arg";
  c2_info[33].dominantType = "double";
  c2_info[33].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c2_info[33].fileTimeLo = 1286818694U;
  c2_info[33].fileTimeHi = 0U;
  c2_info[33].mFileTimeLo = 0U;
  c2_info[33].mFileTimeHi = 0U;
  c2_info[34].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m!isintegral";
  c2_info[34].name = "isinf";
  c2_info[34].dominantType = "double";
  c2_info[34].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isinf.m";
  c2_info[34].fileTimeLo = 1286818760U;
  c2_info[34].fileTimeHi = 0U;
  c2_info[34].mFileTimeLo = 0U;
  c2_info[34].mFileTimeHi = 0U;
  c2_info[35].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m!numel_for_size";
  c2_info[35].name = "mtimes";
  c2_info[35].dominantType = "double";
  c2_info[35].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[35].fileTimeLo = 1289519692U;
  c2_info[35].fileTimeHi = 0U;
  c2_info[35].mFileTimeLo = 0U;
  c2_info[35].mFileTimeHi = 0U;
  c2_info[36].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c2_info[36].name = "eml_index_class";
  c2_info[36].dominantType = "";
  c2_info[36].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c2_info[36].fileTimeLo = 1323170578U;
  c2_info[36].fileTimeHi = 0U;
  c2_info[36].mFileTimeLo = 0U;
  c2_info[36].mFileTimeHi = 0U;
  c2_info[37].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c2_info[37].name = "intmax";
  c2_info[37].dominantType = "char";
  c2_info[37].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c2_info[37].fileTimeLo = 1311255316U;
  c2_info[37].fileTimeHi = 0U;
  c2_info[37].mFileTimeLo = 0U;
  c2_info[37].mFileTimeHi = 0U;
  c2_info[38].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c2_info[38].name = "eml_is_float_class";
  c2_info[38].dominantType = "char";
  c2_info[38].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c2_info[38].fileTimeLo = 1286818782U;
  c2_info[38].fileTimeHi = 0U;
  c2_info[38].mFileTimeLo = 0U;
  c2_info[38].mFileTimeHi = 0U;
  c2_info[39].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c2_info[39].name = "min";
  c2_info[39].dominantType = "double";
  c2_info[39].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c2_info[39].fileTimeLo = 1311255318U;
  c2_info[39].fileTimeHi = 0U;
  c2_info[39].mFileTimeLo = 0U;
  c2_info[39].mFileTimeHi = 0U;
  c2_info[40].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c2_info[40].name = "eml_min_or_max";
  c2_info[40].dominantType = "char";
  c2_info[40].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m";
  c2_info[40].fileTimeLo = 1334071490U;
  c2_info[40].fileTimeHi = 0U;
  c2_info[40].mFileTimeLo = 0U;
  c2_info[40].mFileTimeHi = 0U;
  c2_info[41].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c2_info[41].name = "eml_scalar_eg";
  c2_info[41].dominantType = "double";
  c2_info[41].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c2_info[41].fileTimeLo = 1286818796U;
  c2_info[41].fileTimeHi = 0U;
  c2_info[41].mFileTimeLo = 0U;
  c2_info[41].mFileTimeHi = 0U;
  c2_info[42].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c2_info[42].name = "eml_scalexp_alloc";
  c2_info[42].dominantType = "double";
  c2_info[42].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c2_info[42].fileTimeLo = 1330608434U;
  c2_info[42].fileTimeHi = 0U;
  c2_info[42].mFileTimeLo = 0U;
  c2_info[42].mFileTimeHi = 0U;
  c2_info[43].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c2_info[43].name = "eml_index_class";
  c2_info[43].dominantType = "";
  c2_info[43].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c2_info[43].fileTimeLo = 1323170578U;
  c2_info[43].fileTimeHi = 0U;
  c2_info[43].mFileTimeLo = 0U;
  c2_info[43].mFileTimeHi = 0U;
  c2_info[44].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_scalar_bin_extremum";
  c2_info[44].name = "eml_scalar_eg";
  c2_info[44].dominantType = "double";
  c2_info[44].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c2_info[44].fileTimeLo = 1286818796U;
  c2_info[44].fileTimeHi = 0U;
  c2_info[44].mFileTimeLo = 0U;
  c2_info[44].mFileTimeHi = 0U;
  c2_info[45].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c2_info[45].name = "eml_index_class";
  c2_info[45].dominantType = "";
  c2_info[45].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c2_info[45].fileTimeLo = 1323170578U;
  c2_info[45].fileTimeHi = 0U;
  c2_info[45].mFileTimeLo = 0U;
  c2_info[45].mFileTimeHi = 0U;
  c2_info[46].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c2_info[46].name = "eml_int_forloop_overflow_check";
  c2_info[46].dominantType = "";
  c2_info[46].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c2_info[46].fileTimeLo = 1332168672U;
  c2_info[46].fileTimeHi = 0U;
  c2_info[46].mFileTimeLo = 0U;
  c2_info[46].mFileTimeHi = 0U;
  c2_info[47].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m!eml_int_forloop_overflow_check_helper";
  c2_info[47].name = "intmax";
  c2_info[47].dominantType = "char";
  c2_info[47].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c2_info[47].fileTimeLo = 1311255316U;
  c2_info[47].fileTimeHi = 0U;
  c2_info[47].mFileTimeLo = 0U;
  c2_info[47].mFileTimeHi = 0U;
}

static void c2_rdivide(SFc2_objectTrackingFilterInstanceStruct *chartInstance,
  real_T c2_x[4], real_T c2_y, real_T c2_z[4])
{
  real_T c2_b_y;
  int32_T c2_i227;
  c2_b_y = c2_y;
  for (c2_i227 = 0; c2_i227 < 4; c2_i227++) {
    c2_z[c2_i227] = c2_x[c2_i227] / c2_b_y;
  }
}

static void c2_eml_scalar_eg(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance)
{
}

static void c2_b_eml_scalar_eg(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance)
{
}

static void c2_c_eml_scalar_eg(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance)
{
}

static void c2_inv(SFc2_objectTrackingFilterInstanceStruct *chartInstance,
                   real_T c2_x[4], real_T c2_y[4])
{
  real_T c2_b_x;
  real_T c2_c_x;
  real_T c2_d_x;
  real_T c2_b_y;
  real_T c2_e_x;
  real_T c2_f_x;
  real_T c2_c_y;
  real_T c2_d;
  real_T c2_g_x;
  real_T c2_h_x;
  real_T c2_i_x;
  real_T c2_d_y;
  real_T c2_j_x;
  real_T c2_k_x;
  real_T c2_e_y;
  real_T c2_b_d;
  real_T c2_A;
  real_T c2_B;
  real_T c2_l_x;
  real_T c2_f_y;
  real_T c2_m_x;
  real_T c2_g_y;
  real_T c2_r;
  real_T c2_a;
  real_T c2_b;
  real_T c2_h_y;
  real_T c2_b_B;
  real_T c2_i_y;
  real_T c2_j_y;
  real_T c2_t;
  real_T c2_b_A;
  real_T c2_c_B;
  real_T c2_n_x;
  real_T c2_k_y;
  real_T c2_o_x;
  real_T c2_l_y;
  real_T c2_m_y;
  real_T c2_b_a;
  real_T c2_b_b;
  real_T c2_n_y;
  real_T c2_c_A;
  real_T c2_d_B;
  real_T c2_p_x;
  real_T c2_o_y;
  real_T c2_q_x;
  real_T c2_p_y;
  real_T c2_q_y;
  real_T c2_c_a;
  real_T c2_c_b;
  real_T c2_r_y;
  real_T c2_d_a;
  real_T c2_d_b;
  real_T c2_s_y;
  real_T c2_d_A;
  real_T c2_e_B;
  real_T c2_r_x;
  real_T c2_t_y;
  real_T c2_s_x;
  real_T c2_u_y;
  real_T c2_e_a;
  real_T c2_e_b;
  real_T c2_v_y;
  real_T c2_f_B;
  real_T c2_w_y;
  real_T c2_x_y;
  real_T c2_e_A;
  real_T c2_g_B;
  real_T c2_t_x;
  real_T c2_y_y;
  real_T c2_u_x;
  real_T c2_ab_y;
  real_T c2_bb_y;
  real_T c2_f_a;
  real_T c2_f_b;
  real_T c2_cb_y;
  real_T c2_g_a;
  real_T c2_g_b;
  real_T c2_db_y;
  real_T c2_f_A;
  real_T c2_h_B;
  real_T c2_v_x;
  real_T c2_eb_y;
  real_T c2_w_x;
  real_T c2_fb_y;
  real_T c2_gb_y;
  real_T c2_h_a;
  real_T c2_h_b;
  real_T c2_hb_y;
  int32_T c2_i228;
  real_T c2_x_x[4];
  real_T c2_n1x;
  int32_T c2_i229;
  real_T c2_ib_y[4];
  real_T c2_n1xinv;
  real_T c2_i_a;
  real_T c2_i_b;
  real_T c2_jb_y;
  real_T c2_rc;
  real_T c2_y_x;
  boolean_T c2_j_b;
  real_T c2_ab_x;
  int32_T c2_i230;
  static char_T c2_cv0[8] = { '%', '%', '%', 'd', '.', '%', 'd', 'e' };

  char_T c2_u[8];
  const mxArray *c2_kb_y = NULL;
  real_T c2_b_u;
  const mxArray *c2_lb_y = NULL;
  real_T c2_c_u;
  const mxArray *c2_mb_y = NULL;
  real_T c2_d_u;
  const mxArray *c2_nb_y = NULL;
  char_T c2_str[14];
  int32_T c2_i231;
  char_T c2_b_str[14];
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  c2_b_x = c2_x[1];
  c2_c_x = c2_b_x;
  c2_d_x = c2_c_x;
  c2_b_y = muDoubleScalarAbs(c2_d_x);
  c2_e_x = 0.0;
  c2_f_x = c2_e_x;
  c2_c_y = muDoubleScalarAbs(c2_f_x);
  c2_d = c2_b_y + c2_c_y;
  c2_g_x = c2_x[0];
  c2_h_x = c2_g_x;
  c2_i_x = c2_h_x;
  c2_d_y = muDoubleScalarAbs(c2_i_x);
  c2_j_x = 0.0;
  c2_k_x = c2_j_x;
  c2_e_y = muDoubleScalarAbs(c2_k_x);
  c2_b_d = c2_d_y + c2_e_y;
  if (c2_d > c2_b_d) {
    c2_A = c2_x[0];
    c2_B = c2_x[1];
    c2_l_x = c2_A;
    c2_f_y = c2_B;
    c2_m_x = c2_l_x;
    c2_g_y = c2_f_y;
    c2_r = c2_m_x / c2_g_y;
    c2_a = c2_r;
    c2_b = c2_x[3];
    c2_h_y = c2_a * c2_b;
    c2_b_B = c2_h_y - c2_x[2];
    c2_i_y = c2_b_B;
    c2_j_y = c2_i_y;
    c2_t = 1.0 / c2_j_y;
    c2_b_A = c2_x[3];
    c2_c_B = c2_x[1];
    c2_n_x = c2_b_A;
    c2_k_y = c2_c_B;
    c2_o_x = c2_n_x;
    c2_l_y = c2_k_y;
    c2_m_y = c2_o_x / c2_l_y;
    c2_b_a = c2_m_y;
    c2_b_b = c2_t;
    c2_n_y = c2_b_a * c2_b_b;
    c2_y[0] = c2_n_y;
    c2_y[1] = -c2_t;
    c2_c_A = -c2_x[2];
    c2_d_B = c2_x[1];
    c2_p_x = c2_c_A;
    c2_o_y = c2_d_B;
    c2_q_x = c2_p_x;
    c2_p_y = c2_o_y;
    c2_q_y = c2_q_x / c2_p_y;
    c2_c_a = c2_q_y;
    c2_c_b = c2_t;
    c2_r_y = c2_c_a * c2_c_b;
    c2_y[2] = c2_r_y;
    c2_d_a = c2_r;
    c2_d_b = c2_t;
    c2_s_y = c2_d_a * c2_d_b;
    c2_y[3] = c2_s_y;
  } else {
    c2_d_A = c2_x[1];
    c2_e_B = c2_x[0];
    c2_r_x = c2_d_A;
    c2_t_y = c2_e_B;
    c2_s_x = c2_r_x;
    c2_u_y = c2_t_y;
    c2_r = c2_s_x / c2_u_y;
    c2_e_a = c2_r;
    c2_e_b = c2_x[2];
    c2_v_y = c2_e_a * c2_e_b;
    c2_f_B = c2_x[3] - c2_v_y;
    c2_w_y = c2_f_B;
    c2_x_y = c2_w_y;
    c2_t = 1.0 / c2_x_y;
    c2_e_A = c2_x[3];
    c2_g_B = c2_x[0];
    c2_t_x = c2_e_A;
    c2_y_y = c2_g_B;
    c2_u_x = c2_t_x;
    c2_ab_y = c2_y_y;
    c2_bb_y = c2_u_x / c2_ab_y;
    c2_f_a = c2_bb_y;
    c2_f_b = c2_t;
    c2_cb_y = c2_f_a * c2_f_b;
    c2_y[0] = c2_cb_y;
    c2_g_a = -c2_r;
    c2_g_b = c2_t;
    c2_db_y = c2_g_a * c2_g_b;
    c2_y[1] = c2_db_y;
    c2_f_A = -c2_x[2];
    c2_h_B = c2_x[0];
    c2_v_x = c2_f_A;
    c2_eb_y = c2_h_B;
    c2_w_x = c2_v_x;
    c2_fb_y = c2_eb_y;
    c2_gb_y = c2_w_x / c2_fb_y;
    c2_h_a = c2_gb_y;
    c2_h_b = c2_t;
    c2_hb_y = c2_h_a * c2_h_b;
    c2_y[2] = c2_hb_y;
    c2_y[3] = c2_t;
  }

  for (c2_i228 = 0; c2_i228 < 4; c2_i228++) {
    c2_x_x[c2_i228] = c2_x[c2_i228];
  }

  c2_n1x = c2_norm(chartInstance, c2_x_x);
  for (c2_i229 = 0; c2_i229 < 4; c2_i229++) {
    c2_ib_y[c2_i229] = c2_y[c2_i229];
  }

  c2_n1xinv = c2_norm(chartInstance, c2_ib_y);
  c2_i_a = c2_n1x;
  c2_i_b = c2_n1xinv;
  c2_jb_y = c2_i_a * c2_i_b;
  c2_rc = 1.0 / c2_jb_y;
  guard1 = FALSE;
  guard2 = FALSE;
  if (c2_n1x == 0.0) {
    guard2 = TRUE;
  } else if (c2_n1xinv == 0.0) {
    guard2 = TRUE;
  } else if (c2_rc == 0.0) {
    guard1 = TRUE;
  } else {
    c2_y_x = c2_rc;
    c2_j_b = muDoubleScalarIsNaN(c2_y_x);
    guard3 = FALSE;
    if (c2_j_b) {
      guard3 = TRUE;
    } else {
      if (c2_rc < 2.2204460492503131E-16) {
        guard3 = TRUE;
      }
    }

    if (guard3 == TRUE) {
      c2_ab_x = c2_rc;
      for (c2_i230 = 0; c2_i230 < 8; c2_i230++) {
        c2_u[c2_i230] = c2_cv0[c2_i230];
      }

      c2_kb_y = NULL;
      sf_mex_assign(&c2_kb_y, sf_mex_create("y", c2_u, 10, 0U, 1U, 0U, 2, 1, 8),
                    FALSE);
      c2_b_u = 14.0;
      c2_lb_y = NULL;
      sf_mex_assign(&c2_lb_y, sf_mex_create("y", &c2_b_u, 0, 0U, 0U, 0U, 0),
                    FALSE);
      c2_c_u = 6.0;
      c2_mb_y = NULL;
      sf_mex_assign(&c2_mb_y, sf_mex_create("y", &c2_c_u, 0, 0U, 0U, 0U, 0),
                    FALSE);
      c2_d_u = c2_ab_x;
      c2_nb_y = NULL;
      sf_mex_assign(&c2_nb_y, sf_mex_create("y", &c2_d_u, 0, 0U, 0U, 0U, 0),
                    FALSE);
      c2_o_emlrt_marshallIn(chartInstance, sf_mex_call_debug("sprintf", 1U, 2U,
        14, sf_mex_call_debug("sprintf", 1U, 3U, 14, c2_kb_y, 14, c2_lb_y, 14,
        c2_mb_y), 14, c2_nb_y), "sprintf", c2_str);
      for (c2_i231 = 0; c2_i231 < 14; c2_i231++) {
        c2_b_str[c2_i231] = c2_str[c2_i231];
      }

      c2_b_eml_warning(chartInstance, c2_b_str);
    }
  }

  if (guard2 == TRUE) {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    c2_eml_warning(chartInstance);
  }
}

static real_T c2_norm(SFc2_objectTrackingFilterInstanceStruct *chartInstance,
                      real_T c2_x[4])
{
  real_T c2_y;
  int32_T c2_j;
  real_T c2_b_j;
  real_T c2_s;
  int32_T c2_i;
  real_T c2_b_i;
  real_T c2_b_x;
  real_T c2_c_x;
  real_T c2_b_y;
  real_T c2_d_x;
  boolean_T c2_b;
  boolean_T exitg1;
  c2_y = 0.0;
  c2_j = 0;
  exitg1 = FALSE;
  while ((exitg1 == FALSE) && (c2_j < 2)) {
    c2_b_j = 1.0 + (real_T)c2_j;
    c2_s = 0.0;
    for (c2_i = 0; c2_i < 2; c2_i++) {
      c2_b_i = 1.0 + (real_T)c2_i;
      c2_b_x = c2_x[(_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK
                      ("", c2_b_i), 1, 2, 1, 0) + ((_SFD_EML_ARRAY_BOUNDS_CHECK(
        "", (int32_T)_SFD_INTEGER_CHECK("", c2_b_j), 1, 2, 2, 0) - 1) << 1)) - 1];
      c2_c_x = c2_b_x;
      c2_b_y = muDoubleScalarAbs(c2_c_x);
      c2_s += c2_b_y;
    }

    c2_d_x = c2_s;
    c2_b = muDoubleScalarIsNaN(c2_d_x);
    if (c2_b) {
      c2_y = rtNaN;
      exitg1 = TRUE;
    } else {
      if (c2_s > c2_y) {
        c2_y = c2_s;
      }

      c2_j++;
    }
  }

  return c2_y;
}

static void c2_eml_warning(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance)
{
  int32_T c2_i232;
  static char_T c2_varargin_1[27] = { 'C', 'o', 'd', 'e', 'r', ':', 'M', 'A',
    'T', 'L', 'A', 'B', ':', 's', 'i', 'n', 'g', 'u', 'l', 'a', 'r', 'M', 'a',
    't', 'r', 'i', 'x' };

  char_T c2_u[27];
  const mxArray *c2_y = NULL;
  for (c2_i232 = 0; c2_i232 < 27; c2_i232++) {
    c2_u[c2_i232] = c2_varargin_1[c2_i232];
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 10, 0U, 1U, 0U, 2, 1, 27), FALSE);
  sf_mex_call_debug("warning", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U,
    14, c2_y));
}

static void c2_b_eml_warning(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, char_T c2_varargin_2[14])
{
  int32_T c2_i233;
  static char_T c2_varargin_1[33] = { 'C', 'o', 'd', 'e', 'r', ':', 'M', 'A',
    'T', 'L', 'A', 'B', ':', 'i', 'l', 'l', 'C', 'o', 'n', 'd', 'i', 't', 'i',
    'o', 'n', 'e', 'd', 'M', 'a', 't', 'r', 'i', 'x' };

  char_T c2_u[33];
  const mxArray *c2_y = NULL;
  int32_T c2_i234;
  char_T c2_b_u[14];
  const mxArray *c2_b_y = NULL;
  for (c2_i233 = 0; c2_i233 < 33; c2_i233++) {
    c2_u[c2_i233] = c2_varargin_1[c2_i233];
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 10, 0U, 1U, 0U, 2, 1, 33), FALSE);
  for (c2_i234 = 0; c2_i234 < 14; c2_i234++) {
    c2_b_u[c2_i234] = c2_varargin_2[c2_i234];
  }

  c2_b_y = NULL;
  sf_mex_assign(&c2_b_y, sf_mex_create("y", c2_b_u, 10, 0U, 1U, 0U, 2, 1, 14),
                FALSE);
  sf_mex_call_debug("warning", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 2U,
    14, c2_y, 14, c2_b_y));
}

static void c2_d_eml_scalar_eg(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance)
{
}

static void c2_e_eml_scalar_eg(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance)
{
}

static void c2_f_eml_scalar_eg(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance)
{
}

static void c2_eye(SFc2_objectTrackingFilterInstanceStruct *chartInstance,
                   real_T c2_I[36])
{
  int32_T c2_i235;
  int32_T c2_i;
  int32_T c2_b_i;
  for (c2_i235 = 0; c2_i235 < 36; c2_i235++) {
    c2_I[c2_i235] = 0.0;
  }

  c2_check_forloop_overflow_error(chartInstance);
  for (c2_i = 1; c2_i < 7; c2_i++) {
    c2_b_i = c2_i;
    c2_I[(_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
            (real_T)c2_b_i), 1, 6, 1, 0) + 6 * (_SFD_EML_ARRAY_BOUNDS_CHECK("",
            (int32_T)_SFD_INTEGER_CHECK("", (real_T)c2_b_i), 1, 6, 2, 0) - 1)) -
      1] = 1.0;
  }
}

static void c2_check_forloop_overflow_error
  (SFc2_objectTrackingFilterInstanceStruct *chartInstance)
{
}

static void c2_g_eml_scalar_eg(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance)
{
}

static void c2_h_eml_scalar_eg(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance)
{
}

static void c2_i_eml_scalar_eg(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance)
{
}

static void c2_o_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_sprintf, const char_T *c2_identifier, char_T
  c2_y[14])
{
  emlrtMsgIdentifier c2_thisId;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_p_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_sprintf), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_sprintf);
}

static void c2_p_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  char_T c2_y[14])
{
  char_T c2_cv1[14];
  int32_T c2_i236;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), c2_cv1, 1, 10, 0U, 1, 0U, 2, 1,
                14);
  for (c2_i236 = 0; c2_i236 < 14; c2_i236++) {
    c2_y[c2_i236] = c2_cv1[c2_i236];
  }

  sf_mex_destroy(&c2_u);
}

static const mxArray *c2_k_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_u;
  const mxArray *c2_y = NULL;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_u = *(int32_T *)c2_inData;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", &c2_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static int32_T c2_q_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  int32_T c2_y;
  int32_T c2_i237;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_i237, 1, 6, 0U, 0, 0U, 0);
  c2_y = c2_i237;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void c2_j_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_b_sfEvent;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  int32_T c2_y;
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c2_b_sfEvent = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_q_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_b_sfEvent),
    &c2_thisId);
  sf_mex_destroy(&c2_b_sfEvent);
  *(int32_T *)c2_outData = c2_y;
  sf_mex_destroy(&c2_mxArrayInData);
}

static uint8_T c2_r_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_b_is_active_c2_objectTrackingFilter, const
  char_T *c2_identifier)
{
  uint8_T c2_y;
  emlrtMsgIdentifier c2_thisId;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_s_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c2_b_is_active_c2_objectTrackingFilter), &c2_thisId);
  sf_mex_destroy(&c2_b_is_active_c2_objectTrackingFilter);
  return c2_y;
}

static uint8_T c2_s_emlrt_marshallIn(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  uint8_T c2_y;
  uint8_T c2_u0;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_u0, 1, 3, 0U, 0, 0U, 0);
  c2_y = c2_u0;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void init_dsm_address_info(SFc2_objectTrackingFilterInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c2_objectTrackingFilter_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1368185252U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1508176070U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2756747612U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1105539211U);
}

mxArray *sf_c2_objectTrackingFilter_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("hvNgvHDLSFSbzZTAgfhRfC");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,7,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(6);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(6);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(2);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(6);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(2);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c2_objectTrackingFilter(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x6'type','srcId','name','auxInfo'{{M[1],M[10],T\"K\",},{M[1],M[5],T\"hat_x\",},{M[4],M[0],T\"index\",S'l','i','p'{{M1x2[138 143],M[0],}}},{M[4],M[0],T\"pre_P\",S'l','i','p'{{M1x2[96 101],M[0],}}},{M[4],M[0],T\"pre_x\",S'l','i','p'{{M1x2[117 122],M[0],}}},{M[8],M[0],T\"is_active_c2_objectTrackingFilter\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 6, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c2_objectTrackingFilter_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc2_objectTrackingFilterInstanceStruct *chartInstance;
    chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_objectTrackingFilterMachineNumber_,
           2,
           1,
           1,
           10,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_objectTrackingFilterMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_objectTrackingFilterMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds
            (_objectTrackingFilterMachineNumber_,
             chartInstance->chartNumber,
             0,
             0,
             0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"y");
          _SFD_SET_DATA_PROPS(1,2,0,1,"hat_x");
          _SFD_SET_DATA_PROPS(2,2,0,1,"K");
          _SFD_SET_DATA_PROPS(3,10,0,0,"Q_NED");
          _SFD_SET_DATA_PROPS(4,10,0,0,"H_NED");
          _SFD_SET_DATA_PROPS(5,10,0,0,"E");
          _SFD_SET_DATA_PROPS(6,10,0,0,"R_NED");
          _SFD_SET_DATA_PROPS(7,10,0,0,"disk_A_NED");
          _SFD_SET_DATA_PROPS(8,10,0,0,"SampleTimeKalman");
          _SFD_SET_DATA_PROPS(9,10,0,0,"STM");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,2,0,0,0,0,0,2,1);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,793);
        _SFD_CV_INIT_EML_IF(0,1,0,159,194,-1,317);
        _SFD_CV_INIT_EML_IF(0,1,1,422,437,543,606);

        {
          static int condStart[] = { 162, 180 };

          static int condEnd[] = { 176, 194 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,0,162,194,2,0,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c2_j_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c2_e_sf_marshallOut,(MexInFcnForType)
            c2_e_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 6;
          dimVector[1]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c2_d_sf_marshallOut,(MexInFcnForType)
            c2_d_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 6;
          dimVector[1]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c2_g_sf_marshallOut,(MexInFcnForType)
            c2_g_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 2;
          dimVector[1]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c2_i_sf_marshallOut,(MexInFcnForType)
            c2_i_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_f_sf_marshallOut,(MexInFcnForType)c2_f_sf_marshallIn);

        {
          unsigned int dimVector[2];
          dimVector[0]= 2;
          dimVector[1]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c2_h_sf_marshallOut,(MexInFcnForType)
            c2_h_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 6;
          dimVector[1]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c2_g_sf_marshallOut,(MexInFcnForType)
            c2_g_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_f_sf_marshallOut,(MexInFcnForType)c2_f_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_f_sf_marshallOut,(MexInFcnForType)c2_f_sf_marshallIn);

        {
          real_T (*c2_y)[2];
          real_T (*c2_hat_x)[6];
          real_T (*c2_K)[12];
          c2_K = (real_T (*)[12])ssGetOutputPortSignal(chartInstance->S, 2);
          c2_hat_x = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
          c2_y = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c2_y);
          _SFD_SET_DATA_VALUE_PTR(1U, *c2_hat_x);
          _SFD_SET_DATA_VALUE_PTR(2U, *c2_K);
          _SFD_SET_DATA_VALUE_PTR(3U, chartInstance->c2_Q_NED);
          _SFD_SET_DATA_VALUE_PTR(4U, chartInstance->c2_H_NED);
          _SFD_SET_DATA_VALUE_PTR(5U, &chartInstance->c2_E);
          _SFD_SET_DATA_VALUE_PTR(6U, chartInstance->c2_R_NED);
          _SFD_SET_DATA_VALUE_PTR(7U, chartInstance->c2_disk_A_NED);
          _SFD_SET_DATA_VALUE_PTR(8U, &chartInstance->c2_SampleTimeKalman);
          _SFD_SET_DATA_VALUE_PTR(9U, &chartInstance->c2_STM);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration
        (_objectTrackingFilterMachineNumber_,chartInstance->chartNumber,
         chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "FG4LUUmlg0YSHPfS5CuYoF";
}

static void sf_opaque_initialize_c2_objectTrackingFilter(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc2_objectTrackingFilterInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c2_objectTrackingFilter
    ((SFc2_objectTrackingFilterInstanceStruct*) chartInstanceVar);
  initialize_c2_objectTrackingFilter((SFc2_objectTrackingFilterInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c2_objectTrackingFilter(void *chartInstanceVar)
{
  enable_c2_objectTrackingFilter((SFc2_objectTrackingFilterInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_disable_c2_objectTrackingFilter(void *chartInstanceVar)
{
  disable_c2_objectTrackingFilter((SFc2_objectTrackingFilterInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c2_objectTrackingFilter(void *chartInstanceVar)
{
  sf_c2_objectTrackingFilter((SFc2_objectTrackingFilterInstanceStruct*)
    chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c2_objectTrackingFilter
  (SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c2_objectTrackingFilter
    ((SFc2_objectTrackingFilterInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c2_objectTrackingFilter();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c2_objectTrackingFilter(SimStruct* S,
  const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c2_objectTrackingFilter();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c2_objectTrackingFilter((SFc2_objectTrackingFilterInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c2_objectTrackingFilter(SimStruct*
  S)
{
  return sf_internal_get_sim_state_c2_objectTrackingFilter(S);
}

static void sf_opaque_set_sim_state_c2_objectTrackingFilter(SimStruct* S, const
  mxArray *st)
{
  sf_internal_set_sim_state_c2_objectTrackingFilter(S, st);
}

static void sf_opaque_terminate_c2_objectTrackingFilter(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc2_objectTrackingFilterInstanceStruct*) chartInstanceVar
      )->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c2_objectTrackingFilter((SFc2_objectTrackingFilterInstanceStruct*)
      chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_objectTrackingFilter_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc2_objectTrackingFilter((SFc2_objectTrackingFilterInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c2_objectTrackingFilter(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c2_objectTrackingFilter
      ((SFc2_objectTrackingFilterInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c2_objectTrackingFilter(SimStruct *S)
{
  /* Actual parameters from chart:
     E H_NED Q_NED R_NED STM SampleTimeKalman disk_A_NED
   */
  const char_T *rtParamNames[] = { "p1", "p2", "p3", "p4", "p5", "p6", "p7" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for E*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for H_NED*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for Q_NED*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);

  /* registration for R_NED*/
  ssRegDlgParamAsRunTimeParam(S, 3, 3, rtParamNames[3], SS_DOUBLE);

  /* registration for STM*/
  ssRegDlgParamAsRunTimeParam(S, 4, 4, rtParamNames[4], SS_DOUBLE);

  /* registration for SampleTimeKalman*/
  ssRegDlgParamAsRunTimeParam(S, 5, 5, rtParamNames[5], SS_DOUBLE);

  /* registration for disk_A_NED*/
  ssRegDlgParamAsRunTimeParam(S, 6, 6, rtParamNames[6], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_objectTrackingFilter_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      2);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,2,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,2,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,2,1);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,2,2);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,2);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(4067502628U));
  ssSetChecksum1(S,(1810539664U));
  ssSetChecksum2(S,(3335056879U));
  ssSetChecksum3(S,(1713358186U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c2_objectTrackingFilter(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c2_objectTrackingFilter(SimStruct *S)
{
  SFc2_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc2_objectTrackingFilterInstanceStruct *)malloc(sizeof
    (SFc2_objectTrackingFilterInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc2_objectTrackingFilterInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c2_objectTrackingFilter;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c2_objectTrackingFilter;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c2_objectTrackingFilter;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c2_objectTrackingFilter;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c2_objectTrackingFilter;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c2_objectTrackingFilter;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c2_objectTrackingFilter;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c2_objectTrackingFilter;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c2_objectTrackingFilter;
  chartInstance->chartInfo.mdlStart = mdlStart_c2_objectTrackingFilter;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c2_objectTrackingFilter;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c2_objectTrackingFilter_method_dispatcher(SimStruct *S, int_T method, void *
  data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c2_objectTrackingFilter(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c2_objectTrackingFilter(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c2_objectTrackingFilter(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c2_objectTrackingFilter_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
