#ifndef __c9_objectTrackingFilter_h__
#define __c9_objectTrackingFilter_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_c9_ResolvedFunctionInfo
#define typedef_c9_ResolvedFunctionInfo

typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c9_ResolvedFunctionInfo;

#endif                                 /*typedef_c9_ResolvedFunctionInfo*/

#ifndef typedef_SFc9_objectTrackingFilterInstanceStruct
#define typedef_SFc9_objectTrackingFilterInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c9_sfEvent;
  boolean_T c9_isStable;
  boolean_T c9_doneDoubleBufferReInit;
  uint8_T c9_is_active_c9_objectTrackingFilter;
  real_T c9_Q2_BODY[81];
  real_T c9_H2_BODY[27];
  real_T c9_E2;
  real_T c9_R2_BODY[9];
  real_T c9_Disk_A_method2[81];
  real_T c9_SampleTimeKalman;
  real_T c9_STM;
  real_T c9_pre_P[81];
  boolean_T c9_pre_P_not_empty;
  real_T c9_pre_x[9];
  boolean_T c9_pre_x_not_empty;
  real_T c9_index;
  boolean_T c9_index_not_empty;
} SFc9_objectTrackingFilterInstanceStruct;

#endif                                 /*typedef_SFc9_objectTrackingFilterInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c9_objectTrackingFilter_get_eml_resolved_functions_info
  (void);

/* Function Definitions */
extern void sf_c9_objectTrackingFilter_get_check_sum(mxArray *plhs[]);
extern void c9_objectTrackingFilter_method_dispatcher(SimStruct *S, int_T method,
  void *data);

#endif
