clear all 
close all


CaseOneDynamicObsDubins = load('CaseOneDynamicObsDubins');
CaseOneDynamicObsNSB =load('CaseOneDynamicObsNSB');


CaseTwoDynamicObsDubins = load('CaseTwoDynamicObsDubins');
CaseTwoDynamicObsNSB =load('CaseTwoDynamicObsNSB');


CaseThreeDynamicObsDubins = load('CaseThreeDynamicObsDubins');
CaseThreeDynamicObsNSB =load('CaseThreeDynamicObsNSB');

CaseOneStaticObstacleNSB = load('CaseOneStaticObsNSB');
CaseOneStaticObstacleDubins = load('CaseOneStaticObsDubins');



x_veh_NSB1 = CaseOneDynamicObsNSB.logsout.get('eta').Values.Data(:,1);
y_veh_NSB1 = CaseOneDynamicObsNSB.logsout.get('eta').Values.Data(:,2);


x_veh_Dubins1 = CaseOneDynamicObsDubins.logsout.get('eta').Values.Data(:,1);
y_veh_Dubins1 = CaseOneDynamicObsDubins.logsout.get('eta').Values.Data(:,2);



x_veh_NSB2 = CaseTwoDynamicObsNSB.logsout.get('eta').Values.Data(:,1);
y_veh_NSB2 = CaseTwoDynamicObsNSB.logsout.get('eta').Values.Data(:,2);


x_veh_Dubins2 = CaseTwoDynamicObsDubins.logsout.get('eta').Values.Data(:,1);
y_veh_Dubins2 = CaseTwoDynamicObsDubins.logsout.get('eta').Values.Data(:,2);



x_veh_NSB3 = CaseThreeDynamicObsNSB.logsout.get('eta').Values.Data(:,1);
y_veh_NSB3 = CaseThreeDynamicObsNSB.logsout.get('eta').Values.Data(:,2);


x_veh_Dubins3 = CaseThreeDynamicObsDubins.logsout.get('eta').Values.Data(:,1);
y_veh_Dubins3 = CaseThreeDynamicObsDubins.logsout.get('eta').Values.Data(:,2);


x_veh_NSB4 = CaseOneStaticObstacleNSB.logsout.get('eta').Values.Data(:,1);
y_veh_NSB4 = CaseOneStaticObstacleNSB.logsout.get('eta').Values.Data(:,2);


x_veh_Dubins4 = CaseOneStaticObstacleDubins.logsout.get('eta').Values.Data(:,1);
y_veh_Dubins4 = CaseOneStaticObstacleDubins.logsout.get('eta').Values.Data(:,2);

%% obstacle list for static obstacles

   obslist                  = [114 40 25 0;
                               226 50 30 0;
                               180 135 20 0;
                               150 -40 20 0];

figure(1);clf

hold on

plot(x_veh_NSB1,y_veh_NSB1,'k')

plot(x_veh_Dubins1,y_veh_Dubins1)

legend('NSB','Dubins', 'location', 'NorthEastOutside')

title('The path of the vehicle with both methods')

xlabel('x [m]')
ylabel('y [m]')

axis equal



%%
exportPlot(1, 'comparisonOfPath', 1);
exportPlot(1, 'comparisonOfPath_small', 0.8);




figure(2);clf

hold on

plot(x_veh_NSB2,y_veh_NSB2,'k')

plot(x_veh_Dubins2,y_veh_Dubins2)

legend('NSB','Dubins', 'location', 'NorthEastOutside')

title('The path of the vehicle with both methods')

xlabel('x [m]')
ylabel('y [m]')

axis equal

exportPlot(2, 'comparisonOfPathHeadsOn', 1);
exportPlot(2, 'comparisonOfPathHeadsOn_small', 0.8);




figure(3);clf

hold on

plot(x_veh_NSB3,y_veh_NSB3,'k')

plot(x_veh_Dubins3,y_veh_Dubins3)

legend('NSB','Dubins', 'location', 'NorthEastOutside')

title('The path of the vehicle with both methods')

xlabel('x [m]')
ylabel('y [m]')

axis equal

exportPlot(3, 'comparisonOfPathBack', 1);
exportPlot(3, 'comparisonOfPatBack_small', 0.8);



figure(4);clf
w = 0:0.1:2.1*pi;
hold on


plot(x_veh_NSB4,y_veh_NSB4,'k')

plot(x_veh_Dubins4,y_veh_Dubins4)

legend('NSB','Dubins', 'location', 'NorthEastOutside')


for i = 1:size(obslist,1)
    
    
    plot(obslist(i,1)+obslist(i,3)*cos(w),obslist(i,2)+obslist(i,3)*sin(w),'r' )
end


title('The path of the vehicle with both methods')

xlabel('x [m]')
ylabel('y [m]')

axis equal

exportPlot(4, 'comparisonOfPathStatic', 1);
exportPlot(4, 'comparisonOfPatStatic_small', 0.8);



