/* Include files */

#include "blascompat32.h"
#include "objectTrackingFilter_sfun.h"
#include "c4_objectTrackingFilter.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "objectTrackingFilter_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c4_debug_family_names[20] = { "WpNext", "WpPre", "R", "v_r",
  "ak", "s", "delta", "K_p", "K_i", "x_r", "nargin", "nargout", "eta", "intE",
  "clock", "WP", "x_d", "V", "e", "index" };

/* Function Declarations */
static void initialize_c4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance);
static void initialize_params_c4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance);
static void enable_c4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance);
static void disable_c4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance);
static void c4_update_debugger_state_c4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance);
static void set_sim_state_c4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance, const mxArray *c4_st);
static void finalize_c4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance);
static void sf_c4_objectTrackingFilter(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance);
static void c4_chartstep_c4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance);
static void initSimStructsc4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c4_machineNumber, uint32_T
  c4_chartNumber);
static const mxArray *c4_sf_marshallOut(void *chartInstanceVoid, void *c4_inData);
static real_T c4_emlrt_marshallIn(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c4_b_index, const char_T *c4_identifier);
static real_T c4_b_emlrt_marshallIn(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void c4_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_b_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static real_T c4_c_emlrt_marshallIn(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c4_e, const char_T *c4_identifier);
static real_T c4_d_emlrt_marshallIn(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void c4_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_c_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static void c4_e_emlrt_marshallIn(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[6]);
static void c4_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_d_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static const mxArray *c4_e_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static void c4_f_emlrt_marshallIn(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[2]);
static void c4_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static void c4_info_helper(c4_ResolvedFunctionInfo c4_info[44]);
static void c4_eml_scalar_eg(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance);
static real_T c4_norm(SFc4_objectTrackingFilterInstanceStruct *chartInstance,
                      real_T c4_x[2]);
static void c4_check_forloop_overflow_error
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance);
static real_T c4_mpower(SFc4_objectTrackingFilterInstanceStruct *chartInstance,
  real_T c4_a);
static void c4_eml_error(SFc4_objectTrackingFilterInstanceStruct *chartInstance);
static const mxArray *c4_f_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static int32_T c4_g_emlrt_marshallIn(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void c4_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static uint8_T c4_h_emlrt_marshallIn(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c4_b_is_active_c4_objectTrackingFilter, const
  char_T *c4_identifier);
static uint8_T c4_i_emlrt_marshallIn(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void init_dsm_address_info(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance)
{
  chartInstance->c4_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c4_index_not_empty = FALSE;
  chartInstance->c4_is_active_c4_objectTrackingFilter = 0U;
}

static void initialize_params_c4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance)
{
  real_T c4_dv0[6];
  int32_T c4_i0;
  sf_set_error_prefix_string(
    "Error evaluating data 'WP' in the parent workspace.\n");
  sf_mex_import_named("WP", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      c4_dv0, 0, 0, 0U, 1, 0U, 2, 2, 3);
  for (c4_i0 = 0; c4_i0 < 6; c4_i0++) {
    chartInstance->c4_WP[c4_i0] = c4_dv0[c4_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c4_update_debugger_state_c4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance)
{
  const mxArray *c4_st;
  const mxArray *c4_y = NULL;
  real_T c4_hoistedGlobal;
  real_T c4_u;
  const mxArray *c4_b_y = NULL;
  real_T c4_b_hoistedGlobal;
  real_T c4_b_u;
  const mxArray *c4_c_y = NULL;
  real_T c4_c_hoistedGlobal;
  real_T c4_c_u;
  const mxArray *c4_d_y = NULL;
  real_T c4_d_hoistedGlobal;
  real_T c4_d_u;
  const mxArray *c4_e_y = NULL;
  uint8_T c4_e_hoistedGlobal;
  uint8_T c4_e_u;
  const mxArray *c4_f_y = NULL;
  real_T *c4_V;
  real_T *c4_e;
  real_T *c4_x_d;
  c4_e = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c4_V = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c4_x_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c4_st = NULL;
  c4_st = NULL;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_createcellarray(5), FALSE);
  c4_hoistedGlobal = *c4_V;
  c4_u = c4_hoistedGlobal;
  c4_b_y = NULL;
  sf_mex_assign(&c4_b_y, sf_mex_create("y", &c4_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c4_y, 0, c4_b_y);
  c4_b_hoistedGlobal = *c4_e;
  c4_b_u = c4_b_hoistedGlobal;
  c4_c_y = NULL;
  sf_mex_assign(&c4_c_y, sf_mex_create("y", &c4_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c4_y, 1, c4_c_y);
  c4_c_hoistedGlobal = *c4_x_d;
  c4_c_u = c4_c_hoistedGlobal;
  c4_d_y = NULL;
  sf_mex_assign(&c4_d_y, sf_mex_create("y", &c4_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c4_y, 2, c4_d_y);
  c4_d_hoistedGlobal = chartInstance->c4_index;
  c4_d_u = c4_d_hoistedGlobal;
  c4_e_y = NULL;
  if (!chartInstance->c4_index_not_empty) {
    sf_mex_assign(&c4_e_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c4_e_y, sf_mex_create("y", &c4_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c4_y, 3, c4_e_y);
  c4_e_hoistedGlobal = chartInstance->c4_is_active_c4_objectTrackingFilter;
  c4_e_u = c4_e_hoistedGlobal;
  c4_f_y = NULL;
  sf_mex_assign(&c4_f_y, sf_mex_create("y", &c4_e_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c4_y, 4, c4_f_y);
  sf_mex_assign(&c4_st, c4_y, FALSE);
  return c4_st;
}

static void set_sim_state_c4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance, const mxArray *c4_st)
{
  const mxArray *c4_u;
  real_T *c4_V;
  real_T *c4_e;
  real_T *c4_x_d;
  c4_e = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c4_V = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c4_x_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c4_doneDoubleBufferReInit = TRUE;
  c4_u = sf_mex_dup(c4_st);
  *c4_V = c4_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c4_u, 0)),
    "V");
  *c4_e = c4_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c4_u, 1)),
    "e");
  *c4_x_d = c4_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c4_u,
    2)), "x_d");
  chartInstance->c4_index = c4_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c4_u, 3)), "index");
  chartInstance->c4_is_active_c4_objectTrackingFilter = c4_h_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c4_u, 4)),
     "is_active_c4_objectTrackingFilter");
  sf_mex_destroy(&c4_u);
  c4_update_debugger_state_c4_objectTrackingFilter(chartInstance);
  sf_mex_destroy(&c4_st);
}

static void finalize_c4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance)
{
}

static void sf_c4_objectTrackingFilter(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance)
{
  int32_T c4_i1;
  int32_T c4_i2;
  real_T *c4_x_d;
  real_T *c4_V;
  real_T *c4_intE;
  real_T *c4_e;
  real_T *c4_clock;
  real_T (*c4_eta)[3];
  c4_clock = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c4_e = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c4_intE = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c4_V = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c4_x_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c4_eta = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 3U, chartInstance->c4_sfEvent);
  for (c4_i1 = 0; c4_i1 < 3; c4_i1++) {
    _SFD_DATA_RANGE_CHECK((*c4_eta)[c4_i1], 0U);
  }

  _SFD_DATA_RANGE_CHECK(*c4_x_d, 1U);
  _SFD_DATA_RANGE_CHECK(*c4_V, 2U);
  _SFD_DATA_RANGE_CHECK(*c4_intE, 3U);
  _SFD_DATA_RANGE_CHECK(*c4_e, 4U);
  _SFD_DATA_RANGE_CHECK(*c4_clock, 5U);
  for (c4_i2 = 0; c4_i2 < 6; c4_i2++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c4_WP[c4_i2], 6U);
  }

  chartInstance->c4_sfEvent = CALL_EVENT;
  c4_chartstep_c4_objectTrackingFilter(chartInstance);
  sf_debug_check_for_state_inconsistency(_objectTrackingFilterMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c4_chartstep_c4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance)
{
  real_T c4_hoistedGlobal;
  real_T c4_b_hoistedGlobal;
  int32_T c4_i3;
  real_T c4_eta[3];
  real_T c4_intE;
  real_T c4_clock;
  int32_T c4_i4;
  real_T c4_b_WP[6];
  uint32_T c4_debug_family_var_map[20];
  real_T c4_WpNext[2];
  real_T c4_WpPre[2];
  real_T c4_R;
  real_T c4_v_r;
  real_T c4_ak;
  real_T c4_s;
  real_T c4_delta;
  real_T c4_K_p;
  real_T c4_K_i;
  real_T c4_x_r;
  real_T c4_nargin = 4.0;
  real_T c4_nargout = 3.0;
  real_T c4_x_d;
  real_T c4_V;
  real_T c4_e;
  int32_T c4_i5;
  int32_T c4_i6;
  int32_T c4_i7;
  int32_T c4_i8;
  real_T c4_y;
  real_T c4_x;
  real_T c4_b_y;
  real_T c4_b_x;
  real_T c4_c_x;
  real_T c4_d_x;
  real_T c4_a;
  real_T c4_b;
  real_T c4_c_y;
  real_T c4_e_x;
  real_T c4_f_x;
  real_T c4_b_a;
  real_T c4_b_b;
  real_T c4_d_y;
  real_T c4_g_x;
  real_T c4_h_x;
  real_T c4_c_a;
  real_T c4_c_b;
  real_T c4_e_y;
  real_T c4_i_x;
  real_T c4_j_x;
  real_T c4_d_a;
  real_T c4_d_b;
  real_T c4_f_y;
  real_T c4_k_x;
  real_T c4_l_x;
  real_T c4_g_y;
  real_T c4_m_x;
  real_T c4_n_x;
  real_T c4_h_y;
  real_T c4_e_b;
  int32_T c4_i9;
  real_T c4_b_WpPre[2];
  real_T c4_o_x;
  real_T c4_p_x;
  real_T c4_q_x;
  real_T c4_r_x;
  real_T c4_B;
  real_T c4_i_y;
  real_T c4_j_y;
  real_T c4_e_a;
  real_T c4_f_b;
  real_T c4_k_y;
  real_T c4_f_a;
  real_T c4_l_y;
  real_T c4_s_x;
  real_T c4_t_x;
  int32_T c4_i10;
  real_T c4_b_eta[2];
  real_T c4_c_hoistedGlobal;
  real_T c4_u;
  const mxArray *c4_m_y = NULL;
  real_T *c4_b_e;
  real_T *c4_b_V;
  real_T *c4_b_x_d;
  real_T *c4_b_clock;
  real_T *c4_b_intE;
  real_T (*c4_c_eta)[3];
  boolean_T guard1 = FALSE;
  c4_b_clock = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c4_b_e = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c4_b_intE = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c4_b_V = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c4_b_x_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c4_c_eta = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 3U, chartInstance->c4_sfEvent);
  c4_hoistedGlobal = *c4_b_intE;
  c4_b_hoistedGlobal = *c4_b_clock;
  for (c4_i3 = 0; c4_i3 < 3; c4_i3++) {
    c4_eta[c4_i3] = (*c4_c_eta)[c4_i3];
  }

  c4_intE = c4_hoistedGlobal;
  c4_clock = c4_b_hoistedGlobal;
  for (c4_i4 = 0; c4_i4 < 6; c4_i4++) {
    c4_b_WP[c4_i4] = chartInstance->c4_WP[c4_i4];
  }

  sf_debug_symbol_scope_push_eml(0U, 20U, 20U, c4_debug_family_names,
    c4_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(c4_WpNext, 0U, c4_e_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_WpPre, 1U, c4_e_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_R, 2U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_v_r, 3U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_ak, 4U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_s, 5U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_delta, 6U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_K_p, 7U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c4_K_i, 8U, c4_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c4_x_r, 9U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_nargin, 10U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_nargout, 11U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c4_eta, 12U, c4_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c4_intE, 13U, c4_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c4_clock, 14U, c4_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c4_b_WP, 15U, c4_c_sf_marshallOut,
    c4_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_x_d, 16U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_V, 17U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_e, 18U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c4_index, 19U,
    c4_sf_marshallOut, c4_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 3);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 7);
  if (CV_EML_IF(0, 1, 0, !chartInstance->c4_index_not_empty)) {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 9);
    chartInstance->c4_index = 1.0;
    chartInstance->c4_index_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 14);
  c4_i5 = _SFD_EML_ARRAY_BOUNDS_CHECK("WP", (int32_T)_SFD_INTEGER_CHECK(
    "index+1", chartInstance->c4_index + 1.0), 1, 3, 2, 0) - 1;
  for (c4_i6 = 0; c4_i6 < 2; c4_i6++) {
    c4_WpNext[c4_i6] = c4_b_WP[c4_i6 + (c4_i5 << 1)];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 15);
  c4_i7 = _SFD_EML_ARRAY_BOUNDS_CHECK("WP", (int32_T)_SFD_INTEGER_CHECK("index",
    chartInstance->c4_index), 1, 3, 2, 0) - 1;
  for (c4_i8 = 0; c4_i8 < 2; c4_i8++) {
    c4_WpPre[c4_i8] = c4_b_WP[c4_i8 + (c4_i7 << 1)];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 17);
  c4_R = 20.0;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 18);
  c4_v_r = 5.0;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 24);
  c4_y = c4_WpNext[1] - c4_WpPre[1];
  c4_x = c4_WpNext[0] - c4_WpPre[0];
  c4_eml_scalar_eg(chartInstance);
  c4_b_y = c4_y;
  c4_b_x = c4_x;
  c4_ak = muDoubleScalarAtan2(c4_b_y, c4_b_x);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 28);
  c4_c_x = c4_ak;
  c4_d_x = c4_c_x;
  c4_d_x = muDoubleScalarSin(c4_d_x);
  c4_a = -(c4_eta[0] - c4_WpPre[0]);
  c4_b = c4_d_x;
  c4_c_y = c4_a * c4_b;
  c4_e_x = c4_ak;
  c4_f_x = c4_e_x;
  c4_f_x = muDoubleScalarCos(c4_f_x);
  c4_b_a = c4_eta[1] - c4_WpPre[1];
  c4_b_b = c4_f_x;
  c4_d_y = c4_b_a * c4_b_b;
  c4_e = c4_c_y + c4_d_y;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 29);
  c4_g_x = c4_ak;
  c4_h_x = c4_g_x;
  c4_h_x = muDoubleScalarCos(c4_h_x);
  c4_c_a = c4_eta[0] - c4_WpPre[0];
  c4_c_b = c4_h_x;
  c4_e_y = c4_c_a * c4_c_b;
  c4_i_x = c4_ak;
  c4_j_x = c4_i_x;
  c4_j_x = muDoubleScalarSin(c4_j_x);
  c4_d_a = c4_eta[1] - c4_WpPre[1];
  c4_d_b = c4_j_x;
  c4_f_y = c4_d_a * c4_d_b;
  c4_s = c4_e_y + c4_f_y;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 30);
  c4_k_x = c4_e;
  c4_l_x = c4_k_x;
  c4_g_y = muDoubleScalarAbs(c4_l_x);
  if (CV_EML_IF(0, 1, 1, c4_g_y > c4_R)) {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 31);
    c4_m_x = c4_e;
    c4_n_x = c4_m_x;
    c4_h_y = muDoubleScalarAbs(c4_n_x);
    c4_e_b = c4_h_y;
    c4_R = 3.0 * c4_e_b;
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 34);
  for (c4_i9 = 0; c4_i9 < 2; c4_i9++) {
    c4_b_WpPre[c4_i9] = c4_WpPre[c4_i9] - c4_WpNext[c4_i9];
  }

  c4_norm(chartInstance, c4_b_WpPre);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 36);
  c4_o_x = c4_mpower(chartInstance, c4_R) - c4_mpower(chartInstance, c4_e);
  c4_delta = c4_o_x;
  if (c4_delta < 0.0) {
    c4_eml_error(chartInstance);
  }

  c4_p_x = c4_delta;
  c4_delta = c4_p_x;
  c4_delta = muDoubleScalarSqrt(c4_delta);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 38);
  c4_q_x = c4_mpower(chartInstance, c4_R) - c4_mpower(chartInstance, c4_e);
  c4_r_x = c4_q_x;
  if (c4_r_x < 0.0) {
    c4_eml_error(chartInstance);
  }

  c4_r_x = muDoubleScalarSqrt(c4_r_x);
  c4_B = c4_r_x;
  c4_i_y = c4_B;
  c4_j_y = c4_i_y;
  c4_K_p = 1.0 / c4_j_y;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 39);
  c4_K_i = 0.001;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 40);
  c4_e_a = -c4_e;
  c4_f_b = c4_K_p;
  c4_k_y = c4_e_a * c4_f_b;
  c4_f_a = c4_intE;
  c4_l_y = c4_f_a * 0.001;
  c4_s_x = c4_k_y - c4_l_y;
  c4_x_r = c4_s_x;
  c4_t_x = c4_x_r;
  c4_x_r = c4_t_x;
  c4_x_r = muDoubleScalarAtan(c4_x_r);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 43);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 44);
  c4_x_d = c4_ak + c4_x_r;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 45);
  if (CV_EML_IF(0, 1, 2, c4_clock > 40.0)) {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 48);
    c4_V = 6.0;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 50);
    c4_V = 3.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 58);
  for (c4_i10 = 0; c4_i10 < 2; c4_i10++) {
    c4_b_eta[c4_i10] = c4_eta[c4_i10] - c4_WpNext[c4_i10];
  }

  guard1 = FALSE;
  if (CV_EML_COND(0, 1, 0, c4_norm(chartInstance, c4_b_eta) <= 20.0)) {
    if (CV_EML_COND(0, 1, 1, chartInstance->c4_index < 2.0)) {
      CV_EML_MCDC(0, 1, 0, TRUE);
      CV_EML_IF(0, 1, 3, TRUE);
      _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 59);
      chartInstance->c4_index++;
      sf_mex_printf("%s =\\n", "index");
      c4_c_hoistedGlobal = chartInstance->c4_index;
      c4_u = c4_c_hoistedGlobal;
      c4_m_y = NULL;
      sf_mex_assign(&c4_m_y, sf_mex_create("y", &c4_u, 0, 0U, 0U, 0U, 0), FALSE);
      sf_mex_call_debug("disp", 0U, 1U, 14, c4_m_y);
    } else {
      guard1 = TRUE;
    }
  } else {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    CV_EML_MCDC(0, 1, 0, FALSE);
    CV_EML_IF(0, 1, 3, FALSE);
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 61);
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, -61);
  sf_debug_symbol_scope_pop();
  *c4_b_x_d = c4_x_d;
  *c4_b_V = c4_V;
  *c4_b_e = c4_e;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 3U, chartInstance->c4_sfEvent);
}

static void initSimStructsc4_objectTrackingFilter
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c4_machineNumber, uint32_T
  c4_chartNumber)
{
}

static const mxArray *c4_sf_marshallOut(void *chartInstanceVoid, void *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  real_T c4_u;
  const mxArray *c4_y = NULL;
  SFc4_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc4_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_u = *(real_T *)c4_inData;
  c4_y = NULL;
  if (!chartInstance->c4_index_not_empty) {
    sf_mex_assign(&c4_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c4_y, sf_mex_create("y", &c4_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static real_T c4_emlrt_marshallIn(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c4_b_index, const char_T *c4_identifier)
{
  real_T c4_y;
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_index), &c4_thisId);
  sf_mex_destroy(&c4_b_index);
  return c4_y;
}

static real_T c4_b_emlrt_marshallIn(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  real_T c4_y;
  real_T c4_d0;
  if (mxIsEmpty(c4_u)) {
    chartInstance->c4_index_not_empty = FALSE;
  } else {
    chartInstance->c4_index_not_empty = TRUE;
    sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_d0, 1, 0, 0U, 0, 0U, 0);
    c4_y = c4_d0;
  }

  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void c4_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_b_index;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y;
  SFc4_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc4_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c4_b_index = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_index), &c4_thisId);
  sf_mex_destroy(&c4_b_index);
  *(real_T *)c4_outData = c4_y;
  sf_mex_destroy(&c4_mxArrayInData);
}

static const mxArray *c4_b_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  real_T c4_u;
  const mxArray *c4_y = NULL;
  SFc4_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc4_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_u = *(real_T *)c4_inData;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", &c4_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static real_T c4_c_emlrt_marshallIn(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c4_e, const char_T *c4_identifier)
{
  real_T c4_y;
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_e), &c4_thisId);
  sf_mex_destroy(&c4_e);
  return c4_y;
}

static real_T c4_d_emlrt_marshallIn(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  real_T c4_y;
  real_T c4_d1;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_d1, 1, 0, 0U, 0, 0U, 0);
  c4_y = c4_d1;
  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void c4_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_e;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y;
  SFc4_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc4_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c4_e = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_e), &c4_thisId);
  sf_mex_destroy(&c4_e);
  *(real_T *)c4_outData = c4_y;
  sf_mex_destroy(&c4_mxArrayInData);
}

static const mxArray *c4_c_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_i11;
  int32_T c4_i12;
  int32_T c4_i13;
  real_T c4_b_inData[6];
  int32_T c4_i14;
  int32_T c4_i15;
  int32_T c4_i16;
  real_T c4_u[6];
  const mxArray *c4_y = NULL;
  SFc4_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc4_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_i11 = 0;
  for (c4_i12 = 0; c4_i12 < 3; c4_i12++) {
    for (c4_i13 = 0; c4_i13 < 2; c4_i13++) {
      c4_b_inData[c4_i13 + c4_i11] = (*(real_T (*)[6])c4_inData)[c4_i13 + c4_i11];
    }

    c4_i11 += 2;
  }

  c4_i14 = 0;
  for (c4_i15 = 0; c4_i15 < 3; c4_i15++) {
    for (c4_i16 = 0; c4_i16 < 2; c4_i16++) {
      c4_u[c4_i16 + c4_i14] = c4_b_inData[c4_i16 + c4_i14];
    }

    c4_i14 += 2;
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 2, 2, 3), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static void c4_e_emlrt_marshallIn(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[6])
{
  real_T c4_dv1[6];
  int32_T c4_i17;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), c4_dv1, 1, 0, 0U, 1, 0U, 2, 2, 3);
  for (c4_i17 = 0; c4_i17 < 6; c4_i17++) {
    c4_y[c4_i17] = c4_dv1[c4_i17];
  }

  sf_mex_destroy(&c4_u);
}

static void c4_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_b_WP;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y[6];
  int32_T c4_i18;
  int32_T c4_i19;
  int32_T c4_i20;
  SFc4_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc4_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c4_b_WP = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_WP), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_b_WP);
  c4_i18 = 0;
  for (c4_i19 = 0; c4_i19 < 3; c4_i19++) {
    for (c4_i20 = 0; c4_i20 < 2; c4_i20++) {
      (*(real_T (*)[6])c4_outData)[c4_i20 + c4_i18] = c4_y[c4_i20 + c4_i18];
    }

    c4_i18 += 2;
  }

  sf_mex_destroy(&c4_mxArrayInData);
}

static const mxArray *c4_d_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_i21;
  real_T c4_b_inData[3];
  int32_T c4_i22;
  real_T c4_u[3];
  const mxArray *c4_y = NULL;
  SFc4_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc4_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  for (c4_i21 = 0; c4_i21 < 3; c4_i21++) {
    c4_b_inData[c4_i21] = (*(real_T (*)[3])c4_inData)[c4_i21];
  }

  for (c4_i22 = 0; c4_i22 < 3; c4_i22++) {
    c4_u[c4_i22] = c4_b_inData[c4_i22];
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static const mxArray *c4_e_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_i23;
  real_T c4_b_inData[2];
  int32_T c4_i24;
  real_T c4_u[2];
  const mxArray *c4_y = NULL;
  SFc4_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc4_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  for (c4_i23 = 0; c4_i23 < 2; c4_i23++) {
    c4_b_inData[c4_i23] = (*(real_T (*)[2])c4_inData)[c4_i23];
  }

  for (c4_i24 = 0; c4_i24 < 2; c4_i24++) {
    c4_u[c4_i24] = c4_b_inData[c4_i24];
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 1, 2), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static void c4_f_emlrt_marshallIn(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[2])
{
  real_T c4_dv2[2];
  int32_T c4_i25;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), c4_dv2, 1, 0, 0U, 1, 0U, 1, 2);
  for (c4_i25 = 0; c4_i25 < 2; c4_i25++) {
    c4_y[c4_i25] = c4_dv2[c4_i25];
  }

  sf_mex_destroy(&c4_u);
}

static void c4_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_WpPre;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y[2];
  int32_T c4_i26;
  SFc4_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc4_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c4_WpPre = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_WpPre), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_WpPre);
  for (c4_i26 = 0; c4_i26 < 2; c4_i26++) {
    (*(real_T (*)[2])c4_outData)[c4_i26] = c4_y[c4_i26];
  }

  sf_mex_destroy(&c4_mxArrayInData);
}

const mxArray *sf_c4_objectTrackingFilter_get_eml_resolved_functions_info(void)
{
  const mxArray *c4_nameCaptureInfo;
  c4_ResolvedFunctionInfo c4_info[44];
  const mxArray *c4_m0 = NULL;
  int32_T c4_i27;
  c4_ResolvedFunctionInfo *c4_r0;
  c4_nameCaptureInfo = NULL;
  c4_nameCaptureInfo = NULL;
  c4_info_helper(c4_info);
  sf_mex_assign(&c4_m0, sf_mex_createstruct("nameCaptureInfo", 1, 44), FALSE);
  for (c4_i27 = 0; c4_i27 < 44; c4_i27++) {
    c4_r0 = &c4_info[c4_i27];
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c4_r0->context)), "context", "nameCaptureInfo",
                    c4_i27);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c4_r0->name)), "name", "nameCaptureInfo", c4_i27);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c4_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c4_i27);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c4_r0->resolved)), "resolved", "nameCaptureInfo",
                    c4_i27);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c4_i27);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c4_i27);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c4_i27);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c4_i27);
  }

  sf_mex_assign(&c4_nameCaptureInfo, c4_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c4_nameCaptureInfo);
  return c4_nameCaptureInfo;
}

static void c4_info_helper(c4_ResolvedFunctionInfo c4_info[44])
{
  c4_info[0].context = "";
  c4_info[0].name = "atan2";
  c4_info[0].dominantType = "double";
  c4_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c4_info[0].fileTimeLo = 1286818704U;
  c4_info[0].fileTimeHi = 0U;
  c4_info[0].mFileTimeLo = 0U;
  c4_info[0].mFileTimeHi = 0U;
  c4_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c4_info[1].name = "eml_scalar_eg";
  c4_info[1].dominantType = "double";
  c4_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c4_info[1].fileTimeLo = 1286818796U;
  c4_info[1].fileTimeHi = 0U;
  c4_info[1].mFileTimeLo = 0U;
  c4_info[1].mFileTimeHi = 0U;
  c4_info[2].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c4_info[2].name = "eml_scalexp_alloc";
  c4_info[2].dominantType = "double";
  c4_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c4_info[2].fileTimeLo = 1330608434U;
  c4_info[2].fileTimeHi = 0U;
  c4_info[2].mFileTimeLo = 0U;
  c4_info[2].mFileTimeHi = 0U;
  c4_info[3].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c4_info[3].name = "eml_scalar_atan2";
  c4_info[3].dominantType = "double";
  c4_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_atan2.m";
  c4_info[3].fileTimeLo = 1286818720U;
  c4_info[3].fileTimeHi = 0U;
  c4_info[3].mFileTimeLo = 0U;
  c4_info[3].mFileTimeHi = 0U;
  c4_info[4].context = "";
  c4_info[4].name = "sin";
  c4_info[4].dominantType = "double";
  c4_info[4].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c4_info[4].fileTimeLo = 1286818750U;
  c4_info[4].fileTimeHi = 0U;
  c4_info[4].mFileTimeLo = 0U;
  c4_info[4].mFileTimeHi = 0U;
  c4_info[5].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c4_info[5].name = "eml_scalar_sin";
  c4_info[5].dominantType = "double";
  c4_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c4_info[5].fileTimeLo = 1286818736U;
  c4_info[5].fileTimeHi = 0U;
  c4_info[5].mFileTimeLo = 0U;
  c4_info[5].mFileTimeHi = 0U;
  c4_info[6].context = "";
  c4_info[6].name = "mtimes";
  c4_info[6].dominantType = "double";
  c4_info[6].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c4_info[6].fileTimeLo = 1289519692U;
  c4_info[6].fileTimeHi = 0U;
  c4_info[6].mFileTimeLo = 0U;
  c4_info[6].mFileTimeHi = 0U;
  c4_info[7].context = "";
  c4_info[7].name = "cos";
  c4_info[7].dominantType = "double";
  c4_info[7].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c4_info[7].fileTimeLo = 1286818706U;
  c4_info[7].fileTimeHi = 0U;
  c4_info[7].mFileTimeLo = 0U;
  c4_info[7].mFileTimeHi = 0U;
  c4_info[8].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c4_info[8].name = "eml_scalar_cos";
  c4_info[8].dominantType = "double";
  c4_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c4_info[8].fileTimeLo = 1286818722U;
  c4_info[8].fileTimeHi = 0U;
  c4_info[8].mFileTimeLo = 0U;
  c4_info[8].mFileTimeHi = 0U;
  c4_info[9].context = "";
  c4_info[9].name = "abs";
  c4_info[9].dominantType = "double";
  c4_info[9].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c4_info[9].fileTimeLo = 1286818694U;
  c4_info[9].fileTimeHi = 0U;
  c4_info[9].mFileTimeLo = 0U;
  c4_info[9].mFileTimeHi = 0U;
  c4_info[10].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c4_info[10].name = "eml_scalar_abs";
  c4_info[10].dominantType = "double";
  c4_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c4_info[10].fileTimeLo = 1286818712U;
  c4_info[10].fileTimeHi = 0U;
  c4_info[10].mFileTimeLo = 0U;
  c4_info[10].mFileTimeHi = 0U;
  c4_info[11].context = "";
  c4_info[11].name = "norm";
  c4_info[11].dominantType = "double";
  c4_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m";
  c4_info[11].fileTimeLo = 1336522094U;
  c4_info[11].fileTimeHi = 0U;
  c4_info[11].mFileTimeLo = 0U;
  c4_info[11].mFileTimeHi = 0U;
  c4_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!genpnorm";
  c4_info[12].name = "eml_index_class";
  c4_info[12].dominantType = "";
  c4_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c4_info[12].fileTimeLo = 1323170578U;
  c4_info[12].fileTimeHi = 0U;
  c4_info[12].mFileTimeLo = 0U;
  c4_info[12].mFileTimeHi = 0U;
  c4_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!genpnorm";
  c4_info[13].name = "eml_xnrm2";
  c4_info[13].dominantType = "double";
  c4_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xnrm2.m";
  c4_info[13].fileTimeLo = 1299076776U;
  c4_info[13].fileTimeHi = 0U;
  c4_info[13].mFileTimeLo = 0U;
  c4_info[13].mFileTimeHi = 0U;
  c4_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xnrm2.m";
  c4_info[14].name = "eml_blas_inline";
  c4_info[14].dominantType = "";
  c4_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c4_info[14].fileTimeLo = 1299076768U;
  c4_info[14].fileTimeHi = 0U;
  c4_info[14].mFileTimeLo = 0U;
  c4_info[14].mFileTimeHi = 0U;
  c4_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xnrm2.m";
  c4_info[15].name = "eml_index_class";
  c4_info[15].dominantType = "";
  c4_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c4_info[15].fileTimeLo = 1323170578U;
  c4_info[15].fileTimeHi = 0U;
  c4_info[15].mFileTimeLo = 0U;
  c4_info[15].mFileTimeHi = 0U;
  c4_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xnrm2.m";
  c4_info[16].name = "eml_refblas_xnrm2";
  c4_info[16].dominantType = "double";
  c4_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c4_info[16].fileTimeLo = 1299076784U;
  c4_info[16].fileTimeHi = 0U;
  c4_info[16].mFileTimeLo = 0U;
  c4_info[16].mFileTimeHi = 0U;
  c4_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c4_info[17].name = "realmin";
  c4_info[17].dominantType = "char";
  c4_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c4_info[17].fileTimeLo = 1307651242U;
  c4_info[17].fileTimeHi = 0U;
  c4_info[17].mFileTimeLo = 0U;
  c4_info[17].mFileTimeHi = 0U;
  c4_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c4_info[18].name = "eml_realmin";
  c4_info[18].dominantType = "char";
  c4_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmin.m";
  c4_info[18].fileTimeLo = 1307651244U;
  c4_info[18].fileTimeHi = 0U;
  c4_info[18].mFileTimeLo = 0U;
  c4_info[18].mFileTimeHi = 0U;
  c4_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmin.m";
  c4_info[19].name = "eml_float_model";
  c4_info[19].dominantType = "char";
  c4_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_float_model.m";
  c4_info[19].fileTimeLo = 1326727996U;
  c4_info[19].fileTimeHi = 0U;
  c4_info[19].mFileTimeLo = 0U;
  c4_info[19].mFileTimeHi = 0U;
  c4_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c4_info[20].name = "eml_index_class";
  c4_info[20].dominantType = "";
  c4_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c4_info[20].fileTimeLo = 1323170578U;
  c4_info[20].fileTimeHi = 0U;
  c4_info[20].mFileTimeLo = 0U;
  c4_info[20].mFileTimeHi = 0U;
  c4_info[21].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c4_info[21].name = "eml_index_minus";
  c4_info[21].dominantType = "double";
  c4_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c4_info[21].fileTimeLo = 1286818778U;
  c4_info[21].fileTimeHi = 0U;
  c4_info[21].mFileTimeLo = 0U;
  c4_info[21].mFileTimeHi = 0U;
  c4_info[22].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c4_info[22].name = "eml_index_class";
  c4_info[22].dominantType = "";
  c4_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c4_info[22].fileTimeLo = 1323170578U;
  c4_info[22].fileTimeHi = 0U;
  c4_info[22].mFileTimeLo = 0U;
  c4_info[22].mFileTimeHi = 0U;
  c4_info[23].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c4_info[23].name = "eml_index_times";
  c4_info[23].dominantType = "coder.internal.indexInt";
  c4_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c4_info[23].fileTimeLo = 1286818780U;
  c4_info[23].fileTimeHi = 0U;
  c4_info[23].mFileTimeLo = 0U;
  c4_info[23].mFileTimeHi = 0U;
  c4_info[24].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c4_info[24].name = "eml_index_class";
  c4_info[24].dominantType = "";
  c4_info[24].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c4_info[24].fileTimeLo = 1323170578U;
  c4_info[24].fileTimeHi = 0U;
  c4_info[24].mFileTimeLo = 0U;
  c4_info[24].mFileTimeHi = 0U;
  c4_info[25].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c4_info[25].name = "eml_index_plus";
  c4_info[25].dominantType = "coder.internal.indexInt";
  c4_info[25].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c4_info[25].fileTimeLo = 1286818778U;
  c4_info[25].fileTimeHi = 0U;
  c4_info[25].mFileTimeLo = 0U;
  c4_info[25].mFileTimeHi = 0U;
  c4_info[26].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c4_info[26].name = "eml_index_class";
  c4_info[26].dominantType = "";
  c4_info[26].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c4_info[26].fileTimeLo = 1323170578U;
  c4_info[26].fileTimeHi = 0U;
  c4_info[26].mFileTimeLo = 0U;
  c4_info[26].mFileTimeHi = 0U;
  c4_info[27].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c4_info[27].name = "eml_int_forloop_overflow_check";
  c4_info[27].dominantType = "";
  c4_info[27].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c4_info[27].fileTimeLo = 1332168672U;
  c4_info[27].fileTimeHi = 0U;
  c4_info[27].mFileTimeLo = 0U;
  c4_info[27].mFileTimeHi = 0U;
  c4_info[28].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m!eml_int_forloop_overflow_check_helper";
  c4_info[28].name = "intmax";
  c4_info[28].dominantType = "char";
  c4_info[28].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c4_info[28].fileTimeLo = 1311255316U;
  c4_info[28].fileTimeHi = 0U;
  c4_info[28].mFileTimeLo = 0U;
  c4_info[28].mFileTimeHi = 0U;
  c4_info[29].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c4_info[29].name = "abs";
  c4_info[29].dominantType = "double";
  c4_info[29].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c4_info[29].fileTimeLo = 1286818694U;
  c4_info[29].fileTimeHi = 0U;
  c4_info[29].mFileTimeLo = 0U;
  c4_info[29].mFileTimeHi = 0U;
  c4_info[30].context = "";
  c4_info[30].name = "mpower";
  c4_info[30].dominantType = "double";
  c4_info[30].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c4_info[30].fileTimeLo = 1286818842U;
  c4_info[30].fileTimeHi = 0U;
  c4_info[30].mFileTimeLo = 0U;
  c4_info[30].mFileTimeHi = 0U;
  c4_info[31].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c4_info[31].name = "power";
  c4_info[31].dominantType = "double";
  c4_info[31].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c4_info[31].fileTimeLo = 1336522096U;
  c4_info[31].fileTimeHi = 0U;
  c4_info[31].mFileTimeLo = 0U;
  c4_info[31].mFileTimeHi = 0U;
  c4_info[32].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c4_info[32].name = "eml_scalar_eg";
  c4_info[32].dominantType = "double";
  c4_info[32].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c4_info[32].fileTimeLo = 1286818796U;
  c4_info[32].fileTimeHi = 0U;
  c4_info[32].mFileTimeLo = 0U;
  c4_info[32].mFileTimeHi = 0U;
  c4_info[33].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c4_info[33].name = "eml_scalexp_alloc";
  c4_info[33].dominantType = "double";
  c4_info[33].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c4_info[33].fileTimeLo = 1330608434U;
  c4_info[33].fileTimeHi = 0U;
  c4_info[33].mFileTimeLo = 0U;
  c4_info[33].mFileTimeHi = 0U;
  c4_info[34].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c4_info[34].name = "floor";
  c4_info[34].dominantType = "double";
  c4_info[34].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c4_info[34].fileTimeLo = 1286818742U;
  c4_info[34].fileTimeHi = 0U;
  c4_info[34].mFileTimeLo = 0U;
  c4_info[34].mFileTimeHi = 0U;
  c4_info[35].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c4_info[35].name = "eml_scalar_floor";
  c4_info[35].dominantType = "double";
  c4_info[35].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c4_info[35].fileTimeLo = 1286818726U;
  c4_info[35].fileTimeHi = 0U;
  c4_info[35].mFileTimeLo = 0U;
  c4_info[35].mFileTimeHi = 0U;
  c4_info[36].context = "";
  c4_info[36].name = "sqrt";
  c4_info[36].dominantType = "double";
  c4_info[36].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c4_info[36].fileTimeLo = 1286818752U;
  c4_info[36].fileTimeHi = 0U;
  c4_info[36].mFileTimeLo = 0U;
  c4_info[36].mFileTimeHi = 0U;
  c4_info[37].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c4_info[37].name = "eml_error";
  c4_info[37].dominantType = "char";
  c4_info[37].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  c4_info[37].fileTimeLo = 1305318000U;
  c4_info[37].fileTimeHi = 0U;
  c4_info[37].mFileTimeLo = 0U;
  c4_info[37].mFileTimeHi = 0U;
  c4_info[38].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c4_info[38].name = "eml_scalar_sqrt";
  c4_info[38].dominantType = "double";
  c4_info[38].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m";
  c4_info[38].fileTimeLo = 1286818738U;
  c4_info[38].fileTimeHi = 0U;
  c4_info[38].mFileTimeLo = 0U;
  c4_info[38].mFileTimeHi = 0U;
  c4_info[39].context = "";
  c4_info[39].name = "mrdivide";
  c4_info[39].dominantType = "double";
  c4_info[39].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c4_info[39].fileTimeLo = 1342810944U;
  c4_info[39].fileTimeHi = 0U;
  c4_info[39].mFileTimeLo = 1319729966U;
  c4_info[39].mFileTimeHi = 0U;
  c4_info[40].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c4_info[40].name = "rdivide";
  c4_info[40].dominantType = "double";
  c4_info[40].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c4_info[40].fileTimeLo = 1286818844U;
  c4_info[40].fileTimeHi = 0U;
  c4_info[40].mFileTimeLo = 0U;
  c4_info[40].mFileTimeHi = 0U;
  c4_info[41].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c4_info[41].name = "eml_div";
  c4_info[41].dominantType = "double";
  c4_info[41].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c4_info[41].fileTimeLo = 1313347810U;
  c4_info[41].fileTimeHi = 0U;
  c4_info[41].mFileTimeLo = 0U;
  c4_info[41].mFileTimeHi = 0U;
  c4_info[42].context = "";
  c4_info[42].name = "atan";
  c4_info[42].dominantType = "double";
  c4_info[42].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan.m";
  c4_info[42].fileTimeLo = 1305317998U;
  c4_info[42].fileTimeHi = 0U;
  c4_info[42].mFileTimeLo = 0U;
  c4_info[42].mFileTimeHi = 0U;
  c4_info[43].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan.m";
  c4_info[43].name = "eml_scalar_atan";
  c4_info[43].dominantType = "double";
  c4_info[43].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_atan.m";
  c4_info[43].fileTimeLo = 1286818718U;
  c4_info[43].fileTimeHi = 0U;
  c4_info[43].mFileTimeLo = 0U;
  c4_info[43].mFileTimeHi = 0U;
}

static void c4_eml_scalar_eg(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance)
{
}

static real_T c4_norm(SFc4_objectTrackingFilterInstanceStruct *chartInstance,
                      real_T c4_x[2])
{
  real_T c4_y;
  real_T c4_scale;
  int32_T c4_k;
  int32_T c4_b_k;
  real_T c4_b_x;
  real_T c4_c_x;
  real_T c4_absxk;
  real_T c4_t;
  c4_y = 0.0;
  c4_scale = 2.2250738585072014E-308;
  c4_check_forloop_overflow_error(chartInstance);
  for (c4_k = 1; c4_k < 3; c4_k++) {
    c4_b_k = c4_k;
    c4_b_x = c4_x[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      (real_T)c4_b_k), 1, 2, 1, 0) - 1];
    c4_c_x = c4_b_x;
    c4_absxk = muDoubleScalarAbs(c4_c_x);
    if (c4_absxk > c4_scale) {
      c4_t = c4_scale / c4_absxk;
      c4_y = 1.0 + c4_y * c4_t * c4_t;
      c4_scale = c4_absxk;
    } else {
      c4_t = c4_absxk / c4_scale;
      c4_y += c4_t * c4_t;
    }
  }

  return c4_scale * muDoubleScalarSqrt(c4_y);
}

static void c4_check_forloop_overflow_error
  (SFc4_objectTrackingFilterInstanceStruct *chartInstance)
{
}

static real_T c4_mpower(SFc4_objectTrackingFilterInstanceStruct *chartInstance,
  real_T c4_a)
{
  real_T c4_b_a;
  real_T c4_c_a;
  real_T c4_ak;
  c4_b_a = c4_a;
  c4_c_a = c4_b_a;
  c4_eml_scalar_eg(chartInstance);
  c4_ak = c4_c_a;
  return muDoubleScalarPower(c4_ak, 2.0);
}

static void c4_eml_error(SFc4_objectTrackingFilterInstanceStruct *chartInstance)
{
  int32_T c4_i28;
  static char_T c4_varargin_1[30] = { 'C', 'o', 'd', 'e', 'r', ':', 't', 'o',
    'o', 'l', 'b', 'o', 'x', ':', 's', 'q', 'r', 't', '_', 'd', 'o', 'm', 'a',
    'i', 'n', 'E', 'r', 'r', 'o', 'r' };

  char_T c4_u[30];
  const mxArray *c4_y = NULL;
  for (c4_i28 = 0; c4_i28 < 30; c4_i28++) {
    c4_u[c4_i28] = c4_varargin_1[c4_i28];
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 10, 0U, 1U, 0U, 2, 1, 30), FALSE);
  sf_mex_call_debug("error", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U, 14,
    c4_y));
}

static const mxArray *c4_f_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_u;
  const mxArray *c4_y = NULL;
  SFc4_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc4_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_u = *(int32_T *)c4_inData;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", &c4_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static int32_T c4_g_emlrt_marshallIn(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  int32_T c4_y;
  int32_T c4_i29;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_i29, 1, 6, 0U, 0, 0U, 0);
  c4_y = c4_i29;
  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void c4_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_b_sfEvent;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  int32_T c4_y;
  SFc4_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc4_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c4_b_sfEvent = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_sfEvent),
    &c4_thisId);
  sf_mex_destroy(&c4_b_sfEvent);
  *(int32_T *)c4_outData = c4_y;
  sf_mex_destroy(&c4_mxArrayInData);
}

static uint8_T c4_h_emlrt_marshallIn(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c4_b_is_active_c4_objectTrackingFilter, const
  char_T *c4_identifier)
{
  uint8_T c4_y;
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_i_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c4_b_is_active_c4_objectTrackingFilter), &c4_thisId);
  sf_mex_destroy(&c4_b_is_active_c4_objectTrackingFilter);
  return c4_y;
}

static uint8_T c4_i_emlrt_marshallIn(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  uint8_T c4_y;
  uint8_T c4_u0;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_u0, 1, 3, 0U, 0, 0U, 0);
  c4_y = c4_u0;
  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void init_dsm_address_info(SFc4_objectTrackingFilterInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c4_objectTrackingFilter_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3554347339U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2688472354U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2406846660U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3914860367U);
}

mxArray *sf_c4_objectTrackingFilter_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("oBuvaYxK1YQTh1scSlSJoF");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(3);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c4_objectTrackingFilter(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x5'type','srcId','name','auxInfo'{{M[1],M[11],T\"V\",},{M[1],M[13],T\"e\",},{M[1],M[5],T\"x_d\",},{M[4],M[0],T\"index\",S'l','i','p'{{M1x2[60 65],M[0],}}},{M[8],M[0],T\"is_active_c4_objectTrackingFilter\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 5, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c4_objectTrackingFilter_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc4_objectTrackingFilterInstanceStruct *chartInstance;
    chartInstance = (SFc4_objectTrackingFilterInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_objectTrackingFilterMachineNumber_,
           4,
           1,
           1,
           7,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_objectTrackingFilterMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_objectTrackingFilterMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds
            (_objectTrackingFilterMachineNumber_,
             chartInstance->chartNumber,
             0,
             0,
             0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"eta");
          _SFD_SET_DATA_PROPS(1,2,0,1,"x_d");
          _SFD_SET_DATA_PROPS(2,2,0,1,"V");
          _SFD_SET_DATA_PROPS(3,1,1,0,"intE");
          _SFD_SET_DATA_PROPS(4,2,0,1,"e");
          _SFD_SET_DATA_PROPS(5,1,1,0,"clock");
          _SFD_SET_DATA_PROPS(6,10,0,0,"WP");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,4,0,0,0,0,0,2,1);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,959);
        _SFD_CV_INIT_EML_IF(0,1,0,81,98,-1,155);
        _SFD_CV_INIT_EML_IF(0,1,1,455,468,-1,491);
        _SFD_CV_INIT_EML_IF(0,1,2,732,745,765,793);
        _SFD_CV_INIT_EML_IF(0,1,3,831,885,914,949);

        {
          static int condStart[] = { 834, 864 };

          static int condEnd[] = { 860, 885 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,0,834,885,2,0,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_b_sf_marshallOut,(MexInFcnForType)c4_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_b_sf_marshallOut,(MexInFcnForType)c4_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_b_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_b_sf_marshallOut,(MexInFcnForType)c4_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_b_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[2];
          dimVector[0]= 2;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_c_sf_marshallOut,(MexInFcnForType)
            c4_c_sf_marshallIn);
        }

        {
          real_T *c4_x_d;
          real_T *c4_V;
          real_T *c4_intE;
          real_T *c4_e;
          real_T *c4_clock;
          real_T (*c4_eta)[3];
          c4_clock = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c4_e = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c4_intE = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c4_V = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c4_x_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c4_eta = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c4_eta);
          _SFD_SET_DATA_VALUE_PTR(1U, c4_x_d);
          _SFD_SET_DATA_VALUE_PTR(2U, c4_V);
          _SFD_SET_DATA_VALUE_PTR(3U, c4_intE);
          _SFD_SET_DATA_VALUE_PTR(4U, c4_e);
          _SFD_SET_DATA_VALUE_PTR(5U, c4_clock);
          _SFD_SET_DATA_VALUE_PTR(6U, chartInstance->c4_WP);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration
        (_objectTrackingFilterMachineNumber_,chartInstance->chartNumber,
         chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "P6pKXkucouBhh2ydnPNzrG";
}

static void sf_opaque_initialize_c4_objectTrackingFilter(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc4_objectTrackingFilterInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c4_objectTrackingFilter
    ((SFc4_objectTrackingFilterInstanceStruct*) chartInstanceVar);
  initialize_c4_objectTrackingFilter((SFc4_objectTrackingFilterInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c4_objectTrackingFilter(void *chartInstanceVar)
{
  enable_c4_objectTrackingFilter((SFc4_objectTrackingFilterInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_disable_c4_objectTrackingFilter(void *chartInstanceVar)
{
  disable_c4_objectTrackingFilter((SFc4_objectTrackingFilterInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c4_objectTrackingFilter(void *chartInstanceVar)
{
  sf_c4_objectTrackingFilter((SFc4_objectTrackingFilterInstanceStruct*)
    chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c4_objectTrackingFilter
  (SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c4_objectTrackingFilter
    ((SFc4_objectTrackingFilterInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c4_objectTrackingFilter();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c4_objectTrackingFilter(SimStruct* S,
  const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c4_objectTrackingFilter();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c4_objectTrackingFilter((SFc4_objectTrackingFilterInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c4_objectTrackingFilter(SimStruct*
  S)
{
  return sf_internal_get_sim_state_c4_objectTrackingFilter(S);
}

static void sf_opaque_set_sim_state_c4_objectTrackingFilter(SimStruct* S, const
  mxArray *st)
{
  sf_internal_set_sim_state_c4_objectTrackingFilter(S, st);
}

static void sf_opaque_terminate_c4_objectTrackingFilter(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc4_objectTrackingFilterInstanceStruct*) chartInstanceVar
      )->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c4_objectTrackingFilter((SFc4_objectTrackingFilterInstanceStruct*)
      chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_objectTrackingFilter_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc4_objectTrackingFilter((SFc4_objectTrackingFilterInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c4_objectTrackingFilter(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c4_objectTrackingFilter
      ((SFc4_objectTrackingFilterInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c4_objectTrackingFilter(SimStruct *S)
{
  /* Actual parameters from chart:
     WP
   */
  const char_T *rtParamNames[] = { "p1" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for WP*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_objectTrackingFilter_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      4);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,4,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,4,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,4,3);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,4,3);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,4);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2258729621U));
  ssSetChecksum1(S,(835090015U));
  ssSetChecksum2(S,(2874310698U));
  ssSetChecksum3(S,(2119676330U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c4_objectTrackingFilter(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c4_objectTrackingFilter(SimStruct *S)
{
  SFc4_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc4_objectTrackingFilterInstanceStruct *)malloc(sizeof
    (SFc4_objectTrackingFilterInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc4_objectTrackingFilterInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c4_objectTrackingFilter;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c4_objectTrackingFilter;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c4_objectTrackingFilter;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c4_objectTrackingFilter;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c4_objectTrackingFilter;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c4_objectTrackingFilter;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c4_objectTrackingFilter;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c4_objectTrackingFilter;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c4_objectTrackingFilter;
  chartInstance->chartInfo.mdlStart = mdlStart_c4_objectTrackingFilter;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c4_objectTrackingFilter;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c4_objectTrackingFilter_method_dispatcher(SimStruct *S, int_T method, void *
  data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c4_objectTrackingFilter(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c4_objectTrackingFilter(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c4_objectTrackingFilter(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c4_objectTrackingFilter_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
