#ifndef __c5_Dubins_vehicle_simulator_h__
#define __c5_Dubins_vehicle_simulator_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_c5_ResolvedFunctionInfo
#define typedef_c5_ResolvedFunctionInfo

typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c5_ResolvedFunctionInfo;

#endif                                 /*typedef_c5_ResolvedFunctionInfo*/

#ifndef typedef_SFc5_Dubins_vehicle_simulatorInstanceStruct
#define typedef_SFc5_Dubins_vehicle_simulatorInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c5_sfEvent;
  boolean_T c5_isStable;
  boolean_T c5_doneDoubleBufferReInit;
  uint8_T c5_is_active_c5_Dubins_vehicle_simulator;
  real_T c5_target[2];
  real_T c5_Wp_k1[2];
  boolean_T c5_Wp_k1_not_empty;
  real_T c5_WP_data[2000];
  int32_T c5_WP_sizes[2];
  boolean_T c5_WP_not_empty;
  real_T c5_index;
  boolean_T c5_index_not_empty;
  real_T c5_DirectPathToTarget;
  boolean_T c5_DirectPathToTarget_not_empty;
  real_T c5_LastObstacle[2];
  boolean_T c5_LastObstacle_not_empty;
  boolean_T c5_lastVelocity_not_empty;
  boolean_T c5_LastObstacleList_not_empty;
} SFc5_Dubins_vehicle_simulatorInstanceStruct;

#endif                                 /*typedef_SFc5_Dubins_vehicle_simulatorInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray
  *sf_c5_Dubins_vehicle_simulator_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c5_Dubins_vehicle_simulator_get_check_sum(mxArray *plhs[]);
extern void c5_Dubins_vehicle_simulator_method_dispatcher(SimStruct *S, int_T
  method, void *data);

#endif
