#ifndef __c2_Dubins_h__
#define __c2_Dubins_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_c2_ResolvedFunctionInfo
#define typedef_c2_ResolvedFunctionInfo

typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c2_ResolvedFunctionInfo;

#endif                                 /*typedef_c2_ResolvedFunctionInfo*/

#ifndef typedef_SFc2_DubinsInstanceStruct
#define typedef_SFc2_DubinsInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c2_sfEvent;
  boolean_T c2_isStable;
  boolean_T c2_doneDoubleBufferReInit;
  uint8_T c2_is_active_c2_Dubins;
  real_T c2_Wp_k2[2];
  boolean_T c2_Wp_k2_not_empty;
  real_T c2_LastObstacle[4];
  boolean_T c2_LastObstacle_not_empty;
  real_T c2_WP_data[2000];
  int32_T c2_WP_sizes[2];
  boolean_T c2_WP_not_empty;
  real_T c2_index;
  boolean_T c2_index_not_empty;
  real_T c2_safteyCircle;
  boolean_T c2_safteyCircle_not_empty;
  real_T c2_ClockWise;
  boolean_T c2_ClockWise_not_empty;
  real_T c2_lastVelocity[2];
  boolean_T c2_lastVelocity_not_empty;
  real_T c2_LastObstacleList[8];
  boolean_T c2_LastObstacleList_not_empty;
} SFc2_DubinsInstanceStruct;

#endif                                 /*typedef_SFc2_DubinsInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c2_Dubins_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c2_Dubins_get_check_sum(mxArray *plhs[]);
extern void c2_Dubins_method_dispatcher(SimStruct *S, int_T method, void *data);

#endif
