/* Include files */

#include "blascompat32.h"
#include "Dubins_sfun.h"
#include "c3_Dubins.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "Dubins_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c3_debug_family_names[14] = { "searchRadius", "b", "c",
  "theta", "lengthObVes", "tempDisObsVes", "nargin", "nargout", "eta", "obslist",
  "target", "vehicle_velocityList", "obs", "ObsList" };

/* Function Declarations */
static void initialize_c3_Dubins(SFc3_DubinsInstanceStruct *chartInstance);
static void initialize_params_c3_Dubins(SFc3_DubinsInstanceStruct *chartInstance);
static void enable_c3_Dubins(SFc3_DubinsInstanceStruct *chartInstance);
static void disable_c3_Dubins(SFc3_DubinsInstanceStruct *chartInstance);
static void c3_update_debugger_state_c3_Dubins(SFc3_DubinsInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c3_Dubins(SFc3_DubinsInstanceStruct
  *chartInstance);
static void set_sim_state_c3_Dubins(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_st);
static void finalize_c3_Dubins(SFc3_DubinsInstanceStruct *chartInstance);
static void sf_c3_Dubins(SFc3_DubinsInstanceStruct *chartInstance);
static void c3_chartstep_c3_Dubins(SFc3_DubinsInstanceStruct *chartInstance);
static void initSimStructsc3_Dubins(SFc3_DubinsInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
  c3_chartNumber);
static const mxArray *c3_sf_marshallOut(void *chartInstanceVoid, void *c3_inData);
static void c3_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance, const
  mxArray *c3_ObsList, const char_T *c3_identifier, real_T c3_y[8]);
static void c3_b_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId, real_T c3_y[8]);
static void c3_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static const mxArray *c3_b_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static void c3_c_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_obs, const char_T *c3_identifier, real_T c3_y[4]);
static void c3_d_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId, real_T c3_y[4]);
static void c3_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static const mxArray *c3_c_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static const mxArray *c3_d_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static real_T c3_e_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void c3_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static const mxArray *c3_e_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static creal_T c3_f_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void c3_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static void c3_g_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId, real_T c3_y[2]);
static void c3_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static void c3_info_helper(c3_ResolvedFunctionInfo c3_info[79]);
static void c3_b_info_helper(c3_ResolvedFunctionInfo c3_info[79]);
static void c3_eml_scalar_eg(SFc3_DubinsInstanceStruct *chartInstance);
static void c3_check_forloop_overflow_error(SFc3_DubinsInstanceStruct
  *chartInstance);
static real_T c3_norm(SFc3_DubinsInstanceStruct *chartInstance, real_T c3_x[2]);
static creal_T c3_eml_scalar_sqrt(SFc3_DubinsInstanceStruct *chartInstance,
  creal_T c3_x);
static void c3_realmax(SFc3_DubinsInstanceStruct *chartInstance);
static real_T c3_eml_scalar_hypot(SFc3_DubinsInstanceStruct *chartInstance,
  real_T c3_x, real_T c3_y);
static void c3_eps(SFc3_DubinsInstanceStruct *chartInstance);
static const mxArray *c3_f_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static int32_T c3_h_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void c3_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static uint8_T c3_i_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_b_is_active_c3_Dubins, const char_T *c3_identifier);
static uint8_T c3_j_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void c3_b_eml_scalar_sqrt(SFc3_DubinsInstanceStruct *chartInstance,
  creal_T *c3_x);
static void init_dsm_address_info(SFc3_DubinsInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c3_Dubins(SFc3_DubinsInstanceStruct *chartInstance)
{
  chartInstance->c3_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c3_is_active_c3_Dubins = 0U;
}

static void initialize_params_c3_Dubins(SFc3_DubinsInstanceStruct *chartInstance)
{
}

static void enable_c3_Dubins(SFc3_DubinsInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c3_Dubins(SFc3_DubinsInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c3_update_debugger_state_c3_Dubins(SFc3_DubinsInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c3_Dubins(SFc3_DubinsInstanceStruct
  *chartInstance)
{
  const mxArray *c3_st;
  const mxArray *c3_y = NULL;
  int32_T c3_i0;
  real_T c3_u[8];
  const mxArray *c3_b_y = NULL;
  int32_T c3_i1;
  real_T c3_b_u[4];
  const mxArray *c3_c_y = NULL;
  uint8_T c3_hoistedGlobal;
  uint8_T c3_c_u;
  const mxArray *c3_d_y = NULL;
  real_T (*c3_obs)[4];
  real_T (*c3_ObsList)[8];
  c3_ObsList = (real_T (*)[8])ssGetOutputPortSignal(chartInstance->S, 2);
  c3_obs = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c3_st = NULL;
  c3_st = NULL;
  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_createcellarray(3), FALSE);
  for (c3_i0 = 0; c3_i0 < 8; c3_i0++) {
    c3_u[c3_i0] = (*c3_ObsList)[c3_i0];
  }

  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create("y", c3_u, 0, 0U, 1U, 0U, 2, 2, 4), FALSE);
  sf_mex_setcell(c3_y, 0, c3_b_y);
  for (c3_i1 = 0; c3_i1 < 4; c3_i1++) {
    c3_b_u[c3_i1] = (*c3_obs)[c3_i1];
  }

  c3_c_y = NULL;
  sf_mex_assign(&c3_c_y, sf_mex_create("y", c3_b_u, 0, 0U, 1U, 0U, 2, 1, 4),
                FALSE);
  sf_mex_setcell(c3_y, 1, c3_c_y);
  c3_hoistedGlobal = chartInstance->c3_is_active_c3_Dubins;
  c3_c_u = c3_hoistedGlobal;
  c3_d_y = NULL;
  sf_mex_assign(&c3_d_y, sf_mex_create("y", &c3_c_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 2, c3_d_y);
  sf_mex_assign(&c3_st, c3_y, FALSE);
  return c3_st;
}

static void set_sim_state_c3_Dubins(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_st)
{
  const mxArray *c3_u;
  real_T c3_dv0[8];
  int32_T c3_i2;
  real_T c3_dv1[4];
  int32_T c3_i3;
  real_T (*c3_ObsList)[8];
  real_T (*c3_obs)[4];
  c3_ObsList = (real_T (*)[8])ssGetOutputPortSignal(chartInstance->S, 2);
  c3_obs = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c3_doneDoubleBufferReInit = TRUE;
  c3_u = sf_mex_dup(c3_st);
  c3_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c3_u, 0)),
                      "ObsList", c3_dv0);
  for (c3_i2 = 0; c3_i2 < 8; c3_i2++) {
    (*c3_ObsList)[c3_i2] = c3_dv0[c3_i2];
  }

  c3_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c3_u, 1)),
                        "obs", c3_dv1);
  for (c3_i3 = 0; c3_i3 < 4; c3_i3++) {
    (*c3_obs)[c3_i3] = c3_dv1[c3_i3];
  }

  chartInstance->c3_is_active_c3_Dubins = c3_i_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c3_u, 2)), "is_active_c3_Dubins");
  sf_mex_destroy(&c3_u);
  c3_update_debugger_state_c3_Dubins(chartInstance);
  sf_mex_destroy(&c3_st);
}

static void finalize_c3_Dubins(SFc3_DubinsInstanceStruct *chartInstance)
{
}

static void sf_c3_Dubins(SFc3_DubinsInstanceStruct *chartInstance)
{
  int32_T c3_i4;
  int32_T c3_i5;
  int32_T c3_i6;
  int32_T c3_i7;
  int32_T c3_i8;
  real_T *c3_vehicle_velocityList;
  real_T (*c3_ObsList)[8];
  real_T (*c3_target)[2];
  real_T (*c3_obslist)[8];
  real_T (*c3_obs)[4];
  real_T (*c3_eta)[2];
  c3_vehicle_velocityList = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c3_ObsList = (real_T (*)[8])ssGetOutputPortSignal(chartInstance->S, 2);
  c3_target = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 2);
  c3_obslist = (real_T (*)[8])ssGetInputPortSignal(chartInstance->S, 1);
  c3_obs = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c3_eta = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 2U, chartInstance->c3_sfEvent);
  for (c3_i4 = 0; c3_i4 < 2; c3_i4++) {
    _SFD_DATA_RANGE_CHECK((*c3_eta)[c3_i4], 0U);
  }

  for (c3_i5 = 0; c3_i5 < 4; c3_i5++) {
    _SFD_DATA_RANGE_CHECK((*c3_obs)[c3_i5], 1U);
  }

  for (c3_i6 = 0; c3_i6 < 8; c3_i6++) {
    _SFD_DATA_RANGE_CHECK((*c3_obslist)[c3_i6], 2U);
  }

  for (c3_i7 = 0; c3_i7 < 2; c3_i7++) {
    _SFD_DATA_RANGE_CHECK((*c3_target)[c3_i7], 3U);
  }

  for (c3_i8 = 0; c3_i8 < 8; c3_i8++) {
    _SFD_DATA_RANGE_CHECK((*c3_ObsList)[c3_i8], 4U);
  }

  _SFD_DATA_RANGE_CHECK(*c3_vehicle_velocityList, 5U);
  chartInstance->c3_sfEvent = CALL_EVENT;
  c3_chartstep_c3_Dubins(chartInstance);
  sf_debug_check_for_state_inconsistency(_DubinsMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c3_chartstep_c3_Dubins(SFc3_DubinsInstanceStruct *chartInstance)
{
  real_T c3_hoistedGlobal;
  int32_T c3_i9;
  real_T c3_eta[2];
  int32_T c3_i10;
  real_T c3_obslist[8];
  int32_T c3_i11;
  real_T c3_target[2];
  real_T c3_vehicle_velocityList;
  uint32_T c3_debug_family_var_map[14];
  real_T c3_searchRadius;
  real_T c3_b[2];
  real_T c3_c[2];
  creal_T c3_theta;
  real_T c3_lengthObVes;
  real_T c3_tempDisObsVes;
  real_T c3_nargin = 4.0;
  real_T c3_nargout = 2.0;
  real_T c3_obs[4];
  real_T c3_ObsList[8];
  int32_T c3_i;
  real_T c3_b_i;
  int32_T c3_i12;
  int32_T c3_c_i;
  int32_T c3_i13;
  int32_T c3_i14;
  real_T c3_a[2];
  int32_T c3_i15;
  real_T c3_b_b[2];
  real_T c3_b_c;
  int32_T c3_k;
  int32_T c3_b_k;
  int32_T c3_i16;
  real_T c3_c_b[2];
  real_T c3_b_a;
  int32_T c3_i17;
  real_T c3_c_c[2];
  real_T c3_d_b;
  real_T c3_y;
  real_T c3_A;
  real_T c3_B;
  real_T c3_x;
  real_T c3_b_y;
  real_T c3_b_x;
  real_T c3_c_y;
  real_T c3_d_y;
  creal_T c3_v;
  static creal_T c3_dc0 = { 1.0, 0.0 };

  creal_T c3_u;
  real_T c3_c_x;
  real_T c3_e_y;
  real_T c3_d_x;
  real_T c3_f_y;
  real_T c3_g_y;
  real_T c3_e_x;
  real_T c3_r;
  real_T c3_e_b;
  real_T c3_yr;
  real_T c3_f_x;
  real_T c3_yi;
  boolean_T c3_xneg;
  real_T c3_t;
  real_T c3_z;
  real_T c3_g_x;
  real_T c3_h_x;
  real_T c3_absz;
  real_T c3_i_x;
  real_T c3_j_x;
  boolean_T c3_f_b;
  boolean_T c3_b0;
  real_T c3_k_x;
  boolean_T c3_g_b;
  boolean_T c3_b1;
  boolean_T c3_h_b;
  real_T c3_l_x;
  real_T c3_b_u;
  real_T c3_m_x;
  real_T c3_n_x;
  int32_T c3_d_i;
  int32_T c3_i18;
  real_T c3_b_obslist[2];
  int32_T c3_i19;
  int32_T c3_i20;
  int32_T c3_e_i;
  int32_T c3_f_i;
  int32_T c3_i21;
  real_T c3_c_obslist[2];
  int32_T c3_g_i;
  int32_T c3_i22;
  int32_T c3_i23;
  int32_T c3_i24;
  int32_T c3_i25;
  real_T *c3_b_vehicle_velocityList;
  real_T (*c3_b_ObsList)[8];
  real_T (*c3_b_obs)[4];
  real_T (*c3_b_target)[2];
  real_T (*c3_d_obslist)[8];
  real_T (*c3_b_eta)[2];
  boolean_T guard1 = FALSE;
  c3_b_vehicle_velocityList = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c3_b_ObsList = (real_T (*)[8])ssGetOutputPortSignal(chartInstance->S, 2);
  c3_b_target = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 2);
  c3_d_obslist = (real_T (*)[8])ssGetInputPortSignal(chartInstance->S, 1);
  c3_b_obs = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c3_b_eta = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 2U, chartInstance->c3_sfEvent);
  c3_hoistedGlobal = *c3_b_vehicle_velocityList;
  for (c3_i9 = 0; c3_i9 < 2; c3_i9++) {
    c3_eta[c3_i9] = (*c3_b_eta)[c3_i9];
  }

  for (c3_i10 = 0; c3_i10 < 8; c3_i10++) {
    c3_obslist[c3_i10] = (*c3_d_obslist)[c3_i10];
  }

  for (c3_i11 = 0; c3_i11 < 2; c3_i11++) {
    c3_target[c3_i11] = (*c3_b_target)[c3_i11];
  }

  c3_vehicle_velocityList = c3_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 14U, 14U, c3_debug_family_names,
    c3_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c3_searchRadius, 0U,
    c3_c_sf_marshallOut, c3_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c3_b, 1U, c3_d_sf_marshallOut,
    c3_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c3_c, 2U, c3_d_sf_marshallOut,
    c3_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c3_theta, 3U, c3_e_sf_marshallOut,
    c3_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c3_lengthObVes, 4U,
    c3_c_sf_marshallOut, c3_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c3_tempDisObsVes, 5U,
    c3_c_sf_marshallOut, c3_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c3_nargin, 6U, c3_c_sf_marshallOut,
    c3_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c3_nargout, 7U, c3_c_sf_marshallOut,
    c3_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c3_eta, 8U, c3_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c3_obslist, 9U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c3_target, 10U, c3_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_vehicle_velocityList, 11U,
    c3_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c3_obs, 12U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c3_ObsList, 13U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 5);
  c3_searchRadius = 90.0;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 11);
  c3_i = 0;
  while (c3_i < 2) {
    c3_b_i = 1.0 + (real_T)c3_i;
    CV_EML_FOR(0, 1, 0, 1);
    _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 12);
    for (c3_i12 = 0; c3_i12 < 2; c3_i12++) {
      c3_b[c3_i12] = c3_target[c3_i12] - c3_eta[c3_i12];
    }

    _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 13);
    c3_c_i = _SFD_EML_ARRAY_BOUNDS_CHECK("obslist", (int32_T)_SFD_INTEGER_CHECK(
      "i", c3_b_i), 1, 2, 1, 0) - 1;
    for (c3_i13 = 0; c3_i13 < 2; c3_i13++) {
      c3_c[c3_i13] = c3_eta[c3_i13] - c3_obslist[c3_c_i + (c3_i13 << 1)];
    }

    _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 14);
    for (c3_i14 = 0; c3_i14 < 2; c3_i14++) {
      c3_a[c3_i14] = c3_b[c3_i14];
    }

    for (c3_i15 = 0; c3_i15 < 2; c3_i15++) {
      c3_b_b[c3_i15] = c3_c[c3_i15];
    }

    c3_eml_scalar_eg(chartInstance);
    c3_eml_scalar_eg(chartInstance);
    c3_b_c = 0.0;
    c3_check_forloop_overflow_error(chartInstance);
    for (c3_k = 1; c3_k < 3; c3_k++) {
      c3_b_k = c3_k;
      c3_b_c += c3_a[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK
        ("", (real_T)c3_b_k), 1, 2, 1, 0) - 1] *
        c3_b_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
        (real_T)c3_b_k), 1, 2, 1, 0) - 1];
    }

    for (c3_i16 = 0; c3_i16 < 2; c3_i16++) {
      c3_c_b[c3_i16] = c3_b[c3_i16];
    }

    c3_b_a = c3_norm(chartInstance, c3_c_b);
    for (c3_i17 = 0; c3_i17 < 2; c3_i17++) {
      c3_c_c[c3_i17] = c3_c[c3_i17];
    }

    c3_d_b = c3_norm(chartInstance, c3_c_c);
    c3_y = c3_b_a * c3_d_b;
    c3_A = c3_b_c;
    c3_B = c3_y;
    c3_x = c3_A;
    c3_b_y = c3_B;
    c3_b_x = c3_x;
    c3_c_y = c3_b_y;
    c3_d_y = c3_b_x / c3_c_y;
    c3_v.re = c3_d_y;
    c3_v.im = 0.0;
    c3_theta = c3_v;
    c3_v = c3_theta;
    c3_theta = c3_v;
    c3_v.re = c3_dc0.re + c3_theta.re;
    c3_v.im = c3_dc0.im + c3_theta.im;
    c3_b_eml_scalar_sqrt(chartInstance, &c3_v);
    c3_u.re = c3_dc0.re - c3_theta.re;
    c3_u.im = c3_dc0.im - c3_theta.im;
    c3_b_eml_scalar_sqrt(chartInstance, &c3_u);
    c3_c_x = c3_u.re;
    c3_e_y = muDoubleScalarAbs(c3_c_x);
    c3_d_x = c3_v.re;
    c3_f_y = muDoubleScalarAbs(c3_d_x);
    c3_g_y = c3_e_y;
    c3_e_x = c3_f_y;
    c3_r = muDoubleScalarAtan2(c3_g_y, c3_e_x);
    c3_e_b = c3_r;
    c3_yr = 2.0 * c3_e_b;
    if (c3_u.re < 0.0 != c3_v.re < 0.0) {
      c3_yr = -c3_yr;
    }

    c3_f_x = c3_u.im * c3_v.re - c3_u.re * c3_v.im;
    c3_yi = c3_f_x;
    c3_xneg = (c3_yi < 0.0);
    if (c3_xneg) {
      c3_yi = -c3_yi;
    }

    if (c3_yi >= 2.68435456E+8) {
      c3_yi = muDoubleScalarLog(c3_yi) + 0.69314718055994529;
    } else if (c3_yi > 2.0) {
      c3_yi = muDoubleScalarLog(2.0 * c3_yi + 1.0 / (muDoubleScalarSqrt(c3_yi *
        c3_yi + 1.0) + c3_yi));
    } else {
      c3_t = c3_yi * c3_yi;
      c3_z = c3_yi + c3_t / (1.0 + muDoubleScalarSqrt(1.0 + c3_t));
      c3_yi = c3_z;
      c3_g_x = c3_yi;
      c3_h_x = c3_g_x;
      c3_absz = muDoubleScalarAbs(c3_h_x);
      c3_eps(chartInstance);
      guard1 = FALSE;
      if (c3_absz > 4.503599627370496E+15) {
        guard1 = TRUE;
      } else {
        c3_i_x = c3_yi;
        c3_j_x = c3_i_x;
        c3_f_b = muDoubleScalarIsInf(c3_j_x);
        c3_b0 = !c3_f_b;
        c3_k_x = c3_i_x;
        c3_g_b = muDoubleScalarIsNaN(c3_k_x);
        c3_b1 = !c3_g_b;
        c3_h_b = (c3_b0 && c3_b1);
        if (!c3_h_b) {
          guard1 = TRUE;
        } else {
          c3_eps(chartInstance);
          if (c3_absz < 2.2204460492503131E-16) {
          } else {
            c3_b_u = 1.0 + c3_yi;
            c3_m_x = c3_b_u;
            c3_n_x = c3_m_x;
            c3_realmax(chartInstance);
            c3_n_x = muDoubleScalarLog(c3_n_x);
            c3_yi = c3_n_x * (c3_yi / (c3_b_u - 1.0));
          }
        }
      }

      if (guard1 == TRUE) {
        c3_l_x = 1.0 + c3_yi;
        c3_yi = c3_l_x;
        c3_realmax(chartInstance);
        c3_yi = muDoubleScalarLog(c3_yi);
      }
    }

    if (c3_xneg) {
      c3_yi = -c3_yi;
    }

    c3_theta.re = c3_yr;
    c3_theta.im = c3_yi;
    _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 16);
    c3_d_i = _SFD_EML_ARRAY_BOUNDS_CHECK("obslist", (int32_T)_SFD_INTEGER_CHECK(
      "i", c3_b_i), 1, 2, 1, 0) - 1;
    for (c3_i18 = 0; c3_i18 < 2; c3_i18++) {
      c3_b_obslist[c3_i18] = c3_obslist[c3_d_i + (c3_i18 << 1)] - c3_eta[c3_i18];
    }

    if (CV_EML_IF(0, 1, 0, c3_norm(chartInstance, c3_b_obslist) <
                  c3_searchRadius)) {
      _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 17);
      c3_obslist[_SFD_EML_ARRAY_BOUNDS_CHECK("obslist", (int32_T)
        _SFD_INTEGER_CHECK("i", c3_b_i), 1, 2, 1, 0) + 5] = 1.0;
    }

    c3_i++;
    sf_mex_listen_for_ctrl_c(chartInstance->S);
  }

  CV_EML_FOR(0, 1, 0, 0);
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 26);
  c3_i19 = 0;
  for (c3_i20 = 0; c3_i20 < 4; c3_i20++) {
    c3_obs[c3_i20] = c3_obslist[c3_i19];
    c3_i19 += 2;
  }

  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 27);
  c3_lengthObVes = c3_searchRadius;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 28);
  c3_e_i = 0;
  while (c3_e_i < 2) {
    c3_b_i = 1.0 + (real_T)c3_e_i;
    CV_EML_FOR(0, 1, 1, 1);
    _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 29);
    if (CV_EML_IF(0, 1, 1, c3_obslist[_SFD_EML_ARRAY_BOUNDS_CHECK("obslist",
          (int32_T)_SFD_INTEGER_CHECK("i", c3_b_i), 1, 2, 1, 0) + 5] > 0.0)) {
      _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 32);
      c3_f_i = _SFD_EML_ARRAY_BOUNDS_CHECK("obslist", (int32_T)
        _SFD_INTEGER_CHECK("i", c3_b_i), 1, 2, 1, 0) - 1;
      for (c3_i21 = 0; c3_i21 < 2; c3_i21++) {
        c3_c_obslist[c3_i21] = c3_obslist[c3_f_i + (c3_i21 << 1)] -
          c3_eta[c3_i21];
      }

      c3_tempDisObsVes = c3_norm(chartInstance, c3_c_obslist) -
        c3_obslist[_SFD_EML_ARRAY_BOUNDS_CHECK("obslist", (int32_T)
        _SFD_INTEGER_CHECK("i", c3_b_i), 1, 2, 1, 0) + 3];
      _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 34);
      if (CV_EML_IF(0, 1, 2, c3_tempDisObsVes <= c3_lengthObVes)) {
        _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 35);
        c3_g_i = _SFD_EML_ARRAY_BOUNDS_CHECK("obslist", (int32_T)
          _SFD_INTEGER_CHECK("i", c3_b_i), 1, 2, 1, 0) - 1;
        for (c3_i22 = 0; c3_i22 < 4; c3_i22++) {
          c3_obs[c3_i22] = c3_obslist[c3_g_i + (c3_i22 << 1)];
        }

        _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 36);
        c3_lengthObVes = c3_tempDisObsVes;
      }
    }

    c3_e_i++;
    sf_mex_listen_for_ctrl_c(chartInstance->S);
  }

  CV_EML_FOR(0, 1, 1, 0);
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 43);
  for (c3_i23 = 0; c3_i23 < 8; c3_i23++) {
    c3_ObsList[c3_i23] = c3_obslist[c3_i23];
  }

  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, -43);
  sf_debug_symbol_scope_pop();
  for (c3_i24 = 0; c3_i24 < 4; c3_i24++) {
    (*c3_b_obs)[c3_i24] = c3_obs[c3_i24];
  }

  for (c3_i25 = 0; c3_i25 < 8; c3_i25++) {
    (*c3_b_ObsList)[c3_i25] = c3_ObsList[c3_i25];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 2U, chartInstance->c3_sfEvent);
}

static void initSimStructsc3_Dubins(SFc3_DubinsInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
  c3_chartNumber)
{
}

static const mxArray *c3_sf_marshallOut(void *chartInstanceVoid, void *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  int32_T c3_i26;
  int32_T c3_i27;
  int32_T c3_i28;
  real_T c3_b_inData[8];
  int32_T c3_i29;
  int32_T c3_i30;
  int32_T c3_i31;
  real_T c3_u[8];
  const mxArray *c3_y = NULL;
  SFc3_DubinsInstanceStruct *chartInstance;
  chartInstance = (SFc3_DubinsInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_i26 = 0;
  for (c3_i27 = 0; c3_i27 < 4; c3_i27++) {
    for (c3_i28 = 0; c3_i28 < 2; c3_i28++) {
      c3_b_inData[c3_i28 + c3_i26] = (*(real_T (*)[8])c3_inData)[c3_i28 + c3_i26];
    }

    c3_i26 += 2;
  }

  c3_i29 = 0;
  for (c3_i30 = 0; c3_i30 < 4; c3_i30++) {
    for (c3_i31 = 0; c3_i31 < 2; c3_i31++) {
      c3_u[c3_i31 + c3_i29] = c3_b_inData[c3_i31 + c3_i29];
    }

    c3_i29 += 2;
  }

  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", c3_u, 0, 0U, 1U, 0U, 2, 2, 4), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static void c3_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance, const
  mxArray *c3_ObsList, const char_T *c3_identifier, real_T c3_y[8])
{
  emlrtMsgIdentifier c3_thisId;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_ObsList), &c3_thisId, c3_y);
  sf_mex_destroy(&c3_ObsList);
}

static void c3_b_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId, real_T c3_y[8])
{
  real_T c3_dv2[8];
  int32_T c3_i32;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), c3_dv2, 1, 0, 0U, 1, 0U, 2, 2, 4);
  for (c3_i32 = 0; c3_i32 < 8; c3_i32++) {
    c3_y[c3_i32] = c3_dv2[c3_i32];
  }

  sf_mex_destroy(&c3_u);
}

static void c3_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_ObsList;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  real_T c3_y[8];
  int32_T c3_i33;
  int32_T c3_i34;
  int32_T c3_i35;
  SFc3_DubinsInstanceStruct *chartInstance;
  chartInstance = (SFc3_DubinsInstanceStruct *)chartInstanceVoid;
  c3_ObsList = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_ObsList), &c3_thisId, c3_y);
  sf_mex_destroy(&c3_ObsList);
  c3_i33 = 0;
  for (c3_i34 = 0; c3_i34 < 4; c3_i34++) {
    for (c3_i35 = 0; c3_i35 < 2; c3_i35++) {
      (*(real_T (*)[8])c3_outData)[c3_i35 + c3_i33] = c3_y[c3_i35 + c3_i33];
    }

    c3_i33 += 2;
  }

  sf_mex_destroy(&c3_mxArrayInData);
}

static const mxArray *c3_b_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  int32_T c3_i36;
  real_T c3_b_inData[4];
  int32_T c3_i37;
  real_T c3_u[4];
  const mxArray *c3_y = NULL;
  SFc3_DubinsInstanceStruct *chartInstance;
  chartInstance = (SFc3_DubinsInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  for (c3_i36 = 0; c3_i36 < 4; c3_i36++) {
    c3_b_inData[c3_i36] = (*(real_T (*)[4])c3_inData)[c3_i36];
  }

  for (c3_i37 = 0; c3_i37 < 4; c3_i37++) {
    c3_u[c3_i37] = c3_b_inData[c3_i37];
  }

  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", c3_u, 0, 0U, 1U, 0U, 2, 1, 4), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static void c3_c_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_obs, const char_T *c3_identifier, real_T c3_y[4])
{
  emlrtMsgIdentifier c3_thisId;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_obs), &c3_thisId, c3_y);
  sf_mex_destroy(&c3_obs);
}

static void c3_d_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId, real_T c3_y[4])
{
  real_T c3_dv3[4];
  int32_T c3_i38;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), c3_dv3, 1, 0, 0U, 1, 0U, 2, 1, 4);
  for (c3_i38 = 0; c3_i38 < 4; c3_i38++) {
    c3_y[c3_i38] = c3_dv3[c3_i38];
  }

  sf_mex_destroy(&c3_u);
}

static void c3_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_obs;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  real_T c3_y[4];
  int32_T c3_i39;
  SFc3_DubinsInstanceStruct *chartInstance;
  chartInstance = (SFc3_DubinsInstanceStruct *)chartInstanceVoid;
  c3_obs = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_obs), &c3_thisId, c3_y);
  sf_mex_destroy(&c3_obs);
  for (c3_i39 = 0; c3_i39 < 4; c3_i39++) {
    (*(real_T (*)[4])c3_outData)[c3_i39] = c3_y[c3_i39];
  }

  sf_mex_destroy(&c3_mxArrayInData);
}

static const mxArray *c3_c_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  real_T c3_u;
  const mxArray *c3_y = NULL;
  SFc3_DubinsInstanceStruct *chartInstance;
  chartInstance = (SFc3_DubinsInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_u = *(real_T *)c3_inData;
  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", &c3_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static const mxArray *c3_d_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  int32_T c3_i40;
  real_T c3_b_inData[2];
  int32_T c3_i41;
  real_T c3_u[2];
  const mxArray *c3_y = NULL;
  SFc3_DubinsInstanceStruct *chartInstance;
  chartInstance = (SFc3_DubinsInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  for (c3_i40 = 0; c3_i40 < 2; c3_i40++) {
    c3_b_inData[c3_i40] = (*(real_T (*)[2])c3_inData)[c3_i40];
  }

  for (c3_i41 = 0; c3_i41 < 2; c3_i41++) {
    c3_u[c3_i41] = c3_b_inData[c3_i41];
  }

  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", c3_u, 0, 0U, 1U, 0U, 1, 2), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static real_T c3_e_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  real_T c3_y;
  real_T c3_d0;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_d0, 1, 0, 0U, 0, 0U, 0);
  c3_y = c3_d0;
  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void c3_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_nargout;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  real_T c3_y;
  SFc3_DubinsInstanceStruct *chartInstance;
  chartInstance = (SFc3_DubinsInstanceStruct *)chartInstanceVoid;
  c3_nargout = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_nargout), &c3_thisId);
  sf_mex_destroy(&c3_nargout);
  *(real_T *)c3_outData = c3_y;
  sf_mex_destroy(&c3_mxArrayInData);
}

static const mxArray *c3_e_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  creal_T c3_u;
  const mxArray *c3_y = NULL;
  SFc3_DubinsInstanceStruct *chartInstance;
  chartInstance = (SFc3_DubinsInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_u = *(creal_T *)c3_inData;
  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", &c3_u, 0, 1U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static creal_T c3_f_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  creal_T c3_y;
  creal_T c3_dc1;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_dc1, 1, 0, 1U, 0, 0U, 0);
  c3_y = c3_dc1;
  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void c3_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_theta;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  creal_T c3_y;
  SFc3_DubinsInstanceStruct *chartInstance;
  chartInstance = (SFc3_DubinsInstanceStruct *)chartInstanceVoid;
  c3_theta = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_theta), &c3_thisId);
  sf_mex_destroy(&c3_theta);
  *(creal_T *)c3_outData = c3_y;
  sf_mex_destroy(&c3_mxArrayInData);
}

static void c3_g_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId, real_T c3_y[2])
{
  real_T c3_dv4[2];
  int32_T c3_i42;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), c3_dv4, 1, 0, 0U, 1, 0U, 1, 2);
  for (c3_i42 = 0; c3_i42 < 2; c3_i42++) {
    c3_y[c3_i42] = c3_dv4[c3_i42];
  }

  sf_mex_destroy(&c3_u);
}

static void c3_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_c;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  real_T c3_y[2];
  int32_T c3_i43;
  SFc3_DubinsInstanceStruct *chartInstance;
  chartInstance = (SFc3_DubinsInstanceStruct *)chartInstanceVoid;
  c3_c = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_c), &c3_thisId, c3_y);
  sf_mex_destroy(&c3_c);
  for (c3_i43 = 0; c3_i43 < 2; c3_i43++) {
    (*(real_T (*)[2])c3_outData)[c3_i43] = c3_y[c3_i43];
  }

  sf_mex_destroy(&c3_mxArrayInData);
}

const mxArray *sf_c3_Dubins_get_eml_resolved_functions_info(void)
{
  const mxArray *c3_nameCaptureInfo;
  c3_ResolvedFunctionInfo c3_info[79];
  const mxArray *c3_m0 = NULL;
  int32_T c3_i44;
  c3_ResolvedFunctionInfo *c3_r0;
  c3_nameCaptureInfo = NULL;
  c3_nameCaptureInfo = NULL;
  c3_info_helper(c3_info);
  c3_b_info_helper(c3_info);
  sf_mex_assign(&c3_m0, sf_mex_createstruct("nameCaptureInfo", 1, 79), FALSE);
  for (c3_i44 = 0; c3_i44 < 79; c3_i44++) {
    c3_r0 = &c3_info[c3_i44];
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c3_r0->context)), "context", "nameCaptureInfo",
                    c3_i44);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c3_r0->name)), "name", "nameCaptureInfo", c3_i44);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c3_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c3_i44);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c3_r0->resolved)), "resolved", "nameCaptureInfo",
                    c3_i44);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c3_i44);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c3_i44);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c3_i44);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c3_i44);
  }

  sf_mex_assign(&c3_nameCaptureInfo, c3_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c3_nameCaptureInfo);
  return c3_nameCaptureInfo;
}

static void c3_info_helper(c3_ResolvedFunctionInfo c3_info[79])
{
  c3_info[0].context = "";
  c3_info[0].name = "dot";
  c3_info[0].dominantType = "double";
  c3_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/specfun/dot.m";
  c3_info[0].fileTimeLo = 1313347816U;
  c3_info[0].fileTimeHi = 0U;
  c3_info[0].mFileTimeLo = 0U;
  c3_info[0].mFileTimeHi = 0U;
  c3_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/specfun/dot.m";
  c3_info[1].name = "isequal";
  c3_info[1].dominantType = "double";
  c3_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isequal.m";
  c3_info[1].fileTimeLo = 1286818758U;
  c3_info[1].fileTimeHi = 0U;
  c3_info[1].mFileTimeLo = 0U;
  c3_info[1].mFileTimeHi = 0U;
  c3_info[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isequal.m";
  c3_info[2].name = "eml_isequal_core";
  c3_info[2].dominantType = "double";
  c3_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_isequal_core.m";
  c3_info[2].fileTimeLo = 1286818786U;
  c3_info[2].fileTimeHi = 0U;
  c3_info[2].mFileTimeLo = 0U;
  c3_info[2].mFileTimeHi = 0U;
  c3_info[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_isequal_core.m!isequal_scalar";
  c3_info[3].name = "isnan";
  c3_info[3].dominantType = "double";
  c3_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isnan.m";
  c3_info[3].fileTimeLo = 1286818760U;
  c3_info[3].fileTimeHi = 0U;
  c3_info[3].mFileTimeLo = 0U;
  c3_info[3].mFileTimeHi = 0U;
  c3_info[4].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/specfun/dot.m";
  c3_info[4].name = "eml_index_class";
  c3_info[4].dominantType = "";
  c3_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c3_info[4].fileTimeLo = 1323170578U;
  c3_info[4].fileTimeHi = 0U;
  c3_info[4].mFileTimeLo = 0U;
  c3_info[4].mFileTimeHi = 0U;
  c3_info[5].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/specfun/dot.m";
  c3_info[5].name = "eml_scalar_eg";
  c3_info[5].dominantType = "double";
  c3_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c3_info[5].fileTimeLo = 1286818796U;
  c3_info[5].fileTimeHi = 0U;
  c3_info[5].mFileTimeLo = 0U;
  c3_info[5].mFileTimeHi = 0U;
  c3_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/specfun/dot.m!vdot";
  c3_info[6].name = "eml_xdotc";
  c3_info[6].dominantType = "double";
  c3_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotc.m";
  c3_info[6].fileTimeLo = 1299076772U;
  c3_info[6].fileTimeHi = 0U;
  c3_info[6].mFileTimeLo = 0U;
  c3_info[6].mFileTimeHi = 0U;
  c3_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotc.m";
  c3_info[7].name = "eml_blas_inline";
  c3_info[7].dominantType = "";
  c3_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c3_info[7].fileTimeLo = 1299076768U;
  c3_info[7].fileTimeHi = 0U;
  c3_info[7].mFileTimeLo = 0U;
  c3_info[7].mFileTimeHi = 0U;
  c3_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotc.m";
  c3_info[8].name = "eml_xdot";
  c3_info[8].dominantType = "double";
  c3_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdot.m";
  c3_info[8].fileTimeLo = 1299076772U;
  c3_info[8].fileTimeHi = 0U;
  c3_info[8].mFileTimeLo = 0U;
  c3_info[8].mFileTimeHi = 0U;
  c3_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdot.m";
  c3_info[9].name = "eml_blas_inline";
  c3_info[9].dominantType = "";
  c3_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c3_info[9].fileTimeLo = 1299076768U;
  c3_info[9].fileTimeHi = 0U;
  c3_info[9].mFileTimeLo = 0U;
  c3_info[9].mFileTimeHi = 0U;
  c3_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xdot.m!below_threshold";
  c3_info[10].name = "length";
  c3_info[10].dominantType = "double";
  c3_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  c3_info[10].fileTimeLo = 1303146206U;
  c3_info[10].fileTimeHi = 0U;
  c3_info[10].mFileTimeLo = 0U;
  c3_info[10].mFileTimeHi = 0U;
  c3_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xdot.m";
  c3_info[11].name = "eml_index_class";
  c3_info[11].dominantType = "";
  c3_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c3_info[11].fileTimeLo = 1323170578U;
  c3_info[11].fileTimeHi = 0U;
  c3_info[11].mFileTimeLo = 0U;
  c3_info[11].mFileTimeHi = 0U;
  c3_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xdot.m";
  c3_info[12].name = "eml_refblas_xdot";
  c3_info[12].dominantType = "double";
  c3_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdot.m";
  c3_info[12].fileTimeLo = 1299076772U;
  c3_info[12].fileTimeHi = 0U;
  c3_info[12].mFileTimeLo = 0U;
  c3_info[12].mFileTimeHi = 0U;
  c3_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdot.m";
  c3_info[13].name = "eml_refblas_xdotx";
  c3_info[13].dominantType = "char";
  c3_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c3_info[13].fileTimeLo = 1299076774U;
  c3_info[13].fileTimeHi = 0U;
  c3_info[13].mFileTimeLo = 0U;
  c3_info[13].mFileTimeHi = 0U;
  c3_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c3_info[14].name = "eml_scalar_eg";
  c3_info[14].dominantType = "double";
  c3_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c3_info[14].fileTimeLo = 1286818796U;
  c3_info[14].fileTimeHi = 0U;
  c3_info[14].mFileTimeLo = 0U;
  c3_info[14].mFileTimeHi = 0U;
  c3_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c3_info[15].name = "eml_index_class";
  c3_info[15].dominantType = "";
  c3_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c3_info[15].fileTimeLo = 1323170578U;
  c3_info[15].fileTimeHi = 0U;
  c3_info[15].mFileTimeLo = 0U;
  c3_info[15].mFileTimeHi = 0U;
  c3_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c3_info[16].name = "eml_int_forloop_overflow_check";
  c3_info[16].dominantType = "";
  c3_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c3_info[16].fileTimeLo = 1332168672U;
  c3_info[16].fileTimeHi = 0U;
  c3_info[16].mFileTimeLo = 0U;
  c3_info[16].mFileTimeHi = 0U;
  c3_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m!eml_int_forloop_overflow_check_helper";
  c3_info[17].name = "intmax";
  c3_info[17].dominantType = "char";
  c3_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c3_info[17].fileTimeLo = 1311255316U;
  c3_info[17].fileTimeHi = 0U;
  c3_info[17].mFileTimeLo = 0U;
  c3_info[17].mFileTimeHi = 0U;
  c3_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c3_info[18].name = "eml_index_minus";
  c3_info[18].dominantType = "double";
  c3_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c3_info[18].fileTimeLo = 1286818778U;
  c3_info[18].fileTimeHi = 0U;
  c3_info[18].mFileTimeLo = 0U;
  c3_info[18].mFileTimeHi = 0U;
  c3_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c3_info[19].name = "eml_index_class";
  c3_info[19].dominantType = "";
  c3_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c3_info[19].fileTimeLo = 1323170578U;
  c3_info[19].fileTimeHi = 0U;
  c3_info[19].mFileTimeLo = 0U;
  c3_info[19].mFileTimeHi = 0U;
  c3_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c3_info[20].name = "eml_index_times";
  c3_info[20].dominantType = "coder.internal.indexInt";
  c3_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c3_info[20].fileTimeLo = 1286818780U;
  c3_info[20].fileTimeHi = 0U;
  c3_info[20].mFileTimeLo = 0U;
  c3_info[20].mFileTimeHi = 0U;
  c3_info[21].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c3_info[21].name = "eml_index_class";
  c3_info[21].dominantType = "";
  c3_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c3_info[21].fileTimeLo = 1323170578U;
  c3_info[21].fileTimeHi = 0U;
  c3_info[21].mFileTimeLo = 0U;
  c3_info[21].mFileTimeHi = 0U;
  c3_info[22].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c3_info[22].name = "eml_index_plus";
  c3_info[22].dominantType = "coder.internal.indexInt";
  c3_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c3_info[22].fileTimeLo = 1286818778U;
  c3_info[22].fileTimeHi = 0U;
  c3_info[22].mFileTimeLo = 0U;
  c3_info[22].mFileTimeHi = 0U;
  c3_info[23].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c3_info[23].name = "eml_index_class";
  c3_info[23].dominantType = "";
  c3_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c3_info[23].fileTimeLo = 1323170578U;
  c3_info[23].fileTimeHi = 0U;
  c3_info[23].mFileTimeLo = 0U;
  c3_info[23].mFileTimeHi = 0U;
  c3_info[24].context = "";
  c3_info[24].name = "norm";
  c3_info[24].dominantType = "double";
  c3_info[24].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m";
  c3_info[24].fileTimeLo = 1336522094U;
  c3_info[24].fileTimeHi = 0U;
  c3_info[24].mFileTimeLo = 0U;
  c3_info[24].mFileTimeHi = 0U;
  c3_info[25].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!genpnorm";
  c3_info[25].name = "eml_index_class";
  c3_info[25].dominantType = "";
  c3_info[25].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c3_info[25].fileTimeLo = 1323170578U;
  c3_info[25].fileTimeHi = 0U;
  c3_info[25].mFileTimeLo = 0U;
  c3_info[25].mFileTimeHi = 0U;
  c3_info[26].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!genpnorm";
  c3_info[26].name = "eml_xnrm2";
  c3_info[26].dominantType = "double";
  c3_info[26].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xnrm2.m";
  c3_info[26].fileTimeLo = 1299076776U;
  c3_info[26].fileTimeHi = 0U;
  c3_info[26].mFileTimeLo = 0U;
  c3_info[26].mFileTimeHi = 0U;
  c3_info[27].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xnrm2.m";
  c3_info[27].name = "eml_blas_inline";
  c3_info[27].dominantType = "";
  c3_info[27].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c3_info[27].fileTimeLo = 1299076768U;
  c3_info[27].fileTimeHi = 0U;
  c3_info[27].mFileTimeLo = 0U;
  c3_info[27].mFileTimeHi = 0U;
  c3_info[28].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xnrm2.m";
  c3_info[28].name = "eml_index_class";
  c3_info[28].dominantType = "";
  c3_info[28].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c3_info[28].fileTimeLo = 1323170578U;
  c3_info[28].fileTimeHi = 0U;
  c3_info[28].mFileTimeLo = 0U;
  c3_info[28].mFileTimeHi = 0U;
  c3_info[29].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xnrm2.m";
  c3_info[29].name = "eml_refblas_xnrm2";
  c3_info[29].dominantType = "double";
  c3_info[29].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c3_info[29].fileTimeLo = 1299076784U;
  c3_info[29].fileTimeHi = 0U;
  c3_info[29].mFileTimeLo = 0U;
  c3_info[29].mFileTimeHi = 0U;
  c3_info[30].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c3_info[30].name = "realmin";
  c3_info[30].dominantType = "char";
  c3_info[30].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c3_info[30].fileTimeLo = 1307651242U;
  c3_info[30].fileTimeHi = 0U;
  c3_info[30].mFileTimeLo = 0U;
  c3_info[30].mFileTimeHi = 0U;
  c3_info[31].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c3_info[31].name = "eml_realmin";
  c3_info[31].dominantType = "char";
  c3_info[31].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmin.m";
  c3_info[31].fileTimeLo = 1307651244U;
  c3_info[31].fileTimeHi = 0U;
  c3_info[31].mFileTimeLo = 0U;
  c3_info[31].mFileTimeHi = 0U;
  c3_info[32].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmin.m";
  c3_info[32].name = "eml_float_model";
  c3_info[32].dominantType = "char";
  c3_info[32].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_float_model.m";
  c3_info[32].fileTimeLo = 1326727996U;
  c3_info[32].fileTimeHi = 0U;
  c3_info[32].mFileTimeLo = 0U;
  c3_info[32].mFileTimeHi = 0U;
  c3_info[33].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c3_info[33].name = "eml_index_class";
  c3_info[33].dominantType = "";
  c3_info[33].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c3_info[33].fileTimeLo = 1323170578U;
  c3_info[33].fileTimeHi = 0U;
  c3_info[33].mFileTimeLo = 0U;
  c3_info[33].mFileTimeHi = 0U;
  c3_info[34].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c3_info[34].name = "eml_index_minus";
  c3_info[34].dominantType = "double";
  c3_info[34].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c3_info[34].fileTimeLo = 1286818778U;
  c3_info[34].fileTimeHi = 0U;
  c3_info[34].mFileTimeLo = 0U;
  c3_info[34].mFileTimeHi = 0U;
  c3_info[35].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c3_info[35].name = "eml_index_times";
  c3_info[35].dominantType = "coder.internal.indexInt";
  c3_info[35].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c3_info[35].fileTimeLo = 1286818780U;
  c3_info[35].fileTimeHi = 0U;
  c3_info[35].mFileTimeLo = 0U;
  c3_info[35].mFileTimeHi = 0U;
  c3_info[36].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c3_info[36].name = "eml_index_plus";
  c3_info[36].dominantType = "coder.internal.indexInt";
  c3_info[36].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c3_info[36].fileTimeLo = 1286818778U;
  c3_info[36].fileTimeHi = 0U;
  c3_info[36].mFileTimeLo = 0U;
  c3_info[36].mFileTimeHi = 0U;
  c3_info[37].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c3_info[37].name = "eml_int_forloop_overflow_check";
  c3_info[37].dominantType = "";
  c3_info[37].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c3_info[37].fileTimeLo = 1332168672U;
  c3_info[37].fileTimeHi = 0U;
  c3_info[37].mFileTimeLo = 0U;
  c3_info[37].mFileTimeHi = 0U;
  c3_info[38].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c3_info[38].name = "abs";
  c3_info[38].dominantType = "double";
  c3_info[38].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[38].fileTimeLo = 1286818694U;
  c3_info[38].fileTimeHi = 0U;
  c3_info[38].mFileTimeLo = 0U;
  c3_info[38].mFileTimeHi = 0U;
  c3_info[39].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[39].name = "eml_scalar_abs";
  c3_info[39].dominantType = "double";
  c3_info[39].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c3_info[39].fileTimeLo = 1286818712U;
  c3_info[39].fileTimeHi = 0U;
  c3_info[39].mFileTimeLo = 0U;
  c3_info[39].mFileTimeHi = 0U;
  c3_info[40].context = "";
  c3_info[40].name = "mtimes";
  c3_info[40].dominantType = "double";
  c3_info[40].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c3_info[40].fileTimeLo = 1289519692U;
  c3_info[40].fileTimeHi = 0U;
  c3_info[40].mFileTimeLo = 0U;
  c3_info[40].mFileTimeHi = 0U;
  c3_info[41].context = "";
  c3_info[41].name = "mrdivide";
  c3_info[41].dominantType = "double";
  c3_info[41].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c3_info[41].fileTimeLo = 1342810944U;
  c3_info[41].fileTimeHi = 0U;
  c3_info[41].mFileTimeLo = 1319729966U;
  c3_info[41].mFileTimeHi = 0U;
  c3_info[42].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c3_info[42].name = "rdivide";
  c3_info[42].dominantType = "double";
  c3_info[42].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c3_info[42].fileTimeLo = 1286818844U;
  c3_info[42].fileTimeHi = 0U;
  c3_info[42].mFileTimeLo = 0U;
  c3_info[42].mFileTimeHi = 0U;
  c3_info[43].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c3_info[43].name = "eml_div";
  c3_info[43].dominantType = "double";
  c3_info[43].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c3_info[43].fileTimeLo = 1313347810U;
  c3_info[43].fileTimeHi = 0U;
  c3_info[43].mFileTimeLo = 0U;
  c3_info[43].mFileTimeHi = 0U;
  c3_info[44].context = "";
  c3_info[44].name = "acos";
  c3_info[44].dominantType = "double";
  c3_info[44].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/acos.m";
  c3_info[44].fileTimeLo = 1286818694U;
  c3_info[44].fileTimeHi = 0U;
  c3_info[44].mFileTimeLo = 0U;
  c3_info[44].mFileTimeHi = 0U;
  c3_info[45].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/acos.m";
  c3_info[45].name = "eml_scalar_acos";
  c3_info[45].dominantType = "double";
  c3_info[45].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_acos.m";
  c3_info[45].fileTimeLo = 1286818712U;
  c3_info[45].fileTimeHi = 0U;
  c3_info[45].mFileTimeLo = 0U;
  c3_info[45].mFileTimeHi = 0U;
  c3_info[46].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_acos.m";
  c3_info[46].name = "eml_scalar_sqrt";
  c3_info[46].dominantType = "double";
  c3_info[46].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m";
  c3_info[46].fileTimeLo = 1286818738U;
  c3_info[46].fileTimeHi = 0U;
  c3_info[46].mFileTimeLo = 0U;
  c3_info[46].mFileTimeHi = 0U;
  c3_info[47].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m!eml_complex_scalar_sqrt";
  c3_info[47].name = "rdivide";
  c3_info[47].dominantType = "double";
  c3_info[47].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c3_info[47].fileTimeLo = 1286818844U;
  c3_info[47].fileTimeHi = 0U;
  c3_info[47].mFileTimeLo = 0U;
  c3_info[47].mFileTimeHi = 0U;
  c3_info[48].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m!eml_complex_scalar_sqrt";
  c3_info[48].name = "isnan";
  c3_info[48].dominantType = "double";
  c3_info[48].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isnan.m";
  c3_info[48].fileTimeLo = 1286818760U;
  c3_info[48].fileTimeHi = 0U;
  c3_info[48].mFileTimeLo = 0U;
  c3_info[48].mFileTimeHi = 0U;
  c3_info[49].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m!eml_complex_scalar_sqrt";
  c3_info[49].name = "eml_guarded_nan";
  c3_info[49].dominantType = "char";
  c3_info[49].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_guarded_nan.m";
  c3_info[49].fileTimeLo = 1286818776U;
  c3_info[49].fileTimeHi = 0U;
  c3_info[49].mFileTimeLo = 0U;
  c3_info[49].mFileTimeHi = 0U;
  c3_info[50].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_guarded_nan.m";
  c3_info[50].name = "eml_is_float_class";
  c3_info[50].dominantType = "char";
  c3_info[50].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c3_info[50].fileTimeLo = 1286818782U;
  c3_info[50].fileTimeHi = 0U;
  c3_info[50].mFileTimeLo = 0U;
  c3_info[50].mFileTimeHi = 0U;
  c3_info[51].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m!eml_complex_scalar_sqrt";
  c3_info[51].name = "isinf";
  c3_info[51].dominantType = "double";
  c3_info[51].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isinf.m";
  c3_info[51].fileTimeLo = 1286818760U;
  c3_info[51].fileTimeHi = 0U;
  c3_info[51].mFileTimeLo = 0U;
  c3_info[51].mFileTimeHi = 0U;
  c3_info[52].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m!eml_complex_scalar_sqrt";
  c3_info[52].name = "eml_guarded_inf";
  c3_info[52].dominantType = "char";
  c3_info[52].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_guarded_inf.m";
  c3_info[52].fileTimeLo = 1286818776U;
  c3_info[52].fileTimeHi = 0U;
  c3_info[52].mFileTimeLo = 0U;
  c3_info[52].mFileTimeHi = 0U;
  c3_info[53].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_guarded_inf.m";
  c3_info[53].name = "eml_is_float_class";
  c3_info[53].dominantType = "char";
  c3_info[53].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c3_info[53].fileTimeLo = 1286818782U;
  c3_info[53].fileTimeHi = 0U;
  c3_info[53].mFileTimeLo = 0U;
  c3_info[53].mFileTimeHi = 0U;
  c3_info[54].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m!eml_complex_scalar_sqrt";
  c3_info[54].name = "realmax";
  c3_info[54].dominantType = "char";
  c3_info[54].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmax.m";
  c3_info[54].fileTimeLo = 1307651242U;
  c3_info[54].fileTimeHi = 0U;
  c3_info[54].mFileTimeLo = 0U;
  c3_info[54].mFileTimeHi = 0U;
  c3_info[55].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmax.m";
  c3_info[55].name = "eml_realmax";
  c3_info[55].dominantType = "char";
  c3_info[55].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmax.m";
  c3_info[55].fileTimeLo = 1326727996U;
  c3_info[55].fileTimeHi = 0U;
  c3_info[55].mFileTimeLo = 0U;
  c3_info[55].mFileTimeHi = 0U;
  c3_info[56].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmax.m";
  c3_info[56].name = "eml_float_model";
  c3_info[56].dominantType = "char";
  c3_info[56].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_float_model.m";
  c3_info[56].fileTimeLo = 1326727996U;
  c3_info[56].fileTimeHi = 0U;
  c3_info[56].mFileTimeLo = 0U;
  c3_info[56].mFileTimeHi = 0U;
  c3_info[57].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmax.m";
  c3_info[57].name = "mtimes";
  c3_info[57].dominantType = "double";
  c3_info[57].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c3_info[57].fileTimeLo = 1289519692U;
  c3_info[57].fileTimeHi = 0U;
  c3_info[57].mFileTimeLo = 0U;
  c3_info[57].mFileTimeHi = 0U;
  c3_info[58].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m!eml_complex_scalar_sqrt";
  c3_info[58].name = "mrdivide";
  c3_info[58].dominantType = "double";
  c3_info[58].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c3_info[58].fileTimeLo = 1342810944U;
  c3_info[58].fileTimeHi = 0U;
  c3_info[58].mFileTimeLo = 1319729966U;
  c3_info[58].mFileTimeHi = 0U;
  c3_info[59].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m!eml_complex_scalar_sqrt";
  c3_info[59].name = "mtimes";
  c3_info[59].dominantType = "double";
  c3_info[59].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c3_info[59].fileTimeLo = 1289519692U;
  c3_info[59].fileTimeHi = 0U;
  c3_info[59].mFileTimeLo = 0U;
  c3_info[59].mFileTimeHi = 0U;
  c3_info[60].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m!eml_complex_scalar_sqrt";
  c3_info[60].name = "eml_scalar_hypot";
  c3_info[60].dominantType = "double";
  c3_info[60].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_hypot.m";
  c3_info[60].fileTimeLo = 1286818726U;
  c3_info[60].fileTimeHi = 0U;
  c3_info[60].mFileTimeLo = 0U;
  c3_info[60].mFileTimeHi = 0U;
  c3_info[61].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_hypot.m";
  c3_info[61].name = "eml_scalar_eg";
  c3_info[61].dominantType = "double";
  c3_info[61].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c3_info[61].fileTimeLo = 1286818796U;
  c3_info[61].fileTimeHi = 0U;
  c3_info[61].mFileTimeLo = 0U;
  c3_info[61].mFileTimeHi = 0U;
  c3_info[62].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_hypot.m";
  c3_info[62].name = "eml_dlapy2";
  c3_info[62].dominantType = "double";
  c3_info[62].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_dlapy2.m";
  c3_info[62].fileTimeLo = 1307651240U;
  c3_info[62].fileTimeHi = 0U;
  c3_info[62].mFileTimeLo = 0U;
  c3_info[62].mFileTimeHi = 0U;
  c3_info[63].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_acos.m";
  c3_info[63].name = "eml_scalar_abs";
  c3_info[63].dominantType = "double";
  c3_info[63].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c3_info[63].fileTimeLo = 1286818712U;
  c3_info[63].fileTimeHi = 0U;
  c3_info[63].mFileTimeLo = 0U;
  c3_info[63].mFileTimeHi = 0U;
}

static void c3_b_info_helper(c3_ResolvedFunctionInfo c3_info[79])
{
  c3_info[64].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_acos.m";
  c3_info[64].name = "eml_scalar_atan2";
  c3_info[64].dominantType = "double";
  c3_info[64].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_atan2.m";
  c3_info[64].fileTimeLo = 1286818720U;
  c3_info[64].fileTimeHi = 0U;
  c3_info[64].mFileTimeLo = 0U;
  c3_info[64].mFileTimeHi = 0U;
  c3_info[65].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_acos.m";
  c3_info[65].name = "mtimes";
  c3_info[65].dominantType = "double";
  c3_info[65].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c3_info[65].fileTimeLo = 1289519692U;
  c3_info[65].fileTimeHi = 0U;
  c3_info[65].mFileTimeLo = 0U;
  c3_info[65].mFileTimeHi = 0U;
  c3_info[66].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_acos.m";
  c3_info[66].name = "eml_scalar_asinh";
  c3_info[66].dominantType = "double";
  c3_info[66].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_asinh.m";
  c3_info[66].fileTimeLo = 1286818718U;
  c3_info[66].fileTimeHi = 0U;
  c3_info[66].mFileTimeLo = 0U;
  c3_info[66].mFileTimeHi = 0U;
  c3_info[67].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_asinh.m";
  c3_info[67].name = "eml_scalar_log1p";
  c3_info[67].dominantType = "double";
  c3_info[67].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_log1p.m";
  c3_info[67].fileTimeLo = 1286818728U;
  c3_info[67].fileTimeHi = 0U;
  c3_info[67].mFileTimeLo = 0U;
  c3_info[67].mFileTimeHi = 0U;
  c3_info[68].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_log1p.m";
  c3_info[68].name = "abs";
  c3_info[68].dominantType = "double";
  c3_info[68].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[68].fileTimeLo = 1286818694U;
  c3_info[68].fileTimeHi = 0U;
  c3_info[68].mFileTimeLo = 0U;
  c3_info[68].mFileTimeHi = 0U;
  c3_info[69].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_log1p.m";
  c3_info[69].name = "eps";
  c3_info[69].dominantType = "char";
  c3_info[69].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c3_info[69].fileTimeLo = 1326727996U;
  c3_info[69].fileTimeHi = 0U;
  c3_info[69].mFileTimeLo = 0U;
  c3_info[69].mFileTimeHi = 0U;
  c3_info[70].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c3_info[70].name = "eml_is_float_class";
  c3_info[70].dominantType = "char";
  c3_info[70].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c3_info[70].fileTimeLo = 1286818782U;
  c3_info[70].fileTimeHi = 0U;
  c3_info[70].mFileTimeLo = 0U;
  c3_info[70].mFileTimeHi = 0U;
  c3_info[71].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c3_info[71].name = "eml_eps";
  c3_info[71].dominantType = "char";
  c3_info[71].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_eps.m";
  c3_info[71].fileTimeLo = 1326727996U;
  c3_info[71].fileTimeHi = 0U;
  c3_info[71].mFileTimeLo = 0U;
  c3_info[71].mFileTimeHi = 0U;
  c3_info[72].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_eps.m";
  c3_info[72].name = "eml_float_model";
  c3_info[72].dominantType = "char";
  c3_info[72].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_float_model.m";
  c3_info[72].fileTimeLo = 1326727996U;
  c3_info[72].fileTimeHi = 0U;
  c3_info[72].mFileTimeLo = 0U;
  c3_info[72].mFileTimeHi = 0U;
  c3_info[73].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_log1p.m";
  c3_info[73].name = "isfinite";
  c3_info[73].dominantType = "double";
  c3_info[73].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isfinite.m";
  c3_info[73].fileTimeLo = 1286818758U;
  c3_info[73].fileTimeHi = 0U;
  c3_info[73].mFileTimeLo = 0U;
  c3_info[73].mFileTimeHi = 0U;
  c3_info[74].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isfinite.m";
  c3_info[74].name = "isinf";
  c3_info[74].dominantType = "double";
  c3_info[74].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isinf.m";
  c3_info[74].fileTimeLo = 1286818760U;
  c3_info[74].fileTimeHi = 0U;
  c3_info[74].mFileTimeLo = 0U;
  c3_info[74].mFileTimeHi = 0U;
  c3_info[75].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isfinite.m";
  c3_info[75].name = "isnan";
  c3_info[75].dominantType = "double";
  c3_info[75].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isnan.m";
  c3_info[75].fileTimeLo = 1286818760U;
  c3_info[75].fileTimeHi = 0U;
  c3_info[75].mFileTimeLo = 0U;
  c3_info[75].mFileTimeHi = 0U;
  c3_info[76].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_log1p.m";
  c3_info[76].name = "eml_scalar_log";
  c3_info[76].dominantType = "double";
  c3_info[76].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_log.m";
  c3_info[76].fileTimeLo = 1286818728U;
  c3_info[76].fileTimeHi = 0U;
  c3_info[76].mFileTimeLo = 0U;
  c3_info[76].mFileTimeHi = 0U;
  c3_info[77].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_log.m";
  c3_info[77].name = "realmax";
  c3_info[77].dominantType = "char";
  c3_info[77].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmax.m";
  c3_info[77].fileTimeLo = 1307651242U;
  c3_info[77].fileTimeHi = 0U;
  c3_info[77].mFileTimeLo = 0U;
  c3_info[77].mFileTimeHi = 0U;
  c3_info[78].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_log.m";
  c3_info[78].name = "mrdivide";
  c3_info[78].dominantType = "double";
  c3_info[78].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c3_info[78].fileTimeLo = 1342810944U;
  c3_info[78].fileTimeHi = 0U;
  c3_info[78].mFileTimeLo = 1319729966U;
  c3_info[78].mFileTimeHi = 0U;
}

static void c3_eml_scalar_eg(SFc3_DubinsInstanceStruct *chartInstance)
{
}

static void c3_check_forloop_overflow_error(SFc3_DubinsInstanceStruct
  *chartInstance)
{
}

static real_T c3_norm(SFc3_DubinsInstanceStruct *chartInstance, real_T c3_x[2])
{
  real_T c3_y;
  real_T c3_scale;
  int32_T c3_k;
  int32_T c3_b_k;
  real_T c3_b_x;
  real_T c3_c_x;
  real_T c3_absxk;
  real_T c3_t;
  c3_y = 0.0;
  c3_scale = 2.2250738585072014E-308;
  c3_check_forloop_overflow_error(chartInstance);
  for (c3_k = 1; c3_k < 3; c3_k++) {
    c3_b_k = c3_k;
    c3_b_x = c3_x[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      (real_T)c3_b_k), 1, 2, 1, 0) - 1];
    c3_c_x = c3_b_x;
    c3_absxk = muDoubleScalarAbs(c3_c_x);
    if (c3_absxk > c3_scale) {
      c3_t = c3_scale / c3_absxk;
      c3_y = 1.0 + c3_y * c3_t * c3_t;
      c3_scale = c3_absxk;
    } else {
      c3_t = c3_absxk / c3_scale;
      c3_y += c3_t * c3_t;
    }
  }

  return c3_scale * muDoubleScalarSqrt(c3_y);
}

static creal_T c3_eml_scalar_sqrt(SFc3_DubinsInstanceStruct *chartInstance,
  creal_T c3_x)
{
  creal_T c3_b_x;
  c3_b_x = c3_x;
  c3_b_eml_scalar_sqrt(chartInstance, &c3_b_x);
  return c3_b_x;
}

static void c3_realmax(SFc3_DubinsInstanceStruct *chartInstance)
{
}

static real_T c3_eml_scalar_hypot(SFc3_DubinsInstanceStruct *chartInstance,
  real_T c3_x, real_T c3_y)
{
  real_T c3_x1;
  real_T c3_x2;
  real_T c3_a;
  real_T c3_b;
  c3_x1 = c3_x;
  c3_x2 = c3_y;
  c3_a = muDoubleScalarAbs(c3_x1);
  c3_b = muDoubleScalarAbs(c3_x2);
  return muDoubleScalarHypot(c3_a, c3_b);
}

static void c3_eps(SFc3_DubinsInstanceStruct *chartInstance)
{
}

static const mxArray *c3_f_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  int32_T c3_u;
  const mxArray *c3_y = NULL;
  SFc3_DubinsInstanceStruct *chartInstance;
  chartInstance = (SFc3_DubinsInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_u = *(int32_T *)c3_inData;
  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", &c3_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static int32_T c3_h_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  int32_T c3_y;
  int32_T c3_i45;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_i45, 1, 6, 0U, 0, 0U, 0);
  c3_y = c3_i45;
  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void c3_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_b_sfEvent;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  int32_T c3_y;
  SFc3_DubinsInstanceStruct *chartInstance;
  chartInstance = (SFc3_DubinsInstanceStruct *)chartInstanceVoid;
  c3_b_sfEvent = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_b_sfEvent),
    &c3_thisId);
  sf_mex_destroy(&c3_b_sfEvent);
  *(int32_T *)c3_outData = c3_y;
  sf_mex_destroy(&c3_mxArrayInData);
}

static uint8_T c3_i_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_b_is_active_c3_Dubins, const char_T *c3_identifier)
{
  uint8_T c3_y;
  emlrtMsgIdentifier c3_thisId;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_j_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c3_b_is_active_c3_Dubins), &c3_thisId);
  sf_mex_destroy(&c3_b_is_active_c3_Dubins);
  return c3_y;
}

static uint8_T c3_j_emlrt_marshallIn(SFc3_DubinsInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  uint8_T c3_y;
  uint8_T c3_u0;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_u0, 1, 3, 0U, 0, 0U, 0);
  c3_y = c3_u0;
  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void c3_b_eml_scalar_sqrt(SFc3_DubinsInstanceStruct *chartInstance,
  creal_T *c3_x)
{
  real_T c3_yr;
  real_T c3_yi;
  real_T c3_b_x;
  real_T c3_c_x;
  real_T c3_z;
  real_T c3_d_x;
  real_T c3_e_x;
  real_T c3_b_z;
  boolean_T c3_b2;
  boolean_T c3_b3;
  boolean_T c3_b;
  real_T c3_f_x;
  boolean_T c3_b_b;
  real_T c3_g_x;
  boolean_T c3_c_b;
  real_T c3_absxr;
  real_T c3_absxi;
  real_T c3_a;
  real_T c3_b_a;
  real_T c3_absxd2;
  real_T c3_h_x;
  real_T c3_y;
  real_T c3_i_x;
  real_T c3_b_y;
  real_T c3_c_z;
  real_T c3_j_x;
  real_T c3_c_y;
  real_T c3_k_x;
  real_T c3_d_y;
  real_T c3_d_z;
  real_T c3_l_x;
  real_T c3_e_y;
  real_T c3_m_x;
  real_T c3_f_y;
  real_T c3_e_z;
  boolean_T guard1 = FALSE;
  if (c3_x->im == 0.0) {
    if (c3_x->re < 0.0) {
      c3_yr = 0.0;
      c3_yi = muDoubleScalarSqrt(muDoubleScalarAbs(c3_x->re));
    } else {
      c3_yr = muDoubleScalarSqrt(c3_x->re);
      c3_yi = 0.0;
    }
  } else if (c3_x->re == 0.0) {
    if (c3_x->im < 0.0) {
      c3_b_x = -c3_x->im;
      c3_c_x = c3_b_x;
      c3_z = c3_c_x / 2.0;
      c3_yr = muDoubleScalarSqrt(c3_z);
      c3_yi = -c3_yr;
    } else {
      c3_d_x = c3_x->im;
      c3_e_x = c3_d_x;
      c3_b_z = c3_e_x / 2.0;
      c3_yr = muDoubleScalarSqrt(c3_b_z);
      c3_yi = c3_yr;
    }
  } else {
    c3_b2 = muDoubleScalarIsNaN(c3_x->re);
    c3_b3 = muDoubleScalarIsNaN(c3_x->im);
    c3_b = (c3_b2 || c3_b3);
    if (c3_b) {
      c3_yr = rtNaN;
      c3_yi = rtNaN;
    } else {
      c3_f_x = c3_x->im;
      c3_b_b = muDoubleScalarIsInf(c3_f_x);
      if (c3_b_b) {
        c3_yr = rtInf;
        c3_yi = c3_x->im;
      } else {
        c3_g_x = c3_x->re;
        c3_c_b = muDoubleScalarIsInf(c3_g_x);
        if (c3_c_b) {
          if (c3_x->re < 0.0) {
            c3_yr = 0.0;
            c3_yi = rtInf;
          } else {
            c3_yr = rtInf;
            c3_yi = 0.0;
          }
        } else {
          c3_absxr = muDoubleScalarAbs(c3_x->re);
          c3_absxi = muDoubleScalarAbs(c3_x->im);
          c3_realmax(chartInstance);
          guard1 = FALSE;
          if (c3_absxr > 4.4942328371557893E+307) {
            guard1 = TRUE;
          } else {
            c3_realmax(chartInstance);
            if (c3_absxi > 4.4942328371557893E+307) {
              guard1 = TRUE;
            } else {
              c3_yr = muDoubleScalarSqrt((c3_eml_scalar_hypot(chartInstance,
                c3_absxr, c3_absxi) + c3_absxr) * 0.5);
            }
          }

          if (guard1 == TRUE) {
            c3_a = c3_absxr;
            c3_absxr = c3_a * 0.5;
            c3_b_a = c3_absxi;
            c3_absxi = c3_b_a * 0.5;
            c3_absxd2 = c3_eml_scalar_hypot(chartInstance, c3_absxr, c3_absxi);
            if (c3_absxd2 > c3_absxr) {
              c3_h_x = c3_absxr;
              c3_y = c3_absxd2;
              c3_i_x = c3_h_x;
              c3_b_y = c3_y;
              c3_c_z = c3_i_x / c3_b_y;
              c3_yr = muDoubleScalarSqrt(c3_absxd2) * muDoubleScalarSqrt(1.0 +
                c3_c_z);
            } else {
              c3_yr = muDoubleScalarSqrt(c3_absxd2) * 1.4142135623730951;
            }
          }

          if (c3_x->re > 0.0) {
            c3_j_x = c3_x->im;
            c3_c_y = c3_yr;
            c3_k_x = c3_j_x;
            c3_d_y = c3_c_y;
            c3_d_z = c3_k_x / c3_d_y;
            c3_yi = 0.5 * c3_d_z;
          } else {
            if (c3_x->im < 0.0) {
              c3_yi = -c3_yr;
            } else {
              c3_yi = c3_yr;
            }

            c3_l_x = c3_x->im;
            c3_e_y = c3_yi;
            c3_m_x = c3_l_x;
            c3_f_y = c3_e_y;
            c3_e_z = c3_m_x / c3_f_y;
            c3_yr = 0.5 * c3_e_z;
          }
        }
      }
    }
  }

  c3_x->re = c3_yr;
  c3_x->im = c3_yi;
}

static void init_dsm_address_info(SFc3_DubinsInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c3_Dubins_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3893327965U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1586888241U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(4069052033U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(824273677U);
}

mxArray *sf_c3_Dubins_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("c2rQmSkeJCpdnZUA0OvgS");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(4);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(4);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(4);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c3_Dubins(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[8],T\"ObsList\",},{M[1],M[5],T\"obs\",},{M[8],M[0],T\"is_active_c3_Dubins\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c3_Dubins_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc3_DubinsInstanceStruct *chartInstance;
    chartInstance = (SFc3_DubinsInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_DubinsMachineNumber_,
          3,
          1,
          1,
          6,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_DubinsMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_DubinsMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_DubinsMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"eta");
          _SFD_SET_DATA_PROPS(1,2,0,1,"obs");
          _SFD_SET_DATA_PROPS(2,1,1,0,"obslist");
          _SFD_SET_DATA_PROPS(3,1,1,0,"target");
          _SFD_SET_DATA_PROPS(4,2,0,1,"ObsList");
          _SFD_SET_DATA_PROPS(5,1,1,0,"vehicle_velocityList");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,3,0,0,0,2,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,862);
        _SFD_CV_INIT_EML_IF(0,1,0,358,401,-1,495);
        _SFD_CV_INIT_EML_IF(0,1,1,581,600,-1,832);
        _SFD_CV_INIT_EML_IF(0,1,2,694,725,-1,824);
        _SFD_CV_INIT_EML_FOR(0,1,0,139,165,499);
        _SFD_CV_INIT_EML_FOR(0,1,1,551,577,836);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 1;
          dimVector[1]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_b_sf_marshallOut,(MexInFcnForType)
            c3_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 2;
          dimVector[1]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 2;
          dimVector[1]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)
            c3_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_c_sf_marshallOut,(MexInFcnForType)NULL);

        {
          real_T *c3_vehicle_velocityList;
          real_T (*c3_eta)[2];
          real_T (*c3_obs)[4];
          real_T (*c3_obslist)[8];
          real_T (*c3_target)[2];
          real_T (*c3_ObsList)[8];
          c3_vehicle_velocityList = (real_T *)ssGetInputPortSignal
            (chartInstance->S, 3);
          c3_ObsList = (real_T (*)[8])ssGetOutputPortSignal(chartInstance->S, 2);
          c3_target = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 2);
          c3_obslist = (real_T (*)[8])ssGetInputPortSignal(chartInstance->S, 1);
          c3_obs = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
          c3_eta = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c3_eta);
          _SFD_SET_DATA_VALUE_PTR(1U, *c3_obs);
          _SFD_SET_DATA_VALUE_PTR(2U, *c3_obslist);
          _SFD_SET_DATA_VALUE_PTR(3U, *c3_target);
          _SFD_SET_DATA_VALUE_PTR(4U, *c3_ObsList);
          _SFD_SET_DATA_VALUE_PTR(5U, c3_vehicle_velocityList);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_DubinsMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "F53AyzylMegREY6sNINkiC";
}

static void sf_opaque_initialize_c3_Dubins(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc3_DubinsInstanceStruct*) chartInstanceVar)->S,
    0);
  initialize_params_c3_Dubins((SFc3_DubinsInstanceStruct*) chartInstanceVar);
  initialize_c3_Dubins((SFc3_DubinsInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c3_Dubins(void *chartInstanceVar)
{
  enable_c3_Dubins((SFc3_DubinsInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c3_Dubins(void *chartInstanceVar)
{
  disable_c3_Dubins((SFc3_DubinsInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c3_Dubins(void *chartInstanceVar)
{
  sf_c3_Dubins((SFc3_DubinsInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c3_Dubins(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c3_Dubins((SFc3_DubinsInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c3_Dubins();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c3_Dubins(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c3_Dubins();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c3_Dubins((SFc3_DubinsInstanceStruct*)chartInfo->chartInstance,
    mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c3_Dubins(SimStruct* S)
{
  return sf_internal_get_sim_state_c3_Dubins(S);
}

static void sf_opaque_set_sim_state_c3_Dubins(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c3_Dubins(S, st);
}

static void sf_opaque_terminate_c3_Dubins(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc3_DubinsInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c3_Dubins((SFc3_DubinsInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_Dubins_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc3_Dubins((SFc3_DubinsInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c3_Dubins(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c3_Dubins((SFc3_DubinsInstanceStruct*)(((ChartInfoStruct *)
      ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c3_Dubins(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_Dubins_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      3);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,3,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,3,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,3,4);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,3,2);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,3);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(3918171737U));
  ssSetChecksum1(S,(107972686U));
  ssSetChecksum2(S,(1989412738U));
  ssSetChecksum3(S,(3333418366U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c3_Dubins(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c3_Dubins(SimStruct *S)
{
  SFc3_DubinsInstanceStruct *chartInstance;
  chartInstance = (SFc3_DubinsInstanceStruct *)malloc(sizeof
    (SFc3_DubinsInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc3_DubinsInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c3_Dubins;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c3_Dubins;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c3_Dubins;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c3_Dubins;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c3_Dubins;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c3_Dubins;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c3_Dubins;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c3_Dubins;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c3_Dubins;
  chartInstance->chartInfo.mdlStart = mdlStart_c3_Dubins;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c3_Dubins;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c3_Dubins_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c3_Dubins(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c3_Dubins(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c3_Dubins(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c3_Dubins_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
