/* Include files */

#include "blascompat32.h"
#include "objectTrackingFilter_sfun.h"
#include "c18_objectTrackingFilter.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "objectTrackingFilter_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c18_debug_family_names[13] = { "theta", "snit_x", "snit_y",
  "nargin", "nargout", "hat_x", "y", "pre_x", "pre_y", "pre_x_list",
  "pre_y_list", "index", "pre_theta" };

/* Function Declarations */
static void initialize_c18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance);
static void initialize_params_c18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance);
static void enable_c18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance);
static void disable_c18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance);
static void c18_update_debugger_state_c18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance);
static void set_sim_state_c18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance, const mxArray
   *c18_st);
static void finalize_c18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance);
static void sf_c18_objectTrackingFilter(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance);
static void c18_chartstep_c18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance);
static void initSimStructsc18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c18_machineNumber, uint32_T
  c18_chartNumber);
static const mxArray *c18_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData);
static real_T c18_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_b_pre_theta, const char_T *c18_identifier);
static real_T c18_b_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId);
static void c18_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c18_mxArrayInData, const char_T *c18_varName, void *c18_outData);
static const mxArray *c18_b_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData);
static real_T c18_c_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_b_index, const char_T *c18_identifier);
static real_T c18_d_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId);
static void c18_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c18_mxArrayInData, const char_T *c18_varName, void *c18_outData);
static const mxArray *c18_c_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData);
static void c18_e_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_b_pre_y_list, const char_T *c18_identifier,
  real_T c18_y[30]);
static void c18_f_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId,
  real_T c18_y[30]);
static void c18_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c18_mxArrayInData, const char_T *c18_varName, void *c18_outData);
static const mxArray *c18_d_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData);
static void c18_g_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_b_pre_x_list, const char_T *c18_identifier,
  real_T c18_y[30]);
static void c18_h_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId,
  real_T c18_y[30]);
static void c18_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c18_mxArrayInData, const char_T *c18_varName, void *c18_outData);
static const mxArray *c18_e_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData);
static real_T c18_i_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_b_pre_y, const char_T *c18_identifier);
static real_T c18_j_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId);
static void c18_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c18_mxArrayInData, const char_T *c18_varName, void *c18_outData);
static const mxArray *c18_f_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData);
static real_T c18_k_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_b_pre_x, const char_T *c18_identifier);
static real_T c18_l_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId);
static void c18_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c18_mxArrayInData, const char_T *c18_varName, void *c18_outData);
static const mxArray *c18_g_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData);
static void c18_m_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_y, const char_T *c18_identifier, real_T
  c18_b_y[3]);
static void c18_n_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId,
  real_T c18_y[3]);
static void c18_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c18_mxArrayInData, const char_T *c18_varName, void *c18_outData);
static const mxArray *c18_h_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData);
static const mxArray *c18_i_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData);
static real_T c18_o_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId);
static void c18_h_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c18_mxArrayInData, const char_T *c18_varName, void *c18_outData);
static void c18_info_helper(c18_ResolvedFunctionInfo c18_info[15]);
static real_T c18_sum(SFc18_objectTrackingFilterInstanceStruct *chartInstance,
                      real_T c18_x[30]);
static void c18_check_forloop_overflow_error
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance);
static const mxArray *c18_j_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData);
static int32_T c18_p_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId);
static void c18_i_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c18_mxArrayInData, const char_T *c18_varName, void *c18_outData);
static uint8_T c18_q_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_b_is_active_c18_objectTrackingFilter, const
  char_T *c18_identifier);
static uint8_T c18_r_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId);
static void init_dsm_address_info(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance)
{
  chartInstance->c18_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c18_pre_x_not_empty = FALSE;
  chartInstance->c18_pre_y_not_empty = FALSE;
  chartInstance->c18_pre_x_list_not_empty = FALSE;
  chartInstance->c18_pre_y_list_not_empty = FALSE;
  chartInstance->c18_index_not_empty = FALSE;
  chartInstance->c18_pre_theta_not_empty = FALSE;
  chartInstance->c18_is_active_c18_objectTrackingFilter = 0U;
}

static void initialize_params_c18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance)
{
}

static void enable_c18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c18_update_debugger_state_c18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance)
{
  const mxArray *c18_st;
  const mxArray *c18_y = NULL;
  int32_T c18_i0;
  real_T c18_u[3];
  const mxArray *c18_b_y = NULL;
  real_T c18_hoistedGlobal;
  real_T c18_b_u;
  const mxArray *c18_c_y = NULL;
  real_T c18_b_hoistedGlobal;
  real_T c18_c_u;
  const mxArray *c18_d_y = NULL;
  real_T c18_c_hoistedGlobal;
  real_T c18_d_u;
  const mxArray *c18_e_y = NULL;
  int32_T c18_i1;
  real_T c18_e_u[30];
  const mxArray *c18_f_y = NULL;
  real_T c18_d_hoistedGlobal;
  real_T c18_f_u;
  const mxArray *c18_g_y = NULL;
  int32_T c18_i2;
  real_T c18_g_u[30];
  const mxArray *c18_h_y = NULL;
  uint8_T c18_e_hoistedGlobal;
  uint8_T c18_h_u;
  const mxArray *c18_i_y = NULL;
  real_T (*c18_j_y)[3];
  c18_j_y = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c18_st = NULL;
  c18_st = NULL;
  c18_y = NULL;
  sf_mex_assign(&c18_y, sf_mex_createcellarray(8), FALSE);
  for (c18_i0 = 0; c18_i0 < 3; c18_i0++) {
    c18_u[c18_i0] = (*c18_j_y)[c18_i0];
  }

  c18_b_y = NULL;
  sf_mex_assign(&c18_b_y, sf_mex_create("y", c18_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_setcell(c18_y, 0, c18_b_y);
  c18_hoistedGlobal = chartInstance->c18_index;
  c18_b_u = c18_hoistedGlobal;
  c18_c_y = NULL;
  if (!chartInstance->c18_index_not_empty) {
    sf_mex_assign(&c18_c_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c18_c_y, sf_mex_create("y", &c18_b_u, 0, 0U, 0U, 0U, 0),
                  FALSE);
  }

  sf_mex_setcell(c18_y, 1, c18_c_y);
  c18_b_hoistedGlobal = chartInstance->c18_pre_theta;
  c18_c_u = c18_b_hoistedGlobal;
  c18_d_y = NULL;
  if (!chartInstance->c18_pre_theta_not_empty) {
    sf_mex_assign(&c18_d_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c18_d_y, sf_mex_create("y", &c18_c_u, 0, 0U, 0U, 0U, 0),
                  FALSE);
  }

  sf_mex_setcell(c18_y, 2, c18_d_y);
  c18_c_hoistedGlobal = chartInstance->c18_pre_x;
  c18_d_u = c18_c_hoistedGlobal;
  c18_e_y = NULL;
  if (!chartInstance->c18_pre_x_not_empty) {
    sf_mex_assign(&c18_e_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c18_e_y, sf_mex_create("y", &c18_d_u, 0, 0U, 0U, 0U, 0),
                  FALSE);
  }

  sf_mex_setcell(c18_y, 3, c18_e_y);
  for (c18_i1 = 0; c18_i1 < 30; c18_i1++) {
    c18_e_u[c18_i1] = chartInstance->c18_pre_x_list[c18_i1];
  }

  c18_f_y = NULL;
  if (!chartInstance->c18_pre_x_list_not_empty) {
    sf_mex_assign(&c18_f_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c18_f_y, sf_mex_create("y", c18_e_u, 0, 0U, 1U, 0U, 1, 30),
                  FALSE);
  }

  sf_mex_setcell(c18_y, 4, c18_f_y);
  c18_d_hoistedGlobal = chartInstance->c18_pre_y;
  c18_f_u = c18_d_hoistedGlobal;
  c18_g_y = NULL;
  if (!chartInstance->c18_pre_y_not_empty) {
    sf_mex_assign(&c18_g_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c18_g_y, sf_mex_create("y", &c18_f_u, 0, 0U, 0U, 0U, 0),
                  FALSE);
  }

  sf_mex_setcell(c18_y, 5, c18_g_y);
  for (c18_i2 = 0; c18_i2 < 30; c18_i2++) {
    c18_g_u[c18_i2] = chartInstance->c18_pre_y_list[c18_i2];
  }

  c18_h_y = NULL;
  if (!chartInstance->c18_pre_y_list_not_empty) {
    sf_mex_assign(&c18_h_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c18_h_y, sf_mex_create("y", c18_g_u, 0, 0U, 1U, 0U, 1, 30),
                  FALSE);
  }

  sf_mex_setcell(c18_y, 6, c18_h_y);
  c18_e_hoistedGlobal = chartInstance->c18_is_active_c18_objectTrackingFilter;
  c18_h_u = c18_e_hoistedGlobal;
  c18_i_y = NULL;
  sf_mex_assign(&c18_i_y, sf_mex_create("y", &c18_h_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c18_y, 7, c18_i_y);
  sf_mex_assign(&c18_st, c18_y, FALSE);
  return c18_st;
}

static void set_sim_state_c18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance, const mxArray
   *c18_st)
{
  const mxArray *c18_u;
  real_T c18_dv0[3];
  int32_T c18_i3;
  real_T c18_dv1[30];
  int32_T c18_i4;
  real_T c18_dv2[30];
  int32_T c18_i5;
  real_T (*c18_y)[3];
  c18_y = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c18_doneDoubleBufferReInit = TRUE;
  c18_u = sf_mex_dup(c18_st);
  c18_m_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c18_u, 0)),
    "y", c18_dv0);
  for (c18_i3 = 0; c18_i3 < 3; c18_i3++) {
    (*c18_y)[c18_i3] = c18_dv0[c18_i3];
  }

  chartInstance->c18_index = c18_c_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c18_u, 1)), "index");
  chartInstance->c18_pre_theta = c18_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c18_u, 2)), "pre_theta");
  chartInstance->c18_pre_x = c18_k_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c18_u, 3)), "pre_x");
  c18_g_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c18_u, 4)),
    "pre_x_list", c18_dv1);
  for (c18_i4 = 0; c18_i4 < 30; c18_i4++) {
    chartInstance->c18_pre_x_list[c18_i4] = c18_dv1[c18_i4];
  }

  chartInstance->c18_pre_y = c18_i_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c18_u, 5)), "pre_y");
  c18_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c18_u, 6)),
    "pre_y_list", c18_dv2);
  for (c18_i5 = 0; c18_i5 < 30; c18_i5++) {
    chartInstance->c18_pre_y_list[c18_i5] = c18_dv2[c18_i5];
  }

  chartInstance->c18_is_active_c18_objectTrackingFilter = c18_q_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c18_u, 7)),
     "is_active_c18_objectTrackingFilter");
  sf_mex_destroy(&c18_u);
  c18_update_debugger_state_c18_objectTrackingFilter(chartInstance);
  sf_mex_destroy(&c18_st);
}

static void finalize_c18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance)
{
}

static void sf_c18_objectTrackingFilter(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance)
{
  int32_T c18_i6;
  int32_T c18_i7;
  real_T (*c18_y)[3];
  real_T (*c18_hat_x)[2];
  c18_y = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c18_hat_x = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 10U, chartInstance->c18_sfEvent);
  for (c18_i6 = 0; c18_i6 < 2; c18_i6++) {
    _SFD_DATA_RANGE_CHECK((*c18_hat_x)[c18_i6], 0U);
  }

  for (c18_i7 = 0; c18_i7 < 3; c18_i7++) {
    _SFD_DATA_RANGE_CHECK((*c18_y)[c18_i7], 1U);
  }

  chartInstance->c18_sfEvent = CALL_EVENT;
  c18_chartstep_c18_objectTrackingFilter(chartInstance);
  sf_debug_check_for_state_inconsistency(_objectTrackingFilterMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c18_chartstep_c18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance)
{
  int32_T c18_i8;
  real_T c18_hat_x[2];
  uint32_T c18_debug_family_var_map[13];
  real_T c18_theta;
  real_T c18_snit_x;
  real_T c18_snit_y;
  real_T c18_nargin = 1.0;
  real_T c18_nargout = 1.0;
  real_T c18_y[3];
  int32_T c18_i9;
  int32_T c18_i10;
  int32_T c18_i11;
  real_T c18_hoistedGlobal[30];
  real_T c18_b_hoistedGlobal;
  int32_T c18_i12;
  real_T c18_c_hoistedGlobal[30];
  real_T c18_A;
  real_T c18_B;
  real_T c18_x;
  real_T c18_b_y;
  real_T c18_b_x;
  real_T c18_c_y;
  int32_T c18_i13;
  real_T c18_d_hoistedGlobal;
  int32_T c18_i14;
  real_T c18_e_hoistedGlobal[30];
  real_T c18_b_A;
  real_T c18_b_B;
  real_T c18_c_x;
  real_T c18_d_y;
  real_T c18_d_x;
  real_T c18_e_y;
  real_T c18_f_hoistedGlobal;
  real_T c18_g_hoistedGlobal;
  real_T c18_f_y;
  real_T c18_e_x;
  real_T c18_g_y;
  real_T c18_f_x;
  int32_T c18_i15;
  int32_T c18_i16;
  real_T c18_b_hat_x[3];
  int32_T c18_i17;
  int32_T c18_i18;
  real_T (*c18_h_y)[3];
  real_T (*c18_c_hat_x)[2];
  boolean_T guard1 = FALSE;
  c18_h_y = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c18_c_hat_x = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 10U, chartInstance->c18_sfEvent);
  for (c18_i8 = 0; c18_i8 < 2; c18_i8++) {
    c18_hat_x[c18_i8] = (*c18_c_hat_x)[c18_i8];
  }

  sf_debug_symbol_scope_push_eml(0U, 13U, 13U, c18_debug_family_names,
    c18_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c18_theta, 0U, c18_i_sf_marshallOut,
    c18_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c18_snit_x, 1U, c18_i_sf_marshallOut,
    c18_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c18_snit_y, 2U, c18_i_sf_marshallOut,
    c18_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c18_nargin, 3U, c18_i_sf_marshallOut,
    c18_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c18_nargout, 4U,
    c18_i_sf_marshallOut, c18_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c18_hat_x, 5U, c18_h_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c18_y, 6U, c18_g_sf_marshallOut,
    c18_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c18_pre_x, 7U,
    c18_f_sf_marshallOut, c18_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c18_pre_y, 8U,
    c18_e_sf_marshallOut, c18_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(chartInstance->c18_pre_x_list, 9U,
    c18_d_sf_marshallOut, c18_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(chartInstance->c18_pre_y_list, 10U,
    c18_c_sf_marshallOut, c18_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c18_index, 11U,
    c18_b_sf_marshallOut, c18_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c18_pre_theta, 12U,
    c18_sf_marshallOut, c18_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 4);
  _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 5);
  _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 6);
  _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 7);
  _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 8);
  _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 10);
  _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 13);
  guard1 = FALSE;
  if (CV_EML_COND(0, 1, 0, !chartInstance->c18_pre_x_not_empty)) {
    guard1 = TRUE;
  } else if (CV_EML_COND(0, 1, 1, !chartInstance->c18_pre_y_not_empty)) {
    guard1 = TRUE;
  } else {
    CV_EML_MCDC(0, 1, 0, FALSE);
    CV_EML_IF(0, 1, 0, FALSE);
  }

  if (guard1 == TRUE) {
    CV_EML_MCDC(0, 1, 0, TRUE);
    CV_EML_IF(0, 1, 0, TRUE);
    _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 15);
    chartInstance->c18_pre_x = 0.0;
    chartInstance->c18_pre_x_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 16);
    chartInstance->c18_pre_y = 0.0;
    chartInstance->c18_pre_y_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 17);
    chartInstance->c18_pre_theta = 0.0;
    chartInstance->c18_pre_theta_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 18);
    for (c18_i9 = 0; c18_i9 < 30; c18_i9++) {
      chartInstance->c18_pre_x_list[c18_i9] = 0.0;
    }

    chartInstance->c18_pre_x_list_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 19);
    for (c18_i10 = 0; c18_i10 < 30; c18_i10++) {
      chartInstance->c18_pre_y_list[c18_i10] = 0.0;
    }

    chartInstance->c18_pre_y_list_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 20);
    chartInstance->c18_index = 1.0;
    chartInstance->c18_index_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 25);
  if (CV_EML_IF(0, 1, 1, chartInstance->c18_index < 30.0)) {
    _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 26);
    c18_theta = chartInstance->c18_pre_theta;
    _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 27);
    chartInstance->c18_pre_x_list[_SFD_EML_ARRAY_BOUNDS_CHECK("pre_x_list",
      (int32_T)_SFD_INTEGER_CHECK("index", chartInstance->c18_index), 1, 30, 1,
      0) - 1] = c18_hat_x[0];
    _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 28);
    chartInstance->c18_pre_y_list[_SFD_EML_ARRAY_BOUNDS_CHECK("pre_y_list",
      (int32_T)_SFD_INTEGER_CHECK("index", chartInstance->c18_index), 1, 30, 1,
      0) - 1] = c18_hat_x[1];
    _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 29);
    chartInstance->c18_index++;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 32);
    for (c18_i11 = 0; c18_i11 < 30; c18_i11++) {
      c18_hoistedGlobal[c18_i11] = chartInstance->c18_pre_x_list[c18_i11];
    }

    c18_b_hoistedGlobal = chartInstance->c18_index;
    for (c18_i12 = 0; c18_i12 < 30; c18_i12++) {
      c18_c_hoistedGlobal[c18_i12] = c18_hoistedGlobal[c18_i12];
    }

    c18_A = c18_sum(chartInstance, c18_c_hoistedGlobal);
    c18_B = c18_b_hoistedGlobal;
    c18_x = c18_A;
    c18_b_y = c18_B;
    c18_b_x = c18_x;
    c18_c_y = c18_b_y;
    c18_snit_x = c18_b_x / c18_c_y;
    _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 33);
    for (c18_i13 = 0; c18_i13 < 30; c18_i13++) {
      c18_hoistedGlobal[c18_i13] = chartInstance->c18_pre_y_list[c18_i13];
    }

    c18_d_hoistedGlobal = chartInstance->c18_index;
    for (c18_i14 = 0; c18_i14 < 30; c18_i14++) {
      c18_e_hoistedGlobal[c18_i14] = c18_hoistedGlobal[c18_i14];
    }

    c18_b_A = c18_sum(chartInstance, c18_e_hoistedGlobal);
    c18_b_B = c18_d_hoistedGlobal;
    c18_c_x = c18_b_A;
    c18_d_y = c18_b_B;
    c18_d_x = c18_c_x;
    c18_e_y = c18_d_y;
    c18_snit_y = c18_d_x / c18_e_y;
    _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 35);
    c18_f_hoistedGlobal = chartInstance->c18_pre_y;
    c18_g_hoistedGlobal = chartInstance->c18_pre_x;
    c18_f_y = c18_snit_y - c18_f_hoistedGlobal;
    c18_e_x = c18_snit_x - c18_g_hoistedGlobal;
    c18_g_y = c18_f_y;
    c18_f_x = c18_e_x;
    c18_theta = muDoubleScalarAtan2(c18_g_y, c18_f_x);
    _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 36);
    chartInstance->c18_pre_x = c18_snit_x;
    _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 37);
    chartInstance->c18_pre_y = c18_snit_y;
    _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 38);
    for (c18_i15 = 0; c18_i15 < 30; c18_i15++) {
      chartInstance->c18_pre_x_list[c18_i15] = 0.0;
    }

    _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 39);
    for (c18_i16 = 0; c18_i16 < 30; c18_i16++) {
      chartInstance->c18_pre_y_list[c18_i16] = 0.0;
    }

    _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 40);
    chartInstance->c18_index = 1.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 45);
  chartInstance->c18_pre_theta = c18_theta;
  _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, 47);
  c18_b_hat_x[0] = c18_hat_x[0];
  c18_b_hat_x[1] = c18_hat_x[1];
  c18_b_hat_x[2] = c18_theta;
  for (c18_i17 = 0; c18_i17 < 3; c18_i17++) {
    c18_y[c18_i17] = c18_b_hat_x[c18_i17];
  }

  _SFD_EML_CALL(0U, chartInstance->c18_sfEvent, -47);
  sf_debug_symbol_scope_pop();
  for (c18_i18 = 0; c18_i18 < 3; c18_i18++) {
    (*c18_h_y)[c18_i18] = c18_y[c18_i18];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 10U, chartInstance->c18_sfEvent);
}

static void initSimStructsc18_objectTrackingFilter
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c18_machineNumber, uint32_T
  c18_chartNumber)
{
}

static const mxArray *c18_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData)
{
  const mxArray *c18_mxArrayOutData = NULL;
  real_T c18_u;
  const mxArray *c18_y = NULL;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_mxArrayOutData = NULL;
  c18_u = *(real_T *)c18_inData;
  c18_y = NULL;
  if (!chartInstance->c18_pre_theta_not_empty) {
    sf_mex_assign(&c18_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c18_y, sf_mex_create("y", &c18_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c18_mxArrayOutData, c18_y, FALSE);
  return c18_mxArrayOutData;
}

static real_T c18_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_b_pre_theta, const char_T *c18_identifier)
{
  real_T c18_y;
  emlrtMsgIdentifier c18_thisId;
  c18_thisId.fIdentifier = c18_identifier;
  c18_thisId.fParent = NULL;
  c18_y = c18_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c18_b_pre_theta),
    &c18_thisId);
  sf_mex_destroy(&c18_b_pre_theta);
  return c18_y;
}

static real_T c18_b_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId)
{
  real_T c18_y;
  real_T c18_d0;
  if (mxIsEmpty(c18_u)) {
    chartInstance->c18_pre_theta_not_empty = FALSE;
  } else {
    chartInstance->c18_pre_theta_not_empty = TRUE;
    sf_mex_import(c18_parentId, sf_mex_dup(c18_u), &c18_d0, 1, 0, 0U, 0, 0U, 0);
    c18_y = c18_d0;
  }

  sf_mex_destroy(&c18_u);
  return c18_y;
}

static void c18_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c18_mxArrayInData, const char_T *c18_varName, void *c18_outData)
{
  const mxArray *c18_b_pre_theta;
  const char_T *c18_identifier;
  emlrtMsgIdentifier c18_thisId;
  real_T c18_y;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_b_pre_theta = sf_mex_dup(c18_mxArrayInData);
  c18_identifier = c18_varName;
  c18_thisId.fIdentifier = c18_identifier;
  c18_thisId.fParent = NULL;
  c18_y = c18_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c18_b_pre_theta),
    &c18_thisId);
  sf_mex_destroy(&c18_b_pre_theta);
  *(real_T *)c18_outData = c18_y;
  sf_mex_destroy(&c18_mxArrayInData);
}

static const mxArray *c18_b_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData)
{
  const mxArray *c18_mxArrayOutData = NULL;
  real_T c18_u;
  const mxArray *c18_y = NULL;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_mxArrayOutData = NULL;
  c18_u = *(real_T *)c18_inData;
  c18_y = NULL;
  if (!chartInstance->c18_index_not_empty) {
    sf_mex_assign(&c18_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c18_y, sf_mex_create("y", &c18_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c18_mxArrayOutData, c18_y, FALSE);
  return c18_mxArrayOutData;
}

static real_T c18_c_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_b_index, const char_T *c18_identifier)
{
  real_T c18_y;
  emlrtMsgIdentifier c18_thisId;
  c18_thisId.fIdentifier = c18_identifier;
  c18_thisId.fParent = NULL;
  c18_y = c18_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c18_b_index),
    &c18_thisId);
  sf_mex_destroy(&c18_b_index);
  return c18_y;
}

static real_T c18_d_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId)
{
  real_T c18_y;
  real_T c18_d1;
  if (mxIsEmpty(c18_u)) {
    chartInstance->c18_index_not_empty = FALSE;
  } else {
    chartInstance->c18_index_not_empty = TRUE;
    sf_mex_import(c18_parentId, sf_mex_dup(c18_u), &c18_d1, 1, 0, 0U, 0, 0U, 0);
    c18_y = c18_d1;
  }

  sf_mex_destroy(&c18_u);
  return c18_y;
}

static void c18_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c18_mxArrayInData, const char_T *c18_varName, void *c18_outData)
{
  const mxArray *c18_b_index;
  const char_T *c18_identifier;
  emlrtMsgIdentifier c18_thisId;
  real_T c18_y;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_b_index = sf_mex_dup(c18_mxArrayInData);
  c18_identifier = c18_varName;
  c18_thisId.fIdentifier = c18_identifier;
  c18_thisId.fParent = NULL;
  c18_y = c18_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c18_b_index),
    &c18_thisId);
  sf_mex_destroy(&c18_b_index);
  *(real_T *)c18_outData = c18_y;
  sf_mex_destroy(&c18_mxArrayInData);
}

static const mxArray *c18_c_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData)
{
  const mxArray *c18_mxArrayOutData = NULL;
  int32_T c18_i19;
  real_T c18_b_inData[30];
  int32_T c18_i20;
  real_T c18_u[30];
  const mxArray *c18_y = NULL;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_mxArrayOutData = NULL;
  for (c18_i19 = 0; c18_i19 < 30; c18_i19++) {
    c18_b_inData[c18_i19] = (*(real_T (*)[30])c18_inData)[c18_i19];
  }

  for (c18_i20 = 0; c18_i20 < 30; c18_i20++) {
    c18_u[c18_i20] = c18_b_inData[c18_i20];
  }

  c18_y = NULL;
  if (!chartInstance->c18_pre_y_list_not_empty) {
    sf_mex_assign(&c18_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c18_y, sf_mex_create("y", c18_u, 0, 0U, 1U, 0U, 1, 30), FALSE);
  }

  sf_mex_assign(&c18_mxArrayOutData, c18_y, FALSE);
  return c18_mxArrayOutData;
}

static void c18_e_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_b_pre_y_list, const char_T *c18_identifier,
  real_T c18_y[30])
{
  emlrtMsgIdentifier c18_thisId;
  c18_thisId.fIdentifier = c18_identifier;
  c18_thisId.fParent = NULL;
  c18_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c18_b_pre_y_list),
    &c18_thisId, c18_y);
  sf_mex_destroy(&c18_b_pre_y_list);
}

static void c18_f_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId,
  real_T c18_y[30])
{
  real_T c18_dv3[30];
  int32_T c18_i21;
  if (mxIsEmpty(c18_u)) {
    chartInstance->c18_pre_y_list_not_empty = FALSE;
  } else {
    chartInstance->c18_pre_y_list_not_empty = TRUE;
    sf_mex_import(c18_parentId, sf_mex_dup(c18_u), c18_dv3, 1, 0, 0U, 1, 0U, 1,
                  30);
    for (c18_i21 = 0; c18_i21 < 30; c18_i21++) {
      c18_y[c18_i21] = c18_dv3[c18_i21];
    }
  }

  sf_mex_destroy(&c18_u);
}

static void c18_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c18_mxArrayInData, const char_T *c18_varName, void *c18_outData)
{
  const mxArray *c18_b_pre_y_list;
  const char_T *c18_identifier;
  emlrtMsgIdentifier c18_thisId;
  real_T c18_y[30];
  int32_T c18_i22;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_b_pre_y_list = sf_mex_dup(c18_mxArrayInData);
  c18_identifier = c18_varName;
  c18_thisId.fIdentifier = c18_identifier;
  c18_thisId.fParent = NULL;
  c18_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c18_b_pre_y_list),
    &c18_thisId, c18_y);
  sf_mex_destroy(&c18_b_pre_y_list);
  for (c18_i22 = 0; c18_i22 < 30; c18_i22++) {
    (*(real_T (*)[30])c18_outData)[c18_i22] = c18_y[c18_i22];
  }

  sf_mex_destroy(&c18_mxArrayInData);
}

static const mxArray *c18_d_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData)
{
  const mxArray *c18_mxArrayOutData = NULL;
  int32_T c18_i23;
  real_T c18_b_inData[30];
  int32_T c18_i24;
  real_T c18_u[30];
  const mxArray *c18_y = NULL;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_mxArrayOutData = NULL;
  for (c18_i23 = 0; c18_i23 < 30; c18_i23++) {
    c18_b_inData[c18_i23] = (*(real_T (*)[30])c18_inData)[c18_i23];
  }

  for (c18_i24 = 0; c18_i24 < 30; c18_i24++) {
    c18_u[c18_i24] = c18_b_inData[c18_i24];
  }

  c18_y = NULL;
  if (!chartInstance->c18_pre_x_list_not_empty) {
    sf_mex_assign(&c18_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c18_y, sf_mex_create("y", c18_u, 0, 0U, 1U, 0U, 1, 30), FALSE);
  }

  sf_mex_assign(&c18_mxArrayOutData, c18_y, FALSE);
  return c18_mxArrayOutData;
}

static void c18_g_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_b_pre_x_list, const char_T *c18_identifier,
  real_T c18_y[30])
{
  emlrtMsgIdentifier c18_thisId;
  c18_thisId.fIdentifier = c18_identifier;
  c18_thisId.fParent = NULL;
  c18_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c18_b_pre_x_list),
    &c18_thisId, c18_y);
  sf_mex_destroy(&c18_b_pre_x_list);
}

static void c18_h_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId,
  real_T c18_y[30])
{
  real_T c18_dv4[30];
  int32_T c18_i25;
  if (mxIsEmpty(c18_u)) {
    chartInstance->c18_pre_x_list_not_empty = FALSE;
  } else {
    chartInstance->c18_pre_x_list_not_empty = TRUE;
    sf_mex_import(c18_parentId, sf_mex_dup(c18_u), c18_dv4, 1, 0, 0U, 1, 0U, 1,
                  30);
    for (c18_i25 = 0; c18_i25 < 30; c18_i25++) {
      c18_y[c18_i25] = c18_dv4[c18_i25];
    }
  }

  sf_mex_destroy(&c18_u);
}

static void c18_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c18_mxArrayInData, const char_T *c18_varName, void *c18_outData)
{
  const mxArray *c18_b_pre_x_list;
  const char_T *c18_identifier;
  emlrtMsgIdentifier c18_thisId;
  real_T c18_y[30];
  int32_T c18_i26;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_b_pre_x_list = sf_mex_dup(c18_mxArrayInData);
  c18_identifier = c18_varName;
  c18_thisId.fIdentifier = c18_identifier;
  c18_thisId.fParent = NULL;
  c18_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c18_b_pre_x_list),
    &c18_thisId, c18_y);
  sf_mex_destroy(&c18_b_pre_x_list);
  for (c18_i26 = 0; c18_i26 < 30; c18_i26++) {
    (*(real_T (*)[30])c18_outData)[c18_i26] = c18_y[c18_i26];
  }

  sf_mex_destroy(&c18_mxArrayInData);
}

static const mxArray *c18_e_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData)
{
  const mxArray *c18_mxArrayOutData = NULL;
  real_T c18_u;
  const mxArray *c18_y = NULL;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_mxArrayOutData = NULL;
  c18_u = *(real_T *)c18_inData;
  c18_y = NULL;
  if (!chartInstance->c18_pre_y_not_empty) {
    sf_mex_assign(&c18_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c18_y, sf_mex_create("y", &c18_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c18_mxArrayOutData, c18_y, FALSE);
  return c18_mxArrayOutData;
}

static real_T c18_i_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_b_pre_y, const char_T *c18_identifier)
{
  real_T c18_y;
  emlrtMsgIdentifier c18_thisId;
  c18_thisId.fIdentifier = c18_identifier;
  c18_thisId.fParent = NULL;
  c18_y = c18_j_emlrt_marshallIn(chartInstance, sf_mex_dup(c18_b_pre_y),
    &c18_thisId);
  sf_mex_destroy(&c18_b_pre_y);
  return c18_y;
}

static real_T c18_j_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId)
{
  real_T c18_y;
  real_T c18_d2;
  if (mxIsEmpty(c18_u)) {
    chartInstance->c18_pre_y_not_empty = FALSE;
  } else {
    chartInstance->c18_pre_y_not_empty = TRUE;
    sf_mex_import(c18_parentId, sf_mex_dup(c18_u), &c18_d2, 1, 0, 0U, 0, 0U, 0);
    c18_y = c18_d2;
  }

  sf_mex_destroy(&c18_u);
  return c18_y;
}

static void c18_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c18_mxArrayInData, const char_T *c18_varName, void *c18_outData)
{
  const mxArray *c18_b_pre_y;
  const char_T *c18_identifier;
  emlrtMsgIdentifier c18_thisId;
  real_T c18_y;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_b_pre_y = sf_mex_dup(c18_mxArrayInData);
  c18_identifier = c18_varName;
  c18_thisId.fIdentifier = c18_identifier;
  c18_thisId.fParent = NULL;
  c18_y = c18_j_emlrt_marshallIn(chartInstance, sf_mex_dup(c18_b_pre_y),
    &c18_thisId);
  sf_mex_destroy(&c18_b_pre_y);
  *(real_T *)c18_outData = c18_y;
  sf_mex_destroy(&c18_mxArrayInData);
}

static const mxArray *c18_f_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData)
{
  const mxArray *c18_mxArrayOutData = NULL;
  real_T c18_u;
  const mxArray *c18_y = NULL;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_mxArrayOutData = NULL;
  c18_u = *(real_T *)c18_inData;
  c18_y = NULL;
  if (!chartInstance->c18_pre_x_not_empty) {
    sf_mex_assign(&c18_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c18_y, sf_mex_create("y", &c18_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c18_mxArrayOutData, c18_y, FALSE);
  return c18_mxArrayOutData;
}

static real_T c18_k_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_b_pre_x, const char_T *c18_identifier)
{
  real_T c18_y;
  emlrtMsgIdentifier c18_thisId;
  c18_thisId.fIdentifier = c18_identifier;
  c18_thisId.fParent = NULL;
  c18_y = c18_l_emlrt_marshallIn(chartInstance, sf_mex_dup(c18_b_pre_x),
    &c18_thisId);
  sf_mex_destroy(&c18_b_pre_x);
  return c18_y;
}

static real_T c18_l_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId)
{
  real_T c18_y;
  real_T c18_d3;
  if (mxIsEmpty(c18_u)) {
    chartInstance->c18_pre_x_not_empty = FALSE;
  } else {
    chartInstance->c18_pre_x_not_empty = TRUE;
    sf_mex_import(c18_parentId, sf_mex_dup(c18_u), &c18_d3, 1, 0, 0U, 0, 0U, 0);
    c18_y = c18_d3;
  }

  sf_mex_destroy(&c18_u);
  return c18_y;
}

static void c18_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c18_mxArrayInData, const char_T *c18_varName, void *c18_outData)
{
  const mxArray *c18_b_pre_x;
  const char_T *c18_identifier;
  emlrtMsgIdentifier c18_thisId;
  real_T c18_y;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_b_pre_x = sf_mex_dup(c18_mxArrayInData);
  c18_identifier = c18_varName;
  c18_thisId.fIdentifier = c18_identifier;
  c18_thisId.fParent = NULL;
  c18_y = c18_l_emlrt_marshallIn(chartInstance, sf_mex_dup(c18_b_pre_x),
    &c18_thisId);
  sf_mex_destroy(&c18_b_pre_x);
  *(real_T *)c18_outData = c18_y;
  sf_mex_destroy(&c18_mxArrayInData);
}

static const mxArray *c18_g_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData)
{
  const mxArray *c18_mxArrayOutData = NULL;
  int32_T c18_i27;
  real_T c18_b_inData[3];
  int32_T c18_i28;
  real_T c18_u[3];
  const mxArray *c18_y = NULL;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_mxArrayOutData = NULL;
  for (c18_i27 = 0; c18_i27 < 3; c18_i27++) {
    c18_b_inData[c18_i27] = (*(real_T (*)[3])c18_inData)[c18_i27];
  }

  for (c18_i28 = 0; c18_i28 < 3; c18_i28++) {
    c18_u[c18_i28] = c18_b_inData[c18_i28];
  }

  c18_y = NULL;
  sf_mex_assign(&c18_y, sf_mex_create("y", c18_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c18_mxArrayOutData, c18_y, FALSE);
  return c18_mxArrayOutData;
}

static void c18_m_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_y, const char_T *c18_identifier, real_T
  c18_b_y[3])
{
  emlrtMsgIdentifier c18_thisId;
  c18_thisId.fIdentifier = c18_identifier;
  c18_thisId.fParent = NULL;
  c18_n_emlrt_marshallIn(chartInstance, sf_mex_dup(c18_y), &c18_thisId, c18_b_y);
  sf_mex_destroy(&c18_y);
}

static void c18_n_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId,
  real_T c18_y[3])
{
  real_T c18_dv5[3];
  int32_T c18_i29;
  sf_mex_import(c18_parentId, sf_mex_dup(c18_u), c18_dv5, 1, 0, 0U, 1, 0U, 1, 3);
  for (c18_i29 = 0; c18_i29 < 3; c18_i29++) {
    c18_y[c18_i29] = c18_dv5[c18_i29];
  }

  sf_mex_destroy(&c18_u);
}

static void c18_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c18_mxArrayInData, const char_T *c18_varName, void *c18_outData)
{
  const mxArray *c18_y;
  const char_T *c18_identifier;
  emlrtMsgIdentifier c18_thisId;
  real_T c18_b_y[3];
  int32_T c18_i30;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_y = sf_mex_dup(c18_mxArrayInData);
  c18_identifier = c18_varName;
  c18_thisId.fIdentifier = c18_identifier;
  c18_thisId.fParent = NULL;
  c18_n_emlrt_marshallIn(chartInstance, sf_mex_dup(c18_y), &c18_thisId, c18_b_y);
  sf_mex_destroy(&c18_y);
  for (c18_i30 = 0; c18_i30 < 3; c18_i30++) {
    (*(real_T (*)[3])c18_outData)[c18_i30] = c18_b_y[c18_i30];
  }

  sf_mex_destroy(&c18_mxArrayInData);
}

static const mxArray *c18_h_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData)
{
  const mxArray *c18_mxArrayOutData = NULL;
  int32_T c18_i31;
  real_T c18_b_inData[2];
  int32_T c18_i32;
  real_T c18_u[2];
  const mxArray *c18_y = NULL;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_mxArrayOutData = NULL;
  for (c18_i31 = 0; c18_i31 < 2; c18_i31++) {
    c18_b_inData[c18_i31] = (*(real_T (*)[2])c18_inData)[c18_i31];
  }

  for (c18_i32 = 0; c18_i32 < 2; c18_i32++) {
    c18_u[c18_i32] = c18_b_inData[c18_i32];
  }

  c18_y = NULL;
  sf_mex_assign(&c18_y, sf_mex_create("y", c18_u, 0, 0U, 1U, 0U, 1, 2), FALSE);
  sf_mex_assign(&c18_mxArrayOutData, c18_y, FALSE);
  return c18_mxArrayOutData;
}

static const mxArray *c18_i_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData)
{
  const mxArray *c18_mxArrayOutData = NULL;
  real_T c18_u;
  const mxArray *c18_y = NULL;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_mxArrayOutData = NULL;
  c18_u = *(real_T *)c18_inData;
  c18_y = NULL;
  sf_mex_assign(&c18_y, sf_mex_create("y", &c18_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c18_mxArrayOutData, c18_y, FALSE);
  return c18_mxArrayOutData;
}

static real_T c18_o_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId)
{
  real_T c18_y;
  real_T c18_d4;
  sf_mex_import(c18_parentId, sf_mex_dup(c18_u), &c18_d4, 1, 0, 0U, 0, 0U, 0);
  c18_y = c18_d4;
  sf_mex_destroy(&c18_u);
  return c18_y;
}

static void c18_h_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c18_mxArrayInData, const char_T *c18_varName, void *c18_outData)
{
  const mxArray *c18_nargout;
  const char_T *c18_identifier;
  emlrtMsgIdentifier c18_thisId;
  real_T c18_y;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_nargout = sf_mex_dup(c18_mxArrayInData);
  c18_identifier = c18_varName;
  c18_thisId.fIdentifier = c18_identifier;
  c18_thisId.fParent = NULL;
  c18_y = c18_o_emlrt_marshallIn(chartInstance, sf_mex_dup(c18_nargout),
    &c18_thisId);
  sf_mex_destroy(&c18_nargout);
  *(real_T *)c18_outData = c18_y;
  sf_mex_destroy(&c18_mxArrayInData);
}

const mxArray *sf_c18_objectTrackingFilter_get_eml_resolved_functions_info(void)
{
  const mxArray *c18_nameCaptureInfo;
  c18_ResolvedFunctionInfo c18_info[15];
  const mxArray *c18_m0 = NULL;
  int32_T c18_i33;
  c18_ResolvedFunctionInfo *c18_r0;
  c18_nameCaptureInfo = NULL;
  c18_nameCaptureInfo = NULL;
  c18_info_helper(c18_info);
  sf_mex_assign(&c18_m0, sf_mex_createstruct("nameCaptureInfo", 1, 15), FALSE);
  for (c18_i33 = 0; c18_i33 < 15; c18_i33++) {
    c18_r0 = &c18_info[c18_i33];
    sf_mex_addfield(c18_m0, sf_mex_create("nameCaptureInfo", c18_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c18_r0->context)), "context", "nameCaptureInfo",
                    c18_i33);
    sf_mex_addfield(c18_m0, sf_mex_create("nameCaptureInfo", c18_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c18_r0->name)), "name", "nameCaptureInfo",
                    c18_i33);
    sf_mex_addfield(c18_m0, sf_mex_create("nameCaptureInfo",
      c18_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c18_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c18_i33);
    sf_mex_addfield(c18_m0, sf_mex_create("nameCaptureInfo", c18_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c18_r0->resolved)), "resolved",
                    "nameCaptureInfo", c18_i33);
    sf_mex_addfield(c18_m0, sf_mex_create("nameCaptureInfo", &c18_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c18_i33);
    sf_mex_addfield(c18_m0, sf_mex_create("nameCaptureInfo", &c18_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c18_i33);
    sf_mex_addfield(c18_m0, sf_mex_create("nameCaptureInfo",
      &c18_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c18_i33);
    sf_mex_addfield(c18_m0, sf_mex_create("nameCaptureInfo",
      &c18_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c18_i33);
  }

  sf_mex_assign(&c18_nameCaptureInfo, c18_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c18_nameCaptureInfo);
  return c18_nameCaptureInfo;
}

static void c18_info_helper(c18_ResolvedFunctionInfo c18_info[15])
{
  c18_info[0].context = "";
  c18_info[0].name = "sum";
  c18_info[0].dominantType = "double";
  c18_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/sum.m";
  c18_info[0].fileTimeLo = 1314736612U;
  c18_info[0].fileTimeHi = 0U;
  c18_info[0].mFileTimeLo = 0U;
  c18_info[0].mFileTimeHi = 0U;
  c18_info[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/sum.m";
  c18_info[1].name = "isequal";
  c18_info[1].dominantType = "double";
  c18_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isequal.m";
  c18_info[1].fileTimeLo = 1286818758U;
  c18_info[1].fileTimeHi = 0U;
  c18_info[1].mFileTimeLo = 0U;
  c18_info[1].mFileTimeHi = 0U;
  c18_info[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isequal.m";
  c18_info[2].name = "eml_isequal_core";
  c18_info[2].dominantType = "double";
  c18_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_isequal_core.m";
  c18_info[2].fileTimeLo = 1286818786U;
  c18_info[2].fileTimeHi = 0U;
  c18_info[2].mFileTimeLo = 0U;
  c18_info[2].mFileTimeHi = 0U;
  c18_info[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/sum.m";
  c18_info[3].name = "eml_const_nonsingleton_dim";
  c18_info[3].dominantType = "double";
  c18_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_const_nonsingleton_dim.m";
  c18_info[3].fileTimeLo = 1286818696U;
  c18_info[3].fileTimeHi = 0U;
  c18_info[3].mFileTimeLo = 0U;
  c18_info[3].mFileTimeHi = 0U;
  c18_info[4].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/sum.m";
  c18_info[4].name = "eml_scalar_eg";
  c18_info[4].dominantType = "double";
  c18_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c18_info[4].fileTimeLo = 1286818796U;
  c18_info[4].fileTimeHi = 0U;
  c18_info[4].mFileTimeLo = 0U;
  c18_info[4].mFileTimeHi = 0U;
  c18_info[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/sum.m";
  c18_info[5].name = "eml_index_class";
  c18_info[5].dominantType = "";
  c18_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c18_info[5].fileTimeLo = 1323170578U;
  c18_info[5].fileTimeHi = 0U;
  c18_info[5].mFileTimeLo = 0U;
  c18_info[5].mFileTimeHi = 0U;
  c18_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/sum.m";
  c18_info[6].name = "eml_int_forloop_overflow_check";
  c18_info[6].dominantType = "";
  c18_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c18_info[6].fileTimeLo = 1332168672U;
  c18_info[6].fileTimeHi = 0U;
  c18_info[6].mFileTimeLo = 0U;
  c18_info[6].mFileTimeHi = 0U;
  c18_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m!eml_int_forloop_overflow_check_helper";
  c18_info[7].name = "intmax";
  c18_info[7].dominantType = "char";
  c18_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c18_info[7].fileTimeLo = 1311255316U;
  c18_info[7].fileTimeHi = 0U;
  c18_info[7].mFileTimeLo = 0U;
  c18_info[7].mFileTimeHi = 0U;
  c18_info[8].context = "";
  c18_info[8].name = "mrdivide";
  c18_info[8].dominantType = "double";
  c18_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c18_info[8].fileTimeLo = 1342810944U;
  c18_info[8].fileTimeHi = 0U;
  c18_info[8].mFileTimeLo = 1319729966U;
  c18_info[8].mFileTimeHi = 0U;
  c18_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c18_info[9].name = "rdivide";
  c18_info[9].dominantType = "double";
  c18_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c18_info[9].fileTimeLo = 1286818844U;
  c18_info[9].fileTimeHi = 0U;
  c18_info[9].mFileTimeLo = 0U;
  c18_info[9].mFileTimeHi = 0U;
  c18_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c18_info[10].name = "eml_div";
  c18_info[10].dominantType = "double";
  c18_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c18_info[10].fileTimeLo = 1313347810U;
  c18_info[10].fileTimeHi = 0U;
  c18_info[10].mFileTimeLo = 0U;
  c18_info[10].mFileTimeHi = 0U;
  c18_info[11].context = "";
  c18_info[11].name = "atan2";
  c18_info[11].dominantType = "double";
  c18_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c18_info[11].fileTimeLo = 1286818704U;
  c18_info[11].fileTimeHi = 0U;
  c18_info[11].mFileTimeLo = 0U;
  c18_info[11].mFileTimeHi = 0U;
  c18_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c18_info[12].name = "eml_scalar_eg";
  c18_info[12].dominantType = "double";
  c18_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c18_info[12].fileTimeLo = 1286818796U;
  c18_info[12].fileTimeHi = 0U;
  c18_info[12].mFileTimeLo = 0U;
  c18_info[12].mFileTimeHi = 0U;
  c18_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c18_info[13].name = "eml_scalexp_alloc";
  c18_info[13].dominantType = "double";
  c18_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c18_info[13].fileTimeLo = 1330608434U;
  c18_info[13].fileTimeHi = 0U;
  c18_info[13].mFileTimeLo = 0U;
  c18_info[13].mFileTimeHi = 0U;
  c18_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c18_info[14].name = "eml_scalar_atan2";
  c18_info[14].dominantType = "double";
  c18_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_atan2.m";
  c18_info[14].fileTimeLo = 1286818720U;
  c18_info[14].fileTimeHi = 0U;
  c18_info[14].mFileTimeLo = 0U;
  c18_info[14].mFileTimeHi = 0U;
}

static real_T c18_sum(SFc18_objectTrackingFilterInstanceStruct *chartInstance,
                      real_T c18_x[30])
{
  real_T c18_y;
  int32_T c18_k;
  int32_T c18_b_k;
  c18_y = c18_x[0];
  c18_check_forloop_overflow_error(chartInstance);
  for (c18_k = 2; c18_k < 31; c18_k++) {
    c18_b_k = c18_k;
    c18_y += c18_x[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
      "", (real_T)c18_b_k), 1, 30, 1, 0) - 1];
  }

  return c18_y;
}

static void c18_check_forloop_overflow_error
  (SFc18_objectTrackingFilterInstanceStruct *chartInstance)
{
}

static const mxArray *c18_j_sf_marshallOut(void *chartInstanceVoid, void
  *c18_inData)
{
  const mxArray *c18_mxArrayOutData = NULL;
  int32_T c18_u;
  const mxArray *c18_y = NULL;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_mxArrayOutData = NULL;
  c18_u = *(int32_T *)c18_inData;
  c18_y = NULL;
  sf_mex_assign(&c18_y, sf_mex_create("y", &c18_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c18_mxArrayOutData, c18_y, FALSE);
  return c18_mxArrayOutData;
}

static int32_T c18_p_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId)
{
  int32_T c18_y;
  int32_T c18_i34;
  sf_mex_import(c18_parentId, sf_mex_dup(c18_u), &c18_i34, 1, 6, 0U, 0, 0U, 0);
  c18_y = c18_i34;
  sf_mex_destroy(&c18_u);
  return c18_y;
}

static void c18_i_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c18_mxArrayInData, const char_T *c18_varName, void *c18_outData)
{
  const mxArray *c18_b_sfEvent;
  const char_T *c18_identifier;
  emlrtMsgIdentifier c18_thisId;
  int32_T c18_y;
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)chartInstanceVoid;
  c18_b_sfEvent = sf_mex_dup(c18_mxArrayInData);
  c18_identifier = c18_varName;
  c18_thisId.fIdentifier = c18_identifier;
  c18_thisId.fParent = NULL;
  c18_y = c18_p_emlrt_marshallIn(chartInstance, sf_mex_dup(c18_b_sfEvent),
    &c18_thisId);
  sf_mex_destroy(&c18_b_sfEvent);
  *(int32_T *)c18_outData = c18_y;
  sf_mex_destroy(&c18_mxArrayInData);
}

static uint8_T c18_q_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_b_is_active_c18_objectTrackingFilter, const
  char_T *c18_identifier)
{
  uint8_T c18_y;
  emlrtMsgIdentifier c18_thisId;
  c18_thisId.fIdentifier = c18_identifier;
  c18_thisId.fParent = NULL;
  c18_y = c18_r_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c18_b_is_active_c18_objectTrackingFilter), &c18_thisId);
  sf_mex_destroy(&c18_b_is_active_c18_objectTrackingFilter);
  return c18_y;
}

static uint8_T c18_r_emlrt_marshallIn(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance, const mxArray *c18_u, const emlrtMsgIdentifier *c18_parentId)
{
  uint8_T c18_y;
  uint8_T c18_u0;
  sf_mex_import(c18_parentId, sf_mex_dup(c18_u), &c18_u0, 1, 3, 0U, 0, 0U, 0);
  c18_y = c18_u0;
  sf_mex_destroy(&c18_u);
  return c18_y;
}

static void init_dsm_address_info(SFc18_objectTrackingFilterInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c18_objectTrackingFilter_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2462259196U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2997628778U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(714786455U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1289269536U);
}

mxArray *sf_c18_objectTrackingFilter_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("M4IF1nVCbBOGdgnd6SlEnD");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c18_objectTrackingFilter(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x8'type','srcId','name','auxInfo'{{M[1],M[6],T\"y\",},{M[4],M[0],T\"index\",S'l','i','p'{{M1x2[144 149],M[0],}}},{M[4],M[0],T\"pre_theta\",S'l','i','p'{{M1x2[170 179],M[0],}}},{M[4],M[0],T\"pre_x\",S'l','i','p'{{M1x2[50 55],M[0],}}},{M[4],M[0],T\"pre_x_list\",S'l','i','p'{{M1x2[92 102],M[0],}}},{M[4],M[0],T\"pre_y\",S'l','i','p'{{M1x2[71 76],M[0],}}},{M[4],M[0],T\"pre_y_list\",S'l','i','p'{{M1x2[118 128],M[0],}}},{M[8],M[0],T\"is_active_c18_objectTrackingFilter\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 8, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c18_objectTrackingFilter_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc18_objectTrackingFilterInstanceStruct *chartInstance;
    chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_objectTrackingFilterMachineNumber_,
           18,
           1,
           1,
           2,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_objectTrackingFilterMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_objectTrackingFilterMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds
            (_objectTrackingFilterMachineNumber_,
             chartInstance->chartNumber,
             0,
             0,
             0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"hat_x");
          _SFD_SET_DATA_PROPS(1,2,0,1,"y");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,2,0,0,0,0,0,2,1);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,920);
        _SFD_CV_INIT_EML_IF(0,1,0,194,229,-1,415);
        _SFD_CV_INIT_EML_IF(0,1,1,426,439,574,861);

        {
          static int condStart[] = { 197, 215 };

          static int condEnd[] = { 211, 229 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,0,197,229,2,0,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c18_h_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c18_g_sf_marshallOut,(MexInFcnForType)
            c18_g_sf_marshallIn);
        }

        {
          real_T (*c18_hat_x)[2];
          real_T (*c18_y)[3];
          c18_y = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
          c18_hat_x = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c18_hat_x);
          _SFD_SET_DATA_VALUE_PTR(1U, *c18_y);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration
        (_objectTrackingFilterMachineNumber_,chartInstance->chartNumber,
         chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "XJ6AAJSadrx3v1d1dpWGEE";
}

static void sf_opaque_initialize_c18_objectTrackingFilter(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc18_objectTrackingFilterInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c18_objectTrackingFilter
    ((SFc18_objectTrackingFilterInstanceStruct*) chartInstanceVar);
  initialize_c18_objectTrackingFilter((SFc18_objectTrackingFilterInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c18_objectTrackingFilter(void *chartInstanceVar)
{
  enable_c18_objectTrackingFilter((SFc18_objectTrackingFilterInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_disable_c18_objectTrackingFilter(void *chartInstanceVar)
{
  disable_c18_objectTrackingFilter((SFc18_objectTrackingFilterInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c18_objectTrackingFilter(void *chartInstanceVar)
{
  sf_c18_objectTrackingFilter((SFc18_objectTrackingFilterInstanceStruct*)
    chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c18_objectTrackingFilter
  (SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c18_objectTrackingFilter
    ((SFc18_objectTrackingFilterInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c18_objectTrackingFilter();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c18_objectTrackingFilter(SimStruct* S,
  const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c18_objectTrackingFilter();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c18_objectTrackingFilter
    ((SFc18_objectTrackingFilterInstanceStruct*)chartInfo->chartInstance,
     mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c18_objectTrackingFilter(SimStruct*
  S)
{
  return sf_internal_get_sim_state_c18_objectTrackingFilter(S);
}

static void sf_opaque_set_sim_state_c18_objectTrackingFilter(SimStruct* S, const
  mxArray *st)
{
  sf_internal_set_sim_state_c18_objectTrackingFilter(S, st);
}

static void sf_opaque_terminate_c18_objectTrackingFilter(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc18_objectTrackingFilterInstanceStruct*) chartInstanceVar)
      ->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c18_objectTrackingFilter((SFc18_objectTrackingFilterInstanceStruct*)
      chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_objectTrackingFilter_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc18_objectTrackingFilter
    ((SFc18_objectTrackingFilterInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c18_objectTrackingFilter(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c18_objectTrackingFilter
      ((SFc18_objectTrackingFilterInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c18_objectTrackingFilter(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_objectTrackingFilter_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      18);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,18,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,18,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,18,1);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,18,1);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,18);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2852055635U));
  ssSetChecksum1(S,(2440777252U));
  ssSetChecksum2(S,(2450456128U));
  ssSetChecksum3(S,(2211436231U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c18_objectTrackingFilter(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c18_objectTrackingFilter(SimStruct *S)
{
  SFc18_objectTrackingFilterInstanceStruct *chartInstance;
  chartInstance = (SFc18_objectTrackingFilterInstanceStruct *)malloc(sizeof
    (SFc18_objectTrackingFilterInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc18_objectTrackingFilterInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c18_objectTrackingFilter;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c18_objectTrackingFilter;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c18_objectTrackingFilter;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c18_objectTrackingFilter;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c18_objectTrackingFilter;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c18_objectTrackingFilter;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c18_objectTrackingFilter;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c18_objectTrackingFilter;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c18_objectTrackingFilter;
  chartInstance->chartInfo.mdlStart = mdlStart_c18_objectTrackingFilter;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c18_objectTrackingFilter;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c18_objectTrackingFilter_method_dispatcher(SimStruct *S, int_T method, void
  *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c18_objectTrackingFilter(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c18_objectTrackingFilter(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c18_objectTrackingFilter(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c18_objectTrackingFilter_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
