

x                               = logsout.get('eta').Values.Data(:,1);
y                               = logsout.get('eta').Values.Data(:,2);
theta                           = logsout.get('eta').Values.Data(:,3);

u                               = logsout.get('nu').Values.Data(:,1);
r                               = logsout.get('nu').Values.Data(:,3);


t                               = logsout.get('SimulationTime').Values.Data;

s1 = 2800
turningRadius = u(end)/(b_heading*pi*(40/180))

count = 1;
advanceTime = [];
advanceValue = [];
TransferValue = [];
tacticalDiameter = [];
MaximumAdvance = [];
for i = 30/0.01:size(theta,1)
    
   if abs(theta(i)- pi/2) < 0.01 && count == 1
       advanceTime = i;
       advanceValue = x(i) -x(30/0.01);
       TransferValue = y(i) - y(30/0.01);
       
   end
   if abs(theta(i) - pi) < 0.01
       tacticalDiameter = y(i) - y(30/0.01);
       MaximumAdvance = x(i) - x(30/0.01);
       
       count = count +1;
       break;
   end
end
advanceValue
TransferValue
tacticalDiameter
MaximumAdvance
figure(1);clf
hold on
plot(x(s1:end),y(s1:end))
plot(x(end-220)+turningRadius,y(end-220),'k*')
plot([x(end-220) x(end-220)+turningRadius],[y(end-220) y(end-220)],'--k')



title('xy plot of steady turning radius test')
xlabel('x [m]')
ylabel('y [m]')
axis equal
text(195,28,'R = 10 m')
figure(2);clf

plot(t(32/0.01:end),u(32/0.01:end)./r(32/0.01:end))

legend('\phi')
title('heading of steady truning radius test')

figure(3);clf
subplot(2,1,1)
plot(t,u);
%legend('Speed U')
title('Vehicle speed U')
xlabel('time [s]')
ylabel('speed [m/s]')
subplot(2,1,2)

plot(t,r)
%legend('turning rate r')
title('Vehicle turning rate')
xlabel('time [s]')
ylabel('turning rate [rad/s]')


figure(4);clf
hold on
plot(t(:),rad2deg(theta(:)))
plot([t(1) t(end)],[90 90],'k')
legend('\phi')
title('heading of steady truning radius test')
