%% get signal from simulation 

vehicle_xpos = logsout.get('eta').Values.Data(:,1);
vehicle_ypos = logsout.get('eta').Values.Data(:,2);
vehicle_heading = logsout.get('eta').Values.Data(:,3);


vehicle_u = logsout.get('nu').Values.Data(:,1);
vehicle_v = logsout.get('nu').Values.Data(:,2);
vehicle_r = logsout.get('nu').Values.Data(:,3);

SterringCommand = logsout.get('SterringCommand').Values.Data(:,1);
vehicle_lamda = logsout.get('lamda').Values.Data(:,1);

numberOfObstacles = size(obslist,1);
obstacle = logsout.get('Obstacle').Values.Data();

times = logsout.get('SimulationTime').Values.Data;
%% plot simulation



figure(3);clf
hold on

plot(times,vehicle_heading)
plot(times,SterringCommand,'--r')

legend('\psi','\psi_d','location','SouthEast')
title('Vehicle heading')
figure(4);clf

plot(times,vehicle_u)
title('Vehicle speed u')
%legend('vehicle speed')

figure(5);clf

plot(times,vehicle_r)
%legend('turning rate')
title('Turning rate r, for the vehicle')
figure(6);clf

plot(times,vehicle_lamda)
%legend('\delta')
title('Rudder \delta for the vehicle')
