/* Include files */

#include "blascompat32.h"
#include "Dubins_vehicle_simulator_sfun.h"
#include "c6_Dubins_vehicle_simulator.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "Dubins_vehicle_simulator_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c6_debug_family_names[20] = { "R", "v_r", "ak", "s", "delta",
  "K_p", "K_i", "x_r", "nargin", "nargout", "eta", "WpNext", "WpPre", "target",
  "intE", "x_d", "V", "e", "done", "temp_done" };

/* Function Declarations */
static void initialize_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance);
static void initialize_params_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance);
static void enable_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance);
static void disable_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance);
static void c6_update_debugger_state_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance);
static void set_sim_state_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance, const mxArray
   *c6_st);
static void finalize_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance);
static void sf_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance);
static void c6_chartstep_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance);
static void initSimStructsc6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c6_machineNumber, uint32_T
  c6_chartNumber);
static const mxArray *c6_sf_marshallOut(void *chartInstanceVoid, void *c6_inData);
static real_T c6_emlrt_marshallIn(SFc6_Dubins_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c6_b_temp_done, const char_T *c6_identifier);
static real_T c6_b_emlrt_marshallIn(SFc6_Dubins_vehicle_simulatorInstanceStruct *
  chartInstance, const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId);
static void c6_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData);
static const mxArray *c6_b_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData);
static real_T c6_c_emlrt_marshallIn(SFc6_Dubins_vehicle_simulatorInstanceStruct *
  chartInstance, const mxArray *c6_done, const char_T *c6_identifier);
static real_T c6_d_emlrt_marshallIn(SFc6_Dubins_vehicle_simulatorInstanceStruct *
  chartInstance, const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId);
static void c6_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData);
static const mxArray *c6_c_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData);
static void c6_e_emlrt_marshallIn(SFc6_Dubins_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId,
  real_T c6_y[2]);
static void c6_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData);
static const mxArray *c6_d_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData);
static void c6_info_helper(c6_ResolvedFunctionInfo c6_info[44]);
static void c6_eml_scalar_eg(SFc6_Dubins_vehicle_simulatorInstanceStruct
  *chartInstance);
static real_T c6_norm(SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance,
                      real_T c6_x[2]);
static void c6_check_forloop_overflow_error
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance);
static real_T c6_mpower(SFc6_Dubins_vehicle_simulatorInstanceStruct
  *chartInstance, real_T c6_a);
static void c6_eml_error(SFc6_Dubins_vehicle_simulatorInstanceStruct
  *chartInstance);
static const mxArray *c6_e_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData);
static int32_T c6_f_emlrt_marshallIn(SFc6_Dubins_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId);
static void c6_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData);
static uint8_T c6_g_emlrt_marshallIn(SFc6_Dubins_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c6_b_is_active_c6_Dubins_vehicle_simulator,
  const char_T *c6_identifier);
static uint8_T c6_h_emlrt_marshallIn(SFc6_Dubins_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId);
static void init_dsm_address_info(SFc6_Dubins_vehicle_simulatorInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance)
{
  chartInstance->c6_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c6_temp_done_not_empty = FALSE;
  chartInstance->c6_is_active_c6_Dubins_vehicle_simulator = 0U;
}

static void initialize_params_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance)
{
  real_T c6_dv0[2];
  int32_T c6_i0;
  sf_set_error_prefix_string(
    "Error evaluating data 'target' in the parent workspace.\n");
  sf_mex_import_named("target", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      c6_dv0, 0, 0, 0U, 1, 0U, 1, 2);
  for (c6_i0 = 0; c6_i0 < 2; c6_i0++) {
    chartInstance->c6_target[c6_i0] = c6_dv0[c6_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c6_update_debugger_state_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance)
{
  const mxArray *c6_st;
  const mxArray *c6_y = NULL;
  real_T c6_hoistedGlobal;
  real_T c6_u;
  const mxArray *c6_b_y = NULL;
  real_T c6_b_hoistedGlobal;
  real_T c6_b_u;
  const mxArray *c6_c_y = NULL;
  real_T c6_c_hoistedGlobal;
  real_T c6_c_u;
  const mxArray *c6_d_y = NULL;
  real_T c6_d_hoistedGlobal;
  real_T c6_d_u;
  const mxArray *c6_e_y = NULL;
  real_T c6_e_hoistedGlobal;
  real_T c6_e_u;
  const mxArray *c6_f_y = NULL;
  uint8_T c6_f_hoistedGlobal;
  uint8_T c6_f_u;
  const mxArray *c6_g_y = NULL;
  real_T *c6_V;
  real_T *c6_done;
  real_T *c6_e;
  real_T *c6_x_d;
  c6_done = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c6_e = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c6_V = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c6_x_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c6_st = NULL;
  c6_st = NULL;
  c6_y = NULL;
  sf_mex_assign(&c6_y, sf_mex_createcellarray(6), FALSE);
  c6_hoistedGlobal = *c6_V;
  c6_u = c6_hoistedGlobal;
  c6_b_y = NULL;
  sf_mex_assign(&c6_b_y, sf_mex_create("y", &c6_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c6_y, 0, c6_b_y);
  c6_b_hoistedGlobal = *c6_done;
  c6_b_u = c6_b_hoistedGlobal;
  c6_c_y = NULL;
  sf_mex_assign(&c6_c_y, sf_mex_create("y", &c6_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c6_y, 1, c6_c_y);
  c6_c_hoistedGlobal = *c6_e;
  c6_c_u = c6_c_hoistedGlobal;
  c6_d_y = NULL;
  sf_mex_assign(&c6_d_y, sf_mex_create("y", &c6_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c6_y, 2, c6_d_y);
  c6_d_hoistedGlobal = *c6_x_d;
  c6_d_u = c6_d_hoistedGlobal;
  c6_e_y = NULL;
  sf_mex_assign(&c6_e_y, sf_mex_create("y", &c6_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c6_y, 3, c6_e_y);
  c6_e_hoistedGlobal = chartInstance->c6_temp_done;
  c6_e_u = c6_e_hoistedGlobal;
  c6_f_y = NULL;
  if (!chartInstance->c6_temp_done_not_empty) {
    sf_mex_assign(&c6_f_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c6_f_y, sf_mex_create("y", &c6_e_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c6_y, 4, c6_f_y);
  c6_f_hoistedGlobal = chartInstance->c6_is_active_c6_Dubins_vehicle_simulator;
  c6_f_u = c6_f_hoistedGlobal;
  c6_g_y = NULL;
  sf_mex_assign(&c6_g_y, sf_mex_create("y", &c6_f_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c6_y, 5, c6_g_y);
  sf_mex_assign(&c6_st, c6_y, FALSE);
  return c6_st;
}

static void set_sim_state_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance, const mxArray
   *c6_st)
{
  const mxArray *c6_u;
  real_T *c6_V;
  real_T *c6_done;
  real_T *c6_e;
  real_T *c6_x_d;
  c6_done = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c6_e = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c6_V = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c6_x_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c6_doneDoubleBufferReInit = TRUE;
  c6_u = sf_mex_dup(c6_st);
  *c6_V = c6_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c6_u, 0)),
    "V");
  *c6_done = c6_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c6_u,
    1)), "done");
  *c6_e = c6_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c6_u, 2)),
    "e");
  *c6_x_d = c6_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c6_u,
    3)), "x_d");
  chartInstance->c6_temp_done = c6_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c6_u, 4)), "temp_done");
  chartInstance->c6_is_active_c6_Dubins_vehicle_simulator =
    c6_g_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c6_u, 5)),
    "is_active_c6_Dubins_vehicle_simulator");
  sf_mex_destroy(&c6_u);
  c6_update_debugger_state_c6_Dubins_vehicle_simulator(chartInstance);
  sf_mex_destroy(&c6_st);
}

static void finalize_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance)
{
}

static void sf_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance)
{
  int32_T c6_i1;
  int32_T c6_i2;
  int32_T c6_i3;
  int32_T c6_i4;
  real_T *c6_x_d;
  real_T *c6_V;
  real_T *c6_intE;
  real_T *c6_e;
  real_T *c6_done;
  real_T (*c6_WpPre)[2];
  real_T (*c6_WpNext)[2];
  real_T (*c6_eta)[3];
  c6_done = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c6_e = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c6_intE = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c6_V = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c6_x_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c6_WpPre = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 2);
  c6_WpNext = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 1);
  c6_eta = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 4U, chartInstance->c6_sfEvent);
  for (c6_i1 = 0; c6_i1 < 3; c6_i1++) {
    _SFD_DATA_RANGE_CHECK((*c6_eta)[c6_i1], 0U);
  }

  for (c6_i2 = 0; c6_i2 < 2; c6_i2++) {
    _SFD_DATA_RANGE_CHECK((*c6_WpNext)[c6_i2], 1U);
  }

  for (c6_i3 = 0; c6_i3 < 2; c6_i3++) {
    _SFD_DATA_RANGE_CHECK((*c6_WpPre)[c6_i3], 2U);
  }

  _SFD_DATA_RANGE_CHECK(*c6_x_d, 3U);
  for (c6_i4 = 0; c6_i4 < 2; c6_i4++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c6_target[c6_i4], 4U);
  }

  _SFD_DATA_RANGE_CHECK(*c6_V, 5U);
  _SFD_DATA_RANGE_CHECK(*c6_intE, 6U);
  _SFD_DATA_RANGE_CHECK(*c6_e, 7U);
  _SFD_DATA_RANGE_CHECK(*c6_done, 8U);
  chartInstance->c6_sfEvent = CALL_EVENT;
  c6_chartstep_c6_Dubins_vehicle_simulator(chartInstance);
  sf_debug_check_for_state_inconsistency(_Dubins_vehicle_simulatorMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c6_chartstep_c6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance)
{
  real_T c6_hoistedGlobal;
  int32_T c6_i5;
  real_T c6_eta[3];
  int32_T c6_i6;
  real_T c6_WpNext[2];
  int32_T c6_i7;
  real_T c6_WpPre[2];
  int32_T c6_i8;
  real_T c6_b_target[2];
  real_T c6_intE;
  uint32_T c6_debug_family_var_map[20];
  real_T c6_R;
  real_T c6_v_r;
  real_T c6_ak;
  real_T c6_s;
  real_T c6_delta;
  real_T c6_K_p;
  real_T c6_K_i;
  real_T c6_x_r;
  real_T c6_nargin = 5.0;
  real_T c6_nargout = 4.0;
  real_T c6_x_d;
  real_T c6_V;
  real_T c6_e;
  real_T c6_done;
  real_T c6_y;
  real_T c6_x;
  real_T c6_b_y;
  real_T c6_b_x;
  real_T c6_c_x;
  real_T c6_d_x;
  real_T c6_a;
  real_T c6_b;
  real_T c6_c_y;
  real_T c6_e_x;
  real_T c6_f_x;
  real_T c6_b_a;
  real_T c6_b_b;
  real_T c6_d_y;
  real_T c6_g_x;
  real_T c6_h_x;
  real_T c6_c_a;
  real_T c6_c_b;
  real_T c6_e_y;
  real_T c6_i_x;
  real_T c6_j_x;
  real_T c6_d_a;
  real_T c6_d_b;
  real_T c6_f_y;
  real_T c6_k_x;
  real_T c6_l_x;
  real_T c6_g_y;
  real_T c6_m_x;
  real_T c6_n_x;
  real_T c6_h_y;
  real_T c6_e_b;
  int32_T c6_i9;
  real_T c6_b_WpPre[2];
  real_T c6_o_x;
  real_T c6_p_x;
  real_T c6_q_x;
  real_T c6_r_x;
  real_T c6_B;
  real_T c6_i_y;
  real_T c6_j_y;
  real_T c6_e_a;
  real_T c6_f_b;
  real_T c6_k_y;
  real_T c6_f_a;
  real_T c6_l_y;
  real_T c6_s_x;
  real_T c6_t_x;
  int32_T c6_i10;
  real_T c6_b_eta[2];
  real_T *c6_b_done;
  real_T *c6_b_e;
  real_T *c6_b_V;
  real_T *c6_b_x_d;
  real_T *c6_b_intE;
  real_T (*c6_c_WpPre)[2];
  real_T (*c6_b_WpNext)[2];
  real_T (*c6_c_eta)[3];
  c6_b_done = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c6_b_e = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c6_b_intE = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c6_b_V = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c6_b_x_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c6_c_WpPre = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 2);
  c6_b_WpNext = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 1);
  c6_c_eta = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 4U, chartInstance->c6_sfEvent);
  c6_hoistedGlobal = *c6_b_intE;
  for (c6_i5 = 0; c6_i5 < 3; c6_i5++) {
    c6_eta[c6_i5] = (*c6_c_eta)[c6_i5];
  }

  for (c6_i6 = 0; c6_i6 < 2; c6_i6++) {
    c6_WpNext[c6_i6] = (*c6_b_WpNext)[c6_i6];
  }

  for (c6_i7 = 0; c6_i7 < 2; c6_i7++) {
    c6_WpPre[c6_i7] = (*c6_c_WpPre)[c6_i7];
  }

  for (c6_i8 = 0; c6_i8 < 2; c6_i8++) {
    c6_b_target[c6_i8] = chartInstance->c6_target[c6_i8];
  }

  c6_intE = c6_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 20U, 20U, c6_debug_family_names,
    c6_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c6_R, 0U, c6_b_sf_marshallOut,
    c6_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c6_v_r, 1U, c6_b_sf_marshallOut,
    c6_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c6_ak, 2U, c6_b_sf_marshallOut,
    c6_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c6_s, 3U, c6_b_sf_marshallOut,
    c6_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c6_delta, 4U, c6_b_sf_marshallOut,
    c6_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c6_K_p, 5U, c6_b_sf_marshallOut,
    c6_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c6_K_i, 6U, c6_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c6_x_r, 7U, c6_b_sf_marshallOut,
    c6_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c6_nargin, 8U, c6_b_sf_marshallOut,
    c6_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c6_nargout, 9U, c6_b_sf_marshallOut,
    c6_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c6_eta, 10U, c6_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c6_WpNext, 11U, c6_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c6_WpPre, 12U, c6_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c6_b_target, 13U, c6_c_sf_marshallOut,
    c6_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c6_intE, 14U, c6_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c6_x_d, 15U, c6_b_sf_marshallOut,
    c6_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c6_V, 16U, c6_b_sf_marshallOut,
    c6_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c6_e, 17U, c6_b_sf_marshallOut,
    c6_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c6_done, 18U, c6_b_sf_marshallOut,
    c6_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c6_temp_done, 19U,
    c6_sf_marshallOut, c6_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 4);
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 6);
  if (CV_EML_IF(0, 1, 0, !chartInstance->c6_temp_done_not_empty)) {
    _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 8);
    chartInstance->c6_temp_done = 0.0;
    chartInstance->c6_temp_done_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 13);
  c6_R = 40.0;
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 14);
  c6_v_r = 7.0;
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 18);
  c6_y = c6_WpNext[1] - c6_WpPre[1];
  c6_x = c6_WpNext[0] - c6_WpPre[0];
  c6_eml_scalar_eg(chartInstance);
  c6_b_y = c6_y;
  c6_b_x = c6_x;
  c6_ak = muDoubleScalarAtan2(c6_b_y, c6_b_x);
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 22);
  c6_c_x = c6_ak;
  c6_d_x = c6_c_x;
  c6_d_x = muDoubleScalarSin(c6_d_x);
  c6_a = -(c6_eta[0] - c6_WpPre[0]);
  c6_b = c6_d_x;
  c6_c_y = c6_a * c6_b;
  c6_e_x = c6_ak;
  c6_f_x = c6_e_x;
  c6_f_x = muDoubleScalarCos(c6_f_x);
  c6_b_a = c6_eta[1] - c6_WpPre[1];
  c6_b_b = c6_f_x;
  c6_d_y = c6_b_a * c6_b_b;
  c6_e = c6_c_y + c6_d_y;
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 23);
  c6_g_x = c6_ak;
  c6_h_x = c6_g_x;
  c6_h_x = muDoubleScalarCos(c6_h_x);
  c6_c_a = c6_eta[0] - c6_WpPre[0];
  c6_c_b = c6_h_x;
  c6_e_y = c6_c_a * c6_c_b;
  c6_i_x = c6_ak;
  c6_j_x = c6_i_x;
  c6_j_x = muDoubleScalarSin(c6_j_x);
  c6_d_a = c6_eta[1] - c6_WpPre[1];
  c6_d_b = c6_j_x;
  c6_f_y = c6_d_a * c6_d_b;
  c6_s = c6_e_y + c6_f_y;
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 24);
  c6_k_x = c6_e;
  c6_l_x = c6_k_x;
  c6_g_y = muDoubleScalarAbs(c6_l_x);
  if (CV_EML_IF(0, 1, 1, c6_g_y > c6_R)) {
    _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 25);
    c6_m_x = c6_e;
    c6_n_x = c6_m_x;
    c6_h_y = muDoubleScalarAbs(c6_n_x);
    c6_e_b = c6_h_y;
    c6_R = 3.0 * c6_e_b;
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 28);
  for (c6_i9 = 0; c6_i9 < 2; c6_i9++) {
    c6_b_WpPre[c6_i9] = c6_WpPre[c6_i9] - c6_WpNext[c6_i9];
  }

  c6_norm(chartInstance, c6_b_WpPre);
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 30);
  c6_o_x = c6_mpower(chartInstance, c6_R) - c6_mpower(chartInstance, c6_e);
  c6_delta = c6_o_x;
  if (c6_delta < 0.0) {
    c6_eml_error(chartInstance);
  }

  c6_p_x = c6_delta;
  c6_delta = c6_p_x;
  c6_delta = muDoubleScalarSqrt(c6_delta);
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 32);
  c6_q_x = c6_mpower(chartInstance, c6_R) - c6_mpower(chartInstance, c6_e);
  c6_r_x = c6_q_x;
  if (c6_r_x < 0.0) {
    c6_eml_error(chartInstance);
  }

  c6_r_x = muDoubleScalarSqrt(c6_r_x);
  c6_B = c6_r_x;
  c6_i_y = c6_B;
  c6_j_y = c6_i_y;
  c6_K_p = 1.0 / c6_j_y;
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 33);
  c6_K_i = 1.0E-5;
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 34);
  c6_e_a = -c6_e;
  c6_f_b = c6_K_p;
  c6_k_y = c6_e_a * c6_f_b;
  c6_f_a = c6_intE;
  c6_l_y = c6_f_a * 1.0E-5;
  c6_s_x = c6_k_y - c6_l_y;
  c6_x_r = c6_s_x;
  c6_t_x = c6_x_r;
  c6_x_r = c6_t_x;
  c6_x_r = muDoubleScalarAtan(c6_x_r);
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 37);
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 38);
  c6_x_d = c6_ak + c6_x_r;
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 40);
  for (c6_i10 = 0; c6_i10 < 2; c6_i10++) {
    c6_b_eta[c6_i10] = c6_eta[c6_i10] - c6_b_target[c6_i10];
  }

  if (CV_EML_IF(0, 1, 2, c6_norm(chartInstance, c6_b_eta) < 2.0)) {
    _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 41);
    chartInstance->c6_temp_done = 1.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 44);
  if (CV_EML_IF(0, 1, 3, chartInstance->c6_temp_done == 0.0)) {
    _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 47);
    c6_V = c6_v_r;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 49);
    c6_V = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 54);
  c6_done = chartInstance->c6_temp_done;
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, -54);
  sf_debug_symbol_scope_pop();
  *c6_b_x_d = c6_x_d;
  *c6_b_V = c6_V;
  *c6_b_e = c6_e;
  *c6_b_done = c6_done;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 4U, chartInstance->c6_sfEvent);
}

static void initSimStructsc6_Dubins_vehicle_simulator
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c6_machineNumber, uint32_T
  c6_chartNumber)
{
}

static const mxArray *c6_sf_marshallOut(void *chartInstanceVoid, void *c6_inData)
{
  const mxArray *c6_mxArrayOutData = NULL;
  real_T c6_u;
  const mxArray *c6_y = NULL;
  SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc6_Dubins_vehicle_simulatorInstanceStruct *)
    chartInstanceVoid;
  c6_mxArrayOutData = NULL;
  c6_u = *(real_T *)c6_inData;
  c6_y = NULL;
  if (!chartInstance->c6_temp_done_not_empty) {
    sf_mex_assign(&c6_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c6_y, sf_mex_create("y", &c6_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c6_mxArrayOutData, c6_y, FALSE);
  return c6_mxArrayOutData;
}

static real_T c6_emlrt_marshallIn(SFc6_Dubins_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c6_b_temp_done, const char_T *c6_identifier)
{
  real_T c6_y;
  emlrtMsgIdentifier c6_thisId;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_y = c6_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_b_temp_done),
    &c6_thisId);
  sf_mex_destroy(&c6_b_temp_done);
  return c6_y;
}

static real_T c6_b_emlrt_marshallIn(SFc6_Dubins_vehicle_simulatorInstanceStruct *
  chartInstance, const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId)
{
  real_T c6_y;
  real_T c6_d0;
  if (mxIsEmpty(c6_u)) {
    chartInstance->c6_temp_done_not_empty = FALSE;
  } else {
    chartInstance->c6_temp_done_not_empty = TRUE;
    sf_mex_import(c6_parentId, sf_mex_dup(c6_u), &c6_d0, 1, 0, 0U, 0, 0U, 0);
    c6_y = c6_d0;
  }

  sf_mex_destroy(&c6_u);
  return c6_y;
}

static void c6_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData)
{
  const mxArray *c6_b_temp_done;
  const char_T *c6_identifier;
  emlrtMsgIdentifier c6_thisId;
  real_T c6_y;
  SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc6_Dubins_vehicle_simulatorInstanceStruct *)
    chartInstanceVoid;
  c6_b_temp_done = sf_mex_dup(c6_mxArrayInData);
  c6_identifier = c6_varName;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_y = c6_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_b_temp_done),
    &c6_thisId);
  sf_mex_destroy(&c6_b_temp_done);
  *(real_T *)c6_outData = c6_y;
  sf_mex_destroy(&c6_mxArrayInData);
}

static const mxArray *c6_b_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData)
{
  const mxArray *c6_mxArrayOutData = NULL;
  real_T c6_u;
  const mxArray *c6_y = NULL;
  SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc6_Dubins_vehicle_simulatorInstanceStruct *)
    chartInstanceVoid;
  c6_mxArrayOutData = NULL;
  c6_u = *(real_T *)c6_inData;
  c6_y = NULL;
  sf_mex_assign(&c6_y, sf_mex_create("y", &c6_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c6_mxArrayOutData, c6_y, FALSE);
  return c6_mxArrayOutData;
}

static real_T c6_c_emlrt_marshallIn(SFc6_Dubins_vehicle_simulatorInstanceStruct *
  chartInstance, const mxArray *c6_done, const char_T *c6_identifier)
{
  real_T c6_y;
  emlrtMsgIdentifier c6_thisId;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_y = c6_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_done), &c6_thisId);
  sf_mex_destroy(&c6_done);
  return c6_y;
}

static real_T c6_d_emlrt_marshallIn(SFc6_Dubins_vehicle_simulatorInstanceStruct *
  chartInstance, const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId)
{
  real_T c6_y;
  real_T c6_d1;
  sf_mex_import(c6_parentId, sf_mex_dup(c6_u), &c6_d1, 1, 0, 0U, 0, 0U, 0);
  c6_y = c6_d1;
  sf_mex_destroy(&c6_u);
  return c6_y;
}

static void c6_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData)
{
  const mxArray *c6_done;
  const char_T *c6_identifier;
  emlrtMsgIdentifier c6_thisId;
  real_T c6_y;
  SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc6_Dubins_vehicle_simulatorInstanceStruct *)
    chartInstanceVoid;
  c6_done = sf_mex_dup(c6_mxArrayInData);
  c6_identifier = c6_varName;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_y = c6_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_done), &c6_thisId);
  sf_mex_destroy(&c6_done);
  *(real_T *)c6_outData = c6_y;
  sf_mex_destroy(&c6_mxArrayInData);
}

static const mxArray *c6_c_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData)
{
  const mxArray *c6_mxArrayOutData = NULL;
  int32_T c6_i11;
  real_T c6_b_inData[2];
  int32_T c6_i12;
  real_T c6_u[2];
  const mxArray *c6_y = NULL;
  SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc6_Dubins_vehicle_simulatorInstanceStruct *)
    chartInstanceVoid;
  c6_mxArrayOutData = NULL;
  for (c6_i11 = 0; c6_i11 < 2; c6_i11++) {
    c6_b_inData[c6_i11] = (*(real_T (*)[2])c6_inData)[c6_i11];
  }

  for (c6_i12 = 0; c6_i12 < 2; c6_i12++) {
    c6_u[c6_i12] = c6_b_inData[c6_i12];
  }

  c6_y = NULL;
  sf_mex_assign(&c6_y, sf_mex_create("y", c6_u, 0, 0U, 1U, 0U, 1, 2), FALSE);
  sf_mex_assign(&c6_mxArrayOutData, c6_y, FALSE);
  return c6_mxArrayOutData;
}

static void c6_e_emlrt_marshallIn(SFc6_Dubins_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId,
  real_T c6_y[2])
{
  real_T c6_dv1[2];
  int32_T c6_i13;
  sf_mex_import(c6_parentId, sf_mex_dup(c6_u), c6_dv1, 1, 0, 0U, 1, 0U, 1, 2);
  for (c6_i13 = 0; c6_i13 < 2; c6_i13++) {
    c6_y[c6_i13] = c6_dv1[c6_i13];
  }

  sf_mex_destroy(&c6_u);
}

static void c6_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData)
{
  const mxArray *c6_b_target;
  const char_T *c6_identifier;
  emlrtMsgIdentifier c6_thisId;
  real_T c6_y[2];
  int32_T c6_i14;
  SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc6_Dubins_vehicle_simulatorInstanceStruct *)
    chartInstanceVoid;
  c6_b_target = sf_mex_dup(c6_mxArrayInData);
  c6_identifier = c6_varName;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_b_target), &c6_thisId, c6_y);
  sf_mex_destroy(&c6_b_target);
  for (c6_i14 = 0; c6_i14 < 2; c6_i14++) {
    (*(real_T (*)[2])c6_outData)[c6_i14] = c6_y[c6_i14];
  }

  sf_mex_destroy(&c6_mxArrayInData);
}

static const mxArray *c6_d_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData)
{
  const mxArray *c6_mxArrayOutData = NULL;
  int32_T c6_i15;
  real_T c6_b_inData[3];
  int32_T c6_i16;
  real_T c6_u[3];
  const mxArray *c6_y = NULL;
  SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc6_Dubins_vehicle_simulatorInstanceStruct *)
    chartInstanceVoid;
  c6_mxArrayOutData = NULL;
  for (c6_i15 = 0; c6_i15 < 3; c6_i15++) {
    c6_b_inData[c6_i15] = (*(real_T (*)[3])c6_inData)[c6_i15];
  }

  for (c6_i16 = 0; c6_i16 < 3; c6_i16++) {
    c6_u[c6_i16] = c6_b_inData[c6_i16];
  }

  c6_y = NULL;
  sf_mex_assign(&c6_y, sf_mex_create("y", c6_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c6_mxArrayOutData, c6_y, FALSE);
  return c6_mxArrayOutData;
}

const mxArray *sf_c6_Dubins_vehicle_simulator_get_eml_resolved_functions_info
  (void)
{
  const mxArray *c6_nameCaptureInfo;
  c6_ResolvedFunctionInfo c6_info[44];
  const mxArray *c6_m0 = NULL;
  int32_T c6_i17;
  c6_ResolvedFunctionInfo *c6_r0;
  c6_nameCaptureInfo = NULL;
  c6_nameCaptureInfo = NULL;
  c6_info_helper(c6_info);
  sf_mex_assign(&c6_m0, sf_mex_createstruct("nameCaptureInfo", 1, 44), FALSE);
  for (c6_i17 = 0; c6_i17 < 44; c6_i17++) {
    c6_r0 = &c6_info[c6_i17];
    sf_mex_addfield(c6_m0, sf_mex_create("nameCaptureInfo", c6_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c6_r0->context)), "context", "nameCaptureInfo",
                    c6_i17);
    sf_mex_addfield(c6_m0, sf_mex_create("nameCaptureInfo", c6_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c6_r0->name)), "name", "nameCaptureInfo", c6_i17);
    sf_mex_addfield(c6_m0, sf_mex_create("nameCaptureInfo", c6_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c6_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c6_i17);
    sf_mex_addfield(c6_m0, sf_mex_create("nameCaptureInfo", c6_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c6_r0->resolved)), "resolved", "nameCaptureInfo",
                    c6_i17);
    sf_mex_addfield(c6_m0, sf_mex_create("nameCaptureInfo", &c6_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c6_i17);
    sf_mex_addfield(c6_m0, sf_mex_create("nameCaptureInfo", &c6_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c6_i17);
    sf_mex_addfield(c6_m0, sf_mex_create("nameCaptureInfo", &c6_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c6_i17);
    sf_mex_addfield(c6_m0, sf_mex_create("nameCaptureInfo", &c6_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c6_i17);
  }

  sf_mex_assign(&c6_nameCaptureInfo, c6_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c6_nameCaptureInfo);
  return c6_nameCaptureInfo;
}

static void c6_info_helper(c6_ResolvedFunctionInfo c6_info[44])
{
  c6_info[0].context = "";
  c6_info[0].name = "atan2";
  c6_info[0].dominantType = "double";
  c6_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c6_info[0].fileTimeLo = 1286818704U;
  c6_info[0].fileTimeHi = 0U;
  c6_info[0].mFileTimeLo = 0U;
  c6_info[0].mFileTimeHi = 0U;
  c6_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c6_info[1].name = "eml_scalar_eg";
  c6_info[1].dominantType = "double";
  c6_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c6_info[1].fileTimeLo = 1286818796U;
  c6_info[1].fileTimeHi = 0U;
  c6_info[1].mFileTimeLo = 0U;
  c6_info[1].mFileTimeHi = 0U;
  c6_info[2].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c6_info[2].name = "eml_scalexp_alloc";
  c6_info[2].dominantType = "double";
  c6_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c6_info[2].fileTimeLo = 1330608434U;
  c6_info[2].fileTimeHi = 0U;
  c6_info[2].mFileTimeLo = 0U;
  c6_info[2].mFileTimeHi = 0U;
  c6_info[3].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c6_info[3].name = "eml_scalar_atan2";
  c6_info[3].dominantType = "double";
  c6_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_atan2.m";
  c6_info[3].fileTimeLo = 1286818720U;
  c6_info[3].fileTimeHi = 0U;
  c6_info[3].mFileTimeLo = 0U;
  c6_info[3].mFileTimeHi = 0U;
  c6_info[4].context = "";
  c6_info[4].name = "sin";
  c6_info[4].dominantType = "double";
  c6_info[4].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c6_info[4].fileTimeLo = 1286818750U;
  c6_info[4].fileTimeHi = 0U;
  c6_info[4].mFileTimeLo = 0U;
  c6_info[4].mFileTimeHi = 0U;
  c6_info[5].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c6_info[5].name = "eml_scalar_sin";
  c6_info[5].dominantType = "double";
  c6_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c6_info[5].fileTimeLo = 1286818736U;
  c6_info[5].fileTimeHi = 0U;
  c6_info[5].mFileTimeLo = 0U;
  c6_info[5].mFileTimeHi = 0U;
  c6_info[6].context = "";
  c6_info[6].name = "mtimes";
  c6_info[6].dominantType = "double";
  c6_info[6].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c6_info[6].fileTimeLo = 1289519692U;
  c6_info[6].fileTimeHi = 0U;
  c6_info[6].mFileTimeLo = 0U;
  c6_info[6].mFileTimeHi = 0U;
  c6_info[7].context = "";
  c6_info[7].name = "cos";
  c6_info[7].dominantType = "double";
  c6_info[7].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c6_info[7].fileTimeLo = 1286818706U;
  c6_info[7].fileTimeHi = 0U;
  c6_info[7].mFileTimeLo = 0U;
  c6_info[7].mFileTimeHi = 0U;
  c6_info[8].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c6_info[8].name = "eml_scalar_cos";
  c6_info[8].dominantType = "double";
  c6_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c6_info[8].fileTimeLo = 1286818722U;
  c6_info[8].fileTimeHi = 0U;
  c6_info[8].mFileTimeLo = 0U;
  c6_info[8].mFileTimeHi = 0U;
  c6_info[9].context = "";
  c6_info[9].name = "abs";
  c6_info[9].dominantType = "double";
  c6_info[9].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c6_info[9].fileTimeLo = 1286818694U;
  c6_info[9].fileTimeHi = 0U;
  c6_info[9].mFileTimeLo = 0U;
  c6_info[9].mFileTimeHi = 0U;
  c6_info[10].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c6_info[10].name = "eml_scalar_abs";
  c6_info[10].dominantType = "double";
  c6_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c6_info[10].fileTimeLo = 1286818712U;
  c6_info[10].fileTimeHi = 0U;
  c6_info[10].mFileTimeLo = 0U;
  c6_info[10].mFileTimeHi = 0U;
  c6_info[11].context = "";
  c6_info[11].name = "norm";
  c6_info[11].dominantType = "double";
  c6_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m";
  c6_info[11].fileTimeLo = 1336522094U;
  c6_info[11].fileTimeHi = 0U;
  c6_info[11].mFileTimeLo = 0U;
  c6_info[11].mFileTimeHi = 0U;
  c6_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!genpnorm";
  c6_info[12].name = "eml_index_class";
  c6_info[12].dominantType = "";
  c6_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c6_info[12].fileTimeLo = 1323170578U;
  c6_info[12].fileTimeHi = 0U;
  c6_info[12].mFileTimeLo = 0U;
  c6_info[12].mFileTimeHi = 0U;
  c6_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!genpnorm";
  c6_info[13].name = "eml_xnrm2";
  c6_info[13].dominantType = "double";
  c6_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xnrm2.m";
  c6_info[13].fileTimeLo = 1299076776U;
  c6_info[13].fileTimeHi = 0U;
  c6_info[13].mFileTimeLo = 0U;
  c6_info[13].mFileTimeHi = 0U;
  c6_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xnrm2.m";
  c6_info[14].name = "eml_blas_inline";
  c6_info[14].dominantType = "";
  c6_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c6_info[14].fileTimeLo = 1299076768U;
  c6_info[14].fileTimeHi = 0U;
  c6_info[14].mFileTimeLo = 0U;
  c6_info[14].mFileTimeHi = 0U;
  c6_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xnrm2.m";
  c6_info[15].name = "eml_index_class";
  c6_info[15].dominantType = "";
  c6_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c6_info[15].fileTimeLo = 1323170578U;
  c6_info[15].fileTimeHi = 0U;
  c6_info[15].mFileTimeLo = 0U;
  c6_info[15].mFileTimeHi = 0U;
  c6_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xnrm2.m";
  c6_info[16].name = "eml_refblas_xnrm2";
  c6_info[16].dominantType = "double";
  c6_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c6_info[16].fileTimeLo = 1299076784U;
  c6_info[16].fileTimeHi = 0U;
  c6_info[16].mFileTimeLo = 0U;
  c6_info[16].mFileTimeHi = 0U;
  c6_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c6_info[17].name = "realmin";
  c6_info[17].dominantType = "char";
  c6_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c6_info[17].fileTimeLo = 1307651242U;
  c6_info[17].fileTimeHi = 0U;
  c6_info[17].mFileTimeLo = 0U;
  c6_info[17].mFileTimeHi = 0U;
  c6_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c6_info[18].name = "eml_realmin";
  c6_info[18].dominantType = "char";
  c6_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmin.m";
  c6_info[18].fileTimeLo = 1307651244U;
  c6_info[18].fileTimeHi = 0U;
  c6_info[18].mFileTimeLo = 0U;
  c6_info[18].mFileTimeHi = 0U;
  c6_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmin.m";
  c6_info[19].name = "eml_float_model";
  c6_info[19].dominantType = "char";
  c6_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_float_model.m";
  c6_info[19].fileTimeLo = 1326727996U;
  c6_info[19].fileTimeHi = 0U;
  c6_info[19].mFileTimeLo = 0U;
  c6_info[19].mFileTimeHi = 0U;
  c6_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c6_info[20].name = "eml_index_class";
  c6_info[20].dominantType = "";
  c6_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c6_info[20].fileTimeLo = 1323170578U;
  c6_info[20].fileTimeHi = 0U;
  c6_info[20].mFileTimeLo = 0U;
  c6_info[20].mFileTimeHi = 0U;
  c6_info[21].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c6_info[21].name = "eml_index_minus";
  c6_info[21].dominantType = "double";
  c6_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c6_info[21].fileTimeLo = 1286818778U;
  c6_info[21].fileTimeHi = 0U;
  c6_info[21].mFileTimeLo = 0U;
  c6_info[21].mFileTimeHi = 0U;
  c6_info[22].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c6_info[22].name = "eml_index_class";
  c6_info[22].dominantType = "";
  c6_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c6_info[22].fileTimeLo = 1323170578U;
  c6_info[22].fileTimeHi = 0U;
  c6_info[22].mFileTimeLo = 0U;
  c6_info[22].mFileTimeHi = 0U;
  c6_info[23].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c6_info[23].name = "eml_index_times";
  c6_info[23].dominantType = "coder.internal.indexInt";
  c6_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c6_info[23].fileTimeLo = 1286818780U;
  c6_info[23].fileTimeHi = 0U;
  c6_info[23].mFileTimeLo = 0U;
  c6_info[23].mFileTimeHi = 0U;
  c6_info[24].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c6_info[24].name = "eml_index_class";
  c6_info[24].dominantType = "";
  c6_info[24].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c6_info[24].fileTimeLo = 1323170578U;
  c6_info[24].fileTimeHi = 0U;
  c6_info[24].mFileTimeLo = 0U;
  c6_info[24].mFileTimeHi = 0U;
  c6_info[25].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c6_info[25].name = "eml_index_plus";
  c6_info[25].dominantType = "coder.internal.indexInt";
  c6_info[25].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c6_info[25].fileTimeLo = 1286818778U;
  c6_info[25].fileTimeHi = 0U;
  c6_info[25].mFileTimeLo = 0U;
  c6_info[25].mFileTimeHi = 0U;
  c6_info[26].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c6_info[26].name = "eml_index_class";
  c6_info[26].dominantType = "";
  c6_info[26].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c6_info[26].fileTimeLo = 1323170578U;
  c6_info[26].fileTimeHi = 0U;
  c6_info[26].mFileTimeLo = 0U;
  c6_info[26].mFileTimeHi = 0U;
  c6_info[27].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c6_info[27].name = "eml_int_forloop_overflow_check";
  c6_info[27].dominantType = "";
  c6_info[27].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c6_info[27].fileTimeLo = 1332168672U;
  c6_info[27].fileTimeHi = 0U;
  c6_info[27].mFileTimeLo = 0U;
  c6_info[27].mFileTimeHi = 0U;
  c6_info[28].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m!eml_int_forloop_overflow_check_helper";
  c6_info[28].name = "intmax";
  c6_info[28].dominantType = "char";
  c6_info[28].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c6_info[28].fileTimeLo = 1311255316U;
  c6_info[28].fileTimeHi = 0U;
  c6_info[28].mFileTimeLo = 0U;
  c6_info[28].mFileTimeHi = 0U;
  c6_info[29].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c6_info[29].name = "abs";
  c6_info[29].dominantType = "double";
  c6_info[29].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c6_info[29].fileTimeLo = 1286818694U;
  c6_info[29].fileTimeHi = 0U;
  c6_info[29].mFileTimeLo = 0U;
  c6_info[29].mFileTimeHi = 0U;
  c6_info[30].context = "";
  c6_info[30].name = "mpower";
  c6_info[30].dominantType = "double";
  c6_info[30].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c6_info[30].fileTimeLo = 1286818842U;
  c6_info[30].fileTimeHi = 0U;
  c6_info[30].mFileTimeLo = 0U;
  c6_info[30].mFileTimeHi = 0U;
  c6_info[31].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c6_info[31].name = "power";
  c6_info[31].dominantType = "double";
  c6_info[31].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c6_info[31].fileTimeLo = 1336522096U;
  c6_info[31].fileTimeHi = 0U;
  c6_info[31].mFileTimeLo = 0U;
  c6_info[31].mFileTimeHi = 0U;
  c6_info[32].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c6_info[32].name = "eml_scalar_eg";
  c6_info[32].dominantType = "double";
  c6_info[32].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c6_info[32].fileTimeLo = 1286818796U;
  c6_info[32].fileTimeHi = 0U;
  c6_info[32].mFileTimeLo = 0U;
  c6_info[32].mFileTimeHi = 0U;
  c6_info[33].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c6_info[33].name = "eml_scalexp_alloc";
  c6_info[33].dominantType = "double";
  c6_info[33].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c6_info[33].fileTimeLo = 1330608434U;
  c6_info[33].fileTimeHi = 0U;
  c6_info[33].mFileTimeLo = 0U;
  c6_info[33].mFileTimeHi = 0U;
  c6_info[34].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c6_info[34].name = "floor";
  c6_info[34].dominantType = "double";
  c6_info[34].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c6_info[34].fileTimeLo = 1286818742U;
  c6_info[34].fileTimeHi = 0U;
  c6_info[34].mFileTimeLo = 0U;
  c6_info[34].mFileTimeHi = 0U;
  c6_info[35].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c6_info[35].name = "eml_scalar_floor";
  c6_info[35].dominantType = "double";
  c6_info[35].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c6_info[35].fileTimeLo = 1286818726U;
  c6_info[35].fileTimeHi = 0U;
  c6_info[35].mFileTimeLo = 0U;
  c6_info[35].mFileTimeHi = 0U;
  c6_info[36].context = "";
  c6_info[36].name = "sqrt";
  c6_info[36].dominantType = "double";
  c6_info[36].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c6_info[36].fileTimeLo = 1286818752U;
  c6_info[36].fileTimeHi = 0U;
  c6_info[36].mFileTimeLo = 0U;
  c6_info[36].mFileTimeHi = 0U;
  c6_info[37].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c6_info[37].name = "eml_error";
  c6_info[37].dominantType = "char";
  c6_info[37].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  c6_info[37].fileTimeLo = 1305318000U;
  c6_info[37].fileTimeHi = 0U;
  c6_info[37].mFileTimeLo = 0U;
  c6_info[37].mFileTimeHi = 0U;
  c6_info[38].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c6_info[38].name = "eml_scalar_sqrt";
  c6_info[38].dominantType = "double";
  c6_info[38].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m";
  c6_info[38].fileTimeLo = 1286818738U;
  c6_info[38].fileTimeHi = 0U;
  c6_info[38].mFileTimeLo = 0U;
  c6_info[38].mFileTimeHi = 0U;
  c6_info[39].context = "";
  c6_info[39].name = "mrdivide";
  c6_info[39].dominantType = "double";
  c6_info[39].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c6_info[39].fileTimeLo = 1342810944U;
  c6_info[39].fileTimeHi = 0U;
  c6_info[39].mFileTimeLo = 1319729966U;
  c6_info[39].mFileTimeHi = 0U;
  c6_info[40].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c6_info[40].name = "rdivide";
  c6_info[40].dominantType = "double";
  c6_info[40].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c6_info[40].fileTimeLo = 1286818844U;
  c6_info[40].fileTimeHi = 0U;
  c6_info[40].mFileTimeLo = 0U;
  c6_info[40].mFileTimeHi = 0U;
  c6_info[41].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c6_info[41].name = "eml_div";
  c6_info[41].dominantType = "double";
  c6_info[41].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c6_info[41].fileTimeLo = 1313347810U;
  c6_info[41].fileTimeHi = 0U;
  c6_info[41].mFileTimeLo = 0U;
  c6_info[41].mFileTimeHi = 0U;
  c6_info[42].context = "";
  c6_info[42].name = "atan";
  c6_info[42].dominantType = "double";
  c6_info[42].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan.m";
  c6_info[42].fileTimeLo = 1305317998U;
  c6_info[42].fileTimeHi = 0U;
  c6_info[42].mFileTimeLo = 0U;
  c6_info[42].mFileTimeHi = 0U;
  c6_info[43].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan.m";
  c6_info[43].name = "eml_scalar_atan";
  c6_info[43].dominantType = "double";
  c6_info[43].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_atan.m";
  c6_info[43].fileTimeLo = 1286818718U;
  c6_info[43].fileTimeHi = 0U;
  c6_info[43].mFileTimeLo = 0U;
  c6_info[43].mFileTimeHi = 0U;
}

static void c6_eml_scalar_eg(SFc6_Dubins_vehicle_simulatorInstanceStruct
  *chartInstance)
{
}

static real_T c6_norm(SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance,
                      real_T c6_x[2])
{
  real_T c6_y;
  real_T c6_scale;
  int32_T c6_k;
  int32_T c6_b_k;
  real_T c6_b_x;
  real_T c6_c_x;
  real_T c6_absxk;
  real_T c6_t;
  c6_y = 0.0;
  c6_scale = 2.2250738585072014E-308;
  c6_check_forloop_overflow_error(chartInstance);
  for (c6_k = 1; c6_k < 3; c6_k++) {
    c6_b_k = c6_k;
    c6_b_x = c6_x[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      (real_T)c6_b_k), 1, 2, 1, 0) - 1];
    c6_c_x = c6_b_x;
    c6_absxk = muDoubleScalarAbs(c6_c_x);
    if (c6_absxk > c6_scale) {
      c6_t = c6_scale / c6_absxk;
      c6_y = 1.0 + c6_y * c6_t * c6_t;
      c6_scale = c6_absxk;
    } else {
      c6_t = c6_absxk / c6_scale;
      c6_y += c6_t * c6_t;
    }
  }

  return c6_scale * muDoubleScalarSqrt(c6_y);
}

static void c6_check_forloop_overflow_error
  (SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance)
{
}

static real_T c6_mpower(SFc6_Dubins_vehicle_simulatorInstanceStruct
  *chartInstance, real_T c6_a)
{
  real_T c6_b_a;
  real_T c6_c_a;
  real_T c6_ak;
  c6_b_a = c6_a;
  c6_c_a = c6_b_a;
  c6_eml_scalar_eg(chartInstance);
  c6_ak = c6_c_a;
  return muDoubleScalarPower(c6_ak, 2.0);
}

static void c6_eml_error(SFc6_Dubins_vehicle_simulatorInstanceStruct
  *chartInstance)
{
  int32_T c6_i18;
  static char_T c6_varargin_1[30] = { 'C', 'o', 'd', 'e', 'r', ':', 't', 'o',
    'o', 'l', 'b', 'o', 'x', ':', 's', 'q', 'r', 't', '_', 'd', 'o', 'm', 'a',
    'i', 'n', 'E', 'r', 'r', 'o', 'r' };

  char_T c6_u[30];
  const mxArray *c6_y = NULL;
  for (c6_i18 = 0; c6_i18 < 30; c6_i18++) {
    c6_u[c6_i18] = c6_varargin_1[c6_i18];
  }

  c6_y = NULL;
  sf_mex_assign(&c6_y, sf_mex_create("y", c6_u, 10, 0U, 1U, 0U, 2, 1, 30), FALSE);
  sf_mex_call_debug("error", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U, 14,
    c6_y));
}

static const mxArray *c6_e_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData)
{
  const mxArray *c6_mxArrayOutData = NULL;
  int32_T c6_u;
  const mxArray *c6_y = NULL;
  SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc6_Dubins_vehicle_simulatorInstanceStruct *)
    chartInstanceVoid;
  c6_mxArrayOutData = NULL;
  c6_u = *(int32_T *)c6_inData;
  c6_y = NULL;
  sf_mex_assign(&c6_y, sf_mex_create("y", &c6_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c6_mxArrayOutData, c6_y, FALSE);
  return c6_mxArrayOutData;
}

static int32_T c6_f_emlrt_marshallIn(SFc6_Dubins_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId)
{
  int32_T c6_y;
  int32_T c6_i19;
  sf_mex_import(c6_parentId, sf_mex_dup(c6_u), &c6_i19, 1, 6, 0U, 0, 0U, 0);
  c6_y = c6_i19;
  sf_mex_destroy(&c6_u);
  return c6_y;
}

static void c6_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData)
{
  const mxArray *c6_b_sfEvent;
  const char_T *c6_identifier;
  emlrtMsgIdentifier c6_thisId;
  int32_T c6_y;
  SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc6_Dubins_vehicle_simulatorInstanceStruct *)
    chartInstanceVoid;
  c6_b_sfEvent = sf_mex_dup(c6_mxArrayInData);
  c6_identifier = c6_varName;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_y = c6_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_b_sfEvent),
    &c6_thisId);
  sf_mex_destroy(&c6_b_sfEvent);
  *(int32_T *)c6_outData = c6_y;
  sf_mex_destroy(&c6_mxArrayInData);
}

static uint8_T c6_g_emlrt_marshallIn(SFc6_Dubins_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c6_b_is_active_c6_Dubins_vehicle_simulator,
  const char_T *c6_identifier)
{
  uint8_T c6_y;
  emlrtMsgIdentifier c6_thisId;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_y = c6_h_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c6_b_is_active_c6_Dubins_vehicle_simulator), &c6_thisId);
  sf_mex_destroy(&c6_b_is_active_c6_Dubins_vehicle_simulator);
  return c6_y;
}

static uint8_T c6_h_emlrt_marshallIn(SFc6_Dubins_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId)
{
  uint8_T c6_y;
  uint8_T c6_u0;
  sf_mex_import(c6_parentId, sf_mex_dup(c6_u), &c6_u0, 1, 3, 0U, 0, 0U, 0);
  c6_y = c6_u0;
  sf_mex_destroy(&c6_u);
  return c6_y;
}

static void init_dsm_address_info(SFc6_Dubins_vehicle_simulatorInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c6_Dubins_vehicle_simulator_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(880483404U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(4222833210U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3498653525U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2294348609U);
}

mxArray *sf_c6_Dubins_vehicle_simulator_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("7U7LZSxny7sQorHQBVn1ZG");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c6_Dubins_vehicle_simulator(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x6'type','srcId','name','auxInfo'{{M[1],M[11],T\"V\",},{M[1],M[14],T\"done\",},{M[1],M[13],T\"e\",},{M[1],M[5],T\"x_d\",},{M[4],M[0],T\"temp_done\",S'l','i','p'{{M1x2[78 87],M[0],}}},{M[8],M[0],T\"is_active_c6_Dubins_vehicle_simulator\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 6, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c6_Dubins_vehicle_simulator_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance;
    chartInstance = (SFc6_Dubins_vehicle_simulatorInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_Dubins_vehicle_simulatorMachineNumber_,
           6,
           1,
           1,
           9,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_Dubins_vehicle_simulatorMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_Dubins_vehicle_simulatorMachineNumber_,chartInstance->chartNumber,
             1);
          sf_debug_set_chart_event_thresholds
            (_Dubins_vehicle_simulatorMachineNumber_,
             chartInstance->chartNumber,
             0,
             0,
             0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"eta");
          _SFD_SET_DATA_PROPS(1,1,1,0,"WpNext");
          _SFD_SET_DATA_PROPS(2,1,1,0,"WpPre");
          _SFD_SET_DATA_PROPS(3,2,0,1,"x_d");
          _SFD_SET_DATA_PROPS(4,10,0,0,"target");
          _SFD_SET_DATA_PROPS(5,2,0,1,"V");
          _SFD_SET_DATA_PROPS(6,1,1,0,"intE");
          _SFD_SET_DATA_PROPS(7,2,0,1,"e");
          _SFD_SET_DATA_PROPS(8,2,0,1,"done");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,4,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,1106);
        _SFD_CV_INIT_EML_IF(0,1,0,97,118,-1,170);
        _SFD_CV_INIT_EML_IF(0,1,1,420,433,-1,456);
        _SFD_CV_INIT_EML_IF(0,1,2,696,724,-1,747);
        _SFD_CV_INIT_EML_IF(0,1,3,749,766,819,840);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c6_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c6_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c6_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c6_b_sf_marshallOut,(MexInFcnForType)c6_b_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c6_c_sf_marshallOut,(MexInFcnForType)
            c6_c_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c6_b_sf_marshallOut,(MexInFcnForType)c6_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c6_b_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c6_b_sf_marshallOut,(MexInFcnForType)c6_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c6_b_sf_marshallOut,(MexInFcnForType)c6_b_sf_marshallIn);

        {
          real_T *c6_x_d;
          real_T *c6_V;
          real_T *c6_intE;
          real_T *c6_e;
          real_T *c6_done;
          real_T (*c6_eta)[3];
          real_T (*c6_WpNext)[2];
          real_T (*c6_WpPre)[2];
          c6_done = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
          c6_e = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c6_intE = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c6_V = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c6_x_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c6_WpPre = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 2);
          c6_WpNext = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 1);
          c6_eta = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c6_eta);
          _SFD_SET_DATA_VALUE_PTR(1U, *c6_WpNext);
          _SFD_SET_DATA_VALUE_PTR(2U, *c6_WpPre);
          _SFD_SET_DATA_VALUE_PTR(3U, c6_x_d);
          _SFD_SET_DATA_VALUE_PTR(4U, chartInstance->c6_target);
          _SFD_SET_DATA_VALUE_PTR(5U, c6_V);
          _SFD_SET_DATA_VALUE_PTR(6U, c6_intE);
          _SFD_SET_DATA_VALUE_PTR(7U, c6_e);
          _SFD_SET_DATA_VALUE_PTR(8U, c6_done);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration
        (_Dubins_vehicle_simulatorMachineNumber_,chartInstance->chartNumber,
         chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "jCjKEkgT1voAuv2ti8wxJF";
}

static void sf_opaque_initialize_c6_Dubins_vehicle_simulator(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc6_Dubins_vehicle_simulatorInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c6_Dubins_vehicle_simulator
    ((SFc6_Dubins_vehicle_simulatorInstanceStruct*) chartInstanceVar);
  initialize_c6_Dubins_vehicle_simulator
    ((SFc6_Dubins_vehicle_simulatorInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c6_Dubins_vehicle_simulator(void *chartInstanceVar)
{
  enable_c6_Dubins_vehicle_simulator
    ((SFc6_Dubins_vehicle_simulatorInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c6_Dubins_vehicle_simulator(void *chartInstanceVar)
{
  disable_c6_Dubins_vehicle_simulator
    ((SFc6_Dubins_vehicle_simulatorInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c6_Dubins_vehicle_simulator(void *chartInstanceVar)
{
  sf_c6_Dubins_vehicle_simulator((SFc6_Dubins_vehicle_simulatorInstanceStruct*)
    chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c6_Dubins_vehicle_simulator
  (SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c6_Dubins_vehicle_simulator
    ((SFc6_Dubins_vehicle_simulatorInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c6_Dubins_vehicle_simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c6_Dubins_vehicle_simulator(SimStruct* S,
  const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c6_Dubins_vehicle_simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c6_Dubins_vehicle_simulator
    ((SFc6_Dubins_vehicle_simulatorInstanceStruct*)chartInfo->chartInstance,
     mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c6_Dubins_vehicle_simulator
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c6_Dubins_vehicle_simulator(S);
}

static void sf_opaque_set_sim_state_c6_Dubins_vehicle_simulator(SimStruct* S,
  const mxArray *st)
{
  sf_internal_set_sim_state_c6_Dubins_vehicle_simulator(S, st);
}

static void sf_opaque_terminate_c6_Dubins_vehicle_simulator(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc6_Dubins_vehicle_simulatorInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c6_Dubins_vehicle_simulator
      ((SFc6_Dubins_vehicle_simulatorInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_Dubins_vehicle_simulator_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc6_Dubins_vehicle_simulator
    ((SFc6_Dubins_vehicle_simulatorInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c6_Dubins_vehicle_simulator(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c6_Dubins_vehicle_simulator
      ((SFc6_Dubins_vehicle_simulatorInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c6_Dubins_vehicle_simulator(SimStruct *S)
{
  /* Actual parameters from chart:
     target
   */
  const char_T *rtParamNames[] = { "p1" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for target*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_Dubins_vehicle_simulator_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      6);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,6,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,6,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,6,4);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,6,4);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,6);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(3725305690U));
  ssSetChecksum1(S,(1723221047U));
  ssSetChecksum2(S,(1156145639U));
  ssSetChecksum3(S,(3368553109U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c6_Dubins_vehicle_simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c6_Dubins_vehicle_simulator(SimStruct *S)
{
  SFc6_Dubins_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc6_Dubins_vehicle_simulatorInstanceStruct *)malloc(sizeof
    (SFc6_Dubins_vehicle_simulatorInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc6_Dubins_vehicle_simulatorInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c6_Dubins_vehicle_simulator;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c6_Dubins_vehicle_simulator;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c6_Dubins_vehicle_simulator;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c6_Dubins_vehicle_simulator;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c6_Dubins_vehicle_simulator;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c6_Dubins_vehicle_simulator;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c6_Dubins_vehicle_simulator;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c6_Dubins_vehicle_simulator;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c6_Dubins_vehicle_simulator;
  chartInstance->chartInfo.mdlStart = mdlStart_c6_Dubins_vehicle_simulator;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c6_Dubins_vehicle_simulator;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c6_Dubins_vehicle_simulator_method_dispatcher(SimStruct *S, int_T method,
  void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c6_Dubins_vehicle_simulator(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c6_Dubins_vehicle_simulator(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c6_Dubins_vehicle_simulator(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c6_Dubins_vehicle_simulator_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
