/* Include files */

#include "blascompat32.h"
#include "NSB_vehicle_simulator_sfun.h"
#include "c10_NSB_vehicle_simulator.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "NSB_vehicle_simulator_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c10_debug_family_names[16] = { "U_max", "alfa", "ak", "R",
  "temp", "s", "e", "deltaS", "nargin", "nargout", "nu", "eta", "target",
  "start", "ud", "done" };

/* Function Declarations */
static void initialize_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static void initialize_params_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static void enable_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static void disable_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static void c10_update_debugger_state_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static void set_sim_state_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance, const mxArray
   *c10_st);
static void finalize_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static void sf_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static void c10_chartstep_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static void initSimStructsc10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c10_machineNumber, uint32_T
  c10_chartNumber);
static const mxArray *c10_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static real_T c10_emlrt_marshallIn(SFc10_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c10_b_done, const char_T *c10_identifier);
static real_T c10_b_emlrt_marshallIn(SFc10_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId);
static void c10_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static const mxArray *c10_b_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static real_T c10_c_emlrt_marshallIn(SFc10_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c10_ud, const char_T *c10_identifier);
static real_T c10_d_emlrt_marshallIn(SFc10_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId);
static void c10_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static const mxArray *c10_c_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static const mxArray *c10_d_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static void c10_e_emlrt_marshallIn(SFc10_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId,
  real_T c10_y[2]);
static void c10_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static const mxArray *c10_e_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static void c10_f_emlrt_marshallIn(SFc10_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId,
  real_T c10_y[4]);
static void c10_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static void c10_info_helper(c10_ResolvedFunctionInfo c10_info[37]);
static real_T c10_atan2(SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance,
  real_T c10_y, real_T c10_x);
static void c10_eml_scalar_eg(SFc10_NSB_vehicle_simulatorInstanceStruct
  *chartInstance);
static void c10_check_forloop_overflow_error
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static const mxArray *c10_f_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static int32_T c10_g_emlrt_marshallIn(SFc10_NSB_vehicle_simulatorInstanceStruct *
  chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId);
static void c10_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static uint8_T c10_h_emlrt_marshallIn(SFc10_NSB_vehicle_simulatorInstanceStruct *
  chartInstance, const mxArray *c10_b_is_active_c10_NSB_vehicle_simulator, const
  char_T *c10_identifier);
static uint8_T c10_i_emlrt_marshallIn(SFc10_NSB_vehicle_simulatorInstanceStruct *
  chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId);
static void init_dsm_address_info(SFc10_NSB_vehicle_simulatorInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
  chartInstance->c10_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c10_done_not_empty = FALSE;
  chartInstance->c10_is_active_c10_NSB_vehicle_simulator = 0U;
}

static void initialize_params_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
}

static void enable_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c10_update_debugger_state_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
  const mxArray *c10_st;
  const mxArray *c10_y = NULL;
  real_T c10_hoistedGlobal;
  real_T c10_u;
  const mxArray *c10_b_y = NULL;
  real_T c10_b_hoistedGlobal;
  real_T c10_b_u;
  const mxArray *c10_c_y = NULL;
  uint8_T c10_c_hoistedGlobal;
  uint8_T c10_c_u;
  const mxArray *c10_d_y = NULL;
  real_T *c10_ud;
  c10_ud = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c10_st = NULL;
  c10_st = NULL;
  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_createcellarray(3), FALSE);
  c10_hoistedGlobal = *c10_ud;
  c10_u = c10_hoistedGlobal;
  c10_b_y = NULL;
  sf_mex_assign(&c10_b_y, sf_mex_create("y", &c10_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c10_y, 0, c10_b_y);
  c10_b_hoistedGlobal = chartInstance->c10_done;
  c10_b_u = c10_b_hoistedGlobal;
  c10_c_y = NULL;
  if (!chartInstance->c10_done_not_empty) {
    sf_mex_assign(&c10_c_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c10_c_y, sf_mex_create("y", &c10_b_u, 0, 0U, 0U, 0U, 0),
                  FALSE);
  }

  sf_mex_setcell(c10_y, 1, c10_c_y);
  c10_c_hoistedGlobal = chartInstance->c10_is_active_c10_NSB_vehicle_simulator;
  c10_c_u = c10_c_hoistedGlobal;
  c10_d_y = NULL;
  sf_mex_assign(&c10_d_y, sf_mex_create("y", &c10_c_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c10_y, 2, c10_d_y);
  sf_mex_assign(&c10_st, c10_y, FALSE);
  return c10_st;
}

static void set_sim_state_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance, const mxArray
   *c10_st)
{
  const mxArray *c10_u;
  real_T *c10_ud;
  c10_ud = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c10_doneDoubleBufferReInit = TRUE;
  c10_u = sf_mex_dup(c10_st);
  *c10_ud = c10_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c10_u, 0)), "ud");
  chartInstance->c10_done = c10_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c10_u, 1)), "done");
  chartInstance->c10_is_active_c10_NSB_vehicle_simulator =
    c10_h_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c10_u, 2)),
    "is_active_c10_NSB_vehicle_simulator");
  sf_mex_destroy(&c10_u);
  c10_update_debugger_state_c10_NSB_vehicle_simulator(chartInstance);
  sf_mex_destroy(&c10_st);
}

static void finalize_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
}

static void sf_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
  int32_T c10_i0;
  int32_T c10_i1;
  int32_T c10_i2;
  real_T *c10_nu;
  real_T *c10_ud;
  real_T (*c10_start)[3];
  real_T (*c10_target)[2];
  real_T (*c10_eta)[3];
  c10_start = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
  c10_target = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 2);
  c10_ud = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c10_eta = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
  c10_nu = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 5U, chartInstance->c10_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c10_nu, 0U);
  for (c10_i0 = 0; c10_i0 < 3; c10_i0++) {
    _SFD_DATA_RANGE_CHECK((*c10_eta)[c10_i0], 1U);
  }

  _SFD_DATA_RANGE_CHECK(*c10_ud, 2U);
  for (c10_i1 = 0; c10_i1 < 2; c10_i1++) {
    _SFD_DATA_RANGE_CHECK((*c10_target)[c10_i1], 3U);
  }

  for (c10_i2 = 0; c10_i2 < 3; c10_i2++) {
    _SFD_DATA_RANGE_CHECK((*c10_start)[c10_i2], 4U);
  }

  chartInstance->c10_sfEvent = CALL_EVENT;
  c10_chartstep_c10_NSB_vehicle_simulator(chartInstance);
  sf_debug_check_for_state_inconsistency(_NSB_vehicle_simulatorMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c10_chartstep_c10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
  real_T c10_hoistedGlobal;
  real_T c10_nu;
  int32_T c10_i3;
  real_T c10_eta[3];
  int32_T c10_i4;
  real_T c10_target[2];
  int32_T c10_i5;
  real_T c10_start[3];
  uint32_T c10_debug_family_var_map[16];
  real_T c10_U_max;
  real_T c10_alfa;
  real_T c10_ak;
  real_T c10_R[4];
  real_T c10_temp[2];
  real_T c10_s;
  real_T c10_e;
  real_T c10_deltaS;
  real_T c10_nargin = 4.0;
  real_T c10_nargout = 1.0;
  real_T c10_ud;
  real_T c10_x;
  real_T c10_b_x;
  real_T c10_c_x;
  real_T c10_d_x;
  real_T c10_e_x;
  real_T c10_f_x;
  real_T c10_g_x;
  real_T c10_h_x;
  int32_T c10_i6;
  real_T c10_a[4];
  int32_T c10_i7;
  real_T c10_b[2];
  int32_T c10_i8;
  int32_T c10_i9;
  int32_T c10_i10;
  real_T c10_C[2];
  int32_T c10_i11;
  int32_T c10_i12;
  int32_T c10_i13;
  int32_T c10_i14;
  int32_T c10_i15;
  int32_T c10_i16;
  int32_T c10_i17;
  real_T c10_y;
  real_T c10_scale;
  int32_T c10_k;
  int32_T c10_b_k;
  real_T c10_i_x;
  real_T c10_j_x;
  real_T c10_absxk;
  real_T c10_t;
  real_T *c10_b_ud;
  real_T *c10_b_nu;
  real_T (*c10_b_start)[3];
  real_T (*c10_b_target)[2];
  real_T (*c10_b_eta)[3];
  c10_b_start = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
  c10_b_target = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 2);
  c10_b_ud = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c10_b_eta = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
  c10_b_nu = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 5U, chartInstance->c10_sfEvent);
  c10_hoistedGlobal = *c10_b_nu;
  c10_nu = c10_hoistedGlobal;
  for (c10_i3 = 0; c10_i3 < 3; c10_i3++) {
    c10_eta[c10_i3] = (*c10_b_eta)[c10_i3];
  }

  for (c10_i4 = 0; c10_i4 < 2; c10_i4++) {
    c10_target[c10_i4] = (*c10_b_target)[c10_i4];
  }

  for (c10_i5 = 0; c10_i5 < 3; c10_i5++) {
    c10_start[c10_i5] = (*c10_b_start)[c10_i5];
  }

  sf_debug_symbol_scope_push_eml(0U, 16U, 16U, c10_debug_family_names,
    c10_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c10_U_max, 0U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_alfa, 1U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_ak, 2U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_R, 3U, c10_e_sf_marshallOut,
    c10_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_temp, 4U, c10_d_sf_marshallOut,
    c10_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_s, 5U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_e, 6U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_deltaS, 7U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_nargin, 8U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_nargout, 9U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c10_nu, 10U, c10_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c10_eta, 11U, c10_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c10_target, 12U, c10_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c10_start, 13U, c10_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c10_ud, 14U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c10_done, 15U,
    c10_sf_marshallOut, c10_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 4);
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 6);
  if (CV_EML_IF(0, 1, 0, !chartInstance->c10_done_not_empty)) {
    _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 7);
    chartInstance->c10_done = 0.0;
    chartInstance->c10_done_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 10);
  c10_U_max = 7.0;
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 11);
  c10_alfa = 1.0E-6;
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 13);
  c10_ak = c10_atan2(chartInstance, c10_target[1] - c10_start[1], c10_target[0]
                     - c10_start[0]);
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 15);
  c10_x = c10_ak;
  c10_b_x = c10_x;
  c10_b_x = muDoubleScalarCos(c10_b_x);
  c10_c_x = c10_ak;
  c10_d_x = c10_c_x;
  c10_d_x = muDoubleScalarSin(c10_d_x);
  c10_e_x = c10_ak;
  c10_f_x = c10_e_x;
  c10_f_x = muDoubleScalarSin(c10_f_x);
  c10_g_x = c10_ak;
  c10_h_x = c10_g_x;
  c10_h_x = muDoubleScalarCos(c10_h_x);
  c10_R[0] = c10_b_x;
  c10_R[2] = -c10_d_x;
  c10_R[1] = c10_f_x;
  c10_R[3] = c10_h_x;
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 16);
  for (c10_i6 = 0; c10_i6 < 4; c10_i6++) {
    c10_a[c10_i6] = c10_R[c10_i6];
  }

  for (c10_i7 = 0; c10_i7 < 2; c10_i7++) {
    c10_b[c10_i7] = c10_eta[c10_i7] - c10_target[c10_i7];
  }

  c10_eml_scalar_eg(chartInstance);
  c10_eml_scalar_eg(chartInstance);
  for (c10_i8 = 0; c10_i8 < 2; c10_i8++) {
    c10_temp[c10_i8] = 0.0;
  }

  for (c10_i9 = 0; c10_i9 < 2; c10_i9++) {
    c10_temp[c10_i9] = 0.0;
  }

  for (c10_i10 = 0; c10_i10 < 2; c10_i10++) {
    c10_C[c10_i10] = c10_temp[c10_i10];
  }

  for (c10_i11 = 0; c10_i11 < 2; c10_i11++) {
    c10_temp[c10_i11] = c10_C[c10_i11];
  }

  for (c10_i12 = 0; c10_i12 < 2; c10_i12++) {
    c10_C[c10_i12] = c10_temp[c10_i12];
  }

  for (c10_i13 = 0; c10_i13 < 2; c10_i13++) {
    c10_temp[c10_i13] = c10_C[c10_i13];
  }

  for (c10_i14 = 0; c10_i14 < 2; c10_i14++) {
    c10_temp[c10_i14] = 0.0;
    c10_i15 = 0;
    for (c10_i16 = 0; c10_i16 < 2; c10_i16++) {
      c10_temp[c10_i14] += c10_a[c10_i15 + c10_i14] * c10_b[c10_i16];
      c10_i15 += 2;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 18);
  c10_s = c10_temp[0];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 19);
  c10_e = c10_temp[1];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 20);
  c10_deltaS = 300.0;
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 23);
  for (c10_i17 = 0; c10_i17 < 2; c10_i17++) {
    c10_b[c10_i17] = c10_eta[c10_i17] - c10_target[c10_i17];
  }

  c10_y = 0.0;
  c10_scale = 2.2250738585072014E-308;
  c10_check_forloop_overflow_error(chartInstance);
  for (c10_k = 1; c10_k < 3; c10_k++) {
    c10_b_k = c10_k;
    c10_i_x = c10_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
      "", (real_T)c10_b_k), 1, 2, 1, 0) - 1];
    c10_j_x = c10_i_x;
    c10_absxk = muDoubleScalarAbs(c10_j_x);
    if (c10_absxk > c10_scale) {
      c10_t = c10_scale / c10_absxk;
      c10_y = 1.0 + c10_y * c10_t * c10_t;
      c10_scale = c10_absxk;
    } else {
      c10_t = c10_absxk / c10_scale;
      c10_y += c10_t * c10_t;
    }
  }

  c10_y = c10_scale * muDoubleScalarSqrt(c10_y);
  if (CV_EML_IF(0, 1, 1, c10_y < 7.0)) {
    _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 24);
    chartInstance->c10_done = 1.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 31);
  if (CV_EML_IF(0, 1, 2, chartInstance->c10_done == 0.0)) {
    _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 33);
    c10_ud = c10_U_max;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 35);
    c10_ud = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, -35);
  sf_debug_symbol_scope_pop();
  *c10_b_ud = c10_ud;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 5U, chartInstance->c10_sfEvent);
}

static void initSimStructsc10_NSB_vehicle_simulator
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c10_machineNumber, uint32_T
  c10_chartNumber)
{
}

static const mxArray *c10_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  real_T c10_u;
  const mxArray *c10_y = NULL;
  SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc10_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  c10_u = *(real_T *)c10_inData;
  c10_y = NULL;
  if (!chartInstance->c10_done_not_empty) {
    sf_mex_assign(&c10_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c10_y, sf_mex_create("y", &c10_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static real_T c10_emlrt_marshallIn(SFc10_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c10_b_done, const char_T *c10_identifier)
{
  real_T c10_y;
  emlrtMsgIdentifier c10_thisId;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_b_done),
    &c10_thisId);
  sf_mex_destroy(&c10_b_done);
  return c10_y;
}

static real_T c10_b_emlrt_marshallIn(SFc10_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId)
{
  real_T c10_y;
  real_T c10_d0;
  if (mxIsEmpty(c10_u)) {
    chartInstance->c10_done_not_empty = FALSE;
  } else {
    chartInstance->c10_done_not_empty = TRUE;
    sf_mex_import(c10_parentId, sf_mex_dup(c10_u), &c10_d0, 1, 0, 0U, 0, 0U, 0);
    c10_y = c10_d0;
  }

  sf_mex_destroy(&c10_u);
  return c10_y;
}

static void c10_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_b_done;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  real_T c10_y;
  SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc10_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c10_b_done = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_b_done),
    &c10_thisId);
  sf_mex_destroy(&c10_b_done);
  *(real_T *)c10_outData = c10_y;
  sf_mex_destroy(&c10_mxArrayInData);
}

static const mxArray *c10_b_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  real_T c10_u;
  const mxArray *c10_y = NULL;
  SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc10_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  c10_u = *(real_T *)c10_inData;
  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", &c10_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static real_T c10_c_emlrt_marshallIn(SFc10_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c10_ud, const char_T *c10_identifier)
{
  real_T c10_y;
  emlrtMsgIdentifier c10_thisId;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_ud), &c10_thisId);
  sf_mex_destroy(&c10_ud);
  return c10_y;
}

static real_T c10_d_emlrt_marshallIn(SFc10_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId)
{
  real_T c10_y;
  real_T c10_d1;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), &c10_d1, 1, 0, 0U, 0, 0U, 0);
  c10_y = c10_d1;
  sf_mex_destroy(&c10_u);
  return c10_y;
}

static void c10_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_ud;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  real_T c10_y;
  SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc10_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c10_ud = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_ud), &c10_thisId);
  sf_mex_destroy(&c10_ud);
  *(real_T *)c10_outData = c10_y;
  sf_mex_destroy(&c10_mxArrayInData);
}

static const mxArray *c10_c_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  int32_T c10_i18;
  real_T c10_b_inData[3];
  int32_T c10_i19;
  real_T c10_u[3];
  const mxArray *c10_y = NULL;
  SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc10_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  for (c10_i18 = 0; c10_i18 < 3; c10_i18++) {
    c10_b_inData[c10_i18] = (*(real_T (*)[3])c10_inData)[c10_i18];
  }

  for (c10_i19 = 0; c10_i19 < 3; c10_i19++) {
    c10_u[c10_i19] = c10_b_inData[c10_i19];
  }

  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", c10_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static const mxArray *c10_d_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  int32_T c10_i20;
  real_T c10_b_inData[2];
  int32_T c10_i21;
  real_T c10_u[2];
  const mxArray *c10_y = NULL;
  SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc10_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  for (c10_i20 = 0; c10_i20 < 2; c10_i20++) {
    c10_b_inData[c10_i20] = (*(real_T (*)[2])c10_inData)[c10_i20];
  }

  for (c10_i21 = 0; c10_i21 < 2; c10_i21++) {
    c10_u[c10_i21] = c10_b_inData[c10_i21];
  }

  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", c10_u, 0, 0U, 1U, 0U, 1, 2), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static void c10_e_emlrt_marshallIn(SFc10_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId,
  real_T c10_y[2])
{
  real_T c10_dv0[2];
  int32_T c10_i22;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), c10_dv0, 1, 0, 0U, 1, 0U, 1, 2);
  for (c10_i22 = 0; c10_i22 < 2; c10_i22++) {
    c10_y[c10_i22] = c10_dv0[c10_i22];
  }

  sf_mex_destroy(&c10_u);
}

static void c10_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_temp;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  real_T c10_y[2];
  int32_T c10_i23;
  SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc10_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c10_temp = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_temp), &c10_thisId, c10_y);
  sf_mex_destroy(&c10_temp);
  for (c10_i23 = 0; c10_i23 < 2; c10_i23++) {
    (*(real_T (*)[2])c10_outData)[c10_i23] = c10_y[c10_i23];
  }

  sf_mex_destroy(&c10_mxArrayInData);
}

static const mxArray *c10_e_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  int32_T c10_i24;
  int32_T c10_i25;
  int32_T c10_i26;
  real_T c10_b_inData[4];
  int32_T c10_i27;
  int32_T c10_i28;
  int32_T c10_i29;
  real_T c10_u[4];
  const mxArray *c10_y = NULL;
  SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc10_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  c10_i24 = 0;
  for (c10_i25 = 0; c10_i25 < 2; c10_i25++) {
    for (c10_i26 = 0; c10_i26 < 2; c10_i26++) {
      c10_b_inData[c10_i26 + c10_i24] = (*(real_T (*)[4])c10_inData)[c10_i26 +
        c10_i24];
    }

    c10_i24 += 2;
  }

  c10_i27 = 0;
  for (c10_i28 = 0; c10_i28 < 2; c10_i28++) {
    for (c10_i29 = 0; c10_i29 < 2; c10_i29++) {
      c10_u[c10_i29 + c10_i27] = c10_b_inData[c10_i29 + c10_i27];
    }

    c10_i27 += 2;
  }

  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", c10_u, 0, 0U, 1U, 0U, 2, 2, 2), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static void c10_f_emlrt_marshallIn(SFc10_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId,
  real_T c10_y[4])
{
  real_T c10_dv1[4];
  int32_T c10_i30;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), c10_dv1, 1, 0, 0U, 1, 0U, 2, 2,
                2);
  for (c10_i30 = 0; c10_i30 < 4; c10_i30++) {
    c10_y[c10_i30] = c10_dv1[c10_i30];
  }

  sf_mex_destroy(&c10_u);
}

static void c10_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_R;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  real_T c10_y[4];
  int32_T c10_i31;
  int32_T c10_i32;
  int32_T c10_i33;
  SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc10_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c10_R = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_R), &c10_thisId, c10_y);
  sf_mex_destroy(&c10_R);
  c10_i31 = 0;
  for (c10_i32 = 0; c10_i32 < 2; c10_i32++) {
    for (c10_i33 = 0; c10_i33 < 2; c10_i33++) {
      (*(real_T (*)[4])c10_outData)[c10_i33 + c10_i31] = c10_y[c10_i33 + c10_i31];
    }

    c10_i31 += 2;
  }

  sf_mex_destroy(&c10_mxArrayInData);
}

const mxArray *sf_c10_NSB_vehicle_simulator_get_eml_resolved_functions_info(void)
{
  const mxArray *c10_nameCaptureInfo;
  c10_ResolvedFunctionInfo c10_info[37];
  const mxArray *c10_m0 = NULL;
  int32_T c10_i34;
  c10_ResolvedFunctionInfo *c10_r0;
  c10_nameCaptureInfo = NULL;
  c10_nameCaptureInfo = NULL;
  c10_info_helper(c10_info);
  sf_mex_assign(&c10_m0, sf_mex_createstruct("nameCaptureInfo", 1, 37), FALSE);
  for (c10_i34 = 0; c10_i34 < 37; c10_i34++) {
    c10_r0 = &c10_info[c10_i34];
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", c10_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c10_r0->context)), "context", "nameCaptureInfo",
                    c10_i34);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", c10_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c10_r0->name)), "name", "nameCaptureInfo",
                    c10_i34);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo",
      c10_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c10_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c10_i34);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", c10_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c10_r0->resolved)), "resolved",
                    "nameCaptureInfo", c10_i34);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", &c10_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c10_i34);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", &c10_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c10_i34);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo",
      &c10_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c10_i34);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo",
      &c10_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c10_i34);
  }

  sf_mex_assign(&c10_nameCaptureInfo, c10_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c10_nameCaptureInfo);
  return c10_nameCaptureInfo;
}

static void c10_info_helper(c10_ResolvedFunctionInfo c10_info[37])
{
  c10_info[0].context = "";
  c10_info[0].name = "atan2";
  c10_info[0].dominantType = "double";
  c10_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c10_info[0].fileTimeLo = 1286818704U;
  c10_info[0].fileTimeHi = 0U;
  c10_info[0].mFileTimeLo = 0U;
  c10_info[0].mFileTimeHi = 0U;
  c10_info[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c10_info[1].name = "eml_scalar_eg";
  c10_info[1].dominantType = "double";
  c10_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c10_info[1].fileTimeLo = 1286818796U;
  c10_info[1].fileTimeHi = 0U;
  c10_info[1].mFileTimeLo = 0U;
  c10_info[1].mFileTimeHi = 0U;
  c10_info[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c10_info[2].name = "eml_scalexp_alloc";
  c10_info[2].dominantType = "double";
  c10_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c10_info[2].fileTimeLo = 1330608434U;
  c10_info[2].fileTimeHi = 0U;
  c10_info[2].mFileTimeLo = 0U;
  c10_info[2].mFileTimeHi = 0U;
  c10_info[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c10_info[3].name = "eml_scalar_atan2";
  c10_info[3].dominantType = "double";
  c10_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_atan2.m";
  c10_info[3].fileTimeLo = 1286818720U;
  c10_info[3].fileTimeHi = 0U;
  c10_info[3].mFileTimeLo = 0U;
  c10_info[3].mFileTimeHi = 0U;
  c10_info[4].context = "";
  c10_info[4].name = "cos";
  c10_info[4].dominantType = "double";
  c10_info[4].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c10_info[4].fileTimeLo = 1286818706U;
  c10_info[4].fileTimeHi = 0U;
  c10_info[4].mFileTimeLo = 0U;
  c10_info[4].mFileTimeHi = 0U;
  c10_info[5].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c10_info[5].name = "eml_scalar_cos";
  c10_info[5].dominantType = "double";
  c10_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c10_info[5].fileTimeLo = 1286818722U;
  c10_info[5].fileTimeHi = 0U;
  c10_info[5].mFileTimeLo = 0U;
  c10_info[5].mFileTimeHi = 0U;
  c10_info[6].context = "";
  c10_info[6].name = "sin";
  c10_info[6].dominantType = "double";
  c10_info[6].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c10_info[6].fileTimeLo = 1286818750U;
  c10_info[6].fileTimeHi = 0U;
  c10_info[6].mFileTimeLo = 0U;
  c10_info[6].mFileTimeHi = 0U;
  c10_info[7].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c10_info[7].name = "eml_scalar_sin";
  c10_info[7].dominantType = "double";
  c10_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c10_info[7].fileTimeLo = 1286818736U;
  c10_info[7].fileTimeHi = 0U;
  c10_info[7].mFileTimeLo = 0U;
  c10_info[7].mFileTimeHi = 0U;
  c10_info[8].context = "";
  c10_info[8].name = "mtimes";
  c10_info[8].dominantType = "double";
  c10_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c10_info[8].fileTimeLo = 1289519692U;
  c10_info[8].fileTimeHi = 0U;
  c10_info[8].mFileTimeLo = 0U;
  c10_info[8].mFileTimeHi = 0U;
  c10_info[9].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c10_info[9].name = "eml_index_class";
  c10_info[9].dominantType = "";
  c10_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c10_info[9].fileTimeLo = 1323170578U;
  c10_info[9].fileTimeHi = 0U;
  c10_info[9].mFileTimeLo = 0U;
  c10_info[9].mFileTimeHi = 0U;
  c10_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c10_info[10].name = "eml_scalar_eg";
  c10_info[10].dominantType = "double";
  c10_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c10_info[10].fileTimeLo = 1286818796U;
  c10_info[10].fileTimeHi = 0U;
  c10_info[10].mFileTimeLo = 0U;
  c10_info[10].mFileTimeHi = 0U;
  c10_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c10_info[11].name = "eml_xgemm";
  c10_info[11].dominantType = "char";
  c10_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c10_info[11].fileTimeLo = 1299076772U;
  c10_info[11].fileTimeHi = 0U;
  c10_info[11].mFileTimeLo = 0U;
  c10_info[11].mFileTimeHi = 0U;
  c10_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c10_info[12].name = "eml_blas_inline";
  c10_info[12].dominantType = "";
  c10_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c10_info[12].fileTimeLo = 1299076768U;
  c10_info[12].fileTimeHi = 0U;
  c10_info[12].mFileTimeLo = 0U;
  c10_info[12].mFileTimeHi = 0U;
  c10_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m!below_threshold";
  c10_info[13].name = "mtimes";
  c10_info[13].dominantType = "double";
  c10_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c10_info[13].fileTimeLo = 1289519692U;
  c10_info[13].fileTimeHi = 0U;
  c10_info[13].mFileTimeLo = 0U;
  c10_info[13].mFileTimeHi = 0U;
  c10_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c10_info[14].name = "eml_index_class";
  c10_info[14].dominantType = "";
  c10_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c10_info[14].fileTimeLo = 1323170578U;
  c10_info[14].fileTimeHi = 0U;
  c10_info[14].mFileTimeLo = 0U;
  c10_info[14].mFileTimeHi = 0U;
  c10_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c10_info[15].name = "eml_scalar_eg";
  c10_info[15].dominantType = "double";
  c10_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c10_info[15].fileTimeLo = 1286818796U;
  c10_info[15].fileTimeHi = 0U;
  c10_info[15].mFileTimeLo = 0U;
  c10_info[15].mFileTimeHi = 0U;
  c10_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c10_info[16].name = "eml_refblas_xgemm";
  c10_info[16].dominantType = "char";
  c10_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c10_info[16].fileTimeLo = 1299076774U;
  c10_info[16].fileTimeHi = 0U;
  c10_info[16].mFileTimeLo = 0U;
  c10_info[16].mFileTimeHi = 0U;
  c10_info[17].context = "";
  c10_info[17].name = "norm";
  c10_info[17].dominantType = "double";
  c10_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m";
  c10_info[17].fileTimeLo = 1336522094U;
  c10_info[17].fileTimeHi = 0U;
  c10_info[17].mFileTimeLo = 0U;
  c10_info[17].mFileTimeHi = 0U;
  c10_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!genpnorm";
  c10_info[18].name = "eml_index_class";
  c10_info[18].dominantType = "";
  c10_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c10_info[18].fileTimeLo = 1323170578U;
  c10_info[18].fileTimeHi = 0U;
  c10_info[18].mFileTimeLo = 0U;
  c10_info[18].mFileTimeHi = 0U;
  c10_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!genpnorm";
  c10_info[19].name = "eml_xnrm2";
  c10_info[19].dominantType = "double";
  c10_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xnrm2.m";
  c10_info[19].fileTimeLo = 1299076776U;
  c10_info[19].fileTimeHi = 0U;
  c10_info[19].mFileTimeLo = 0U;
  c10_info[19].mFileTimeHi = 0U;
  c10_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xnrm2.m";
  c10_info[20].name = "eml_blas_inline";
  c10_info[20].dominantType = "";
  c10_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c10_info[20].fileTimeLo = 1299076768U;
  c10_info[20].fileTimeHi = 0U;
  c10_info[20].mFileTimeLo = 0U;
  c10_info[20].mFileTimeHi = 0U;
  c10_info[21].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xnrm2.m";
  c10_info[21].name = "eml_index_class";
  c10_info[21].dominantType = "";
  c10_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c10_info[21].fileTimeLo = 1323170578U;
  c10_info[21].fileTimeHi = 0U;
  c10_info[21].mFileTimeLo = 0U;
  c10_info[21].mFileTimeHi = 0U;
  c10_info[22].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xnrm2.m";
  c10_info[22].name = "eml_refblas_xnrm2";
  c10_info[22].dominantType = "double";
  c10_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c10_info[22].fileTimeLo = 1299076784U;
  c10_info[22].fileTimeHi = 0U;
  c10_info[22].mFileTimeLo = 0U;
  c10_info[22].mFileTimeHi = 0U;
  c10_info[23].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c10_info[23].name = "realmin";
  c10_info[23].dominantType = "char";
  c10_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c10_info[23].fileTimeLo = 1307651242U;
  c10_info[23].fileTimeHi = 0U;
  c10_info[23].mFileTimeLo = 0U;
  c10_info[23].mFileTimeHi = 0U;
  c10_info[24].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c10_info[24].name = "eml_realmin";
  c10_info[24].dominantType = "char";
  c10_info[24].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmin.m";
  c10_info[24].fileTimeLo = 1307651244U;
  c10_info[24].fileTimeHi = 0U;
  c10_info[24].mFileTimeLo = 0U;
  c10_info[24].mFileTimeHi = 0U;
  c10_info[25].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmin.m";
  c10_info[25].name = "eml_float_model";
  c10_info[25].dominantType = "char";
  c10_info[25].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_float_model.m";
  c10_info[25].fileTimeLo = 1326727996U;
  c10_info[25].fileTimeHi = 0U;
  c10_info[25].mFileTimeLo = 0U;
  c10_info[25].mFileTimeHi = 0U;
  c10_info[26].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c10_info[26].name = "eml_index_class";
  c10_info[26].dominantType = "";
  c10_info[26].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c10_info[26].fileTimeLo = 1323170578U;
  c10_info[26].fileTimeHi = 0U;
  c10_info[26].mFileTimeLo = 0U;
  c10_info[26].mFileTimeHi = 0U;
  c10_info[27].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c10_info[27].name = "eml_index_minus";
  c10_info[27].dominantType = "double";
  c10_info[27].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c10_info[27].fileTimeLo = 1286818778U;
  c10_info[27].fileTimeHi = 0U;
  c10_info[27].mFileTimeLo = 0U;
  c10_info[27].mFileTimeHi = 0U;
  c10_info[28].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c10_info[28].name = "eml_index_class";
  c10_info[28].dominantType = "";
  c10_info[28].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c10_info[28].fileTimeLo = 1323170578U;
  c10_info[28].fileTimeHi = 0U;
  c10_info[28].mFileTimeLo = 0U;
  c10_info[28].mFileTimeHi = 0U;
  c10_info[29].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c10_info[29].name = "eml_index_times";
  c10_info[29].dominantType = "coder.internal.indexInt";
  c10_info[29].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c10_info[29].fileTimeLo = 1286818780U;
  c10_info[29].fileTimeHi = 0U;
  c10_info[29].mFileTimeLo = 0U;
  c10_info[29].mFileTimeHi = 0U;
  c10_info[30].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c10_info[30].name = "eml_index_class";
  c10_info[30].dominantType = "";
  c10_info[30].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c10_info[30].fileTimeLo = 1323170578U;
  c10_info[30].fileTimeHi = 0U;
  c10_info[30].mFileTimeLo = 0U;
  c10_info[30].mFileTimeHi = 0U;
  c10_info[31].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c10_info[31].name = "eml_index_plus";
  c10_info[31].dominantType = "coder.internal.indexInt";
  c10_info[31].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c10_info[31].fileTimeLo = 1286818778U;
  c10_info[31].fileTimeHi = 0U;
  c10_info[31].mFileTimeLo = 0U;
  c10_info[31].mFileTimeHi = 0U;
  c10_info[32].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c10_info[32].name = "eml_index_class";
  c10_info[32].dominantType = "";
  c10_info[32].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c10_info[32].fileTimeLo = 1323170578U;
  c10_info[32].fileTimeHi = 0U;
  c10_info[32].mFileTimeLo = 0U;
  c10_info[32].mFileTimeHi = 0U;
  c10_info[33].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c10_info[33].name = "eml_int_forloop_overflow_check";
  c10_info[33].dominantType = "";
  c10_info[33].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c10_info[33].fileTimeLo = 1332168672U;
  c10_info[33].fileTimeHi = 0U;
  c10_info[33].mFileTimeLo = 0U;
  c10_info[33].mFileTimeHi = 0U;
  c10_info[34].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m!eml_int_forloop_overflow_check_helper";
  c10_info[34].name = "intmax";
  c10_info[34].dominantType = "char";
  c10_info[34].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c10_info[34].fileTimeLo = 1311255316U;
  c10_info[34].fileTimeHi = 0U;
  c10_info[34].mFileTimeLo = 0U;
  c10_info[34].mFileTimeHi = 0U;
  c10_info[35].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c10_info[35].name = "abs";
  c10_info[35].dominantType = "double";
  c10_info[35].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c10_info[35].fileTimeLo = 1286818694U;
  c10_info[35].fileTimeHi = 0U;
  c10_info[35].mFileTimeLo = 0U;
  c10_info[35].mFileTimeHi = 0U;
  c10_info[36].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c10_info[36].name = "eml_scalar_abs";
  c10_info[36].dominantType = "double";
  c10_info[36].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c10_info[36].fileTimeLo = 1286818712U;
  c10_info[36].fileTimeHi = 0U;
  c10_info[36].mFileTimeLo = 0U;
  c10_info[36].mFileTimeHi = 0U;
}

static real_T c10_atan2(SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance,
  real_T c10_y, real_T c10_x)
{
  real_T c10_b_y;
  real_T c10_b_x;
  c10_b_y = c10_y;
  c10_b_x = c10_x;
  return muDoubleScalarAtan2(c10_b_y, c10_b_x);
}

static void c10_eml_scalar_eg(SFc10_NSB_vehicle_simulatorInstanceStruct
  *chartInstance)
{
}

static void c10_check_forloop_overflow_error
  (SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
}

static const mxArray *c10_f_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  int32_T c10_u;
  const mxArray *c10_y = NULL;
  SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc10_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  c10_u = *(int32_T *)c10_inData;
  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", &c10_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static int32_T c10_g_emlrt_marshallIn(SFc10_NSB_vehicle_simulatorInstanceStruct *
  chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId)
{
  int32_T c10_y;
  int32_T c10_i35;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), &c10_i35, 1, 6, 0U, 0, 0U, 0);
  c10_y = c10_i35;
  sf_mex_destroy(&c10_u);
  return c10_y;
}

static void c10_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_b_sfEvent;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  int32_T c10_y;
  SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc10_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c10_b_sfEvent = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_b_sfEvent),
    &c10_thisId);
  sf_mex_destroy(&c10_b_sfEvent);
  *(int32_T *)c10_outData = c10_y;
  sf_mex_destroy(&c10_mxArrayInData);
}

static uint8_T c10_h_emlrt_marshallIn(SFc10_NSB_vehicle_simulatorInstanceStruct *
  chartInstance, const mxArray *c10_b_is_active_c10_NSB_vehicle_simulator, const
  char_T *c10_identifier)
{
  uint8_T c10_y;
  emlrtMsgIdentifier c10_thisId;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_i_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c10_b_is_active_c10_NSB_vehicle_simulator), &c10_thisId);
  sf_mex_destroy(&c10_b_is_active_c10_NSB_vehicle_simulator);
  return c10_y;
}

static uint8_T c10_i_emlrt_marshallIn(SFc10_NSB_vehicle_simulatorInstanceStruct *
  chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId)
{
  uint8_T c10_y;
  uint8_T c10_u0;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), &c10_u0, 1, 3, 0U, 0, 0U, 0);
  c10_y = c10_u0;
  sf_mex_destroy(&c10_u);
  return c10_y;
}

static void init_dsm_address_info(SFc10_NSB_vehicle_simulatorInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c10_NSB_vehicle_simulator_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(800384269U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3069518824U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(683054620U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3559477586U);
}

mxArray *sf_c10_NSB_vehicle_simulator_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("6beZbqjrHJMnLV8WYBaDKH");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c10_NSB_vehicle_simulator(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[5],T\"ud\",},{M[4],M[0],T\"done\",S'l','i','p'{{M1x2[61 65],M[0],}}},{M[8],M[0],T\"is_active_c10_NSB_vehicle_simulator\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c10_NSB_vehicle_simulator_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance;
    chartInstance = (SFc10_NSB_vehicle_simulatorInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_NSB_vehicle_simulatorMachineNumber_,
           10,
           1,
           1,
           5,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_NSB_vehicle_simulatorMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_NSB_vehicle_simulatorMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds
            (_NSB_vehicle_simulatorMachineNumber_,
             chartInstance->chartNumber,
             0,
             0,
             0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"nu");
          _SFD_SET_DATA_PROPS(1,1,1,0,"eta");
          _SFD_SET_DATA_PROPS(2,2,0,1,"ud");
          _SFD_SET_DATA_PROPS(3,1,1,0,"target");
          _SFD_SET_DATA_PROPS(4,1,1,0,"start");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,3,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,419);
        _SFD_CV_INIT_EML_IF(0,1,0,71,87,-1,113);
        _SFD_CV_INIT_EML_IF(0,1,1,310,337,-1,356);
        _SFD_CV_INIT_EML_IF(0,1,2,365,377,399,419);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c10_b_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c10_b_sf_marshallOut,(MexInFcnForType)
          c10_b_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          real_T *c10_nu;
          real_T *c10_ud;
          real_T (*c10_eta)[3];
          real_T (*c10_target)[2];
          real_T (*c10_start)[3];
          c10_start = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
          c10_target = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 2);
          c10_ud = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c10_eta = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
          c10_nu = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c10_nu);
          _SFD_SET_DATA_VALUE_PTR(1U, *c10_eta);
          _SFD_SET_DATA_VALUE_PTR(2U, c10_ud);
          _SFD_SET_DATA_VALUE_PTR(3U, *c10_target);
          _SFD_SET_DATA_VALUE_PTR(4U, *c10_start);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration
        (_NSB_vehicle_simulatorMachineNumber_,chartInstance->chartNumber,
         chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "U0BkjCfkQpXnJwfFC3PAd";
}

static void sf_opaque_initialize_c10_NSB_vehicle_simulator(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc10_NSB_vehicle_simulatorInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c10_NSB_vehicle_simulator
    ((SFc10_NSB_vehicle_simulatorInstanceStruct*) chartInstanceVar);
  initialize_c10_NSB_vehicle_simulator
    ((SFc10_NSB_vehicle_simulatorInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c10_NSB_vehicle_simulator(void *chartInstanceVar)
{
  enable_c10_NSB_vehicle_simulator((SFc10_NSB_vehicle_simulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_disable_c10_NSB_vehicle_simulator(void *chartInstanceVar)
{
  disable_c10_NSB_vehicle_simulator((SFc10_NSB_vehicle_simulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c10_NSB_vehicle_simulator(void *chartInstanceVar)
{
  sf_c10_NSB_vehicle_simulator((SFc10_NSB_vehicle_simulatorInstanceStruct*)
    chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c10_NSB_vehicle_simulator
  (SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c10_NSB_vehicle_simulator
    ((SFc10_NSB_vehicle_simulatorInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c10_NSB_vehicle_simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c10_NSB_vehicle_simulator(SimStruct* S,
  const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c10_NSB_vehicle_simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c10_NSB_vehicle_simulator
    ((SFc10_NSB_vehicle_simulatorInstanceStruct*)chartInfo->chartInstance,
     mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c10_NSB_vehicle_simulator
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c10_NSB_vehicle_simulator(S);
}

static void sf_opaque_set_sim_state_c10_NSB_vehicle_simulator(SimStruct* S,
  const mxArray *st)
{
  sf_internal_set_sim_state_c10_NSB_vehicle_simulator(S, st);
}

static void sf_opaque_terminate_c10_NSB_vehicle_simulator(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc10_NSB_vehicle_simulatorInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c10_NSB_vehicle_simulator
      ((SFc10_NSB_vehicle_simulatorInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_NSB_vehicle_simulator_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc10_NSB_vehicle_simulator
    ((SFc10_NSB_vehicle_simulatorInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c10_NSB_vehicle_simulator(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c10_NSB_vehicle_simulator
      ((SFc10_NSB_vehicle_simulatorInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c10_NSB_vehicle_simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_NSB_vehicle_simulator_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      10);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,10,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,10,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,10,4);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,10,1);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,10);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1427024572U));
  ssSetChecksum1(S,(1693428008U));
  ssSetChecksum2(S,(1568974057U));
  ssSetChecksum3(S,(2269345711U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c10_NSB_vehicle_simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c10_NSB_vehicle_simulator(SimStruct *S)
{
  SFc10_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc10_NSB_vehicle_simulatorInstanceStruct *)malloc(sizeof
    (SFc10_NSB_vehicle_simulatorInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc10_NSB_vehicle_simulatorInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c10_NSB_vehicle_simulator;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c10_NSB_vehicle_simulator;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c10_NSB_vehicle_simulator;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c10_NSB_vehicle_simulator;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c10_NSB_vehicle_simulator;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c10_NSB_vehicle_simulator;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c10_NSB_vehicle_simulator;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c10_NSB_vehicle_simulator;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c10_NSB_vehicle_simulator;
  chartInstance->chartInfo.mdlStart = mdlStart_c10_NSB_vehicle_simulator;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c10_NSB_vehicle_simulator;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c10_NSB_vehicle_simulator_method_dispatcher(SimStruct *S, int_T method,
  void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c10_NSB_vehicle_simulator(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c10_NSB_vehicle_simulator(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c10_NSB_vehicle_simulator(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c10_NSB_vehicle_simulator_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
