#ifndef __c2_objectTrackingFilter_h__
#define __c2_objectTrackingFilter_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_c2_ResolvedFunctionInfo
#define typedef_c2_ResolvedFunctionInfo

typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c2_ResolvedFunctionInfo;

#endif                                 /*typedef_c2_ResolvedFunctionInfo*/

#ifndef typedef_SFc2_objectTrackingFilterInstanceStruct
#define typedef_SFc2_objectTrackingFilterInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c2_sfEvent;
  boolean_T c2_isStable;
  boolean_T c2_doneDoubleBufferReInit;
  uint8_T c2_is_active_c2_objectTrackingFilter;
  real_T c2_Q2[81];
  real_T c2_H2[27];
  real_T c2_E2;
  real_T c2_R2[9];
  real_T c2_disk_A[81];
  real_T c2_SampleTimeKalman;
  real_T c2_STM;
  real_T c2_StartVelocity[2];
  real_T c2_pre_P[81];
  boolean_T c2_pre_P_not_empty;
  real_T c2_pre_x[9];
  boolean_T c2_pre_x_not_empty;
  real_T c2_index;
  boolean_T c2_index_not_empty;
} SFc2_objectTrackingFilterInstanceStruct;

#endif                                 /*typedef_SFc2_objectTrackingFilterInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c2_objectTrackingFilter_get_eml_resolved_functions_info
  (void);

/* Function Definitions */
extern void sf_c2_objectTrackingFilter_get_check_sum(mxArray *plhs[]);
extern void c2_objectTrackingFilter_method_dispatcher(SimStruct *S, int_T method,
  void *data);

#endif
