

T_u = 5;
T_heading = 3;
K_u = 1;
b_heading = 0.5;

% set control parameter for surge
m = T_u /K_u;
d = 1/K_u;

sigma = 1.1;
omega_b = 0.8;

omega_n = omega_b/(sqrt(1-2*sigma^2+sqrt(4*sigma^4-4*sigma^2+2)));

Kp_u = m*omega_n^2; 
Ki_u = Kp_u*omega_n/10;
Kd_u = 2*sigma*omega_n*m - d;

% set control parameter for heading 



m_2 = T_u /b_heading;
d_2 = 1/b_heading;

sigma_2 = 1.1;
omega_2b = 0.8;

omega_n2 = omega_2b/(sqrt(1-2*sigma_2^2+sqrt(4*sigma_2^4-4*sigma_2^2+2)));

Kp_heading = m_2*omega_n2^2; 
Ki_heading = 0*Kp_heading*omega_n2/90;
Kd_heading = 2*sigma*omega_n2*m_2 - d_2;